//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// ManagedObjectInstance.cc

// By George Pavlou, February 1995


#include <stdlib.h>
#include "msap.h"
#include "ManagedObjectInstance.h"


int  ManagedObjectInstance::_compare (void* v1, void* v2)
{
    MN mn1 = (MN) v1, mn2 = (MN) v2;

    if (!_mo || mn1->mn_type == mn2->mn_type)
	return ObjectInstance_cmp(mn1, mn2);

    if (mn1->mn_type == MN_NONSPEC || mn1->mn_type == MN_NONSPEC)
	return 2;	// non-comparable

    MName ln1 = *mn1, ln2 = *mn2;

    if (mn1->mn_type == MN_DN)
	ln1.mn_dn = _mo->mn2localdn(mn1);
    if (mn2->mn_type == MN_DN)
	ln2.mn_dn = _mo->mn2localdn(mn2);
    ln1.mn_type = ln2.mn_type = MN_LOCALDN;

    return ObjectInstance_cmp(&ln1, &ln2);
}

