//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// ManagedObjectInstance.h

// By George Pavlou, February 1995


#ifndef _ManagedObjectInstance_h_
#define _ManagedObjectInstance_h_


#ifndef _ObjectInstance_h_
#include "ObjectInstance.h"
#endif

#ifndef _GENERIC_MO_
#include "GenericMO.h"
#endif


/*
 * this syntax class is a specialised ObjectInstance which redefines
 * the polymorphic _compare method to convert global to local names -
 * it is used only by the eventLogRecord support class
 */

class ManagedObjectInstance : public ObjectInstance
{
    MO*  _mo;

protected:
    int		_compare (void* v1, void* v2);

public:
    inline void	setContainingMO (MO* mo)	{ _mo = mo; }
};


#endif
