#include "SmiSntx.h"
#include "transportEntity.h"
#include "GraphicString.h"
#include "Gauge.h"


int transportConnection::createRR (AVA*& err, void*, int)
{
    // call first the parent class createRR method
    if (connection::createRR(err) == NOTOK)
	return NOTOK;

    static Bool classInitialised;

    // update relevant transportEntity's attributes
    transportEntity* tpEnt = (transportEntity*) getSuperior();
    ((GaugeInt*) tpEnt -> transportEntity::openConnections()) ->increment();

    if (!classInitialised)
	classInitialised = True;

    return OK;
}


int transportConnection::deleteRR (AVA*& err, void* info, Bool checkOnly, int)
{
    // update relevant transportEntity's attributes
    if (!checkOnly) {
        transportEntity* tpEnt = (transportEntity*) getSuperior();
        ((GaugeInt*) tpEnt -> transportEntity::openConnections())->decrement();
        tpEnt -> transportEntity::previousConnections()->increment();
    }

    // the following will do nothing but for correct OO style...
    return connection::deleteRR(err, info, checkOnly);
}


void  transportConnection::update (MReport* minfo)
{
    char buf[256];
    transportEntity* tpEnt = (transportEntity*) getSuperior();
    int pdus;

    switch (minfo -> type) {
    case OPREQIN:
    case OPREQOUT:
#ifdef DEBUG
	advise(NULLCP, "Open Request TPDU In/Out, pid %d, cid %d",
				minfo -> id, minfo -> cid);
#endif
	sprintf(buf, "%s %s",
			minfo->u.taddr.tsel, minfo->u.taddr.nsap.na_address);
	connection::remoteSapAddress() -> set(buf);

	protocolClass() -> set(int_Isode_TProtocolClass_tp0);

	minfo -> type == OPREQIN ?
	    tpEnt -> transportEntity::localSuccessfulConnections()
					-> increment() :
	    tpEnt -> transportEntity::remoteSuccessfulConnections()
					-> increment();
	break;

    case SOURCEADDR:
#ifdef DEBUG
	advise(NULLCP, "transportConnection creation, pid %d, cid %d",
				minfo -> id, minfo -> cid);
#endif
	sprintf(buf, "%s %s",
			minfo->u.taddr.tsel, minfo->u.taddr.nsap.na_address);
	connection::localSapAddress() -> set(buf);
	break;

    case USERDT:
	if (minfo -> u.gp.a == 0)
	    minfo -> u.gp.b = 0;	// hack to rectify tsap bug...
#ifdef DEBUG
	advise(NULLCP, "transportConnection data sent, pid %d, fd %d, %d bytes",
		minfo ->id, minfo -> cid, minfo -> u.gp.a);
#endif
	pdus = minfo->u.gp.b - pdusSent()->getint();

	octetsSent() -> increment(minfo->u.gp.a);
	tpEnt->transportEntity::totalNumberTpduSent() -> increment(pdus);
	pdusSent() -> increment(pdus);
	
    case USERDR:
	if (minfo -> u.gp.a == 0)
	    minfo -> u.gp.b = 0;	// hack to rectify tsap bug...
#ifdef DEBUG
	advise(NULLCP, "transportConnection data received, pid %d, fd %d, \
%d bytes",
		minfo ->id, minfo -> cid, minfo -> u.gp.a);
#endif
	pdus = minfo -> u.gp.b - pdusReceived()->getint();

	octetsReceived() -> increment(minfo->u.gp.a);
	tpEnt->transportEntity::totalNumberTpduReceived()
					-> increment(pdus);
	pdusReceived() -> increment(pdus);

	break;

    case DISCREQ:
#ifdef DEBUG
	advise(NULLCP, "transportConnection deletion, pid %d, cid %d",
				minfo -> id, minfo -> cid);
#endif
	pdus = minfo->u.gp.c - pdusSent()->getint();
	pdusSent() -> increment(pdus);
	octetsSent() -> increment(minfo->u.gp.a);
	tpEnt->transportEntity::totalNumberTpduSent() -> increment(pdus);

	pdus = minfo->u.gp.d - pdusReceived()->getint();
	pdusReceived() -> increment(pdus);
	octetsReceived() -> increment(minfo->u.gp.b);
	tpEnt->transportEntity::totalNumberTpduReceived() -> increment(pdus);
	break;
    }
}
