/*
* NAME
*   MonitorSntx.c
*
* DESCRIPTION
*   ISO/IEC 10164-11 Monitor Objects attribute syntaxes
*
* AUTHOR
*   Jim Reilly
*   Technical Research Centre of Finland
*   icm.group@tel.vtt.fi
*/

#ifndef _MONITOR_SNTX_
#define _MONITOR_SNTX_


#ifndef _module_Monitor_defined_
#include "Monitor-types.h"
#endif


#ifndef FunctionPrototypes
#if defined(__STDC__) || defined(__cplusplus)
#define FunctionPrototypes
#endif
#endif

#ifdef	__cplusplus
extern "C" {
#endif


#ifdef FunctionPrototypes

PE              TimePeriod_encode (struct type_Monitor_TimePeriod*);
struct type_Monitor_TimePeriod*
                TimePeriod_decode (PE);
struct type_Monitor_TimePeriod*
                TimePeriod_parse (char*);
int             TimePeriod_print (PS, struct type_Monitor_TimePeriod*, int);
int             TimePeriod2seconds (struct type_Monitor_TimePeriod*);
int             TimePeriod_free (struct type_Monitor_TimePeriod*);
int		TimePeriod_cmp (struct type_Monitor_TimePeriod*,
				struct type_Monitor_TimePeriod*);

#else	/* Old-style C function prototypes */

PE                              TimePeriod_encode ();
struct type_Monitor_TimePeriod*     TimePeriod_decode ();
struct type_Monitor_TimePeriod*     TimePeriod_parse ();
int                             TimePeriod_print ();
int                             TimePeriod2seconds ();
int                             TimePeriod_free ();
int                             TimePeriod_cmp ();

#endif	/* FunctionPrototypes */


void monitor_attr_syntaxes ();
void monitor_syntaxes ();

#ifdef	__cplusplus
}
#endif

#endif
