//
// NAME
//   monitoringSupport.inc.h
//
// DESCRIPTION
//   for monitoringSupport MOC, via OSIMIS GDMO compiler
//   This class is based in the ICM/WP3/NTUA/0097
//   document. 
//
// IMPLEMENTORS
//   George Mykoniatis
//   NTUA
//   mykoniat@ektor.ntua.gr
//
// HISTORY
//   A first version was produced by 
//   Kostas Kasapakis (Alpha), Panos Georgatsos (Alpha),
//   George Mykoniatis (NTUA), Jorge Sanchez (NTUA)
//

protected:

#define MSDERIVEDGAUGETHLDHIGH    9   	// a stupid guess
#define MSDERIVEDGAUGETHLDLOW     4       // a stupid guess

// For the quality of Service Alarm
  Attr*                   	_qosAlarmGauge;
  OID                     	_qosAlarmThldOid;
  type_SMI_AlarmInfo*           _thldAlarmInfo;

  int   buildReport (int eventId, int classLevel, void*& info, Bool& freeFlag);
  // To be redefined in sub-classes
  virtual type_SMI_AlarmInfo* _thldAlarmInfo_alloc ()  { return NULL;}

  int 	status;			// Flag for the initialization
  int 	no_of_attributes;       // Holds the number of observed attributes
  observed_attr **oa_array;     // array of pointers to observed_attr 
  virtual int RemoveOAs(); 	// Deletes memory allocated by the DecomposeAttrList()
				// (Mode 1) or by the FindObservedMOs() (Mode 2)

				// Checks for consistency
  virtual int CheckConsistency() {return 0;}
  				// Starts the object
  virtual int StartUp()	{return 0;}	
  int ShutDown();		// Stops the object

// --------------------------------------------
// Functions  & variables related to the OPERATIONS 
// applied on the observed attributes
// --------------------------------------------

   double *oaval;             // Matrix containing the observed attribute values
   double result;             // Contains the result of the operation
   sumstats *stat_p;          // Pointer to a sumstats object used 
			      // for the result attribute

// --------------------------------------------
// Implemented operations
// --------------------------------------------

   void FindSum();             // Sum of the observed attributes
   void FindDiv();             // first observed attribute / second observed attribute
   void FindMean();            // Mean value of the observed attributes
   void FindProb();            // first obs.attr / second obs.attr
   void FindProd();            // first obs.attr * second obs.attr
   void FindSubstraction();    // first obs.attr - second obs.attr
   void FindSpecialSum();      // first obs.attr-second obs.attr-third obs.attr

// --------------------------------------------
// Functions related with the observed attributes
// --------------------------------------------

    void  update();            // called by the wakeup method    

// --------------------------------------------
// MO and KS redefined functions
// --------------------------------------------

protected:
    int         createRR (AVA*&, void* = NULLVD, int = -1);  
    int         deleteRR (AVA*&, void* = NULLVD, Bool = False, int = -1);  
    int   	set (CMISModifyOp, int, int, void*, AVA*&, Bool = False, int = -1);

public:
    inline int  wakeUp (char*)              
           { update(); return OK; }
