//
// NAME
//   monitoringSupportMode2.inc.h
//
// DESCRIPTION
//   for monitoringSupportMode2 MOC, via OSIMIS GDMO compiler
//   This class inherits from the monitoringSupport
//   and has the functionality to scope and filter according
//   to the two relative attributes and
//   find the observed attributes.
//
// IMPLEMENTORS
//   George Mykoniatis
//   NTUA
//   mykoniat@ektor.ntua.gr
//

private:

  int FindObservedMOs();		// Filtering and Scoping
  int CheckConsistency();		// Checks Consistency
  int StartUp();			// Starts the object
  int InitObservedAttrs();		// Creates and initilize 
					// the observed attrs
  int CheckObservedMOs();		// Checks for errors every time a wake up 
					// has happened
  int CheckFirstTime();			// Checks for errors when observation
					// is initiated
  int GetAttributes();			// Gets the baseManagedObject and
					// the attributeId + some checking

  OID		_oidObservedAttribute;
  int		_typeBaseMO;
  DN		_dnBaseMO;
  char *	_strObservedAttribute;
  MO*		_pBaseMO;
  Attr*	_pObservedAttribute;
  MO** 	_passed;			// array of observed attributes that 
					// passed the filter expression

protected:
    int  createRR(AVA*&, void* = NULLVD, int = -1);
    int  set (CMISModifyOp, int, int, void*, AVA*&, Bool = False, int = -1);

public:
    inline int  wakeUp (char*)              
           { monitoringSupport::update(); return OK; }

