//
// NAME
//   observed_attr.h
//
// DESCRIPTION
//   definition of observed_attr class. This class manipulates
//   the observed attributes. It gets the observed value
//   and starts the sumstat class for the statistics
//
// IMPLEMENTORS
//   George Mykoniatis
//   NTUA
//   mykoniat@ektor.ntua.gr
//

#include "sumdefs.h"
#include "sumstat.h"

#include "Top.h"
#include "msap.h"
#include "Error.h"
#include "Gauge.h"
#include <stdlib.h>

#include "Integer.h"
#include "iostream.h"

#include "GenericKS.h"


#ifndef _SLOA_H_
#define _SLOA_H_

#define MS_OA_GAUGE                1
#define MS_OA_COUNTER              2
#define MS_OA_SNMP		   3

class observed_attr 
{
private:

   Attr *_pvObservedMOattribute;        // Pointer to observed attribute
   int attr_flag;                       // Flag showing if the attribute
                                        // has been initialized properly
   double prev_val;                     // Previous value
                                        // (used for counter rate conversion)
   int period;                          // holds the granularity Period
   MO   	*pObservedMO;		// Pointer to observed MO
   int 		_observedAttrType;	// observed attribute type
   OID		_oidObservedAttr;	// observed attribute OID
   char*	_strObservedAttr;	// observed attribute string
   int		_gaugeType;		// observed attribute gauge type

public:

   void*    	forceGet(MO* pmo, OID oid);
   int     	initialise(MO *pMO, OID oidObsAt);

   int     	check_attr(); 		// Validates the existance of the attribute
   double  	getval_attr();		// Gets the value of the attribute 
					// without updating sumstats
   void 	print_oa();             // Displays contents

   int 		GetOAType()  	{return _observedAttrType;}
   int 		GetGType()  	{return _gaugeType;}
   int  	get_flag()      {return attr_flag;}     
   int    	get_period()    { return period; }

   observed_attr();			
   ~observed_attr();                   
};

#endif
