//
// NAME
//   probabilityEstimator.inc.h
//
// DESCRIPTION
//   for probabilityEstimator MOC, via OSIMIS GDMO compiler
//   This class is based in the ICM/WP3/NTUA/0097
//   document. 
//
// IMPLEMENTORS
//   George Mykoniatis
//   NTUA
//   mykoniat@ektor.ntua.gr
//
// HISTORY
//   A first version was produced by 
//   Kostas Kasapakis (Alpha), Panos Georgatsos (Alpha),
//   George Mykoniatis (NTUA), Jorge Sanchez (NTUA)
//

protected:

#ifndef MSDERIVEDGAUGETHLDHIGH
#define MSDERIVEDGAUGETHLDHIGH    9   	// a stupid guess
#endif
#ifndef MSDERIVEDGAUGETHLDLOW
#define MSDERIVEDGAUGETHLDLOW     4     // a stupid guess
#endif

// Variables related to the observed object 
// instance and attribute

  int          	_typeMO;
  DN           	dnMO;
  OID          	oid;

  int 	status;			// Flag for the initialization
  observed_attr *oa;     	// pointer to observed_attr 

  int          InitObservedAttr();    // Creates and initialise
                                        // the observed attrs
  int          CheckObservedMO();     // Checks the MOs for existance
                                        // every time a wake up has happened

  virtual int RemoveOAs(); 	// Deletes memory allocated 
  virtual int StartUp();	// Starts the object
  int ShutDown();		// Stops the object

// --------------------------------------------
// Functions  & variables related to the OPERATIONS 
// applied on the observed attributes
// --------------------------------------------

  double oaval;              // the observed attribute value
  buffered *buff_p;          // Pointer to a buffered object used 
			     // for the probability-result
  sumstats *stat_p;          // Pointer to a sumstats object used 
			     // for the statistical result 

// --------------------------------------------
// Functions related to the observed attributes
// --------------------------------------------

    void  update();            // called by the wakeup method    

// --------------------------------------------
// MO and KS redefined functions
// --------------------------------------------

protected:
    int         createRR (AVA*&, void* = NULLVD, int = -1);  
    int         deleteRR (AVA*&, void* = NULLVD, Bool = False, int = -1);  
    int   	set (CMISModifyOp, int, int, void*, AVA*&, Bool = False, int = -1);

public:
    inline int  wakeUp (char*)              
           { update(); return OK; }
