//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// CounterThld.h

// By George Pavlou, February 1991


#ifndef _CounterThld_h_
#define _CounterThld_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif

#ifndef _Counter_h_
#include "Counter.h"
#endif


class CounterThreshold : public CThreshold
{
protected:
    inline PE	  _encode ()		{ return CounterThreshold_encode(
					  (CounterThresholdVal*) getval()); }
    inline void*  _decode (PE pe)	{ return CounterThreshold_decode(pe); }
    inline void   _free ()		{ CounterThreshold_free(
					  (CounterThresholdVal*) getval()); }
    inline void*  _parse (char* str)	{ return CounterThreshold_parse(str); }
    inline char*  _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) CounterThreshold_print);}
    inline int	  _compare (void* v1, void* v2)
					{ return CounterThresholdVal_cmp(
					  (CounterThresholdVal*) v1,
					  (CounterThresholdVal*) v2); }
    inline void** _getnext (void* v)	{ return (void**)
				          CounterThreshold_getnext(
					  (CounterThresholdVal*) v); }
public:
    int		add (int, int, Switch);
    inline int	add (void* v)		{ return Attr::add(v); }
    int		setDefault (void*);
    Switch	check (int, int);
    inline char* getSyntax ()		{ return "CounterThreshold"; }

    inline	CounterThreshold () : CThreshold ()	{}
    inline	CounterThreshold (int level, int offset, Switch onoff)
					{ add(level, offset, onoff);
					  counter = NULL; }
};


#endif
