//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// Destination.h

// By George Pavlou, February 1991


#ifndef _Destination_h_
#define _Destination_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif

#ifndef _GEN_ARRAY_
#include "GenArray.h"
#endif


class DestinationAddress: public Attr
{
    int		 _msd;
    Bool	 _wasSet;
    Array*	 _multipleAetState;

    void	 multipleAetStateSetUp ();

protected:
    inline PE	 _encode ()		{ return DestAddress_encode(
					  (struct type_SMI_Destination*)
					  getval()); }
    inline void* _decode (PE pe)	{ return DestAddress_decode(pe); }
    inline void	 _free ()		{ DestAddress_free(
					  (struct type_SMI_Destination*)
					  getval()); }
    inline void* _parse (char* str)	{ return DestAddress_parse(str); }
    inline char* _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) DestAddress_print); }
public:
    inline int	getMsd ()		{ return _msd; }
    inline void	setMsd (int msd)	{ _msd = msd; }
    inline Bool	wasSet ()		{ return _wasSet; }
    inline Array* getMultipleAetState (){ return _multipleAetState; }
    void	multipleAetStateReset ();
    int		set (void*);

    DestinationAddress (type_SMI_Destination*);
    DestinationAddress ();
    ~DestinationAddress ();
};


#endif
