/*
 * Copyright (c) 1990 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* Error.c - error procedures */

/* By George Pavlou, February 1991 */


#include <stdio.h>

#if defined(SOLARIS2)


/*#include <ctype.h>*/

static int isSkipped(int c) {
  if (isdigit(c)) return 1;
  if (c == '+') return 1;
  if (c == '-') return 1;
  if (c == ' ') return 1;
  if (c == '#') return 1;
  if (c == '.') return 1;
  if (c == '*') return 1;
  if (c == '+') return 1;
  return 0;
}

static void safeAdvise(char* what, char* format, 
		   char* a, char* b, char* c, char* d, char* e,
		   char* f, char* g, char* h, char* i, char* j
		   ) 
{
  char* cp;
  int ii;
  char* t[10];
  int nth = -1;

  t[0] = a;
  t[1] = b;
  t[2] = c;
  t[3] = d;
  t[4] = e;
  t[5] = f;
  t[6] = g;
  t[7] = h;
  t[8] = i;
  t[9] = j;

  for (cp = format; *cp; cp++) {
    if (*cp=='%') {
      cp++;
      if (*cp=='%') {continue;}
      nth++;
      while (isSkipped(*cp)) {cp++; }
      if (*cp=='s' && t[nth]==0) {
	fprintf(stderr,"***** Warning: Attempting printf(\"%%s\", 0) -- empty string printed\n");
	t[nth] = "";
      }
    }
  }
  (void) fprintf(stderr,format,t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8],t[9]);
}

#endif /*SOLARIS2*/


/* VARARGS2 */

void  advise (what, fmt, a, b, c, d, e, f, g, h, i, j)
char  *what, *fmt, *a, *b, *c, *d, *e, *f, *g, *h, *i, *j;
{
    (void) fflush(stdout);

#if defined(SOLARIS2)
    /*Solaris 2.3 does not like NULL char*'s; convert them to "" if %s format*/
    safeAdvise(what, fmt, a, b, c, d, e, f, g, h, i, j);
#else
    (void) fprintf(stderr, fmt, a, b, c, d, e, f, g, h, i, j);
#endif
    if (what)
	(void) fputc(' ', stderr), perror(what);
    else
	(void) fputc('\n', stderr);
    (void) fflush(stderr);
}


/* VARARGS2 */

void  error (what, fmt, a, b, c, d, e, f, g, h, i, j)
char  *what, *fmt, *a, *b, *c, *d, *e, *f, *g, *h, *i, *j;
{
    (void) fprintf(stderr, "Error: ");
    advise(what, fmt, a, b, c, d, e, f, g, h, i, j);
    _exit(-1);
}
