//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// Filter.h

// By George Pavlou, February 1991


#ifndef _Filter_h_
#define _Filter_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


/*
 * the class name cannot be Filter as there is the MO::Filter() method
 * while CMISFilter is the name of the encapsulated C struct (mparm.h)
 */

class MFilter : public Attr
{
protected:
    inline PE	 _encode ()		{ return CMISFilter_encode(
					  (CMISFilter*) getval()); }
    inline void* _decode (PE pe)	{ return CMISFilter_decode(pe); }
    inline void	 _free ()		{ mfilter_free((CMISFilter*) getval());}
    inline void* _parse (char* str)	{ return str2mfilter(str); }
    inline char* _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) CMISFilter_print); }
public:
    int	set (void*);

    MFilter ();
    inline MFilter (CMISFilter* filter)	{ setval(filter); }
};


#endif
