//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// IntegerList.h

// By George Pavlou, February 1991


#ifndef _IntegerList_h_
#define _IntegerList_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class IntegerList : public Attr
{
protected:
    inline PE     _encode ()		{ return IntegerList_encode(
                                          (IntegerListVal*) getval()); }
    inline void*  _decode (PE pe)	{ return IntegerList_decode(pe); }
    inline void   _free ()		{  IntegerList_free(
                                           (IntegerListVal*) getval()); }
    inline char*  _print ()		{ return attrv2str(getval(),
                                          (PRINT_FNX) IntegerList_print); }
    inline int    _compare (void* v1, void* v2)
                                        { return IntegerListVal_cmp(
                                          (IntegerListVal*) v1,
					  (IntegerListVal*) v2); }
    inline void*  _getelem (void* v)    { return (void*) IntegerList_getelem(
					  (IntegerListVal*) v); }
    inline void** _getnext (void* v)    { return (void**) IntegerList_getnext(
					  (IntegerListVal*) v); }
public:
    inline int  addval (int val)	{ IntegerListVal* elem =
					  new IntegerListVal;
					  elem->integer = val;
					  elem->next = NULL; return add(elem); }
    inline int  rmval (int val)		{ IntegerListVal elem;
					  elem.integer = val;
					  elem.next=NULL; return remove(&elem);}

    inline      IntegerList ()		{ setval(NULL); }
    inline      IntegerList (int val)	{ addval(val); }
};


#endif
