//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// MgmtId.h

// By George Pavlou, February 1991


#ifndef _MgmtId_h_
#define _MgmtId_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class MgmtId : public Attr
{
protected:
    inline void	 _free ()		{ MID_free((MID) getval()); }
    inline char* _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) MID_print); }
    inline int	 _compare (void* v1, void* v2)
					{ return MID_cmp((MID) v1, (MID) v2); }

    inline MgmtId ()			{ setOID(oid_cpy(DEFAULT_OID)); }
    inline MgmtId (OID oid)		{ setOID(oid); }

public:
    inline OID	 getOID ()		{ MID mid = (MID) getval();
					  return mid ? mid->mid_global:NULLOID;}
    inline void  setOID (OID oid)	{ MID mid = new struct MIDentifier;
					  mid->mid_type = MID_GLOBAL;
                                          mid->mid_global = oid;
                                          setval((void *) mid); }
};


#endif
