//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// MgmtIdList.h

// By George Pavlou, February 1991


#ifndef _MgmtIdList_h_
#define _MgmtIdList_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class MgmtIdList : public Attr
{
protected:
    inline void	  _free ()		{ MIDList_free(
					  (MIDListVal*) getval()); }
    inline char*  _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) MIDList_print); }
    inline int	  _compare (void* v1, void* v2)
					{ return MIDListVal_cmp(
					 (MIDListVal*)v1, (MIDListVal*)v2);}
    inline void*  _getelem (void* v)	{ return (void*)
				          MIDList_getelem( (MIDListVal*) v); }
    inline void** _getnext (void* v)	{ return (void**)
				          MIDList_getnext( (MIDListVal*) v); }

    inline MgmtIdList ()		{ setval(NULL); }
    inline MgmtIdList (OID oid)		{ addval(oid); }

public:
    int		addval (OID oid)	{ MIDListVal *v = new MIDListVal;
					 v->midl_mid.mid_type = MID_GLOBAL;
					 v->midl_mid.mid_global = oid;
					 v->midl_next = NULL; return add(v); }
    inline int  rmval (OID oid)		{ MIDListVal elem;
					  elem.midl_mid.mid_type = MID_GLOBAL;
					  elem.midl_mid.mid_global = oid;
					  elem.midl_next = NULL;
					  return remove(&elem); }
};


#endif
