//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// ObjIdList.h

// By George Pavlou, February 1991


#ifndef _ObjIdList_h_
#define _ObjIdList_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class ObjIdList : public Attr
{
protected:
    inline PE	  _encode ()		{ return OIDList_encode(
					  (ObjIdListVal*) getval()); }
    inline void*  _decode (PE pe)	{ return OIDList_decode(pe); }
    inline void	  _free ()		{ OIDList_free(
					  (ObjIdListVal*) getval()); }
    inline void*  _parse (char* str)	{ return OIDList_parse(str); }
    inline char*  _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) OIDList_print); }
    inline int	  _compare (void* v1, void* v2)
					{ return OIDListVal_cmp(
					 (ObjIdListVal*)v1, (ObjIdListVal*)v2);}
    inline void*  _getelem (void* v)	{ return (void*)
				          OIDList_getelem( (ObjIdListVal*) v); }
    inline void** _getnext (void* v)	{ return (void**)
				          OIDList_getnext( (ObjIdListVal*) v); }
public:
    int		addval (OID oid)	{ ObjIdListVal *v = new ObjIdListVal;
					 v->oidl_oid = oid; v->oidl_next = NULL;
					  return add(v); }
    inline int  rmval (OID oid)		{ ObjIdListVal elem; elem.oidl_oid=oid;
					  elem.oidl_next = NULL;
					  return remove(&elem); }

    inline ObjIdList ()			{ setval(NULL); }
    inline ObjIdList (OID oid)		{ addval (oid); }
};


#endif
