//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// ObjectInstanceList.h

// By George Pavlou, February 1991


#ifndef _ObjectInstanceList_h_
#define _ObjectInstanceList_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class ObjectInstanceList : public Attr
{
protected:
    inline PE	  _encode ()		{ return ObjectInstanceList_encode(
					  (MNListVal*) getval()); }
    inline void*  _decode (PE pe)	{ return ObjectInstanceList_decode(pe);}
    inline void	  _free ()		{ ObjectInstanceList_free(
					  (MNListVal*) getval()); }
    inline void*  _parse (char* str)	{ return ObjectInstanceList_parse(str);}
    inline char*  _print ()		{ return attrv2str(getval(),
					 (PRINT_FNX) ObjectInstanceList_print);}
    inline int	  _compare (void* v1, void* v2)
					{ return ObjectInstanceListVal_cmp(
					 (MNListVal*)v1, (MNListVal*)v2);}
    inline void*  _getelem (void* v)	{ return (void*)
				          ObjectInstanceList_getelem(
    inline void** _getnext (void* v)	{ return (void**)
				          ObjectInstanceList_getnext(
					  (MNListVal*) v); }

public:
    inline int	addval (MN mn)		{ MNListVal *v = new MNListVal;
					  v->mnl_mn = *mn; v->mnl_next = NULL;
					  return add(v); }
    inline int  rmval (MN mn)		{ MNListVal elem; elem.mnl_mn = *mn;
					  elem.mnl_next = NULL;
					  return remove(&elem); }
    inline ObjectInstanceList ()	{ setval(NULL); }
    inline ObjectInstanceList (MN mn)	{ addval(mn); }
    inline ObjectInstanceList (MNListVal* mnlist)
					{ add(mnlist); }
};


#endif
