//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// OctetString.h

// By George Pavlou, February 1991


#ifndef _OctetString_h_
#define _OctetString_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class OctetString : public Attr
{
protected:
    inline PE	 _encode ()		{ return r_octenc((qbuf*) getval()); }
    inline void* _decode (PE pe)	{ return r_octsdec(pe); }
    inline void	 _free ()		{ qb_free((qbuf*) getval()); }
    inline char* _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) r_octprint); }

public:
    inline char* getstr ()		{ return ((qbuf*) getval()) -> qb_data;}
    inline int   getlen ()		{ return ((qbuf*) getval()) -> qb_len; }
    inline void  setstr (char* v, int l){ setval(str2qb(v, l, 1)); }

    Bool	filter (int, void*);
    Bool	filterSubstring (int, void*, Bool);

    inline	OctetString (char* v, int l) { setstr(v, l); }
    inline	OctetString (char* v)	{ setstr(v, strlen(v)); }
    inline	OctetString ()		{ setstr("", 0); }
};


#endif
