//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// Real.h

// By George Pavlou, February 1991


#ifndef _Real_h_
#define _Real_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class Real : public Attr
{
protected:
    inline PE	 _encode ()		{ return real_enc((double*) getval()); }
    inline void* _decode (PE pe)	{ return real_dec(pe); }
    inline void	 _free ()		{ free((char*) getval()); }
    inline char* _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) real_print); }
    inline int	 _compare (void* v1, void* v2)
					{ return real_cmp(
					  (double*) v1, (double*) v2); }
public:
    inline double getreal ()		{ return *(double*) getval(); }
    inline void	set (double val)	{ double* r = (double*) getval();
					  *r = val; replval(r); }
    inline int	set (void* val)		{ set(*(double*) val); return OK; }

    inline	Real ()			{ double val=0; setval(real_cpy(&val));}
    inline	Real (double val)	{ setval(real_cpy(&val)); }
};


#endif
