--
-- Copyright (c) 1990 University College London
-- All rights reserved.
--
-- Redistribution and use in source and binary forms are permitted
-- provided that the above copyright notice and this paragraph are
-- duplicated in all such forms and that any documentation,
-- advertising materials, and other materials related to such
-- distribution and use acknowledge that the software was developed
-- by the Department of Computer Science, University College London.
-- The name of the University may not be used to
-- endorse or promote products derived from this software without
-- specific prior written permission.
-- THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
-- IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
-- WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
--

-- SmiAsn.py - SMI pepsy manually augmented ASN.1 module


SMI DEFINITIONS ::=

%{
#include <stdio.h>
#ifndef	ICR1
#include <isode/isoaddrs.h>
#include <isode/pepsy/ACS-types.h>
#else
#include <isode/ll/isoaddrs.h>
#include <isode/asn1/ACS-types.h>
#endif
%}



PREFIXES build parse print

BEGIN

IMPORTS
	DistinguishedName, RDNSequence FROM IF
	AttributeId, AttributeList FROM CMIP
        AdditionalInformation FROM SMI2
	;


ObservedValue [[P ObservedValue*]] ::= CHOICE
    [[T struct ObservedValue * $ *]] << ov_type >>
    {
    integer	INTEGER [[i ov_integer]],
    real	REAL [[r ov_real]]
    }


CounterThreshold [[P CounterThresholdVal*]]
    ::= SET OF
    [[T struct CounterThresholdVal * $ *]] << ct_next >>
    SEQUENCE
    [[T struct CounterThresholdVal * $ *]]
    {
    comparisonLevel     INTEGER [[i ct_compLevel]],
    offsetValue         INTEGER [[i ct_offsetVal]],
    notificationOnOff   BOOLEAN [[b ct_notifyOnOff]]
    }


GaugeThreshold [[P GaugeThresholdVal*]]
    ::= SET OF
    [[T struct GaugeThresholdVal * $ *]] << gt_next >>
    SEQUENCE
    [[T struct GaugeThresholdVal * $ *]]
    {
    notifyLow	SEQUENCE
		[[T struct GaugeThresholdVal * $ *]]
		{
		threshold   CHOICE
			    [[T struct GaugeThresholdVal * $ *]]
			    << gt_notifyLow.nt_threshold.ov_type >>
			    {
			    integer INTEGER
				    [[i gt_notifyLow.nt_threshold.ov_integer]],
			    real    REAL
				    [[r gt_notifyLow.nt_threshold.ov_real]]
			    },
		notifyOnOff BOOLEAN [[b gt_notifyLow.nt_notifyOnOff]]
		},
    notifyHigh	SEQUENCE
		[[T struct GaugeThresholdVal * $ *]]
		{
		threshold   CHOICE
			    [[T struct GaugeThresholdVal * $ *]]
			    << gt_notifyHigh.nt_threshold.ov_type >>
			    {
			    integer INTEGER
				    [[i gt_notifyHigh.nt_threshold.ov_integer]],
			    real    REAL
				    [[r gt_notifyHigh.nt_threshold.ov_real]]
			    },
		notifyOnOff BOOLEAN [[b gt_notifyHigh.nt_notifyOnOff]]
		}
    }


TideMarkInfo [[P TideMarkVal*]] ::= SEQUENCE
    {
    currentTideMark     CHOICE
			[[T struct TideMarkVal * $ *]]
			<< tm_type >>
			{
			maxTideMark	[0] CHOICE
			    [[T struct TideMarkVal * $ *]]
			    << tm_curValue.ov_type >>
			    {
			    integer INTEGER
				    [[i tm_curValue.ov_integer]],
			    real    REAL
				    [[r tm_curValue.ov_real]]
			    },
			minTideMark	[1] CHOICE
			    [[T struct TideMarkVal * $ *]]
			    << tm_curValue.ov_type >>
			    {
			    integer INTEGER
				    [[i tm_curValue.ov_integer]],
			    real    REAL
				    [[r tm_curValue.ov_real]]
			    }
			},
    previousTideMark	CHOICE
			[[T struct TideMarkVal * $ *]]
			<< tm_type >>
			{
			maxTideMark	[0] CHOICE
			    [[T struct TideMarkVal * $ *]]
			    << tm_curValue.ov_type >>
			    {
			    integer INTEGER
				    [[i tm_curValue.ov_integer]],
			    real    REAL
				    [[r tm_curValue.ov_real]]
			    },
			minTideMark	[1] CHOICE
			    [[T struct TideMarkVal * $ *]]
			    << tm_curValue.ov_type >>
			    {
			    integer INTEGER
				    [[i tm_curValue.ov_integer]],
			    real    REAL
				    [[r tm_curValue.ov_real]]
			    }
			},
    resetTime           GeneralizedTime [[s tm_resetTime]]
    }


AETitle ::= SEQUENCE
    {
    title	OBJECT IDENTIFIER,
    qualifier	GraphicString [[s qualifier]]
    }


AETitleList ::= SET OF AETitle

Destination ::= CHOICE
    {
    singleAET		AETitle,
    multipleAET		AETitleList
    }


DestinationList ::= SEQUENCE OF AETitle


SimpleNameType [[P SimpleNameTypeVal*]] ::= CHOICE
    [[T SimpleNameTypeVal * $ *]] << sn_type >>
    {
    number	INTEGER [[i sn_number]],
    string	GraphicString [[s sn_string]] [[F sfree]]
    }


IntegerList [[P IntegerListVal*]] ::= SET OF
    [[T IntegerListVal * $ *]] << next >>
    INTEGER [[i integer]]


RealList [[P RealListVal*]] ::= SET OF
    [[T RealListVal * $ *]] << next >>
    REAL [[r real]]


IA5StringList [[P StringListVal*]] ::= SET OF
    [[T struct StringListVal * $ *]]
    IA5String [[s string]] [[F sfree]]


GraphicStringList [[P StringListVal*]] ::= SET OF
    [[T struct StringListVal * $ *]]
    GraphicString [[s string]] [[F sfree]]


PrintableStringList [[P StringListVal*]] ::= SET OF
    [[T struct StringListVal * $ *]]
    PrintableString [[s string]] [[F sfree]]


OIDList [[P ObjIdListVal*]] ::= SET OF
    [[T struct ObjIdListVal * $ *]] << oidl_next >>
    OBJECT IDENTIFIER [[O oidl_oid]]


ObjectClassList [[P MIDListVal*]] ::= SET OF
    [[T struct MIDListVal * $ *]] << midl_next >>
    CHOICE
    [[T struct MIDListVal * $ *]] << midl_mid.mid_type >>
    {
    globalForm      [0] IMPLICIT OBJECT IDENTIFIER [[O midl_mid.mid_global]],
    localForm       [1] IMPLICIT INTEGER [[i midl_mid.mid_local]]
    }


ObjectInstanceList [[P MNListVal*]] ::= SET OF
    [[T struct MNListVal * $ *]] << mnl_next >>
    CHOICE
    [[T struct MNListVal * $ *]] << mnl_mn.mn_type >>
    {
    distinguishedName       [2] IMPLICIT DistinguishedName [[p mnl_mn.mn_dn]]
                                -- [[F dn_free]] --,
    nonSpecificForm         [3] IMPLICIT OCTET STRING [[s mnl_mn.mn_nonspec]]
                                -- [[F sfree]] --,
    localDistinguishedName  [4] IMPLICIT RDNSequence [[p mnl_mn.mn_dn]]
                                -- [[F dn_free]]
    }


-- MIDentifier and MIDentifierList model the general OID/INTEGER
-- untagged choice

MIDentifier [[P MIDentifier*]] ::= CHOICE
    [[T struct MIDentifier * $ *]] << mid_type >>
    {
    globalForm      OBJECT IDENTIFIER [[O mid_global]],
    localForm       INTEGER [[i mid_local]]
    }


MIDentifierList [[P MIDListVal*]] ::= SET OF
    [[T struct MIDListVal * $ *]] << midl_next >>
    CHOICE
    [[T struct MIDListVal * $ *]] << midl_mid.mid_type >>
    {
    globalForm      OBJECT IDENTIFIER [[O midl_mid.mid_global]],
    localForm       INTEGER [[i midl_mid.mid_local]]
    }


AdministrativeState ::= ENUMERATED
{
    locked (0),
    unlocked (1),
    shuttingDown (2)
}


OperationalState ::= ENUMERATED
{
    disabled (0),
    enabled (1)
}


UsageState ::= ENUMERATED {
    idle (0),
    active (1),
    busy (2)
}


SourceIndicator ::= ENUMERATED {
    resourceOperation	(0),
    managementOperation	(1),
    unknown		(2)
}


PerceivedSeverity ::= ENUMERATED {
    indeterminate (0),
    critical (1),
    major (2),
    minor (3),
    warning (4),
    cleared (5)
}


ThresholdInfo ::= SEQUENCE
    {
    triggeredThreshold  AttributeId,
    observedValue       ObservedValue
    }


ObjectInfo ::= SEQUENCE
    {
    sourceIndicator	SourceIndicator OPTIONAL,
    attributeList	AttributeList OPTIONAL,
    additionalText	GraphicString [[s additionalText]] [[F sfree]] OPTIONAL
    }


AttrValChangeDefinition ::= SET OF
    SEQUENCE {
	attributeId	AttributeId,
        oldAttrValue	[1] ANY DEFINED BY attributeId OPTIONAL,
        newAttrValue	[2] ANY DEFINED BY attributeId
    }


AttrValChangeInfo ::= SEQUENCE {
    sourceIndicator		SourceIndicator OPTIONAL,
    attrValChangeDefinition	AttrValChangeDefinition,
    additionalText		GraphicString [[s additionalText]] [[F sfree]]
				OPTIONAL
}


AlarmInfo ::= SEQUENCE {
    probableCause       MIDentifier,
			-- ProbableCause,
    specificProblems    [1] MIDentifierList OPTIONAL,
			-- SpecificProblems OPTIONAL,
    perceivedSeverity   PerceivedSeverity,
    thresholdInfo       [4] ThresholdInfo OPTIONAL,
    monitoredAttrs	[8] AttributeList OPTIONAL,
    additionalText	GraphicString [[s additionalText]] [[F sfree]] OPTIONAL,
    additionalInformation [10] AdditionalInformation OPTIONAL
    }


END


%{

int  AEI_free (aei)
AEI aei;
{
    AEIFREE(aei);
    free((char*) aei);
    return OK;
}

%}
