//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// String.cc

// By George Pavlou, February 1991


#include <stdlib.h>
#include <string.h>
#include "msap.h"
#include "Error.h"
#include "String.h"


Bool  String::filterSubstring (int type, void* value, Bool first)
{
    static char* val;
    static int   ln;

    if (first) {
	val = (char*) get();
	ln  = strlen(val);
    }

    char *cp, *thisval = (char*) value;
    int   l,   thisln  = strlen(thisval);

    if (thisln > ln)
        return False;

    switch (type) {
    case FI_Substring_Initial:
	if (memcmp(val, thisval, thisln) == 0) {
	    val += thisln;
	    ln  -= thisln;
	    return True;
	}
	return False;

    case FI_Substring_Any:
	cp = val;
	l  = ln;
	while ((cp = (char*) memchr(cp, *thisval, l)) != NULLCP) {
	    if ((l = ln-abs(cp-val)) < thisln)
		return False;
	    if (memcmp(cp, thisval, thisln) == 0) {
		val = cp + thisln;
		ln  = l - thisln;
		return True;
	    }
	    ++cp; --l;		// to avoid an infinite loop...
	}
	return False;

    case FI_Substring_Final:
	if (memcmp(val+ln-thisln, thisval, thisln) == 0)
	    // does not need to adjust val and ln anymore...
	    return True;
	return False;

    default:
	return False;
    }
}


PE  String::_encode ()
{
    switch (_type) {
    case IA5STRING:
	return ia5s2prim((char*) getval(), strlen((char*) getval()));
    case GRAPHICSTRING:
	return gfxs2prim((char*) getval(), strlen((char*) getval()));
    case PRINTABLESTRING:
	return prts2prim((char*) getval(), strlen((char*) getval()));
    default:
	return NULLPE;
    }
}

