//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// String.h

// By George Pavlou, Saleem Bhatti, February 1991


#ifndef _String_h_
#define _String_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


// the following is due to an obscure bug of the GDMO compiler scripts
// which include String.h instead of OctetString.h

#ifndef _OctetString_h_
#include "OctetString.h"
#endif


class String : public Attr
{
protected:
#define	GRAPHICSTRING	0		/* default type */
#define IA5STRING	1
#define PRINTABLESTRING	2
    int	_type;

    PE		 _encode ();
    inline void* _decode (PE pe)        { int len; return prim2str(pe, &len); }
    inline void  _free ()               { free((char*) getval()); }
    inline void* _parse (char* str)	{ return prtparse(str); }
    inline char* _print ()		{ return attrv2str(getval(),
                                          (PRINT_FNX) strprint); }
    inline int	 _compare (void* v1, void* v2)
					{ return pstrcmp(
						(char*) v1, (char*) v2); }
public:
    Bool	filterSubstring (int, void*, Bool);

    inline int	setType (int type)	{ _type = type; return OK; }
    inline int	set (void* val)		{ setval(strdup((char*) val));
					  return OK; }

    inline	String (int type = GRAPHICSTRING)
					{ if (type != -1) {
					  _type = type; setval(strdup("")); } }
    inline	String (char* val, int type = GRAPHICSTRING)
					{ _type = type; setval(strdup(val)); }
};


#endif
