//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// TideMark.h

// By George Pavlou, February 1991


#ifndef _TideMark_h_
#define _TideMark_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif

#ifndef _Gauge_h_
#include "Gauge.h"
#endif


class TideMark : public TMark
{
    Gauge* gauge;			// associated gauge (for setDefault)

    inline void	resetTime (char** tim)	{ long secs = time((long*) 0); // now
					  UTCtime utct;
					  tm2ut(localtime(&secs), &utct);
					  *tim = strdup(gent2str(&utct)); }
protected:
    inline PE	 _encode ()		{ return TideMark_encode(
					  (TideMarkVal*) getval()); }
    inline void* _decode (PE pe)	{ return TideMark_decode(pe); }
    inline void  _free ()		{ TideMark_free((TideMarkVal*) getval()); }
    inline char* _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) TideMark_print); }
    inline int	 _compare (void* v1, void* v2)
					{ return TideMark_cmp(
					(TideMarkVal*) v1, (TideMarkVal*) v2);}
    TideMark (int);

public:
    // the following is defined because setDefault is permitted
    // but not replace(set), add and remove
    inline int	set (void*)		{ return NOTOK; }

    Switch	check (double);
    int		setDefault (void*);
    void	associateGauge (Gauge*);
    int		setType (int);
    inline char* getSyntax ()		{ return "TideMark"; }

    TideMark ();
};


class TideMarkMin : public TideMark {
public:
    inline TideMarkMin ()		: TideMark(TM_MIN) {}
};


class TideMarkMax : public TideMark {
public:
    inline TideMarkMax ()		: TideMark(TM_MAX) {}
};


#endif
