//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//


#include <stdlib.h>
#include "msap.h"
#include "Error.h"
#include "IsodeCoord.h"
#include "CmisAgent.h"
#include "OdpTestSrv.h"


main (int, char** argv)
{
    // initialise the ASN.1 syntaxes
    if (initialiseSyntaxes(NULLCP, syntaxes) == NOTOK)
	error(NULLCP, "cannot initialise syntaxes");

    // instantiate the coordinator object
    ISODECoordinator coordinator;

    // instantiate and initialise the CMIS agent object
    // the last optional True argument means single-instanced application -
    // it may be used for full location transparency
    CMISAgent agent;
    TSAPdisconnect tds;
    if (agent.initialise(1, argv, service, &tds, True) == NOTOK)
	error(NULLCP, "isode error: [%s]", TErrString(tds.td_reason));


    // create the initial managed objects through the ETC/MIB_INIT_FILE
    if (MO::initialiseMIB(MIB_INIT_FILE) == NOTOK)
	error(NULLCP, "MIB initialisation failed");

    // start listening...
#ifdef DEBUG
    advise(NULLCP, "listening...");
#endif
    coordinator.listen();
}

