//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// OdpTestSrv.h - the classes the server knows of

// By George Pavlou, July 1994


#include "Create.h"
#include "SmiSntx.h"
#include "ODP-Sntx.h"

#include "System.h"

#include "simpleStats.h"


char*	service = "ODPTEST";			// application name

#define	MIB_INIT_FILE	"mib.init.odptest"	/* MIB initialisation info */



// a table of all the MO classes this application supports -
// used to create the meta-class tree

MOClass moclasses[] =
{
// the top class and the MIT-top system

{ "top",
   Top::getClassInfo,
   Top::initialiseClass },

{ "system",
   System::getClassInfo,
   System::initialiseClass },

//  classes specific to this application i.e. ODPTEST

{ "simpleStats",
   simpleStats::getClassInfo,
   simpleStats::initialiseClass },

};

int NCLASSES = sizeof moclasses / sizeof moclasses[0];



// a table mapping notifications to specific log records -
// used to process notifications 

NotificationMapping notificationMappingTable[] =
{
{"dummy"	"eventLogRecord"}	// cannot be empty...
};

int NNOTIFICATIONS = sizeof notificationMappingTable /
			    sizeof notificationMappingTable[0];



// a table of syntaxes this application uses

VoidFunc	syntaxes[] = {
		    smi_syntaxes,
		    odp_syntaxes,
		    NULL
		};

