/*
 * Copyright (c) 1990 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* IsodeSntx.h - ISODE MO attribute and event report method declarations */

/* By George Pavlou, December 1991 */


#ifndef _ISODE_SNTX_
#define _ISODE_SNTX_


#ifndef _module_ISODE_defined_
#include "ISODE-types.h"
#endif


#ifndef FunctionPrototypes
#if defined(__STDC__) || defined(__cplusplus)
#define FunctionPrototypes
#endif
#endif

#ifdef	__cplusplus
extern "C" {
#endif


#ifdef FunctionPrototypes

PE		TProtocolClass_encode (type_ISODE_TProtocolClass*);
type_ISODE_TProtocolClass*	TProtocolClass_decode (PE);
int		TProtocolClass_print (PS, type_ISODE_TProtocolClass*, int);
void		TProtocolClass_free (type_ISODE_TProtocolClass*);
int		TProtocolClass_cmp (type_ISODE_TProtocolClass*,
				    type_ISODE_TProtocolClass*);

#else	/* Old-style C function prototypes */

PE		TProtocolClass_encode ();
struct type_ISODE_TProtocolClass*	TProtocolClass_decode ();
int		TProtocolClass_print ();
void		TProtocolClass_free ();
int		TProtocolClass_cmp ();

#endif	/* FunctionPrototypes */


void isode_attr_syntaxes ();
void isode_syntaxes ();


#ifdef	__cplusplus
}
#endif

#endif
