//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// ObjId.h

// By George Pavlou, February 1991


#ifndef _ObjId_h_
#define _ObjId_h_


#ifndef _GENERIC_ATTR_
#include "GenericAttr.h"
#endif

#ifndef _SMI_SNTX_
#include "SmiSntx.h"
#endif


class ObjId : public Attr
{
protected:
    inline PE	 _encode ()		{ return oid2prim((OID) getval()); }
    inline void* _decode (PE pe)	{ OID oid = prim2oid(pe);
					  return oid ? oid_cpy(oid) : NULLOID; }
    inline void	 _free ()		{ oid_free((OID) getval()); }
    inline char* _print ()		{ return attrv2str(getval(),
					  (PRINT_FNX) oidprint); }
    inline int	 _compare (void* v1, void* v2)
					{ return oid_cmp((OID) v1, (OID) v2); }
public:
    inline ObjId ()			{ setval(oid_cpy(DEFAULT_OID)); }
    inline ObjId (OID myoid)		{ setval(myoid); }
};


#endif
