//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// UxAttr.h - attribute declarations for the UX objects

// By Graham Knight,  May 1991

//  This file contains definitions (C++ classes) for any attributes
//  which are specific to the Unix objects


#ifndef _UX_ATTR_
#define _UX_ATTR_


#include "Time.h"


//  This attribute is derived from the Time attribute (see Time.h). It
//  differs only in that the get() routine consults
//  the system clock before returning

class UxTime : public Time
{
public:
    void*	get ();
};


//  it simply calls the Time::set() method which
//  does the appropriate initialisation and then
//  calls the equivalent method of the parent class

inline void*  UxTime::get()		{ set(); return Time::get(); }


#endif
