/* name.h - */

/*
 * $Header: /xtel/isode/isode/h/quipu/RCS/name.h,v 9.0 1992/06/16 12:23:11 isode Rel $
 *
 *
 * $Log: name.h,v $
 * Revision 9.0  1992/06/16  12:23:11  isode
 * Release 8.0
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */


#ifndef QUIPUNAME
#define QUIPUNAME

#include "isode/quipu/attr.h"


#ifndef FunctionPrototypes
#if defined(__STDC__) || defined(__cplusplus)
#define FunctionPrototypes
#endif
#endif

#ifdef  __cplusplus
extern "C" {
#endif


typedef struct ava {            /* represents AttributeValueAssertion */
    AttributeType ava_type;
    AttributeValue ava_value;
}ava
#ifndef	__cplusplus
, AVA
#endif
;

typedef struct rdncomp {        /* RDN is sequence of attribute value   */
				/* assertions                           */
				/* represents RelativeDistinguishedName */
    attrType       	rdn_at;
    attrVal      	rdn_av;
    struct rdncomp      *rdn_next;
} rdncomp, *RDN;

#define NULLRDN ((RDN) 0)
#define rdn_comp_alloc()          (RDN) smalloc(sizeof(rdncomp))

#ifdef FunctionPrototypes
RDN  rdn_comp_new (AttributeType, AttributeValue);
RDN  rdn_comp_cpy (RDN);
int  rdn_comp_print (PS, RDN, int);
RDN  str2rdn (char*);
RDN  rdn_cpy (RDN);
RDN  rdn_merge (RDN, RDN);
int  rdn_cmp (RDN, RDN);
int  rdn_print (PS, RDN, int);
int  rdn_free (RDN);
#else
RDN  rdn_comp_new ();
RDN  rdn_comp_cpy ();
int  rdn_comp_print ();
RDN  str2rdn();
RDN  rdn_cpy ();
RDN  rdn_merge ();
int  rdn_cmp ();
int  rdn_print ();
int  rdn_free ();
#endif

typedef struct dncomp {         /* DN is sequence of RDNs.              */
				/* represents RDNSequence which is      */
				/* equivalent to DistinguishedName      */
    RDN                 dn_rdn;
    struct dncomp       *dn_parent;
} dncomp, *DN;

#define NULLDN ((DN) 0)

#define dn_comp_alloc()        (DN) smalloc(sizeof(dncomp))
#define dn_comp_print(x,y,z)   if (y!=NULLDN) rdn_print(x,y->dn_rdn,z)
#define dn_comp_fill(x,y)     x -> dn_rdn = y
#define dn_comp_cmp(x,y)      ((rdn_cmp (x->dn_rdn ,y->dn_rdn) == OK) ? OK : NOTOK )

#ifdef FunctionPrototypes
DN  dn_comp_new (RDN);
DN  dn_comp_cpy (DN);
DN  dn_cpy (DN);
DN  str2dn (char*);
int dn_cmp (DN, DN);
int dn_append (DN, DN);
void dn_print (PS, DN, int);
void dn_rfc_print (PS, DN, char*);
void ufn_dn_print (PS, DN, int);
void ufn_rdn_print (PS, RDN);
int ufn_dn_print_aux (PS, DN, DN, int);
char* dn2str (DN);
char *dn2ufn (DN, int);
char *dn2rfc (DN, char*);
int dn_free (DN);
int load_oid_table (char*);
#ifndef __linux__
int ps_printf (PS, const char*, ...);
#endif
#else
DN  dn_comp_new ();
DN  dn_comp_cpy ();
DN  dn_cpy ();
DN  str2dn ();
int dn_cmp ();
int dn_append ();
void dn_print ();
void dn_rfc_print ();
void ufn_dn_print ();
void ufn_rdn_print ();
int ufn_dn_print_aux ();
char* dn2str ();
char *dn2ufn ();
char *dn2rfc ();
int dn_free ();
int load_oid_table ();
int ps_printf ();
#endif

int quipu_syntaxes ();
int standard_syntaxes ();
int string_syntaxes ();

extern int ufn_indent;

#ifdef  __cplusplus
}
#endif

#endif
