/* dsa_smux_info.h - representation of SMUX management info in quipu DSAs */

/* 
 * $Header: /home/isode-consortium/isode/src/h/quipu/RCS/dsa_smux_info.h,v 10.0 1993/02/18 20:24:37 awy Rel $
 *
 *
 * $Log: dsa_smux_info.h,v $
 * Revision 10.0  1993/02/18  20:24:37  awy
 * Release IC-R1
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */
#ifndef DSASMUXINFO
#define DSASMUXINFO

struct dsa_smux_info {
	int	  masterEntries;
	int	  slaveEntries;
	int	  cacheEntries;
	int	  readOps;
	int	  searchOps;
	int	  modifyOps;
};
#define NULL_DSA_SMUX_INFO ((struct dsa_smux_info *)0)
#define dsa_smux_info_alloc()	(struct dsa_smux_info *) smalloc (sizeof (struct dsa_smux_info))
struct dsa_smux_info * dsa_smux_info_cpy ();

struct appl_smux_info {
	int	  uptime;
	int	  inboundAssocs;
	int	  outboundAssocs;
	int	  totalIn;
	int	  totalOut;
	char	* lastIn;
	char	* lastOut;
	int	  failedOut;
};
#define NULL_APPL_SMUX_INFO ((struct appl_smux_info *)0)
#define appl_smux_info_alloc()	(struct appl_smux_info *) smalloc (sizeof (struct appl_smux_info))
struct appl_smux_info * appl_smux_info_cpy ();

struct assoc_smux_info {
	char	* remoteName;
	OID	  applProtocol;
	int	  applType;
#define SMUX_ASSOC_AGENT_INIT	0
#define SMUX_ASSOC_AGENT_RESP	1
#define SMUX_ASSOC_PEER_INIT	2
#define SMUX_ASSOC_PEER_RESP	3
	int	  duration;
};
#define NULL_ASSOC_SMUX_INFO ((struct assoc_smux_info *)0)
#define assoc_smux_info_alloc()	(struct assoc_smux_info *) smalloc (sizeof (struct assoc_smux_info))
struct assoc_smux_info * assoc_smux_info_cpy ();

struct assoc_smux_list {
	struct assoc_smux_info	* asl_info;
	struct assoc_smux_list	* asl_next;
};
#define NULL_ASSOC_SMUX_LIST ((struct assoc_smux_list *)0)
#define assoc_smux_list_alloc()	(struct assoc_smux_list *) smalloc (sizeof (struct assoc_smux_list))
struct assoc_smux_list * assoc_smux_list_cpY ();

struct full_smux_info {
	struct dsa_smux_info	* dsaInfo;
	struct appl_smux_info	* applInfo;
	struct assoc_smux_list	* assocInfoList;
};
#define NULL_FULL_SMUX_INFO ((struct full_smux_info *)0)
#define full_smux_info_alloc()	(struct full_smux_info *) smalloc (sizeof (struct full_smux_info))
struct full_smux_info * full_smux_info_cpy ();
#endif
