/* rosy.h - include file for ROSY users */

/* 
 * $Header: /home/isode-consortium/isode/src/h/ul/RCS/rosy.h,v 10.0 1993/02/18 20:22:55 awy Rel $
 *
 *
 * $Log: rosy.h,v $
 * Revision 10.0  1993/02/18  20:22:55  awy
 * Release IC-R1
 *
 */

/*
 *				  NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions of a license agreement.
 *    Consult the Preface in the User's Manual for the full terms of
 *    this agreement.
 *
 */

#ifndef	_ROSY_
#define	_ROSY_

#ifndef	_MANIFEST_
#include "isode/compat/manifest.h"
#endif
#ifndef	_GENERAL_
#include "isode/compat/general.h"
#endif

#ifndef	_RoSAP_
#include "isode/ul/rosap.h"	/* definitions for RoS-USERs */
#endif

/*  */

#include "isode/asn1/pepsy.h"

struct RyOperation {
    char   *ryo_name;		/* operation name */
    int	    ryo_op;		/* operation code */
    modtyp *ryo_arg_mod;	/* pointer to table for arguement type */
    int	    ryo_arg_index;	/* index to entry in tables */
    int	    ryo_result;		/* result possible */
    modtyp *ryo_res_mod;	/* pointer to table for result type */
    int	    ryo_res_index;	/* index to entry in tables */
    struct RyError **ryo_errors;/* errors possible */
};



struct RyError {
    char   *rye_name;		/* error name */
    int	    rye_err;		/* error code */

    modtyp *rye_param_mod;	/* pointer to table for result type */
    int	    rye_param_index;	/* index to entry in tables */
};

/*  */

struct opsblk {
    struct opsblk *opb_forw;	/* doubly-linked list */
    struct opsblk *opb_back;	/*   .. */

    short	opb_flags;	/* our state */
#define	OPB_NULL	0x0000
#define	OPB_EVENT	0x0001	/* event present */
#define	OPB_INITIATOR	0x0002	/* initiator block */
#define	OPB_RESPONDER	0x0004	/* responder block */

    int	    opb_fd;		/* association descriptor */
    int	    opb_id;		/* invoke ID */

    IFP	    opb_resfnx;		/* result vector */
    IFP	    opb_errfnx;		/* error vector */

    struct RyOperation *opb_ryo;/* entry in operation table */

    struct RoSAPindication opb_event;	/* resulting event */
    caddr_t opb_out;			/* event parameter */
    modtyp *opb_free_mod;	/* pointer to table for result type */
    int	    opb_free_index;	/* index to entry in tables */

    PE	    opb_pe;		/* for Simon */
};
#define	NULLOPB		((struct opsblk *) 0)




struct dspblk {
    struct dspblk *dsb_forw;	/* doubly-linked list */
    struct dspblk *dsb_back;	/*   .. */

    int	    dsb_fd;		/* association descriptor */
				/* NOTOK-valued is wildcard for RyWait */

    struct RyOperation *dsb_ryo;/* entry in operation table */
    
    IFP	    dsb_vector;		/* dispatch vector */
};
#define	NULLDSB		((struct dspblk *) 0)



#define	RY_RESULT	(-1)	/* distinguishes RESULTs from ERRORs */
#define	RY_REJECT	(-2)	/* distinguishes REJECTs from ERRORs */

int	RyWait ();		/* WAIT */

				/* Initiator */
int	RyStub ();		/* STUB */
#define	ROS_INTR	2	/*   invoke stub but return on interrupt */
int	RyDiscard ();		/* DISCARD */
int	RyOperation ();		/* OPERATION */
int	RyOpInvoke ();		/* INVOKE */
int	RyGenID ();		/* generate unique invoke ID */

				/* Responder */
int	RyDispatch ();		/* DISPATCH */
int	RyDsResult ();		/* RESULT */
int	RyDsError ();		/* ERROR */
int	RyDsUReject ();		/* U-REJECT */

int	RyLose ();		/* clean-up after association termination */

struct RyOperation *findopbyop (), *findopbyname ();

struct RyError *finderrbyerr (), *finderrbyname ();

int	freeopblk (), loseopblk ();
struct opsblk *newopblk (), *findopblk (), *firstopblk ();

int	freedsblk (), losedsblk ();
struct dspblk *newdsblk (), *finddsblk ();

#endif
