//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// KboardMgr.cc - keyboard manager realisation

// By George Pavlou, December 1991


#include <stdlib.h>
#include <unistd.h>
#include "msap.h"
#include "KboardMgr.h"


KeyboardMgr::KeyboardMgr ()
{
    t = 0;
    scheduleWakeUps(10, "10");
    scheduleWakeUps(60, "60");
    startListen(STDIN_FILENO);
}


KeyboardMgr::~KeyboardMgr ()
{
    stopListen(STDIN_FILENO);
    cancelWakeUps("10");
    cancelWakeUps("60");
}


int  KeyboardMgr::wakeUp (char* token)
{
    if (strcmp(token, "10") == 0) {
	t += 10;
	printf("time %d\n", t);
    }
    else
    if (strcmp(token, "60") == 0)
	printf("%d minutes\n", (t/60) + 1);

    return OK;
}


int  KeyboardMgr::readCommEndpoint (int)
{
    char c;

    while (c = getchar()) {
	putchar(c);
	if (c == '\n')
	    break;
    }
    return OK;
}
