#include <stdlib.h>
#include <stdio.h>

#include "XCoord.h"
#include "XKboardMgr.h"

#include <Xm/Xm.h>
#include <Xm/Text.h>


main (int argc, char **argv)
{
    XtAppContext appContext;
    Widget	 topLevel, keyDisplayWidget;

    // set the application context, and create widgets
    topLevel = XtVaAppInitialize (&appContext,
                                 "Example",
                                 NULL, 0, 
                                 (Cardinal*) &argc, argv,
                                 NULL, NULL);

    keyDisplayWidget = XtCreateManagedWidget("keyDisplay",
                                            xmTextWidgetClass,
                                            topLevel, 
                                            NULL, 0);

    // instantiate the coordinator
    XCoordinator    coordinator(&appContext);

    // set terminate signal handler because X will do the central listening
    // but we want the OSIMIS coordinator to catch the terminate signal
    XCoordinator::setTerminateSignalHandler();
    
    // if we set the alarm signal handler as below, then the OSIMIS
    // coordinator will handle alarm signals, if not X will do
    XCoordinator::setAlarmSignalHandler();

    // instantiate the keyboard manager knowledge source
    XKeyboardMgr keyboardMgr (keyDisplayWidget);

    // start listening...
    XtRealizeWidget (topLevel);
    XtAppMainLoop (appContext);
}
