/* Copyright (c) 1994 Institute of Computer Science, Foundation of      */
/* Research and Technology - Hellas (ICS-FORTH)                         */ 
/* All rights reserved.                                                 */      

/* Redistribution and use in source and binary forms are permitted      */
/* provided that the above copyright notice and this paragraph are      */
/* duplicated in all such forms and that any documentation, advertising */
/* materials, and other materials related to such distribution and use  */
/* acknowledge that the software was developed by the Institute of      */
/* Computer Science, Foundation of Research and Technology - Hellas.    */
/* The name of the Institute or the Foundation may not be used to       */
/* endorse or promote products derived from this software without       */
/* specific prior written permission.                                   */
/* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR       */
/* IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED       */
/* WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.  */

/* header file for location transparency mechanism using the QUIPU API */

/* Costas Stathopoulos June 1993 */

#ifndef _LOCATION_TRANSPARENCY_
#define _LOCATION_TRANSPARENCY_
#endif

#ifdef PERF_TIME
#include <sys/time.h>
#endif

#define STRINGLEN               256

/* Definitions of the various QUIPU constants we use */

#define DSCLASS                 "dsObjectClass"
#define TOP_DSCLASS             "dsTop"
#define AE_DSCLASS              "applicationEntity"
#define QUIPU_OBJECT_DSCLASS    "quipuObject"
#define ICM_AGENT_DSCLASS       "iCMManagementAgent"
#define PRES_ADD                "presentationAddress"
#define SAC                     "supportedApplicationContext"
#define OPER_STATUS             "operationalStatus"
#define ACL                     "acl"

#define PRES_ADD_SNTX		"PresentationAddress"
#define SAC_SNTX		"OID"
#define OPER_STATUS_SNTX	"caseIgnoreString"

/* Definitions of the error strings emitted in certain errors 	*/
#define	nothingfound		"Nothing found!\n"
#define	localdsaerror		"Problem with remote directory server.\n"
#define remotedsaerror		"Requested data unavailable at present.\n"
#define	duaerror		"Internal DUA error. Sorry!\n"
#define security		"You do not have the access privileges required\nto make this request!\n"
#define namerror		"Invalid directory position!\n"
#define attributerror		"Faulty data found in database!\n"
#define serviceerror		"Directory Service Error!\n"
#define updaterror		"Update Error!\n"

#define UP			'u'
#define DOWN			'd'

#define UPSTR                     "up"
#define DOWNSTR                   "down"

typedef struct dnlist {
	char		*name;
	struct dnlist	*next;
} dnlist, *DNlist;

#ifdef FunctionPrototypes

int		lt_init();
char 		*lt_str2dn(char *, char *);
struct PSAPaddr *lt_read(char *);
int     	lt_update(char *, struct PSAPaddr *, char);
DNlist 		lt_get_mp(char *);
int		lt_server_psaps(char *, struct PSAPaddr *);
int		lt_server_init(int argc, char ** argv, struct PSAPaddr *, struct TSAPdisconnect *);

#else

int             lt_init();
char            *lt_str2dn();
struct PSAPaddr *lt_read();
int     	lt_update();
DNlist 		lt_get_mp();
int             lt_server_psaps();
int		lt_server_init();

#endif

extern char	lt_oper_status;
