/* Copyright (c) 1994 Institute of Computer Science, Foundation of   	*/
/* Research and Technology - Hellas (ICS-FORTH)			     	*/
/* All rights reserved.						     	*/

/* Redistribution and use in source and binary forms are permitted   	*/
/* provided that the above copyright notice and this paragraph are   	*/
/* duplicated in all such forms and that any documentation, advertising */
/* materials, and other materials related to such distribution and use  */
/* acknowledge that the software was developed by the Institute of	*/
/* Computer Science, Foundation of Research and Technology - Hellas.	*/
/* The name of the Institute or the Foundation may not be used to	*/
/* endorse or promote products derived from this software without	*/
/* specific prior written permission.					*/
/* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR	*/
/* IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED	*/
/* WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.	*/

/* This file contains a routine that transforms from the old	*/
/* agent/host pair format to a character string for a DN	*/

/* Costas Stathopoulos August 1993 */

#include "isode/quipu/util.h"
#include "isode/quipu/common.h"
#include "isode/quipu/entry.h"
#ifndef ICR1
#include "isode/tailor.h"
#else
#include "isode/compat/tailor.h"
#endif


#ifndef _LOCATION_TRANSPARENCY_
#include "lt.h"
#endif

extern int     lt_init();
extern char	lt_local_DIT[STRINGLEN];

char * lt_str2dn(rhost, agent)
char *rhost;    /* the name of the management process */
char *agent;    /* the type of the management process' listener */
{
  static char globalName[STRINGLEN];
  char * temp;

  lt_init();

  if (rhost == NULLCP) {
    sprintf(globalName, "%s@cn=%s", lt_local_DIT, agent);
    return (globalName);
  }

  if ( *rhost == '@' )  {/* in case a DN is already there */
    rhost++;
    if ( (agent != NULLCP) && (strcmp(agent,"@") != 0) )
      sprintf(globalName, "%s-%s", rhost, agent);
    else
      sprintf(globalName, "%s", rhost);
    }
  else
    if ( (agent != NULLCP) && (strcmp(agent,"@") != 0)  )
      sprintf(globalName,"%s@cn=%s-%s", lt_local_DIT, rhost, agent);
    else
      sprintf(globalName,"%s@cn=%s", lt_local_DIT, rhost);

return(globalName);
}
