//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
/***********************************************************/
/* 
	File:	Cmisiviews.h

	Notes:	Cmis Interviews interface header file

	Author:
		James Cowan (J.Cowan@uk.ac.ucl.cs)
*/
/***********************************************************/
/* Include files */

#ifdef  __GNUG__
#include <std.h>
#elif   __cplusplus
// Sun C++ major macros conflicts with Interviews
#define _sys_sysmacros_h
#include <stdlib.h>
#include <unistd.h>
#endif

#include <stream.h>
#include <InterViews/adjuster.h>
#include <InterViews/banner.h>
#include <InterViews/border.h>
#include <InterViews/box.h>
#include <InterViews/button.h>
#include <InterViews/dialog.h>
#include <InterViews/frame.h>
#include <InterViews/glue.h>
#include <InterViews/menu.h>
#include <InterViews/message.h>
#include <InterViews/painter.h>
#include <InterViews/scroller.h>
#include <InterViews/sensor.h>
#include <InterViews/strbrowser.h>
#include <InterViews/streditor.h>
#include <InterViews/tray.h>
#include <InterViews/world.h>
#include "cmis.h"
#include "cmisclient.h"
#include "cmisresult.h"

/***********************************************************/
/* Forward references */

class Hosts_Window;
class Browser_Window;

/***********************************************************/
/* End */
/***********************************************************/


