//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
/***********************************************************/
/* 
	File:	ivhosts.h

	Notes:	Cmis Interviews host class header file

	Author:
		James Cowan (J.Cowan@uk.ac.ucl.cs)
*/
/***********************************************************/

#define XCALL_HCONNECT  1
#define XCALL_HQUIT     2

/***********************************************************/
/* Browser list */

class   Browser_list : public Ptrlist
{
public:
        Browser_list()	{}
        ~Browser_list()
        {
		delete_all();
        }

        int     vdelete(int index)
        {
        Browser_Window *browser;

                if (browser=(Browser_Window *) get(index))
                {
                        delete (Browser_Window *) browser;
                        remove(index);
                        return(TRUE);
                }
		else
                	return(FALSE);
        }
	void	delete_browser(Browser_Window *target_browser)
	{
	int	index;

		if ((index=find(target_browser)) >= 0)
			vdelete(index);
	}
	void	delete_all()
	{
                while (vdelete(0))
                        ;
	}
};

/***********************************************************/
/* Host list */

class   Host_Agent
{
        GString  _host, _agent;
public:
        Host_Agent(char *host, char *agent)
        {
                _host = host;
                _agent = agent;
        }
        char    *get_host()     {return _host;}
        char    *get_agent()    {return _agent;}
};

class   Host_list : public Ptrlist
{
public:
        Host_list()	{}
        ~Host_list()
        {
                while (vdelete(0))
                        ;
        }

        int     vdelete(int index)
        {
        Host_Agent *host_agent;

                if (host_agent=(Host_Agent *)get(index))
                {
                        delete host_agent;
                        remove(index);
                        return(TRUE);
                }
                else
                        return(FALSE);
        }
};

/***********************************************************/
/* Hosts Window Class */
/***********************************************************/

class	Hosts_Window : public Menu_Window
{
	Boolean		_done;
	Msg_line	*_msg_line;
	MenuBar		*_menu;
	StringBrowser	*_host_browser;
	Host_list	_hosts_list;
	Browser_list	_browser_list;
	Interactor	*_this_interactor;

	Interactor	*interior();
	Interactor	*commands();
	Interactor	*browser();
	Interactor	*add_vscroller(Interactor *);
	Boolean		select_host(Host_Agent **);
	void		read_hosts(GString);
	void		initialise(GString);
public:
	Hosts_Window(GString hosts_table_name)
	{
		initialise(hosts_table_name);
	}

	~Hosts_Window()
	{
		_browser_list.delete_all();
		GetWorld()->Remove(_this_interactor);
/*
		delete _menu;
		delete _host_browser;
*/
	}
	void	Xcallback(int);
	void	connect();
	void	quit();
	void	Run();
	void	Handle(Event& );
	void	delete_browser(Browser_Window *browser)
	{
		_browser_list.delete_browser(browser);
	}
	void	signal_alarm();
	void	set_alarm_on();
	void	set_alarm_off();
};

/***********************************************************/
/* End */
/***********************************************************/


