//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// EventMgr.cc - event manager realisation

// By George Pavlou, December 1991


#include <stdlib.h>
#include "msap.h"
#include "Error.h"
#include "RMIBAgent.h"
#include "EventMgr.h"


int  EventMgr::receiveEvent (char* objClass, char* objInst, char* eventType)
{
    return _agent->receiveEvent(objClass, objInst, eventType, NULLCP, this);
}


int  EventMgr::stopReceiveEvent (char* objClass, char* objInst, char* eventType)
{
    return _agent->stopReceiveEvent(objClass, objInst, eventType, NULLCP, this);
}


int  EventMgr::eventNotification (char* objClass, char* objInst,
		char* eventType, char* eventTime, Attr* eventInfo, RMIBAgent*)
{
    char* cp;

    advise(NULLCP, "EventReport - %s\ntime: %s\nclass: %s\ninst: %s\nreport: \
%s\n\n",
	eventType, eventTime, objClass, objInst, cp = eventInfo->print());
    free(cp);
    return OK;
}
