//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// RMIBManager.h - the Remote MIB Manager (provides callbacks to the agent)

// By George Pavlou, October 1992 / Thurain Tin, April 1993


#ifndef _RMIB_MANAGER_
#define _RMIB_MANAGER_

#ifndef _RMIB_RESULT_
#include "RMIBresult.h"
#endif


class RMIBAgent;

class RMIBManager
{
public:

    virtual int eventNotification (char*, char*, char*,
			char*, Attr*, RMIBAgent*);
    virtual int generalResult (CMISObjectList*, RMIBAgent*);
    virtual int singleGetResult (CMISObject*, RMIBAgent*);
    virtual int createResult (CMISObject*, RMIBAgent*);
    virtual int noTimeAssertion (RMIBAgent*);
    virtual int brokenAssociation (RMIBAgent*);

    virtual ~RMIBManager ();
};

#define NULLRMIBMANAGER ((RMIBManager*) 0)


// inline methods

inline int RMIBManager::eventNotification (char*, char*,
		char*, char*, Attr*, RMIBAgent*)
{ return NOTOK; }

inline int RMIBManager::generalResult (CMISObjectList*, RMIBAgent*)
{ return NOTOK; }

inline int RMIBManager::singleGetResult (CMISObject*, RMIBAgent*)
{ return NOTOK; }

inline int RMIBManager::createResult (CMISObject*, RMIBAgent*)
{ return NOTOK; }

inline int RMIBManager::noTimeAssertion (RMIBAgent*)
{ return NOTOK; }

inline int RMIBManager::brokenAssociation (RMIBAgent*)
{ return NOTOK; }

inline RMIBManager::~RMIBManager ()
{ }


#endif /* _RMIB_MANAGER_ */
