//
// Copyright (c) 1991 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// TestMgr.h - an asynchronous manager derived from RMIBManager

// By Thurain Tin, July 1994


#ifndef _TEST_MGR_
#define _TEST_MGR_

#ifndef _RMIB_AGENT_
#include "RMIBAgent.h"		/* includes RMIBManager.h */
#endif


class TestMgr : public KS, public RMIBManager
{
    RMIBAgent*      _agent;

public:

    int wakeUp (char*);
    int readCommEndpoint (int);

    int eventNotification (char*, char*, char*, char*, Attr*, RMIBAgent*);
    int generalResult (CMISObjectList*, RMIBAgent*);
    int singleGetResult (CMISObject*, RMIBAgent*);
    int createResult (CMISObject*, RMIBAgent*);
    int noTimeAssertion (RMIBAgent*);
    int brokenAssociation (RMIBAgent*);

    int do_operation ();

    TestMgr (RMIBAgent*);
    ~TestMgr ();
};

#endif /* _TEST_MGR_ */
