//
// Copyright (c) 1995 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// TclRMIBInit.h

// By Thurain Tin, October 1995


#ifndef _TCL_RMIB_INIT_
#define _TCL_RMIB_INIT_ 1


#include <stdlib.h>
extern "C"
{
#include "tcl.h"
#include "tk.h"
};

typedef int (*CBType)(ClientData, Tcl_Interp*, int, char**);

#define DECLARE_CALLBACK(name) \
	static int name(ClientData, Tcl_Interp*, int, char**);

#define DEFINE_CALLBACK(name) \
	static int name(ClientData clientData, \
		Tcl_Interp* interp, int argc, char** argv)

#define CALLBACK_OK return TCL_OK;
#define CALLBACK_ERROR return TCL_ERROR;


int TclRMIB_Init (Tcl_Interp*);


#endif /* _TCL_RMIB_INIT_ */
