#if defined(_files_)

extern int getNewNumber();
extern int releaseNumber(int);

#else
#define _files_
/*
 *
 * Copyright (c) 1995 Technical Research Centre of Finland.
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Id:  $
 *
 * By Kimmo Kettunen, June 1995
 */ 

#include <string.h>
#include <stdio.h> 
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#define BUFSIZE 2048
#define BUFSIZE2 256

extern char *isodetcpath;
static char *mngrslots = "slots.xmp";


int getNewNumber()
{
  int fd,n,k;
  long l;
  int res = -1;
  char buf[BUFSIZE];
  char *ptr;
  static char full_name[BUFSIZE2];

  (void) sprintf (full_name, "%s%s", isodetcpath, mngrslots); 
  fd = open(full_name,O_RDWR );
  if (fd == -1) {
    printf("getNewNumber:file opening error!!\n");
    /*Insert file creation here */
    return res;
  }
  while((n = read(fd, buf, BUFSIZE)) > 0) {
    if((ptr = strchr(buf, ':'))!= NULL) {
      *ptr = '!';
      ptr++;
      res = atoi(ptr); /*!!!!!NOTE !!!!*/
      l = (long) n;
      k = lseek(fd,-l ,SEEK_CUR);
      if (k==-1) {
	printf("getNewNumber:lseek error!!\n");
	goto exit;
      }
      if(write(fd, buf, n) != n) {
	printf("getNewNumber:file read error!!\n");
	goto exit;
      }
      goto exit;
    }
  }
  printf("getNewNumber:can't find any free slots!\n");
exit:
  close(fd);
  return res;
}

int releaseNumber(nr)
int nr;
{
    int fd,n,k;
  long l;
  int res = -1;
  char buf[BUFSIZE];
  char *ptr,*tmp;
  static char full_name[BUFSIZE2];

  (void) sprintf (full_name, "%s%s", isodetcpath, mngrslots); 
  fd = open(full_name,O_RDWR );
  if (fd == -1) {
    printf("releaseNumber:file opening error!!\n");
    /*Insert file creation here */
    return res;
  }
  while((n = read(fd, buf, BUFSIZE)) > 0) {
    ptr = buf;
    while((ptr = strchr(ptr, '!'))!= NULL) {
      tmp = ptr;
      tmp++;
      if(atoi(tmp)==nr) {
	*ptr = ':'; 
	l = (long) n;
	k = lseek(fd,-l ,SEEK_CUR);
	if (k==-1) {
	  printf("getNewNumber:lseek error!!\n");
	  goto exit;
	}
	if(write(fd, buf, n) != n) {
	  printf("getNewNumber:file read error!!\n");
	  goto exit;
	}
	res = 0;
	goto exit;
      }
      ptr++;
    }
  }
  printf("releaseNunber:tried to release free or nonexistent slot:%d!\n",nr);
exit:
  close(fd);
  return res;
}
#endif
