/*
 * Copyright (c) 1994 Technical Research Centre of Finland
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* NOTE this version has memory leak in ies structure in extra fiels !! */
/* isoentity.c - application entity titles -- sequential lookup utilities  */
/*
 * By Matti Hallivuori, Decempber 1994
 */

/* LINTLIBRARY */


#include "msap.h"
#include "mparm.h"
#include "xmsap.h"
#ifndef _TAILOR_

extern char    *isodetcpath;
extern  char *strstr(const char *, const char *);
#define isodefile(file) \
        _isodefile (isodetcpath, (file))
#endif

#define	fetch_aet	str2aet_seq
#define BUF_SIZE 256
#define BUF_SIZE2 128
struct xmpisoentity {		/* for stub directory service */
    OIDentifier ie_identifier;
    char    *ie_descriptor;
    struct PSAPaddr ie_addr;
    char instance[BUF_SIZE];
};

static char objent[BUF_SIZE];
static struct xmpisoentity ies;

/*    DATA */

static char *isoentities = "isoentities";

static FILE *servf = NULL;
static int   stayopen = 0;

static int   mask;
static int   vecp;
static char  buffer[BUF_SIZE + 1];
static char *vec[NVEC + NSLACK + 1];

struct PSAPaddr *aei2addr_stub (AEI);
int	setisoentity (int), endisoentity ();
AEI	oid2aei (OID);

/*  */


char   *_isodefile (path, file)
char   *path, *file;
{
    static char fn_buffer[BUF_SIZE2];

    isodetailor (NULLCP, 0);    /* not really recursive */

    if (*file == '/'
            || (*file == '.'
                    && (file[1] == '/'
                            || (file[1] == '.' && file[2] == '/'))))
        (void) strcpy (fn_buffer, file);
    else
        (void) sprintf (fn_buffer, "%s%s", path, file);

    return fn_buffer;

  }

int	setisoentity (f)
int	f;
{
    if (servf == NULL)
	servf = fopen (isodefile (isoentities), "r");
    else
	rewind (servf);
    stayopen |= f;

    return (servf != NULL);
}


int	endisoentity () {
    if (servf && !stayopen) {
	(void) fclose (servf);
	servf = NULL;
    }

    return 1;
}


int	_startisoentity (descriptor)
char   *descriptor;
{
    register char  *cp,  *dp;
    char   *ep;

    ep = (dp = buffer) + sizeof buffer;
    while (fgets (dp, ep - dp, servf) != NULL) {
	if (*buffer == '#')
	    continue;
	if (*dp == '\n' && dp == buffer)
	    continue;
	if (cp = index (buffer, '\n')) {
	    *cp-- = NULL;
	    if (*cp == '\\') {
		if ((dp = cp) + 1 >= ep)
		    dp = buffer;
		continue;
	    }
	}

	switch (vecp = str2vecX (buffer, vec, 5 + 1, &mask, NULL, 1)) {
	    case 3:			/* no address */
	    case 4:			/* new-style */
	    case 5:                     /* additional fields for instance */
	        break;
	    default:
		continue;
	}

	(void) sprintf (descriptor, "%s-%s", vec[0], vec[1]);
	return OK;
    }
    return DONE;
}



int	_stopisoentity (descriptor, iep)
char   *descriptor;
struct xmpisoentity *iep;
{
    register int    i;
    register struct xmpisoentity  *ie = &ies;
    OID		oid = &ie -> ie_identifier;
    struct PSAPaddr *pa = &ie -> ie_addr;
    struct PSAPaddr *pz;
    static unsigned int elements[NELEM + 1];

    bzero ((char *) ie, sizeof *ie);
    if (strcmp (vec[2], "NULL") == 0)
	elements[i = 0] = 0;
    else
	if ((i = str2elem (vec[2], elements)) <= 1)
	    return NOTOK;
    oid -> oid_elements = elements;
    oid -> oid_nelem = i;
    ie -> ie_descriptor = descriptor;

    switch (vecp) {
	case 3:		/* no address */
	    break;

	case 4:		/* new-style */
        case 5:{         /* fields for instance */
	    if (pz = str2paddr (vec[3]))
		*pa = *pz;		/* struct copy */
            if (vecp == 5) {
                int len = strlen(vec[4]);
                (void) memcpy(ie->instance,vec[4],len);
	      }
	    break;
	  }
    }
    return OK;
}
 

struct PSAPaddr *title2addr_stub (title)
PE	title;
{
    register struct xmpisoentity  *ie = &ies;
    register struct PSAPaddr   *pa;

    if (title
	    ? oid_cmp (&ie -> ie_identifier, prim2oid (title))
	    : ie -> ie_identifier.oid_nelem > 0) {
	return NULLPA;
    }
    pa = &ie -> ie_addr;
    return (pa -> pa_addr.sa_addr.ta_naddr > 0 ? pa : NULLPA);
}

struct PSAPaddr * title2agentPa(title)
PE title;
{
  struct PSAPaddr *pa;
  char *aei_title;
  if (!title) {
    return NULLPA;
  }
  aei_title =  berOID2str(title);
  if (!setisoentity (0)) {
    return NULLPA;
  }
  while (_startisoentity (objent) == OK) {
    if (vec[2]) {
      if (strcmp (vec[2], aei_title) == 0) {
        if (_stopisoentity ( objent, &ies) != OK) {
	  continue;
	}
        break;
      }
    }
  }
  (void) endisoentity ();
  pa = title2addr_stub(title);
  return pa;
}

static int strequal(str1,str2,n)
char *str1, *str2;
int n;
{
  while (n--) {
    if (*str1++ != *str2++) {
      return 0;
    }
  }
  return 1;
}

OID paddr2title(ses,net,ln)
const char *ses,*net;
int ln;
{
  struct PSAPaddr *pa;
  struct NSAPaddr *ns;
  int nl;
  char *str, *na;
  char    objent[BUF_SIZE];
  if ((!ses)  || (!net)) {
    return NULLOID;
  }
  if (!setisoentity (0)) {
    return NULLOID;
  }
  while (_startisoentity (objent) == OK) {
    if (vec[3]) {
      if (str = strstr(vec[3],ses))  {
        if (_stopisoentity ( objent, &ies) == OK) {
          pa = &ies.ie_addr;
          ns = pa->pa_addr.sa_addr.ta_addrs;
          nl = ns->na_addrlen;
          na = ns->na_address;
          if ((nl == ln) && (strequal(na,net,ln)))  {
	    break;
	  }
	}
      }
    }
  }
  (void) endisoentity ();
  return  &ies.ie_identifier;
}


int	str2aet_seq (designator, qualifier, iep)
char   *designator, *qualifier;
struct xmpisoentity *iep;
{
    char    descriptor[BUF_SIZE];
#if defined(SOLARIS) 
   if(designator && qualifier)
#endif
    (void) sprintf (objent, "%s-%s", designator, qualifier);

    if (!setisoentity (0))
	return NOTOK;
    while (_startisoentity (descriptor) == OK) {
	if (strcmp (descriptor, objent) == 0) {
	    if (_stopisoentity (objent, &ies) != OK)
		continue;
	    break;
	}
      }
    (void) endisoentity ();
  return OK;
  }

AEI	str2aei_stub (designator, qualifier)
char   *designator, *qualifier;
{
    if (fetch_aet (designator, qualifier, &ies) == NOTOK) {
	return NULLAEI;
    }
    return oid2aei (&ies.ie_identifier);
}

char   *sprintaei (aei)
AEI	aei;
{
  char *cp, *bp;
  static char buffer1[BUF_SIZE2];
  bp = cp = buffer1;

  *cp++ = '<';

  if (aei -> aei_ap_title) {
    vpushstr (cp);
    vunknown (aei -> aei_ap_title);
    vpopstr ();
    cp += strlen (cp);
  }
  (void) strcpy (cp, ">");

  return bp;
}


struct PSAPaddr *aei2addr_stub (aei)
AEI	aei;
{
    register struct xmpisoentity  *ie = &ies;
    register struct PSAPaddr   *pa;

    if (aei -> aei_ap_title
	    ? oid_cmp (&ie -> ie_identifier, prim2oid (aei -> aei_ap_title))
	    : ie -> ie_identifier.oid_nelem > 0) {
	printf("aei2addr_stub cache miss on %s \n", sprintaei (aei));

	return NULLPA;
    }
    pa = &ie -> ie_addr;
    return (pa -> pa_addr.sa_addr.ta_naddr > 0 ? pa : NULLPA);
}

char *aei2serv_stub(aei)
AEI	aei;
{
    register struct xmpisoentity  *ie = &ies;
    char *cp;

    if (aei -> aei_ap_title
	    ? oid_cmp (&ie -> ie_identifier, prim2oid (aei -> aei_ap_title))
	    : ie -> ie_identifier.oid_nelem > 0) {
	printf("aei2addr_stub cache miss on %s \n", sprintaei (aei));

	return NULL;
    }
    cp = ie -> ie_descriptor;
    return cp;
}

char *aei2pre_stub(aei)
AEI	aei;
{
    register struct xmpisoentity  *ie = &ies;
    char *cp;

    if (aei -> aei_ap_title
	    ? oid_cmp (&ie -> ie_identifier, prim2oid (aei -> aei_ap_title))
	    : ie -> ie_identifier.oid_nelem > 0) {
	fprintf(stderr,"aei2addr_stub cache miss on %s \n", sprintaei (aei));

	return NULL;
    }
    cp = ie->instance;
    return cp;
}


void fillInAddr(char** pa, char** sa, char** ta, char** na, int* nl) {
  *pa = ies.ie_addr.un_pa.pa_un_selector;
  *sa = ies.ie_addr.pa_addr.un_sa.sa_un_selector;
  *ta = ies.ie_addr.pa_addr.sa_addr.un_ta.ta_un_selector;
  *nl = ies.ie_addr.pa_addr.sa_addr.ta_addrs[0].na_un.un_na_nsap.na_nsap_addrlen;
  *na = ies.ie_addr.pa_addr.sa_addr.ta_addrs[0].na_un.un_na_nsap.na_nsap_address;
}

int aet2msd(struct type_SMI_AETitle* aet) {
  return 1;
}

