#ifndef	lint
static char *rcsid = "$Header: moperation.c,v 1.3 94/12/19 09:39:44 mha Exp $";
#endif


/* $Header: moperation.c,v 1.3 94/12/19 09:39:44 mha Exp $ */

/*
 * Copyright (c) 1994 Technical Research Centre of Finland
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* moperation.c - perform the management operations */

/*
 * By Matti Hallivuori, June 1994
 */
#include "xmsap.h"
#include "moperation.h"
#include <signal.h>
#define MP_E_MISTYPED_OPERATION			21
#define MP_E_MISTYPED_ARGUMENT			2

#define DEBUGGING 0

OID ACTUAL_OID = NULLOID;
extern int IamSun;
extern int IamAgent;
static long int oldMask;
OM_EXPORT(MP_AUTOMATIC_DECODING)
OM_EXPORT(MP_CMIS_PKG)
OM_EXPORT(MP_C_COMMUNICATIONS_ERROR)
OM_EXPORT(MP_C_CMIS_SERVICE_ERROR)
OM_EXPORT (MP_C_ENTITY_NAME)
OM_EXPORT (MP_C_ACTION_INFO)
OM_EXPORT (MP_C_ACTION_REPLY)
OM_EXPORT (MP_C_ACTION_TYPE_ID)
OM_EXPORT (MP_C_AVA)
OM_EXPORT (MP_C_DS_DN)
OM_EXPORT (MP_C_FORM1)
OM_EXPORT (MP_C_FORM2)
OM_EXPORT (MP_C_GET_INFO_STATUS)
OM_EXPORT (MP_C_PRESENTATION_ADDRESS)
OM_EXPORT (MP_C_SESSION)
OM_EXPORT (MP_C_ACTION_ERROR_INFO)
OM_EXPORT (MP_C_ERROR_INFO)
OM_EXPORT (MP_C_ATTRIBUTE)
OM_EXPORT (MP_C_ATTRIBUTE_ID)
OM_EXPORT (MP_C_ATTRIBUTE_ID_ERROR)
OM_EXPORT (MP_C_OBJECT_INSTANCE) 
OM_EXPORT (MP_C_CMIS_GET_ARGUMENT)
OM_EXPORT (MP_C_OBJECT_CLASS)
OM_EXPORT (MP_C_CONTEXT)
OM_EXPORT (MP_C_SCOPE)
OM_EXPORT (MP_C_FILTER_ITEM)
OM_EXPORT (MP_C_ACTION_ERROR)
OM_EXPORT(MP_C_LIBRARY_ERROR)
OM_EXPORT (MP_C_CMIS_ACTION_ARGUMENT)
OM_EXPORT (MP_C_CMIS_ACTION_RESULT)
OM_EXPORT (MP_C_CMIS_FILTER)
OM_EXPORT (MP_C_CMIS_CREATE_ARGUMENT)
OM_EXPORT (MP_C_CMIS_CREATE_RESULT)
OM_EXPORT (MP_C_DELETE_ERROR)
OM_EXPORT (MP_C_CMIS_DELETE_RESULT)
OM_EXPORT (MP_C_CMIS_GET_LIST_ERROR)
OM_EXPORT (MP_C_CMIS_GET_RESULT)
OM_EXPORT (MP_C_CMIS_LINKED_REPLY_ARGUMENT)
OM_EXPORT (MP_C_CMIS_SET_LIST_ERROR)
OM_EXPORT (MP_C_CMIS_SET_RESULT)
OM_EXPORT (MP_C_NAME_STRING)
OM_EXPORT (MP_C_NETWORK_ADDRESS)
OM_EXPORT (MP_C_ATTRIBUTE_ID_LIST)

OM_IMPORT (MP_C_ATTRIBUTE_ID_LIST)

OM_EXPORT (MP_C_SETOF_ATTRIBUTE)
OM_IMPORT (MP_C_SETOF_ATTRIBUTE)
OM_EXPORT (MP_C_MODIFICATION_LIST)
OM_IMPORT (MP_C_MODIFICATION_LIST)
OM_EXPORT (MP_C_SETOF_CMIS_FILTER)
OM_IMPORT (MP_C_SETOF_CMIS_FILTER)
OM_EXPORT (MP_C_SETOF_SET_INFO_STATUS)
OM_IMPORT (MP_C_SETOF_SET_INFO_STATUS)
OM_EXPORT (MP_C_SETOF_GET_INFO_STATUS)
OM_IMPORT (MP_C_SETOF_GET_INFO_STATUS)

OM_EXPORT (MP_C_SUBSTRINGS)
OM_EXPORT (MP_C_SUBSTRING)
OM_EXPORT (MP_C_CREATE_OBJECT_INSTANCE)
OM_IMPORT (MP_C_CMIS_GET_ARGUMENT)
OM_IMPORT (MP_C_DS_DN)
OM_IMPORT (MP_C_DS_RDN)
OM_IMPORT (MP_C_AVA)
OM_IMPORT (MP_C_CONTEXT)
OM_IMPORT (MP_C_SCOPE)
OM_IMPORT (MP_C_FILTER_ITEM)
OM_IMPORT(MP_C_CMIS_GET_LIST_ERROR)
OM_IMPORT (MP_C_GET_INFO_STATUS)
OM_IMPORT (MP_C_ACTION_ERROR)
OM_IMPORT (MP_C_ERROR_INFO)
OM_IMPORT (MP_C_CMIS_CREATE_ARGUMENT)
OM_IMPORT (MP_C_CMIS_CREATE_RESULT)
OM_IMPORT (MP_C_DELETE_ERROR)
OM_IMPORT (MP_C_CMIS_DELETE_RESULT)
OM_IMPORT (MP_C_CMIS_GET_LIST_ERROR)
OM_IMPORT (MP_C_CMIS_GET_RESULT)
OM_IMPORT (MP_C_CMIS_LINKED_REPLY_ARGUMENT)
OM_IMPORT (MP_C_CMIS_SET_RESULT)
OM_IMPORT (MP_C_CMIS_SET_LIST_ERROR)
OM_IMPORT (MP_C_ATTRIBUTE)
OM_IMPORT (MP_C_ATTRIBUTE_ID_ERROR)
OM_EXPORT (MP_C_ATTRIBUTE_ERROR)
OM_EXPORT (MP_C_BASE_MANAGED_OBJECT_ID)
OM_EXPORT (MP_C_COMPLEXITY_LIMITATION)
OM_EXPORT (MP_C_MISSING_ATTRIBUTE_VALUE)
OM_EXPORT (MP_C_CMIS_CANCEL_GET_ARGUMENT)
OM_EXPORT (MP_C_CMIS_EVENT_REPORT_ARGUMENT)
OM_EXPORT (MP_C_EVENT_TYPE_ID)
OM_EXPORT (MP_C_EVENT_REPLY)
OM_EXPORT (MP_C_CMIS_EVENT_REPORT_RESULT)
OM_EXPORT (MP_C_CMIS_DELETE_ARGUMENT)
OM_EXPORT (MP_C_NO_SUCH_ACTION)
OM_EXPORT (MP_C_NO_SUCH_ACTION_ID)
OM_EXPORT (MP_C_NO_SUCH_ARGUMENT)
OM_EXPORT (MP_C_NO_SUCH_EVENT_ID)
OM_EXPORT (MP_C_NO_SUCH_EVENT_TYPE)
OM_EXPORT (MP_C_CMIS_SET_ARGUMENT)
OM_EXPORT (MP_C_PROCESSING_FAILURE)
OM_EXPORT (MP_C_SET_INFO_STATUS)
OM_EXPORT (MP_C_SPECIFIC_ERROR_INFO)
OM_EXPORT (MP_C_MODIFICATION)

#include "deepen.c"  

extern xom_head xom_heads[NR_HEADS];
extern xom_ev    xom_event[NR_EVENTS];
#define missing_midP(p)		(!(p) || !(p)->mid_global)
#define missing_mnP(p)     ((!p) || (!p->mn_dn))
#define missing_mn_rdnP(p)     ((!p) || (!p->mn_dn) || \
             ((p->mn_type==MN_DN) && (!p->mn_dn->dn_rdn)))


#define null_midP(p)		(!(p)->mid_global)
#define null_mnP(p)		(!(p)->mn_dn)
#define null_mparmP(p)		(!(p)->mp_id.mid_global || !(p)->mp_val)


static int    M_Error();
static int    arg_fail(), error_fail();
static char*  op2str();


/* LINTLIBRARY */


OM_descriptor NULLDESC[] = {
   OM_NULL_DESCRIPTOR,
};

void assign_oid(oct,o)
OM_descriptor *oct;
OID o;
{
  static unsigned char str[MAX_OID_CHAR];
  static unsigned char stack[MAX_OID_NUMBER];
  static int i, m, n, o1,o2,on;
  static unsigned int *oe;
  static unsigned int j;
  oe =  &o->oid_elements[0];
  if (o == NULLOID
        || ((on = o -> oid_nelem) <= 1)
        || ((o1 = oe[0] ) > 2)
        || ((o2 = oe[1] ) > 39))
    return;

  str[0] = (char)  ( 40* o1 +  o2);
  for (i = 2,n=1;i < on;) {
    j = oe[i++] ;
    if (j<128) {
     str[n++] = (char) j;
   } else {
      m = 0;
      do {
           stack[m++] = j &0x7f;
           j >>= 7;
         } while (j);
      for(;m>1;) {
        str[n++] = (stack[--m] | 0x80);
      }
      str[n++] = stack[0];
    }
  }
  assign_byte_string(oct,(char*) str,n);
}


void assign_octet_string(oct,str)
OM_descriptor *oct;
char *str;
{
  static int len;
   len = str ? strlen(str): 0;
   if (len) {
     oct->value.string.elements = (char *) om_malloc(len);
     memcpy(oct->value.string.elements,str,len);
   } else {
     oct->value.string.elements = 0;
   }
   oct->value.string.length = len;
}  

void assign_byte_string(oct,str,len)
OM_descriptor *oct;
char *str;
int len;
{
   if (len) {
     oct->value.string.elements = (char *) om_malloc(len);
     memcpy(oct->value.string.elements,str,len);
   } else {
     oct->value.string.elements = 0;
   }
   oct->value.string.length = len;
}  

void assign_pe(oct,pe)
OM_descriptor *oct;
PE pe;
{
  static int len;
  len = pe->pe_len;
  if (len) {
    oct->value.string.elements = (char *) om_malloc(len);
    memcpy(oct->value.string.elements,(char *) pe->pe_un1.un_pe_prim,len);
  } else {
    oct->value.string.elements = 0;
  }
  oct->value.string.length = len;
}  

static void assign_typed_pe(oct,pe)
OM_descriptor *oct;
PE pe;
{
  static int len;
  switch (pe->pe_id) {
    case 1:     /* BOOLEAN */ 
    case 2:     /* INTEGER */
    case 10: {  /* ENUMERATION */
      oct->value.integer = prim2num(pe);
      break;
    }
    default: { /* all string types - this may fail if called with improper parameters*/
      len = pe->pe_len;
      if (len) {
        oct->value.string.elements = (char *) om_malloc(len);
        memcpy(oct->value.string.elements,(char *) pe->pe_un1.un_pe_prim,len);
      } else {
        oct->value.string.elements = 0;
      }
      oct->value.string.length = len;
      break;
    }
  }
  oct->syntax = pe->pe_id;
}  

MP_feature  *create_feature_list(fture1,fture2)
OM_object_identifier *fture1, *fture2;
{
MP_feature *sdesc, *desc;
MP_feature       feature_list[] = {
  {{0,0}, MP_ACTIVATE, OM_FALSE},
  {{0,0}, MP_ACTIVATE, OM_FALSE},
  {{0,0}, MP_ACTIVATE, OM_FALSE},
  {{0,0}, MP_ACTIVATE, OM_FALSE}
  };

  sdesc = desc = (MP_feature *) om_malloc(sizeof(feature_list));
  memcpy(desc,feature_list,sizeof(feature_list));
  if (fture1) {
    desc->feature = *fture1;
    desc++;
  }
  if (fture2) {
    desc->feature = *fture2;
    desc++;
  }
  desc->feature = MP_AUTOMATIC_DECODING;
  desc->request = MP_DEACTIVATE;
  return sdesc;    
}
static OM_descriptor *  create_ds_dn_obj(cnt,rdns)
int cnt;
OM_object *rdns;
{
int i;
OM_descriptor *desc;
static const OM_descriptor                ds_dn[] = {
   OM_OID_DESC(OM_CLASS, MP_C_DS_DN),
 { MP_RDNS, OM_S_OBJECT, {0, 0} },
   OM_NULL_DESCRIPTOR,
  };

   desc = (OM_descriptor *) om_malloc((cnt+2)*DSCSIZE);
   desc[0] = ds_dn[0];
   for (i=1;i<=cnt;i++) {
     desc[i] = ds_dn[1];  /* copy rdn descriptors */
     desc[i].value.object.object = rdns[i-1];
   }
   desc[cnt+1] = ds_dn[2];  /* null descriptor */
   return desc;    
}

static OM_descriptor *  create_form2_obj(aei,cnt)
AEI aei;
int cnt;
{
PE pe;
OM_descriptor *desc;
static const OM_descriptor                title2[] = {
   OM_OID_DESC(OM_CLASS, MP_C_FORM2),
 { MP_AP_TITLE_FORM2, OM_S_OBJECT_IDENTIFIER_STRING, {0, 0} },
 { MP_AE_QUALIFIER_FORM2, OM_S_INTEGER, {0, 0} },
 { MP_AP_INVOCATION, OM_S_INTEGER, {0, 0} },
 { MP_AE_INVOCATION, OM_S_INTEGER, {0, 0} },
   OM_NULL_DESCRIPTOR,
 };

   desc = (OM_descriptor *) om_malloc(sizeof(title2));
   memcpy(desc,title2,2*DSCSIZE);
   pe = aei->aei_ap_title;
   assign_pe(&desc[1], pe);
   desc[cnt+1] = title2[5];  /* null descriptor */
   return desc;    
}

/*  hack for sun - makes empty string without core in filter */
static void assign_null_string(oct)
OM_descriptor *oct;
{
  char c[2];
  c[1]=1; c[2]=0; 
  assign_byte_string(oct,c,2);
}

static unsigned char * int2berLen(int clen, int *bs )
{
  int bytes=1;
  static unsigned char c[10];

  if (clen > 127) {
    while (clen) {
      c[bytes++] = (unsigned char) (clen &0xff);
      clen = (clen >> 8);
    }
    c[0] = bytes | 0x80;
  } else {
    c[0] = (unsigned char) clen;
  }
  
  *bs = bytes;
  return c;
}

static int consPeLen(PE pe)
{
  int len=0;
  if (pe->pe_next) {
    len = len + consPeLen(pe->pe_next);
  }

  if (pe->pe_form)  {
    if (pe->pe_un1.un_pe_cons) {
      len = len + consPeLen(pe->pe_un1.un_pe_cons);
    }
  } else {
   len = len + pe->pe_len;
 }
 len = len > 124 ? len+2: len+3;  /* max length with 14 bits */
 return len;
}



void assign_ber(oct,pe)
OM_descriptor *oct;
PE pe;
{
  int end;  
  int delta;
  char* jjc = 0;
  unsigned char *c;
  if (!pe) {
    return;
  }

  if (pe->pe_len > 0) 
    end = pe->pe_len+6;
  else
    end = consPeLen(pe)+6;

  c =  (unsigned char *) om_malloc(end);  /* only one malloc  for all pe's ! */
  oct->value.string.elements = c;
  oct->value.string.length =0;            /* real length used */


  pe2mem(pe, &jjc, &delta);
  end -= delta;
  oct->value.string.length += delta;
  memcpy(&c[end], jjc, delta);
  free(jjc); 

  oct->value.string.elements = &c[end];   /* point string to first element */
}

static OM_descriptor * create_avas_obj(oid,pe)
OID oid;
PE pe;
{
OM_descriptor *desc;
static const OM_descriptor                avas[] = {
OM_OID_DESC(OM_CLASS, MP_C_AVA),
{ MP_NAMING_ATTRIBUTE_ID, OM_S_OBJECT_IDENTIFIER_STRING, {0, 0} },
{ MP_NAMING_ATTRIBUTE_VALUE,  OM_S_ENCODING_STRING /*OM_S_any*/, {0, 0} },
  OM_NULL_DESCRIPTOR,
 };
  desc = (OM_descriptor *) om_malloc(sizeof(avas));
  memcpy(desc,avas,sizeof(avas));
  assign_oid(&desc[1],oid);
  assign_typed_pe(&desc[2],pe);
  return desc;
}


static OM_descriptor *create_class_obj(obj_class,msd)
MID  obj_class;
int msd;
{
int l=1;
OM_descriptor *desc;
static const OM_descriptor                obj_cl[] = {
   OM_OID_DESC(OM_CLASS, MP_C_OBJECT_CLASS),
 { MP_GLOBAL_FORM, OM_S_OBJECT_IDENTIFIER_STRING, {0, 0} },
 { MP_LOCAL_FORM, OM_S_INTEGER, {0, 0} },
  };

   if (!obj_class) {
     return 0;
   }
     
   desc = (OM_descriptor *) om_malloc(sizeof(obj_cl));
   desc[0] = obj_cl[0];

   switch (obj_class->mid_type) {
     case MID_GLOBAL: /* global form */ {
       OID o0;
       desc[l] = obj_cl[1];
       o0 = obj_class->mid_un.mid_un_global;
       if (o0 == NULLOID) { 
/*       The connection is made using lrf defined AEI in manager */
         if (!IamAgent) {
           assign_pe(&desc[l++],xom_heads[msd].calledTitle);
	 } else {
#if 0 
	 assign_pe(&desc[l++],xom_heads[msd].calledTitle);
#else
           return 0;
#endif
	 }
       } else {
         assign_oid(&desc[l++],o0);
       }
      break;
     }
    case MID_LOCAL: /* local form */ {
      desc[l] = obj_cl[2];
      desc[l++].value.integer = obj_class->mid_un.mid_un_local;
      break;
      }
   default:{
     fprintf(stderr,"ObjectClass must be either global or local (type %d)\n", 
                    obj_class->mid_type);
      return 0;
      }
  } /* end switch */
 exit:
  desc[l] = NULLDESC[0];
  return desc;

}

static OM_descriptor  *create_attrID_obj(attrs)
MID  attrs;
{
OM_descriptor  * desc;
static const OM_descriptor                attr_id[] = {
   OM_OID_DESC(OM_CLASS, MP_C_ATTRIBUTE_ID),
 { MP_GLOBAL_FORM, OM_S_OBJECT_IDENTIFIER_STRING, {0, 0} },
 { MP_LOCAL_FORM, OM_S_INTEGER, {0, 0} }, 
  };
  desc = (OM_descriptor *) om_malloc((2+1)*DSCSIZE);
  desc[0] = attr_id[0];
  if (attrs[0].mid_type == MID_GLOBAL) {
     desc[1] =  attr_id[1];
     assign_oid(&desc[1],attrs->mid_global);
  }  else {
     desc[1] =  attr_id[2];
     desc[1].value.integer = attrs->mid_local;
  }
  desc[2] = NULLDESC[0];
  return desc;
}

static OM_descriptor  *create_attrID_obj2(parm,i)
desc_arr *parm;
int i;
{
  return create_attrID_obj(&parm[ACTION_INFO_OBJ].type.mattrs[i]);
}

static OM_descriptor * create_base_managed_object_id(class,inst)
OM_descriptor *class;
OM_descriptor *inst;
{
OM_descriptor  * desc=0;
static const OM_descriptor  base_object_id[] = {
   OM_OID_DESC(OM_CLASS, MP_C_BASE_MANAGED_OBJECT_ID),
 { MP_BASE_MANAGED_OBJECT_CLASS, OM_S_OBJECT, {0, 0} },/* MP_C_OBJECT_CLASS */
 { MP_BASE_MANAGED_OBJECT_INSTANCE, OM_S_OBJECT, {0, 0} },
   OM_NULL_DESCRIPTOR,
  };

  if ((class) && (inst)) {
    desc = (OM_descriptor *) om_malloc(sizeof(base_object_id));
    memcpy(desc,base_object_id,sizeof(base_object_id));
    desc[1].value.object.object = class;
    desc[2].value.object.object = inst;
  }
  return desc;
}

static OM_descriptor *create_limitation_obj(limitation)
CMISComplexityLimitation *limitation;
{
OM_descriptor *desc, *scope, *filter, *sync;
int l=1;
static const OM_descriptor complexity[] = {
   OM_OID_DESC(OM_CLASS, MP_C_COMPLEXITY_LIMITATION),
 { MP_SCOPE, OM_S_OBJECT, {0, 0} },  /* MP_C_SCOPE */
 { MP_FILTER, OM_S_OBJECT, {0, 0} }, /* MP_C_CMIS_FILTER */
 { MP_SYNCHRONIZATION,  OM_S_ENUMERATION, {0, 0} }, /* MP_C_CMIS_SYNC */
   OM_NULL_DESCRIPTOR,
 };
  desc = (OM_descriptor *) om_malloc(sizeof(complexity));
  desc[0] = complexity[0];
  scope = create_scope_obj(&limitation->cl_scope);
  if (scope) {
    desc[l] = complexity[1];
    desc[l++].value.object.object = scope;
  }
  filter = create_filter_obj(limitation->cl_filter);
  if (filter) {
    desc[l] = complexity[2];
    desc[l++].value.object.object = filter;
  }
  if (limitation->cl_sync) {
    desc[l] = complexity[3];
    desc[l++].value.enumeration = (limitation->cl_sync != s_bestEffort)?
                                                          MP_T_ATOMIC: 0; 
  }
  desc[l] = complexity[4];
  return desc;

}

static int  mod_value(inval)
CMISModifyOp inval;
{
int outval=0;
  switch (inval ) {
    case m_replace: {
      outval = MP_T_REPLACE;
      break;
    }
    case m_addValue: {
     outval = MP_T_ADD_VALUES;
     break;
    }
    case m_removeValue: {
      outval = MP_T_REMOVE_VALUES;
      break;
    }
    case m_setToDefault:{
      outval = MP_T_SET_TO_DEFAULT;
      break;
    }
    default: fprintf(stderr,"unkown modify operator %dn",inval);
  }
  return outval;
}


static OM_descriptor *create_modification_obj(parm,i)
desc_arr *parm;
int i;
{
int l=1;
CMISSetAttr* attr;
OM_descriptor  * desc;
static const OM_descriptor                modific[] = {
   OM_OID_DESC(OM_CLASS, MP_C_MODIFICATION),
 { MP_ATTRIBUTE_ID, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE_ID */
 { MP_ATTRIBUTE_VALUE, OM_S_ENCODING_STRING, {0, 0} },
 { MP_MODIFY_OPERATOR, OM_S_INTEGER, {0,0}},
 };
  attr = &parm[ACTION_INFO_OBJ].type.sattrs[i];
  desc = (OM_descriptor *) om_malloc(sizeof(modific)+DSCSIZE);
  desc[0] = modific[0];  /* a little bit faster than memcpy  */
  desc[l] = modific[1];
  desc[l++].value.object.object = create_attrID_obj(&attr->sa_id);
  if ((attr->sa_val) &&  (attr->sa_modify != m_setToDefault)) {
    desc[l] = modific[2];
    assign_ber(&desc[l++],attr->sa_val);
  }
  if (attr->sa_modify != m_replace) {
    desc[l] = modific[3];
    desc[l++].value.enumeration = mod_value(attr->sa_modify); 
  }    
  desc[l] = NULLDESC[0];
  return desc;
}


static OM_descriptor *create_event_type_id_obj(type)
MID type;
{
static const OM_descriptor  event_type[] = {
   OM_OID_DESC(OM_CLASS, MP_C_EVENT_TYPE_ID),
 { MP_GLOBAL_FORM, OM_S_OBJECT_IDENTIFIER_STRING, {0, 0} },
 { MP_LOCAL_FORM, OM_S_INTEGER, {0, 0} },
 };
OM_descriptor *desc;
  desc = (OM_descriptor *) om_malloc((2+1)*DSCSIZE);
  desc[0] = event_type[0];
  if (type[0].mid_type == MID_GLOBAL) {
     desc[1] =  event_type[1];
     assign_oid(&desc[1],type->mid_global);
  }  else {
     desc[1] =  event_type[2];
     desc[1].value.integer = type->mid_local;
  }
  desc[2] = NULLDESC[0];
  return desc;
}


static OM_descriptor *create_action_type_id_obj(type)
MID type;
{
static const OM_descriptor  action_type[] = {
   OM_OID_DESC(OM_CLASS, MP_C_ACTION_TYPE_ID),
 { MP_GLOBAL_FORM, OM_S_OBJECT_IDENTIFIER_STRING, {0, 0} },
 { MP_LOCAL_FORM, OM_S_INTEGER, {0, 0} },
 };
OM_descriptor *desc;
  desc = (OM_descriptor *) om_malloc((2+1)*DSCSIZE);
  desc[0] = action_type[0];
  if (type[0].mid_type == MID_GLOBAL) {
     desc[1] =  action_type[1];
     assign_oid(&desc[1],type->mid_global);
  }  else {
     desc[1] =  action_type[2];
     desc[1].value.integer = type->mid_local;
  }
  desc[2] = NULLDESC[0];
  return desc;
}

static OM_descriptor *create_action_info_obj(type,action)
MID type;
PE action;
{
static OM_descriptor *desc;
static const OM_descriptor                action_info[] = {
  OM_OID_DESC(OM_CLASS, MP_C_ACTION_INFO),
{ MP_ACTION_TYPE, OM_S_OBJECT, {0, 0} },      /* MP_C_ACTION_TYPE_ID */
{ MP_ACTION_INFO_ARG, OM_S_ENCODING_STRING, {0, 0} },
  OM_NULL_DESCRIPTOR,
  };
  desc = (OM_descriptor *) om_malloc(sizeof(action_info));
  memcpy(desc,action_info,sizeof(action_info));
  desc[1].value.object.object = create_action_type_id_obj(type);
  if (!action) { /*no MP_ACTION_INFO_ARG*/
    desc[2].type = 0;
    desc[2].syntax = 0;
  }
  else
  assign_ber(&desc[2],action);
  return desc;
}

static OM_descriptor * create_action_reply_obj(parm)
CMISParam *parm;
{
OM_descriptor *desc=0, *adesc;
static const OM_descriptor                action_reply[] = {
  OM_OID_DESC(OM_CLASS, MP_C_ACTION_REPLY),
{ MP_ACTION_TYPE, OM_S_OBJECT, {0, 0} },  /* MP_C_ACTION_TYPE_ID */
{ MP_ACTION_REPLY_INFO, OM_S_ENCODING_STRING, {0, 0} },
 };
  if (parm) {
    adesc = create_action_type_id_obj(&parm->mp_id);
    desc = create_and_fill_any_obj(action_reply,adesc,parm->mp_val);
  }
  return desc;
}

static OM_descriptor *create_event_reply_obj(reply)
CMISParam * reply;
{ 
int l=2;
OM_descriptor *desc;
static const OM_descriptor event_reply[] = {
   OM_OID_DESC(OM_CLASS, MP_C_EVENT_REPLY),
 { MP_EVENT_TYPE, OM_S_OBJECT, {0, 0} },  /* MP_C_EVENT_TYPE_ID */
 { MP_EVENT_REPLY_INFO, OM_S_ENCODING_STRING, {0, 0} },
 };
  if (!reply) {
    return 0;
  }
  desc = (OM_descriptor *) om_malloc(sizeof(event_reply)+DSCSIZE);
  memcpy(desc,event_reply,2*DSCSIZE);
  desc[1].value.object.object = create_event_type_id_obj(&reply->mp_id);
  if (reply->mp_val) {
    desc[l] = event_reply[2];
    assign_ber(&desc[l++],reply->mp_val);
  }
  desc[l] = NULLDESC[0];
  return desc;
}

static OM_descriptor *create_attrID_list_obj(parm)
desc_arr *parm;
{
int i,l=1;
OM_descriptor *desc;
static const OM_descriptor          alist[] = {
   OM_OID_DESC(OM_CLASS, MP_C_ATTRIBUTE_ID_LIST),
 { MP_ATTRIBUTE_ID, OM_S_OBJECT, {0, 0} },/* MP_C_ATTRIBUTE_ID */
 };
  desc = (OM_descriptor *) om_malloc((2+abs(parm[NATTRS_OBJ].type.intval))*DSCSIZE);
  desc[0] = alist[0];
  if (GET_NOATTRS != parm[NATTRS_OBJ].type.intval) {
    for (i=0;i<parm[NATTRS_OBJ].type.intval;i++) {
      desc[l] = alist[1];
      desc[l++].value.object.object = 
          create_attrID_obj(&parm[ACTION_INFO_OBJ].type.mattrs[i]);
    }   
  }
  desc[l] = NULLDESC[0];
  return desc;
}

static OM_descriptor *create_attr_obj(attrs)
CMISParam  *attrs;
{
OM_descriptor *desc;
static const OM_descriptor          attribute[] = {
   OM_OID_DESC(OM_CLASS, MP_C_ATTRIBUTE),
 { MP_ATTRIBUTE_ID, OM_S_OBJECT, {0, 0} },/* MP_C_ATTRIBUTE_ID */
 { MP_ATTRIBUTE_VALUE, OM_S_ENCODING_STRING, {0, 0} },
   OM_NULL_DESCRIPTOR,
 };

  desc = (OM_descriptor *) om_malloc(sizeof(attribute));
  memcpy(desc,attribute,sizeof(attribute));
  desc[1].value.object.object = create_attrID_obj(&attrs->mp_id);
  assign_ber(&desc[2],attrs->mp_val);
  return desc;
}

static OM_descriptor *create_attr_obj2(parm,i)
desc_arr *parm;
int i;
{
  CMISParam  *attrs;
  switch (parm[ATTRS_PAR].valtype) {
    case GETVAL: {
      attrs = &parm[ATTRS_PAR].type.gattrs[i].ga_ava;
      break;
    }
    case SETVAL: {
      attrs = &parm[ATTRS_PAR].type.sattrs[i].sa_ava;
      break;
    }
    case ATRVAL: {
      attrs = &parm[ATTRS_PAR].type.attrs[i];
      break;
    }
    default:;
  }
  return create_attr_obj(attrs);
}

static OM_descriptor * create_scope_obj(Cscope)
CMISScope* Cscope;
{
OM_descriptor *desc;
static const OM_descriptor                scope[] = {
   OM_OID_DESC(OM_CLASS, MP_C_SCOPE),
 { MP_NAMED_NUMBERS, OM_S_INTEGER, {0, 0} },
 { MP_INDIVIDUAL_LEVELS, OM_S_INTEGER, {0, 0} },
 { MP_BASE_TO_NTH_LEVEL, OM_S_INTEGER, {0, 0} },
  };
   if (Cscope) {
     desc = (OM_descriptor *) om_malloc(sizeof(scope));
     desc[0] = scope[0];
     switch (Cscope->sc_type) {
        case Sc_BaseObject: {
          desc[1] = scope[1];
          desc[1].value.enumeration = MP_T_BASE_OBJECT;
	  break;
	}
        case Sc_FirstLevel: {
          desc[1] = scope[1];
          desc[1].value.enumeration = MP_T_FIRST_LEVEL_ONLY;
	  break;
	}
        case Sc_WholeSubtree: {
          desc[1] = scope[1];
          desc[1].value.enumeration = MP_T_WHOLE_SUBTREE;
	  break;
	}
        case Sc_IndividualLevel: {
          desc[1] = scope[2];
          desc[1].value.integer = Cscope->sc_level;
          break;
	}
        case Sc_BaseToNthLevel: {
          desc[1] = scope[3];
          desc[1].value.integer = Cscope->sc_level;
          break;
	}
        default: fprintf(stderr,"unkown scope\n");
      }
    desc[2] = NULLDESC[0];
    } else {
      desc = 0;
    }
   return desc;
}

static OM_descriptor * build_ds_rdn_obj(rdn)
RDN rdn;
{ 
  OM_descriptor *desc;
  OM_descriptor *new_avas[2];
  attrType atp;
  void *pv;
  PE pe;

  atp = rdn->rdn_at; 
  pv = rdn->rdn_av.av_struct;
  pe = get_syntax_table(rdn->rdn_av.av_syntax)->s_encode(pv); /* do not free*/
  new_avas[0] =  create_avas_obj(atp->oa_ot.ot_oid,pe);
  desc = create_ds_rdn_obj2(1,&new_avas[0],0); /* lifetime mem management */
  return desc;
}

static OM_descriptor * build_ds_dn_obj(dn)
DN dn;
{
int l = 0;
DN r0;
RDN rdn;
OM_descriptor *desc;
static const OM_descriptor                ds_dn[] = {
   OM_OID_DESC(OM_CLASS, MP_C_DS_DN),
 { MP_RDNS, OM_S_OBJECT, {0, 0} },
   OM_NULL_DESCRIPTOR,
  };
  r0 = dn;
  while (r0) {
    r0 = r0->dn_parent;
    l ++;
  }
  if (l== 0) {
    return 0;
  }
  desc = (OM_descriptor *) om_malloc((l+2)*DSCSIZE);
  desc[0] = ds_dn[0];
  l = 1;
  while (dn) {
     desc[l] = ds_dn[1];
     rdn = dn->dn_rdn;
     desc[l++].value.object.object = build_ds_rdn_obj(rdn);
     dn = dn->dn_parent;
  }
  desc[l] = ds_dn[2];
  return desc;
}


static OM_descriptor * build_instance_obj(dn,t)
DN dn;
int t;
{
int type, l = 0;
RDN rdn;
DN d0;
OM_descriptor *desc;
static const OM_descriptor                instance[] = {
OM_OID_DESC(OM_CLASS, MP_C_OBJECT_INSTANCE),
{ MP_DISTINGUISHED_NAME, OM_S_OBJECT, {0, 0 /*ds_dn*/} },
{ MP_LOCAL_DN, OM_S_OBJECT, {0, 0 /*ds_rdn*/} },
{ MP_NON_SPECIFIC_FORM, OM_S_OCTET_STRING, {0, 0} },
};

  d0 = dn;
  while (d0) {
    d0 = d0->dn_parent;
    l ++;
  }

  if (l== 0) {
    return 0;
  }
  type = (t==MN_DN)? 1:2;
  desc = (OM_descriptor *) om_malloc((l+2)*DSCSIZE);
  desc[0] = instance[0];
  l = 1;
  if (t == MN_DN) {
    desc[l] = instance[type];
    desc[l++].value.object.object = build_ds_dn_obj(dn); /* 0 or 1 */
  } else {
    desc[l] = instance[type];
    desc[l++].value.object.object = build_ds_dn_obj(dn);
}
  desc[l] = NULLDESC[0];

  return desc;
}

static OM_descriptor *create_instance_obj(obj_inst,msd)
MN   obj_inst;
int msd;
{
int p1, l=1;
RDN rdn;
DN dn;
OM_descriptor *desc=0;
static const OM_descriptor instance[] = {
OM_OID_DESC(OM_CLASS, MP_C_OBJECT_INSTANCE),
{ MP_DISTINGUISHED_NAME, OM_S_OBJECT, {0, 0 /*ds_dn*/} },
{ MP_LOCAL_DN, OM_S_OBJECT, {0, 0 /*ds_rdn*/} },
{ MP_NON_SPECIFIC_FORM, OM_S_OCTET_STRING, {0, 0} },
};
  if ((obj_inst) && (dn = obj_inst -> mn_dn)) {
    rdn = dn->dn_rdn;
    p1 = obj_inst -> mn_type;
  } else {
    goto exit;
  }
  switch (p1) {
    case MN_DN: /* distinguishedName */ {
      if (rdn != 0) {
        return build_instance_obj(dn,MN_DN);
      } else {
        goto exit;
      }      
      break;
    }     
    case MN_NONSPEC: /* nonSpecificForm */  {
      char *ch, *ch2, *c;
      c = obj_inst -> mn_nonspec;
      if (string_defined(c)) {
        desc = (OM_descriptor *) om_malloc(3*DSCSIZE);
        desc[0] =instance[0];
        desc[l] = instance[3];
        assign_octet_string(&desc[l++],c);
      } else {
        goto exit;
      }
      break;
    }
    case MN_LOCALDN: /* localDistinguishedName */  {  
       if (rdn != 0) {
          return build_instance_obj(dn,MN_LOCALDN);
       } else {
/*       If there is an  AVA in isoentites place it here.
 *       The root instance should be MN_DN, but Osimis things otherwise..
 */
         desc = (OM_descriptor *) om_malloc((1+2)*DSCSIZE);
         desc[0] = instance[0];
         if (xom_heads[msd].ds_rdn == 0) {
           OM_descriptor *dummy[2];
           desc[l] = instance[1];
           desc[l++].value.object.object = create_ds_dn_obj(0,dummy);
         } else {
           OM_descriptor *rdn[2];
           rdn[0] = xom_heads[msd].ds_rdn;
           desc[l] = instance[1]; 
           desc[l++].value.object.object = create_ds_dn_obj(1,rdn); 
	 }
       }
     break;
     }
     default:{
        advise (NULLCP, "ObjectInstance %s%d", PEPY_ERR_INVALID_CHOICE,  p1);
        goto exit;
      }
   }
   if (desc != 0) {
     desc[l] = NULLDESC[0];
   } 
 exit:
   return desc;
}


static OM_descriptor *create_no_such_action_id_obj(parm,msd)
CMISNoSuchArgument * parm;
int msd;
{
int l=1;
OM_descriptor *desc, *object;
static const OM_descriptor  no_such_action_id[] = {
OM_OID_DESC(OM_CLASS, MP_C_NO_SUCH_ACTION_ID),
 { MP_MANAGED_OBJECT_CLASS, OM_S_OBJECT, {0, 0} },  /* MP_C_OBJECT_CLASS */
 { MP_ACTION_TYPE, OM_S_OBJECT, {0, 0} },  /* MP_C_ACTION_TYPE_ID */
 };
  desc = (OM_descriptor *) om_malloc(sizeof(no_such_action_id)+DSCSIZE);
  desc[0] = no_such_action_id[0];
  object =  create_class_obj(&parm->nsa_class,msd);
  if (object) {
    desc[l] = no_such_action_id[1];
    desc[l++].value.object.object = object;
  }
  object = create_action_type_id_obj(&parm->nsa_type);
  if (object) {
    desc[l] = no_such_action_id[2];
    desc[l++].value.object.object = object;
  } else {
    fprintf(stderr,"Action type is mandatory in NoSuchActionId \n");
  }
  desc[l] = NULLDESC[0];   
  return desc;
}

static OM_descriptor * create_no_such_action_obj(info,msd)
CMISNoSuchArgument *info;
int msd;
{
static OM_descriptor *desc1, *desc2;
static const OM_descriptor   no_such_action[] = {
  OM_OID_DESC(OM_CLASS, MP_C_NO_SUCH_ACTION),
{ MP_MANAGED_OBJECT_CLASS, OM_S_OBJECT, {0, 0} },  /* MP_C_OBJECT_CLASS */
{ MP_ACTION_TYPE, OM_S_OBJECT, {0, 0} },  /* MP_C_ACTION_TYPE_ID */
  OM_NULL_DESCRIPTOR,
 };
  desc1 = create_class_obj(&info->nsa_class,msd);
  desc2 = create_action_type_id_obj(&info->nsa_type);
  return  create_and_fill_2obj_obj(no_such_action, desc1,desc2);
}

static OM_descriptor *create_no_such_argument(parm,msd,op)
CMISNoSuchArgument * parm;
int msd,op;
{
int l=1;
OM_descriptor *desc;
static const OM_descriptor  no_such_argument[] = {
OM_OID_DESC(OM_CLASS, MP_C_NO_SUCH_ARGUMENT),
 { MP_ACTION_ID, OM_S_OBJECT, {0, 0} },  /* MP_C_NO_SUCH_ACTION_ID */
 { MP_EVENT_ID, OM_S_OBJECT, {0, 0} },  /* MP_C_NO_SUCH_EVENT_ID */
   OM_NULL_DESCRIPTOR,
 };
  desc = (OM_descriptor *) om_malloc(sizeof(no_such_argument));
  desc[0] = no_such_argument[0];
  if (M_ACTIONC == op) {
    desc[1] = no_such_argument[1];
    desc[1].value.object.object = create_no_such_action_id_obj(parm, msd);
  } else {
    desc[1] = no_such_argument[2];
    desc[1].value.object.object = create_no_such_event_id_obj(parm,msd);
  }
  desc[2] = no_such_argument[3];   
  return desc;
}

OM_descriptor * create_context_obj(sync,limit,mode,pri,pa,aei,msd)
int sync, limit, mode, pri,msd;
struct PSAPaddr *pa;
AEI aei;
{
int l=4;
OM_descriptor *desc;
static const OM_descriptor            ctx[] = {
OM_OID_DESC(OM_CLASS, MP_C_CONTEXT),
 { MP_ASYNCHRONOUS, OM_S_BOOLEAN, {OM_TRUE, 0}},
 { MP_MODE, OM_S_ENUMERATION, {MP_T_CONFIRMED, 0} },
 { MP_PRIORITY, OM_S_ENUMERATION, {MP_T_MEDIUM, 0} },
 { MP_REPLY_LIMIT, OM_S_INTEGER, {0, 0} },
 { MP_RESPONDER_ADDRESS, OM_S_OBJECT, {0, 0} }, /*  mp_c_address */
 { MP_RESPONDER_TITLE, OM_S_OBJECT, {0, 0} },  /*  mp_c_title */
   OM_NULL_DESCRIPTOR,
  };

   desc = (OM_descriptor *) om_malloc(sizeof(ctx));
   memcpy(desc,ctx,4*DSCSIZE);
   if (sync == FALSE) {
     desc[1].value.boolean = OM_FALSE;
   }
   if (mode != MP_T_CONFIRMED) {
     desc[2].value.enumeration = MP_T_NON_CONFIRMED;
   }
   if ((pri !=MP_T_MEDIUM) && ((pri == MP_T_LOW) || (pri == MP_T_HIGH))) {
     desc[3].value.enumeration = pri;
   }
   if (limit >0) {
    desc[l] = ctx[4];
    desc[l++].value.integer = limit;
   }
   if (pa != NULLPA) {
    desc[l] = ctx[5];
    desc[l++].value.object.object = pa2xomAddress(pa,aei);
   } else {
     if (msd>0) {
       desc[l] = ctx[5];
       desc[l++].value.object.object =  msd>NR_HEADS ?
                                  xom_event[msd-NR_HEADS].paddr:
                                  managerAddress(msd);
     }
   }
   if (aei != NULLAEI) {
    desc[l] = ctx[6];
    desc[l++].value.object.object = create_form2_obj(aei,1);
   } 
   desc[l] = ctx[7];
   return desc;
}

static OM_descriptor * create_substring_obj(str)
CMISFilterSubstrings *str;
{
int l=1;
OM_descriptor *desc;
static const OM_descriptor                sub[] = {
   OM_OID_DESC(OM_CLASS, MP_C_SUBSTRING),
 { MP_ATTRIBUTE_ID, OM_S_OBJECT, {0, 0} },
 { MP_SUBSTRING, OM_S_ENCODING_STRING, {0, 0} }, 
   OM_NULL_DESCRIPTOR,
  };

  desc = (OM_descriptor *) om_malloc(sizeof(sub));
  desc[0] = sub[0];
  desc[l] = sub[1];
  desc[l++].value.object.object = create_attrID_obj(&str->fi_sub_attrid);
  desc[l] = sub[2];
  if (!str->fi_sub_string) {
    assign_null_string(&desc[l++]);
  } else {
    assign_ber(&desc[l++],str->fi_sub_string);
  }
  desc[l] = sub[3];  
  return desc;
}

static OM_descriptor * create_substrings_obj(str)
CMISFilterSubstrings *str;
{
int l=1;
CMISFilterSubstrings *this;
OM_descriptor *desc;
OM_descriptor                sub_str[] = {
   OM_OID_DESC(OM_CLASS, MP_C_SUBSTRINGS),
 { MP_INITIAL_SUBSTRING, OM_S_OBJECT, {0, 0} },
 { MP_ANY_SUBSTRING, OM_S_OBJECT, {0, 0} }, 
 { MP_FINAL_SUBSTRING, OM_S_OBJECT, {0, 0} },
   OM_NULL_DESCRIPTOR,
  };
  desc = (OM_descriptor *) om_malloc(sizeof(sub_str));
  desc[0] = sub_str[0];
  switch (str->fi_sub_type) {
    case  FI_Substring_Initial: {
      desc[l] = sub_str[1];
      break;
    }
    case FI_Substring_Any: { 
      desc[l] = sub_str[2];
      break;
    }
    case FI_Substring_Final: {
      desc[l] = sub_str[3];
      break;
    }
  }  /* subtype */
  desc[l++].value.object.object = create_substring_obj(str);
  desc[l] = sub_str[4];
  return desc;
}

static OM_descriptor * create_filter_item_obj(item)
CMISFilterItem *item;
{
int l=1,nstr=0;
CMISParam *par;
CMISFilterSubstrings *this;
OM_descriptor *desc;
static const OM_descriptor                filter_item[] = {
   OM_OID_DESC(OM_CLASS, MP_C_FILTER_ITEM),
 { MP_EQUALITY, OM_S_OBJECT, {0, 0} },
 { MP_SUBSTRINGS, OM_S_OBJECT, {0,0}},
 { MP_GREATER_OR_EQUAL, OM_S_OBJECT, {0,0}},
 { MP_LESS_OR_EQUAL, OM_S_OBJECT, {0,0}},
 { MP_PRESENT, OM_S_OBJECT, {0,0}},
 { MP_SUBSET_OF, OM_S_OBJECT, {0,0}},
 { MP_SUPERSET_OF, OM_S_OBJECT, {0,0}},
 { MP_NON_NULL_SET_INTERSECTION, OM_S_OBJECT, {0,0}}, 
   OM_NULL_DESCRIPTOR,
   OM_NULL_DESCRIPTOR,
   OM_NULL_DESCRIPTOR,
  };
   if (item->fi_type == FI_Substrings)
      for (this = item->fi_substrings;this;this = this->fi_sub_next ) {
      nstr++;
      }
   else
      nstr = 1;
   desc = (OM_descriptor *) om_malloc(nstr*DSCSIZE+sizeof(filter_item));
   desc[0] = filter_item[0];
   par = &(item->fi_un.fi_un_attr);
   switch (item->fi_type ) {
     case  FI_Equality: {
       desc[l] = filter_item[1];
       desc[l++].value.object.object = create_attr_obj(par); /*NOTE */
       break;
     } 
     case FI_Substrings: {
       this = item->fi_un.fi_un_substrings;
       for (this = item->fi_substrings;this;this = this->fi_sub_next ) {
         desc[l] = filter_item[2];
         desc[l++].value.object.object = create_substrings_obj(this);
       } /* for */
       break;
     } /* fi_substrings */
     case  FI_GreaterOrEqual: {
       desc[l] = filter_item[3];
       desc[l++].value.object.object = create_attr_obj(par);
       break;
     }
     case  FI_LessOrEqual: {
       desc[l] = filter_item[4];
       desc[l++].value.object.object = create_attr_obj(par); /*NOTE */ 
       break;
     }
     case  FI_Present:  {
       desc[l] = filter_item[5];
       desc[l++].value.object.object = create_attrID_obj(&par->mp_id); /*NOTE */ 
       break;
     }
     case  FI_SubsetOf:  {
       desc[l] = filter_item[6];
       desc[l++].value.object.object = create_attr_obj(par); /*NOTE */ 
       break;
     }
     case FI_SupersetOf:  {
       desc[l] = filter_item[7];
       desc[l++].value.object.object = create_attr_obj(par); /*NOTE */ 
       break;
     }
     case FI_NonNullSetIntersect:  {
       desc[l] = filter_item[8];
       desc[l++].value.object.object = create_attr_obj(par); /*NOTE */ 
       break;
     }
  } /* outer case */
  desc[l] = filter_item[9];
  return desc;
}

int countStr(parm)
CMISFilter * parm;
{
  CMISFilter * this;
  int i=0;
  switch (parm ->flt_type) {
    case Filter_Item:
    case Filter_Not: {
    return 1;
    }
    case Filter_And:
    case Filter_Or: {
       for (this = parm->flt_filter/**/;this; this = this -> flt_next ) {
         i++;
       }
       return i;
     }
    default:
     return 1;
  } /* end case */
}

static OM_descriptor * create_filter_obj(parm)
CMISFilter * parm;
{
int l=1,i=1,nstr,andOror = 0;
CMISFilter * this;
OM_descriptor *desc = 0, *sdesc = 0;
static const OM_descriptor                result[] = {
   OM_OID_DESC(OM_CLASS, MP_C_CMIS_FILTER),
 { MP_ITEM, OM_S_OBJECT, {0, 0} },  /* MP_C_FILTER_ITEM */
 { MP_AND, OM_S_OBJECT, {0, 0} },   /* MP_C_CMIS_FILTER */
 { MP_OR, OM_S_OBJECT, {0, 0} },    /* MP_C_CMIS_FILTER */
 { MP_NOT, OM_S_OBJECT, {0, 0} },   /* MP_C_CMIS_FILTER */
   OM_NULL_DESCRIPTOR,
 };
static OM_descriptor                set_filt[] = {
   OM_OID_DESC(OM_CLASS, MP_C_SETOF_CMIS_FILTER),
   { MP_FILTER, OM_S_OBJECT, {0,0} },
   { MP_OR, OM_S_OBJECT, {0, 0} },
   OM_NULL_DESCRIPTOR,
 };

   if (parm == NULL) {
     goto exit;
   }
   nstr = countStr(parm);
   desc = (OM_descriptor *) om_malloc(nstr*DSCSIZE+sizeof(result));
   /*desc = (OM_descriptor *) om_malloc(sizeof(result));*/
   desc[0] = result[0];
   /*sdesc[0] = set_filt[0];*/
   switch (parm ->flt_type) {
     case Filter_Item: { /* item */
       desc[l] = result[1];
       desc[l++].value.object.object = 
                         create_filter_item_obj(parm->flt_item);
       break;
     }
     case Filter_And: { /* and */
       andOror = MP_AND;
       for (this = parm->flt_filter;this; this = this -> flt_next ) {
         desc[l] = result[2];
         desc[l++].value.object.object = create_filter_obj(this);
       }
       break;
     }
     case Filter_Or: { /* or */
       andOror = MP_OR;
       for (this = parm->flt_filter;this; this = this -> flt_next ) {
         desc[l] = result[3];
         desc[l++].value.object.object = create_filter_obj(this);
       }
       break;
     }
     case Filter_Not: { /* not */
       this = parm->flt_filter;
       desc[l] = result[4];
       desc[l++].value.object.object = create_filter_obj(this);
       break;
     }
     default: {
       fprintf(stderr,"invalid filter type %d\n",parm ->flt_type);
       desc = NULL;
       goto exit;
     }
   } /* end case */

   desc[l] = result[5];
   if(andOror == MP_OR)
     desc = deepen(desc, FILTER_OR,nstr*DSCSIZE+sizeof(result),
		   nstr*DSCSIZE+sizeof(set_filt));
   if(andOror == MP_AND)
     desc = deepen(desc, FILTER_AND,nstr*DSCSIZE+sizeof(result),
		   nstr*DSCSIZE+sizeof(set_filt));
 exit:
   return desc;
}

static int cmiserr2err(ercode)
CMISErrors /*int*/ ercode;
{
  switch (ercode) {
    case m_noSuchObjectClass: return MP_E_NO_SUCH_OBJECT_CLASS;
    case m_noSuchObjectInstance: return MP_E_NO_SUCH_OBJECT_INSTANCE;
    case m_accessDenied: return MP_E_ACCESS_DENIED;
    case m_syncNotSupported: return MP_E_SYNCHRONIZATION_NOT_SUPPORTED;
    case m_invalidFilter: return MP_E_INVALID_FILTER;
    case m_noSuchAttribute: return MP_E_NO_SUCH_ATTRIBUTE;
    case m_invalidAttributeValue:return MP_E_INVALID_ATTRIBUTE_VALUE;
    case m_getListError: return MP_E_GET_LIST_ERROR;
    case m_setListError: return MP_E_SET_LIST_ERROR;
    case m_noSuchAction: return MP_E_NO_SUCH_ACTION;
    case m_processingFailure: return MP_E_PROCESSING_FAILURE;
    case m_duplicateManagedObjectInstance: return MP_E_DUPLICATE_MANAGED_OBJECT_INSTANCE;
    case m_noSuchReferenceObject: return MP_E_NO_SUCH_REFERENCE_OBJECT;
    case m_noSuchEventType: return MP_E_NO_SUCH_EVENT_TYPE;
    case m_noSuchArgument: return MP_E_NO_SUCH_ARGUMENT;
    case m_invalidArgumentValue: return MP_E_INVALID_ARGUMENT_VALUE;
    case m_invalidScope: return MP_E_INVALID_SCOPE;
    case m_invalidObjectInstance: return MP_E_INVALID_OBJECT_INSTANCE;
    case m_missingAttributeValue: return MP_E_MISSING_ATTRIBUTE_VALUE;
    case m_classInstanceConflict: return MP_E_CLASS_INSTANCE_CONFLICT;
    case m_complexityLimitation: return MP_E_COMPLEXITY_LIMITATION;
    case m_mistypedOperation: return MP_E_MISTYPED_OPERATION;
    case m_noSuchInvokeId: return MP_E_NO_SUCH_INVOKE_ID;
    case m_operationCancelled: return MP_E_OPERATION_CANCELLED;
    case m_invalidOperation: return MP_E_INVALID_OPERATION;
    case m_invalidOperator: return MP_E_INVALID_OPERATOR;
    default: return MP_E_UNRECOGNIZED_OPERATION;
    }
}

static OM_descriptor *create_attribute_error_obj(attrs)
CMISSetAttr* attrs;
{
int l=1;
OM_descriptor *desc;
static const OM_descriptor                attribute_error[] = {
   OM_OID_DESC(OM_CLASS, MP_C_ATTRIBUTE_ERROR),
 { MP_ERROR_STATUS, OM_S_ENUMERATION, {0, 0} },
 { MP_MODIFY_OPERATOR, OM_S_INTEGER, {0, 0} },  /* MP_C_MODIFY_OPERATOR */
 { MP_ATTRIBUTE_ID, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE_ID */
 { MP_ATTRIBUTE_VALUE, OM_S_ENCODING_STRING, {0, 0} },
   OM_NULL_DESCRIPTOR,
  };

  desc = (OM_descriptor *) om_malloc(sizeof(attribute_error));
  desc[0] = attribute_error[0];
  desc[l] = attribute_error[1];
  desc[l++].value.enumeration = cmiserr2err(attrs->sa_error);
  if ((m_invalidOperation == attrs->sa_error)|| 
      (m_invalidOperator == attrs->sa_error)) {
    desc[l] = attribute_error[2];
    desc[l++].value.enumeration = mod_value(attrs->sa_modify); 
  }    
  desc[l] = attribute_error[3];
  desc[l++].value.object.object = create_attrID_obj(&attrs->sa_ava.mp_id);
  if (m_setToDefault != attrs->sa_modify) { 
    desc[l] =attribute_error[4];
   assign_ber(&desc[l++],attrs->sa_val);
  }
  desc[l] = attribute_error[5];
  return desc;
}


static OM_descriptor *create_attribute_id_error_obj(attrs)
CMISGetAttr* attrs;
{
OM_descriptor *desc;
static const OM_descriptor                attribute_id_error[] = {
   OM_OID_DESC(OM_CLASS, MP_C_ATTRIBUTE_ID_ERROR),
 { MP_ERROR_STATUS, OM_S_ENUMERATION, {0, 0} },
 { MP_ATTRIBUTE_ID, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE_ID */
   OM_NULL_DESCRIPTOR,
  };

  desc = (OM_descriptor *) om_malloc(sizeof(attribute_id_error));
  memcpy(desc,attribute_id_error,sizeof(attribute_id_error));
  desc[1].value.enumeration = cmiserr2err(attrs->ga_error);
  desc[2].value.object.object = create_attrID_obj(&attrs->ga_ava.mp_id);
  desc[3] =attribute_id_error[3];
  return desc;
}

static int countMidListElements(ml)
MIDListVal *ml;
{ 
  int cnt=0;
  while (ml) {
    ml = ml->midl_next;
    cnt++;
  }
  return cnt;
}

static OM_descriptor *create_missing_attribute_value_obj(mav)
MIDListVal *mav;
{
 OM_descriptor *desc;
 int l=1,i,nattrs;
static const  OM_descriptor  missing_value[] = {
   OM_OID_DESC(OM_CLASS, MP_C_MISSING_ATTRIBUTE_VALUE),
 { MP_SET_OF_ATTRIBUTE_ID, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE_ID */
   OM_NULL_DESCRIPTOR,
  };
  nattrs = countMidListElements(mav);
  desc = (OM_descriptor *) om_malloc(nattrs*DSCSIZE +sizeof(missing_value));
  memcpy(desc,missing_value,2*DSCSIZE);
  for (i=0;i< nattrs;i++){
    desc[l] = missing_value[1];
    desc[l++].value.object.object = create_attrID_obj(&mav->midl_mid);
    mav = mav->midl_next;
   }
  desc[l] = missing_value[2];
  return desc;
}

static OM_descriptor *create_info_list_obj(parm,i)
desc_arr *parm;
int i;
{
CMISGetAttr* attrs;
OM_descriptor *desc;
static const OM_descriptor                get_info_status[] = {
   OM_OID_DESC(OM_CLASS, MP_C_GET_INFO_STATUS),
 { MP_ATTRIBUTE_ID_ERROR, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE_ID_ERROR */
 { MP_ATTRIBUTE, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE */
   OM_NULL_DESCRIPTOR,
  };

  desc = (OM_descriptor *) om_malloc(sizeof(get_info_status));
  attrs = &parm[ATTRS_PAR].type.gattrs[i];
  memcpy(desc,get_info_status,sizeof(get_info_status));
  if (attrs->ga_error != m_noError) {
     desc[1] =get_info_status[1];
     desc[1].value.object.object = create_attribute_id_error_obj(attrs);
   } else {
     desc[1] =get_info_status[2];
     desc[1].value.object.object = create_attr_obj(&attrs->ga_ava);
   }
  desc[2] =get_info_status[3];
  return desc;
}

static OM_descriptor *create_set_info_status_obj(parm,i)
desc_arr * parm;
int i;
{
CMISSetAttr* attrs;
OM_descriptor *desc;
static const OM_descriptor                set_info_status[] = {
   OM_OID_DESC(OM_CLASS, MP_C_SET_INFO_STATUS),
 { MP_ATTRIBUTE_ERROR, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE_ERROR */
 { MP_ATTRIBUTE, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE */
   OM_NULL_DESCRIPTOR,
  };

  attrs = &parm[ATTRS_PAR].type.sattrs[i];
  desc = (OM_descriptor *) om_malloc(sizeof(set_info_status));
  desc[0] = set_info_status[0];
  if (attrs->sa_error != m_noError) {
     desc[1] =set_info_status[1];
     desc[1].value.object.object = create_attribute_error_obj(attrs);
   } else {
     desc[1] =set_info_status[2];
     desc[1].value.object.object = create_attr_obj(&attrs->sa_ava);
   }
  desc[2] =set_info_status[3];
  return desc;
}

static OM_descriptor *  create_specific_error_info_obj(error)
CMISParam *error;
{
OM_descriptor * desc;
static const OM_descriptor   specific_info[] = {
   OM_OID_DESC(OM_CLASS, MP_C_SPECIFIC_ERROR_INFO),
 { MP_ERROR_ID, OM_S_OBJECT_IDENTIFIER_STRING, {0, 0} },
 { MP_ERROR_INFO, OM_S_ENCODING_STRING, {0, 0} },
   OM_NULL_DESCRIPTOR,
 };
  desc = (OM_descriptor *) om_malloc(sizeof(specific_info));
  memcpy(desc,specific_info,sizeof(specific_info));
  assign_oid(&desc[1],error->mp_id.mid_global);
  assign_ber(&desc[2],error->mp_val);
  return desc;
}

static OM_descriptor * create_processing_failure_obj(failure,msd)
CMISProcessingFailure *failure;
int msd;
{
int l=1;
OM_descriptor *desc, *class, *inst, *info;
static const OM_descriptor   processing_failure[] = {
   OM_OID_DESC(OM_CLASS, MP_C_PROCESSING_FAILURE),
 { MP_MANAGED_OBJECT_CLASS, OM_S_OBJECT, {0, 0} },  /* MP_C_OBJECT_CLASS */
 { MP_MANAGED_OBJECT_INSTANCE, OM_S_OBJECT, {0, 0} },
 { MP_SPECIFIC_ERROR_INFO, OM_S_OBJECT, {0, 0} },
   OM_NULL_DESCRIPTOR,
  };

   desc = (OM_descriptor *) om_malloc(sizeof(processing_failure));
   desc[0] = processing_failure[0];
   class = create_class_obj(&failure->pf_class,msd);
   if (class) {
     desc[l] = processing_failure[1];
     desc[l++].value.object.object = class;
   } else {
     fprintf(stderr,"Object class is oblicatory in processing failure \n");
   }
   inst =  create_instance_obj(&failure->pf_inst,msd);
   if (inst) {
     desc[l] = processing_failure[2];
     desc[l++].value.object.object = inst;
   }
   info = create_specific_error_info_obj(&failure->pf_error);
   if (info) {
     desc[l] = processing_failure[3];
     desc[l++].value.object.object = info;
   } else {
     fprintf(stderr,"Error field is oblicatory in processing failure \n");
   }  
   desc[l] = processing_failure[4];
   return desc;
}

static OM_descriptor *create_getListError_obj(res)
desc_arr *res;
{
static const OM_descriptor         get_list_error[] = {
   OM_OID_DESC(OM_CLASS, MP_C_CMIS_GET_LIST_ERROR),
 { MP_GET_INFO_LIST, OM_S_OBJECT, {0, 0} },  /* MP_C_GET_INFO_STATUS */
  };
  return create_and_fill_common_rsp_obj(get_list_error,res,&create_info_list_obj);
}

static OM_descriptor *create_setListError_obj(parm)
desc_arr *parm;
{
OM_descriptor *desc;
int l=1,i;
static const OM_descriptor         set_list_error[] = {
   OM_OID_DESC(OM_CLASS, MP_C_CMIS_SET_LIST_ERROR),
 { MP_SET_INFO_LIST, OM_S_OBJECT, {0, 0} },  /* MP_C_GET_INFO_STATUS */
  };
  desc = create_and_fill_common_rsp_obj(set_list_error,parm,
                                         &create_set_info_status_obj);
  return desc;
}
 
static OM_descriptor *  create_no_such_event_id_obj(event,msd)
CMISNoSuchArgument * event;
int msd;
{
int l=1;
OM_descriptor *desc=0, *object=0;
static const  OM_descriptor  no_such_event_id[] = {
OM_OID_DESC(OM_CLASS, MP_C_NO_SUCH_EVENT_ID),
 { MP_MANAGED_OBJECT_CLASS, OM_S_OBJECT, {0, 0} },  /* MP_C_OBJECT_CLASS */
 { MP_EVENT_TYPE, OM_S_OBJECT, {0, 0} },  /* MP_C_EVENT_TYPE_ID */
   OM_NULL_DESCRIPTOR,
 };
  desc = (OM_descriptor *) om_malloc(sizeof(no_such_event_id));
  desc[0] = no_such_event_id[0];
  object = create_class_obj(&event->nsa_class,msd);
  if (object) {
    desc[l] = no_such_event_id[1];
    desc[l++].value.object.object = object;
  }
  object =   create_event_type_id_obj(&event->nsa_type);
  if (object) {
    desc[l] = no_such_event_id[2];
    desc[l].value.object.object = object;
  } else {
    fprintf(stderr,"Event type is mandatory in NoSuchEvent \n");
  }
  desc[l] = no_such_event_id[3];
  return desc;
}
 
static OM_descriptor *  create_no_such_event_type_obj(event,msd)
CMISNoSuchArgument * event;
int msd;
{
int l=1;
OM_descriptor *desc=0, *object=0;
static const  OM_descriptor  no_such_event_type[] = {
OM_OID_DESC(OM_CLASS, MP_C_NO_SUCH_EVENT_TYPE),
 { MP_MANAGED_OBJECT_CLASS, OM_S_OBJECT, {0, 0} },  /* MP_C_OBJECT_CLASS */
 { MP_EVENT_TYPE, OM_S_OBJECT, {0, 0} },  /* MP_C_EVENT_TYPE_ID */
   OM_NULL_DESCRIPTOR,
 };
  desc = (OM_descriptor *) om_malloc(sizeof(no_such_event_type));
  desc[0] = no_such_event_type[0];
  object = create_class_obj(&event->nsa_class,msd);
  if (object) {
    desc[l] = no_such_event_type[1];
    desc[l++].value.object.object = object;
  } else {
    fprintf(stderr,"Event type is mandatory in NoSuchEventTpe \n");
  }
  object =   create_event_type_id_obj(&event->nsa_type);
  if (object) {
    desc[l] = no_such_event_type[2];
    desc[l].value.object.object = object;
  } else {
    fprintf(stderr,"Event type is mandatory in NoSuchEventType \n");
  }
  desc[l] = no_such_event_type[3];
  return desc;
}

static OM_descriptor *create_ServiceError_obj(info,ercode,invoke,msd,sdesc,op)
CMISErrorInfo* info;
int ercode, invoke, msd;
OM_descriptor *sdesc;
int op;
{
int l=2, error;
OM_descriptor *desc, *object=0, *object2;
static const OM_descriptor   ErrObj[] = {
   OM_OID_DESC(OM_CLASS, MP_C_CMIS_SERVICE_ERROR),
 { MP_PROBLEM,   OM_S_INTEGER, {0, 0}},
 { MP_PARAMETER, OM_S_OBJECT, {0, 0}},
 { MP_PARAMETER, OM_S_INTEGER, {0, 0}}, /* put invoke id in value */
  };
  desc = (OM_descriptor *) om_malloc(sizeof(ErrObj));
  memcpy(desc,ErrObj,2*DSCSIZE);
  error = cmiserr2err(ercode);
  desc[1].value.enumeration = error;
  desc[l] = ErrObj[2];  /* default setting - used in almost all cases */
  switch (error) {
    case MP_E_PROCESSING_FAILURE: {
      object = create_processing_failure_obj(&info->ei_processingFailure,msd);
      break;
    }
    case MP_E_CLASS_INSTANCE_CONFLICT: {
      object = create_class_obj(&info->ei_classInstanceConflict.cic_class,msd);
      object2 = 
             create_instance_obj(&info->ei_classInstanceConflict.cic_inst,msd);
      object =  create_base_managed_object_id(object,object2);
      break;
    }
    case MP_E_NO_SUCH_OBJECT_CLASS:{
      object = create_class_obj(&info->ei_un.ei_un_noSuchObjectClass,msd);
      break;
    }
    case MP_E_NO_SUCH_OBJECT_INSTANCE: {
      object = create_instance_obj(&info->ei_un.ei_un_noSuchObjectInstance,msd);
      break;
    }
    case MP_E_NO_SUCH_REFERENCE_OBJECT: {
      object = create_instance_obj(&info->ei_un.ei_un_noSuchReferenceObject,msd);
      break;
    }
    case  MP_E_COMPLEXITY_LIMITATION: {
      object = create_limitation_obj(&info->ei_complexityLimitation);
      break;
    }
    case MP_E_DUPLICATE_MANAGED_OBJECT_INSTANCE: {
      object = create_instance_obj(&info->ei_un.ei_un_duplicateObjectInstance,msd);
      break;
    }
    case MP_E_INVALID_OBJECT_INSTANCE: {
      object = create_instance_obj(&info->ei_un.ei_un_invalidObjectInstance,msd);
      break;
    }
    case MP_E_INVALID_FILTER: {
      object = create_filter_obj(info->ei_un.ei_un_invalidFilter);
      break;
    }
    case MP_E_INVALID_SCOPE: {
      object = create_scope_obj(&info->ei_invalidScope);
      break;
    }
    case  MP_E_SYNCHRONIZATION_NOT_SUPPORTED: {
      desc[l] = ErrObj[1];    /* not default - reset it */
      desc[l++].value.enumeration =(info->ei_syncNotSupported != s_bestEffort)?
                                                          MP_T_ATOMIC: 0; 
      break;
    }
    case  MP_E_NO_SUCH_ACTION: {
      object =  create_no_such_action_obj(&info->ei_un.ei_un_noSuchAction,msd);
      break;
    }
    case  MP_E_NO_SUCH_ARGUMENT: {
      object =   create_no_such_argument(&info->ei_un.ei_un_noSuchArgument,msd,op);
      break;
    }
    case MP_E_NO_SUCH_ATTRIBUTE: { 
      object = create_attrID_obj(&info->ei_un.ei_un_noSuchAttribute);
      break;
    }
    case MP_E_NO_SUCH_EVENT_TYPE: {
      object =  create_no_such_event_type_obj(&info->ei_un.ei_un_noSuchEventType,msd);
      break;
    }
    case MP_E_NO_SUCH_INVOKE_ID: {
       desc[l] = ErrObj[3];    /* not default - reset it */
       desc[l++].value.integer =invoke;
       break;
     }
    case MP_E_MISSING_ATTRIBUTE_VALUE: { /* NOTE */
      object = create_missing_attribute_value_obj(
                                  info->ei_un.ei_un_missingAttributeValue);
      break;
    }
    case MP_E_INVALID_ATTRIBUTE_VALUE: { /* NOTE */
      object = create_attr_obj(&info->ei_un.ei_un_invalidAttributeValue);
      break;
    }
    case MP_E_MISTYPED_OPERATION: {
      desc[l] = ErrObj[3];    /* not default - reset it */
      desc[l++].value.integer = invoke;
      break;
    }
    case MP_E_SET_LIST_ERROR: {
      desc[l++].value.object.object = sdesc;
      break;
    }
    case MP_E_GET_LIST_ERROR: {
      desc[l++].value.object.object = sdesc;
      break;
    }
    case  MP_E_OPERATION_CANCELLED: {
      /* NOTE HP does not like this pdu after cancel in mp_get_rsp */
      return 0;
    }

/*
 *   case  MP_E_DUPLICATE_INVOCATION:
 *   case  MP_E_MISTYPED_ARGUMENT:
 *   case  MP_E_RESOURCE_LIMITATION:
 *   case  MP_E_UNRECOGNIZED_OPERATION:
 *   case  MP_E_ACCESS_DENIED: {
 *     break;
 *   }
 */
    default: {
     fprintf(stderr,"service error %d \n",error);
     fprintf(stderr,"This may be caused by\n");
     fprintf(stderr,"a missing MP_E_Invoke_Problem handling!!!\n");
    }
  }
/* common assignment for above cases */
  if (object) {
     desc[l++].value.object.object = object;
  }
  desc[l] = NULLDESC[0];
  return desc;
}

static OM_descriptor *create_create_object_instance_obj(inst,sinst)
OM_descriptor *inst, *sinst;
{
int l=1;
OM_descriptor *desc;
static const OM_descriptor           create_object[] = {
   OM_OID_DESC(OM_CLASS, MP_C_CREATE_OBJECT_INSTANCE),
 { MP_MANAGED_OBJECT_INSTANCE, OM_S_OBJECT, {0, 0} },  /* MP_C_OBJECT_INSTANCE */
 { MP_SUPERIOR_OBJECT_INSTANCE, OM_S_OBJECT, {0, 0} },  /* MP_C_OBJECT_INSTANCE */
   OM_NULL_DESCRIPTOR,
  };

   if ((!inst) && (!sinst)) {
     return 0;
   }
   desc = (OM_descriptor *) om_malloc(sizeof(create_object));
   desc[0] = create_object[0];
   if (inst) {
     desc[l] = create_object[1];
     desc[l++].value.object.object = inst;
   }
   if (sinst) {
     desc[l] = create_object[2];
     desc[l++].value.object.object = sinst;
   }
   desc[l] = create_object[3];  /* null descriptor */
   return desc;    
}
static OM_descriptor * create_and_fill_common_req_obj2(gdesc,parm,wfn)
const OM_descriptor *gdesc;
desc_arr *parm;
FNX wfn;

{
int size, i=1,j=1, nattrs;
static OM_descriptor * desc, *adesc;
static const OM_descriptor body[] = {
 { MP_BASE_MANAGED_OBJECT_CLASS, OM_S_OBJECT, {0, 0 /*object_class*/} },
 { MP_BASE_MANAGED_OBJECT_INSTANCE, OM_S_OBJECT, {0,0 /*object_instance*/} },
 { MP_ACCESS_CONTROL, OM_S_OBJECT, {0, 0} }, /* * mp_c_access_control */
 { MP_SCOPE, OM_S_OBJECT, {0, 0 /*scope*/} },  
 { MP_FILTER, OM_S_OBJECT, {0, 0} },  /* optional filter MP_C_CMIS_FILTER */
 { MP_SYNCHRONIZATION, OM_S_ENUMERATION, {0, 0 } },
  };
static const OM_descriptor attr_set[] = {
  OM_OID_DESC(OM_CLASS, MP_C_MODIFICATION_LIST),
  {MP_MODIFICATION_LIST, OM_S_OBJECT, {0,0} },
  };

  size =  sizeof(body) + (abs(parm[NATTRS_OBJ].type.intval)+2)* DSCSIZE; /* NOTE sun */
  desc = (OM_descriptor *) om_malloc(size);
  desc[0] = gdesc[0];
  while (i < SYNC_OBJ) {
    if (parm[i].type.desc) {
      desc[j] = body[i-1];
      desc[j++].value.object.object = parm[i].type.desc;
    }
    i++;
  }

    desc[j] = body[5]; /* MP_SYNCHRONIZATION */
    desc[j++].value.enumeration = parm[SYNC_OBJ].type.intval; 

  if (wfn != 0) {
    if (MP_ATTRIBUTE_ID_LIST == gdesc[1].type) {
      /* all attributes are send if none specified */
      if (GET_ALLATTRS != parm[NATTRS_OBJ].type.intval) {
        desc[j] = gdesc[1];
        desc[j++].value.object.object = (*wfn)(parm);
      }
      goto exit;
    }
    nattrs = parm[NATTRS_OBJ].type.intval;
    nattrs = (nattrs == 0)? 1 : nattrs;     /* create null list if  0 */
    for (i=0;i<nattrs;i++) {
      desc[j] = gdesc[1];
      desc[j++].value.object.object = (*wfn)(parm,i);
    }
  } else {
   /*delete, action   */
   if (parm[ACTION_INFO_OBJ].type.desc) {
     desc[j] = gdesc[1];
     desc[j++].value.object.object = parm[ACTION_INFO_OBJ].type.desc;
   }
  }
 exit:
    desc[j] =  NULLDESC[0];
    if(MP_MODIFICATION_LIST == gdesc[1].type) {
        adesc = deepen(desc,MODIFICATION_LIST, (j+2)*DSCSIZE, 
              	   (abs(parm[NATTRS_OBJ].type.intval)+1)*DSCSIZE
       	     +sizeof(attr_set));
      return adesc;
    }
    else
      return desc; 
}



static OM_descriptor * create_and_fill_common_rsp_obj(gdesc,parm,wfn)
const OM_descriptor *gdesc;
desc_arr *parm;
FNX wfn; 
{
/* the clas name and parameter list type come in gdesc */
static const OM_descriptor resp_body[] = {
 { MP_MANAGED_OBJECT_CLASS, OM_S_OBJECT, {0, 0} },  /* MP_C_OBJECT_CLASS */
 { MP_MANAGED_OBJECT_INSTANCE, OM_S_OBJECT, {0, 0} },/* MP_C_OBJECT_INSTANCE */
 { MP_CURRENT_TIME, OM_S_GENERALISED_TIME_STRING, {0, 0} },
 { MP_EVENT_TIME, OM_S_GENERALISED_TIME_STRING, {0, 0} }
 };

static const OM_descriptor attr_set[] = {
  OM_OID_DESC(OM_CLASS, MP_C_SETOF_ATTRIBUTE),
  {MP_ATTRIBUTE_LIST, OM_S_OBJECT, {0,0} },
  };
  int i=1, j=1, k=1, size, flag=0;
  char *time;
  CMISParam *ava;
  static OM_descriptor * desc, *adesc;
  if ((!parm[CLASS_OBJ].type.desc) && (!parm[INSTANCE_OBJ].type.desc) && 
      (!parm[TIME_PAR].type.str) && (!parm[EVENT_RPL_OBJ].type.desc) &&
      (0== parm[NATTRS_PAR].type.intval)) {
     return 0;
   }
  size = sizeof(resp_body) + (abs(parm[NATTRS_PAR].type.intval)+2)* DSCSIZE;
  desc = (OM_descriptor *) om_malloc(size);
  desc[0] = gdesc[0];
  if (parm[CLASS_OBJ].type.desc) {
    desc[j] = resp_body[0];
    desc[j++].value.object.object = parm[CLASS_OBJ].type.desc;
  }
  if (parm[INSTANCE_OBJ].type.desc) {
    desc[j] = resp_body[1];
    desc[j++].value.object.object = parm[INSTANCE_OBJ].type.desc;
  }
  time = parm[TIME_PAR].type.str;

  if (time) {
    /* event or current time */
    desc[j] =(MP_EVENT_TYPE == gdesc[1].type) ? resp_body[3]:  resp_body[2];    
    assign_byte_string(&desc[j++],time,strlen(time));
  }

  if (wfn != 0) {
    for (i=0;i<parm[NATTRS_PAR].type.intval;i++) {
      desc[j] = gdesc[1];
      desc[j++].value.object.object = (*wfn)(parm,i);
   }
  } else {
    /* event report argument,action response,delete resp - no function call */
    if (parm[EVENT_RPL_OBJ].type.desc) {
      desc[j] = gdesc[1];
      desc[j++].value.object.object = parm[EVENT_RPL_OBJ].type.desc;    
    }
    if (parm[ATTRS_PAR].type.any) {
      desc[j] = gdesc[2];
      assign_ber(&desc[j++],parm[ATTRS_PAR].type.any);     
    }
  }
  desc[j] =  NULLDESC[0]; /*set_res[3];   null descriptor was 5 */

      adesc = deepen(desc,ATTRIBUTE_LIST, (j+2)*DSCSIZE, 
      	   (abs(parm[NATTRS_PAR].type.intval)+1)*DSCSIZE+
      	   sizeof(attr_set));
      adesc = deepen(adesc,GET_LIST,(j+2)*DSCSIZE, 
      	   (abs(parm[NATTRS_PAR].type.intval)+1)*DSCSIZE+
      	   sizeof(attr_set));
      adesc = deepen(adesc,SET_LIST, (j+2)*DSCSIZE, 
      	   (abs(parm[NATTRS_PAR].type.intval)+1)*DSCSIZE+
      	   sizeof(attr_set));;
    return adesc;
}


/* Fill and create for objects of two rows, last row of type any.
 * First row is mandatory. Second optinal. Last Empty row.
 */
static OM_descriptor * create_and_fill_any_obj(gdesc,parm,pe)
const OM_descriptor *gdesc;
OM_descriptor *parm;
PE pe;
{
  int i=2;
  static OM_descriptor * desc;
  desc = (OM_descriptor *) om_malloc(4*DSCSIZE);
  desc[0] = gdesc[0];
  if (parm) {
     desc[1] = gdesc[1];
     desc[1].value.object.object = parm;
   } else {
     fprintf(stderr,"mandatory field missing in create_and_fill_any_obj\n");
     return 0;
   }
  if (pe) {
    desc[i] = gdesc[2];    
    assign_ber(&desc[i++],pe);
  }
  desc[i] = NULLDESC[0];
  return desc;
}

/* Fill and create for objects of two mandatory rows. Both rows are
 * object pointers.
 */
static OM_descriptor * create_and_fill_2obj_obj(gdesc,pd1,pd2)
const OM_descriptor *gdesc;
OM_descriptor *pd1, *pd2;
{
  static OM_descriptor * desc;
  if ((!pd1) || (!pd2)) {
    fprintf(stderr,"mandatory field missing in create_and_fill_2obj_obj\n");
    return 0;
  }
  desc = (OM_descriptor *) om_malloc(4*DSCSIZE);
  memcpy(desc,gdesc,4*DSCSIZE);
  desc[1].value.object.object = pd1;
  desc[2].value.object.object = pd2;
  return desc;
}

static OM_descriptor * create_action_arg_obj(parm)
desc_arr *parm;
{
static const OM_descriptor action_arg[] = {
  OM_OID_DESC(OM_CLASS, MP_C_CMIS_ACTION_ARGUMENT),
{ MP_ACTION_INFO, OM_S_OBJECT, {0, 0} },  /* MP_C_ACTION_INFO */
 };
  return  create_and_fill_common_req_obj2(action_arg, parm, 0);
}

static OM_descriptor * create_action_rsp_obj(res)
desc_arr *res;
{
static const OM_descriptor  action_res[] = {
  OM_OID_DESC(OM_CLASS, MP_C_CMIS_ACTION_RESULT),
{ MP_ACTION_REPLY, OM_S_OBJECT, {0, 0} }, 
  };
  return create_and_fill_common_rsp_obj(action_res,res,0);
}

static OM_descriptor * create_create_argument_obj(class,inst,sinst,access,rinst,attr,nattrs)
OM_descriptor *class, *inst, *sinst,  *access, *rinst;
CMISParam* attr;
int nattrs;
{
int l=1, j;
int k=1;
OM_descriptor *desc, *adesc;
static const OM_descriptor           create_argument[] = {
   OM_OID_DESC(OM_CLASS, MP_C_CMIS_CREATE_ARGUMENT),
 { MP_MANAGED_OBJECT_CLASS, OM_S_OBJECT, {0, 0} },  /* MP_C_OBJECT_CLASS */
 { MP_MANAGED_OBJECT_INSTANCE, OM_S_OBJECT, {0, 0} },  /* MP_C_OBJECT_INSTANCE */
 { MP_CREATE_OBJECT_INSTANCE, OM_S_OBJECT, {0, 0} },
 { MP_ACCESS_CONTROL, OM_S_OBJECT, {0, 0} },  /* mp_c_access_control */
 { MP_REFERENCE_OBJECT_INSTANCE, OM_S_OBJECT, {0, 0} },  /* MP_C_OBJECT_INSTANCE */
 { MP_ATTRIBUTE_LIST, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE */
  };

static const OM_descriptor           attr_set[] = {
  OM_OID_DESC(OM_CLASS, MP_C_SETOF_ATTRIBUTE),
  {MP_ATTRIBUTE, OM_S_OBJECT, {0,0} },
  };

   adesc = (OM_descriptor *) om_malloc(abs(nattrs+1)*DSCSIZE+sizeof(attr_set));
   memcpy(adesc, attr_set, DSCSIZE);
   for (j=0;j<nattrs;j++) {
     adesc[k] = attr_set[1];
     adesc[k++].value.object.object = create_attr_obj(&attr[j]);
   }
   adesc[k] = NULLDESC[0];

   desc = (OM_descriptor *) om_malloc(abs(nattrs+1)+sizeof(create_argument));
   memcpy(desc,create_argument,2*DSCSIZE);
   desc[l++].value.object.object = class;
   sinst = create_create_object_instance_obj(inst,sinst);
   if (sinst) {
     desc[l] = create_argument[3];
     desc[l++].value.object.object = sinst;
   }
   if (access) {
     desc[l] = create_argument[4];
     desc[l++].value.object.object = access;
   }
   if (rinst) {
     desc[l] = create_argument[5];
     desc[l++].value.object.object = rinst;
   }
   desc[l] = create_argument[6];
   desc[l++].value.object.object = adesc;
   desc[l] = NULLDESC[0];
   return desc;    
}

static OM_descriptor * create_delete_arg_obj(parm)
desc_arr *parm;
{
static const OM_descriptor               delete_arg[] = {
OM_OID_DESC(OM_CLASS, MP_C_CMIS_DELETE_ARGUMENT),
  };
  return create_and_fill_common_req_obj2(delete_arg,parm,0);
}

static OM_descriptor * create_delete_result_obj(parm)
desc_arr * parm;
{
static const OM_descriptor               delete_res[] = {
OM_OID_DESC(OM_CLASS, MP_C_CMIS_DELETE_RESULT),
  };
  return create_and_fill_common_rsp_obj(delete_res,parm,0);
}

static OM_descriptor * create_get_arg_obj(parm)
desc_arr *parm;
{
static const OM_descriptor               get_arg[] = {
OM_OID_DESC(OM_CLASS, MP_C_CMIS_GET_ARGUMENT),
 { MP_ATTRIBUTE_ID_LIST, OM_S_OBJECT, {0, 0 /*attr_id*/} }, /* optional list */
  };
  return create_and_fill_common_req_obj2(get_arg,parm,&create_attrID_list_obj);
}

static OM_descriptor *create_get_resp_obj(res)
desc_arr * res;
{
static const OM_descriptor                get_result_arg[] = {
   OM_OID_DESC(OM_CLASS, MP_C_CMIS_GET_RESULT),
 { MP_ATTRIBUTE_LIST, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE */
  };
  return create_and_fill_common_rsp_obj(get_result_arg,res,&create_attr_obj2);
}

static OM_descriptor * create_canGet_arg_obj(invoke)
int invoke;
{
OM_descriptor *desc;
static const OM_descriptor     cancel_get[] = {
   OM_OID_DESC(OM_CLASS, MP_C_CMIS_CANCEL_GET_ARGUMENT),
 { MP_GET_INVOKE_ID, OM_S_INTEGER, {0, 0} },
   OM_NULL_DESCRIPTOR,
 };
   desc = (OM_descriptor *) om_malloc(sizeof(cancel_get));
   memcpy(desc,cancel_get,sizeof(cancel_get));
   desc[1].value.integer = invoke;
   return desc;
}

static OM_descriptor * create_linked_reply_obj(reply)
OM_descriptor *reply;
{
OM_descriptor *desc=0, *rtype;
int len,type = 0;
char * ch1,*ch2;
static const OM_descriptor                linked_reply[] = {
   OM_OID_DESC(OM_CLASS, MP_C_CMIS_LINKED_REPLY_ARGUMENT),
 { MP_GET_RESULT, OM_S_OBJECT, {0, 0} },  /* MP_C_CMIS_GET_RESULT */
 { MP_GET_LIST_ERROR, OM_S_OBJECT, {0, 0} },  /* MP_C_CMIS_GET_LIST_ERROR */
 { MP_SET_RESULT, OM_S_OBJECT, {0, 0} },  /* MP_C_CMIS_SET_RESULT */
 { MP_SET_LIST_ERROR, OM_S_OBJECT, {0, 0} },  /* MP_C_CMIS_SET_LIST_ERROR */
 { MP_ACTION_RESULT, OM_S_OBJECT, {0, 0} },  /* MP_C_CMIS_ACTION_RESULT */
 { MP_PROCESSING_FAILURE, OM_S_OBJECT, {0, 0} },  /* MP_C_PROCESSING_FAILURE */
 { MP_DELETE_RESULT, OM_S_OBJECT, {0, 0} },  /* MP_C_CMIS_DELETE_RESULT */
 { MP_ACTION_ERROR, OM_S_OBJECT, {0, 0} },  /* MP_C_ACTION_ERROR */
 { MP_DELETE_ERROR, OM_S_OBJECT, {0, 0} },  /* MP_C_DELETE_ERROR */
   OM_NULL_DESCRIPTOR,
  };
 
static const OM_descriptor  types[] = {
  OM_OID_DESC(OM_CLASS,MP_C_CMIS_GET_RESULT),
  OM_OID_DESC(OM_CLASS,MP_C_CMIS_GET_LIST_ERROR),
  OM_OID_DESC(OM_CLASS,MP_C_CMIS_SET_RESULT),
  OM_OID_DESC(OM_CLASS,MP_C_CMIS_SET_LIST_ERROR), 
  OM_OID_DESC(OM_CLASS,MP_C_CMIS_ACTION_RESULT),
  OM_OID_DESC(OM_CLASS,MP_C_PROCESSING_FAILURE), 
  OM_OID_DESC(OM_CLASS,MP_C_CMIS_DELETE_RESULT),
  OM_OID_DESC(OM_CLASS,MP_C_ACTION_ERROR), 
  OM_OID_DESC(OM_CLASS,MP_C_DELETE_ERROR), 
  OM_OID_DESC(OM_CLASS,MP_C_CMIS_SERVICE_ERROR), 
   OM_NULL_DESCRIPTOR,
};
   if (reply) {
     rtype = (OM_descriptor *) &types[0];
     len = reply->value.string.length;
     ch2 = reply->value.string.elements;
     ch2 = &ch2[len-2];
     while (rtype[type].type) {
       /* sun has 0x00 in class oid string - must compare after null */
       ch1 = rtype[type].value.string.elements;
       ch1 = &ch1[len-2];
       if (strncmp(ch1,ch2,2) == 0)
         break;
       type++;
     }
     if (type > 8) {
       if (type == 9) {
         /* cmis_service_error is newer in linked reply */
         return reply;
       }
       fprintf(stderr,"unknown linked reply message\n");
     }
     desc = (OM_descriptor *) om_malloc(3*DSCSIZE);
     desc[0] = linked_reply[0];
     desc[1] = linked_reply[type+1];
     desc[1].value.object.object = reply;
     desc[2] = linked_reply[10];
   } else {
     desc = 0;
   }
   return desc;
}

static OM_descriptor *create_create_rsp_obj(parm)
desc_arr *parm;
{
static const OM_descriptor                create_result[] = {
   OM_OID_DESC(OM_CLASS, MP_C_CMIS_CREATE_RESULT),
 { MP_ATTRIBUTE_LIST, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE */
  };
  return  create_and_fill_common_rsp_obj(create_result,parm,&create_attr_obj2);
}

static OM_descriptor *create_event_rep_arg_obj(parm)
desc_arr *parm;
{
static const OM_descriptor                event_rep[] = {
   OM_OID_DESC(OM_CLASS, MP_C_CMIS_EVENT_REPORT_ARGUMENT),
 { MP_EVENT_TYPE, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE */
 { MP_EVENT_INFO, OM_S_ENCODING_STRING, {0, 0} },
  };
  return create_and_fill_common_rsp_obj(event_rep,parm,0);
}

static OM_descriptor *create_event_resp_arg_obj(parm)
desc_arr * parm;
{
static const OM_descriptor event_resp[] = {
   OM_OID_DESC(OM_CLASS, MP_C_CMIS_EVENT_REPORT_RESULT),
 { MP_EVENT_REPLY, OM_S_OBJECT, {0, 0} },  /* MP_C_EVENT_REPLY */
 };
  return  create_and_fill_common_rsp_obj(event_resp,parm,0);
}

static OM_descriptor * create_set_arg_obj(parm)
desc_arr *parm;
{
static const OM_descriptor               set_arg[] = {
OM_OID_DESC(OM_CLASS, MP_C_CMIS_SET_ARGUMENT),
 { MP_MODIFICATION_LIST, OM_S_OBJECT, {0, 0 /*attr_id*/} }, /* optional list */
  };
  return create_and_fill_common_req_obj2(set_arg,parm,&create_modification_obj);
}

static OM_descriptor * create_set_rsp_obj(parm)
desc_arr *parm;
{
const OM_descriptor               set_res[] = {
OM_OID_DESC(OM_CLASS, MP_C_CMIS_SET_RESULT),
 { MP_ATTRIBUTE_LIST, OM_S_OBJECT, {0, 0} },  /* MP_C_ATTRIBUTE */
  };
 return create_and_fill_common_rsp_obj(set_res,parm,&create_attr_obj2);
}

static OM_private_object create_agent_context(msd,conf,sync)
int msd,conf,sync;
{
  OM_return_code  om_return;
  OM_descriptor  *context;
  OM_private_object private_context;
  long int oldMask=0;

  oldMask = sigblock(sigMask);
  om_return = om_create (MP_C_CONTEXT, OM_TRUE, xom_heads[0].workspace,
                         &private_context);
  sigsetmask(oldMask);
  if (om_return != OM_SUCCESS) {
     printf("om_create context failed \n");
     return NULL;
  }
  context = create_context_obj(sync,0,conf,0,NULLPA,NULLAEI,msd);
  om_return = om_put (private_context, OM_REPLACE_ALL, context, NULL, 0, 0);
  if (om_return != OM_SUCCESS) {
    oldMask = sigblock(sigMask);
    (void)om_delete(private_context);
    sigsetmask(oldMask);
    printf("om_put context failed \n");
    return NULL;
  }
  return private_context;
}

static OM_descriptor * refine_proc_err(error_info,error,invoke,linked,msd,op)
CMISErrorInfo* error_info;
CMISErrors error;
int invoke, linked,msd,op;
{
  OM_descriptor *desc;

  if (linked) {
    desc =create_processing_failure_obj(&error_info->ei_processingFailure,msd);
  } else {
    desc =  create_ServiceError_obj(error_info,error, invoke,msd,0,op);
  }
  return desc;
}

static int updateInvokeIdAndLinkedReply(OM_descriptor **desc,int linked,int invoke)
{
  if (linked) {
    *desc = create_linked_reply_obj( (desc[0]));
    return linked;
  }
 return invoke;
}

static  desc_arr * checkAndCreateCallParameters(msd, op, invoke, obj_class, obj_inst,
       scope, filter,access, sync, nattrs, any_var, mi)
int  msd, op, invoke;
MID  obj_class;
MN   obj_inst;
CMISScope* scope;
CMISFilter* filter;
External* access;
CMISSync sync;
int nattrs;
desc_arr *any_var;
MSAPIndication* mi;
{
  static desc_arr parm[PARMSIZE];
  int i;

  memset(parm,0,sizeof(parm));
  memset(mi,0,sizeof(MSAPIndication));
  if ((msd > NR_HEADS) || (msd < 0) || (xom_heads[msd].session  == 0)
    || (xom_heads[msd].session == 0)) {
    return (desc_arr *) arg_fail_OK(invoke, op, 0, "Management association", mi);
  }

  if (missing_mn_rdnP(obj_inst))
    return (desc_arr *) arg_fail_OK(invoke,op, 0, "Object Instance", mi);

  if (missing_mnP(obj_inst))
     return (desc_arr *) arg_fail_OK(invoke, op, 0, "Object Instance", mi);

 if (GET_RSP == opcode[op]) {
    parm[ACTION_INFO_OBJ].valtype = MIDVAL;
    parm[ACTION_INFO_OBJ].type.mattrs = any_var[0].type.mattrs;
    if (nattrs > 0 && !any_var[0].type.mattrs)
      return (desc_arr *) arg_fail_OK(invoke,op, 0, "AttributeIdList", mi);

    for (i = 0; i < nattrs; i++) {
      if (null_midP(&any_var[0].type.mattrs[i]))
        return (desc_arr *) arg_fail_OK(invoke,op, 0, "AttributeId", mi);
    }
  }

  if (SET_RSP == opcode[op]) {
    parm[ACTION_INFO_OBJ].valtype = SETVAL;
    parm[ACTION_INFO_OBJ].type.sattrs = any_var[0].type.sattrs;
    if (!nattrs || !any_var[0].type.sattrs)
      return (desc_arr *) arg_fail_OK(invoke, op, 0, "Attribute List", mi);
    for (i = 0; i < nattrs; i++) {
     if (null_midP(&any_var[0].type.sattrs->sa_id))
       return (desc_arr *) arg_fail_OK(invoke, M_SET, 0, "AttributeId", mi);	
      if (any_var[0].type.sattrs -> sa_val == NULLPE && 
          any_var[0].type.sattrs -> sa_modify != m_setToDefault)
        return (desc_arr *) arg_fail_OK(invoke, op, 0, "Attribute Value", mi);
    }
  }
  if (ACTION_RSP == opcode[op]) {
    parm[ACTION_INFO_OBJ].valtype = OMDESC;
    parm[ACTION_INFO_OBJ].type.desc = create_action_info_obj(any_var[0].type.mattrs, 
                                                             any_var[1].type.any);
    if (missing_midP(any_var[0].type.mattrs)) /* action type */
       return (desc_arr *) arg_fail_OK(invoke, op, 0, "Action Type", mi);
  }

  if (access) {
    fprintf(stderr," Access controll not yet supported.\n");
  }
  parm[CLASS_OBJ].type.desc = create_class_obj(obj_class,msd);
  parm[INSTANCE_OBJ].type.desc = create_instance_obj(obj_inst,msd);
  parm[ACCESS_OBJ].type.desc = 0;
  parm[SYNC_OBJ].type.intval = ((sync)&&(sync != s_bestEffort))? MP_T_ATOMIC: 0; 
  parm[SCOPE_OBJ].type.desc = create_scope_obj(scope);
  parm[FILTER_OBJ].type.desc = create_filter_obj(filter);
  parm[NATTRS_OBJ].type.intval = nattrs;
  return parm;
}



static  desc_arr * checkErrorsAndCreateCallParameters(msd,op,invoke,linked,obj_class,
                obj_inst,cur_time,nattrs,any_var,error,error_info, mi)
int  msd, op, invoke, linked;
MID  obj_class;
MN   obj_inst;
char* cur_time;
int  nattrs;
desc_arr * any_var;
CMISErrors error;
CMISErrorInfo* error_info;
MSAPIndication* mi;
{
  static desc_arr res[RESSIZE];
  int i;

  if (error) {
    if (NOTOK == M_Error(msd,op,invoke,error,error_info,mi)) {
      return (desc_arr *) 0;
    }
  }

  if (!ACTUAL_OID) {
     ACTUAL_OID = ACTUALCLASS_ASN_OID;
   }
  memset(res,0,sizeof(res));
  memset(mi,0,sizeof(MSAPIndication));
  if ((obj_class && obj_class->mid_type == MID_GLOBAL) &&
     oid_equal(obj_class->mid_un.mid_un_global,ACTUAL_OID)) {
     mid_free(obj_class);
     obj_class->mid_un.mid_un_global = NULLOID;
   }
  res[CLASS_OBJ].type.desc = create_class_obj(obj_class,msd);
  res[INSTANCE_OBJ].type.desc = create_instance_obj(obj_inst,msd);
  res[TIME_PAR].type.str = cur_time;
  res[NATTRS_PAR].type.intval = nattrs;
  res[ATTRS_PAR].type.intval = 0;

  if (SET_RSP == opcode[op]) {
    res[ATTRS_PAR].valtype = SETVAL;
    res[ATTRS_PAR].type.sattrs = any_var[0].type.sattrs;
    for (i = 0; i < nattrs; i++) {
	if (null_midP(&any_var[0].type.sattrs[i].sa_id))
	    return (desc_arr *) arg_fail_OK(invoke, op, 1, "Attribute Id", mi);
        if (any_var[0].type.sattrs[i].sa_val == NULLPE &&
            !any_var[0].type.sattrs[i].sa_error)
	    return (desc_arr *) arg_fail_OK(invoke, op, 1, "Attribute Value", mi);
    }
  }
  if (GET_RSP == opcode[op]) {
    res[ATTRS_PAR].valtype = GETVAL;
    res[ATTRS_PAR].type.gattrs = any_var[0].type.gattrs;
    for (i = 0; i < nattrs; i++) {
      if (null_midP(&any_var[0].type.gattrs[i].ga_id))
	    return (desc_arr *) arg_fail_OK(invoke, op, 1, "Attribute Id", mi);
      if (any_var[0].type.gattrs[i].ga_val == NULLPE && 
          !any_var[0].type.gattrs[i].ga_error)
        return (desc_arr *) arg_fail_OK(invoke, op, 1, "Attribute Value", mi);
    }
  }
  if (CREATE_RSP == opcode[op]) {
    res[ATTRS_PAR].valtype = ATRVAL;
    res[ATTRS_PAR].type.attrs = any_var[0].type.attrs;
    for (i = 0; i < nattrs; i++) {
      if (null_midP(&any_var[0].type.attrs[i].mp_id))
        return (desc_arr *) arg_fail_OK(invoke, op, 1, "Attribute Id", mi);
      if (any_var[0].type.attrs[i].mp_val == NULLPE)
        return (desc_arr *) arg_fail_OK(invoke, op, 1, "Attribute Value", mi);
    }
  }

  if (error) {
    int ecode;
     ecode = (error <= m_invalidOperator)? error_classes[error].rsp[opcode[op]]:NOAP;
     switch(ecode) {
       case PERR:  {
         res[0].type.desc =  refine_proc_err(error_info,error,invoke,linked,msd,op);
         break;
       }
       case MERR: {
         res[0].type.desc = create_ServiceError_obj(error_info,error,invoke,msd,0,op);
         break;
       }
       case LGER: {
         res[0].type.desc = create_getListError_obj(res);
         if(!linked)
            res[0].type.desc = create_ServiceError_obj(error_info,error,invoke,msd,
                                                res[0].type.desc,op);
 	  break; 
       }
       case LSER: {
         res[0].type.desc = create_setListError_obj(res);
         if(!linked)
            res[0].type.desc = create_ServiceError_obj(error_info,error,invoke,msd,
                                                res[0].type.desc,op);
 	  break; 
       }
       case NOAP: 
       default: {
         return (desc_arr *) error_fail_OK(invoke, op, error, mi);
       }	
     }
  }
  return res;
}


int  M_EventRepAux (msd, op, invoke, obj_class, obj_inst,
			event_type, event_time, event_info, mi)
int  msd, op, invoke;
MID  obj_class, event_type;
MN   obj_inst;
char* event_time;
PE   event_info;
MSAPIndication* mi;
{
  MP_status               status;
  OM_private_object       private_context, result;
  OM_descriptor           *cmis_Event_Rep_argument;
  OM_sint32            invoke_id;     
  desc_arr * parm;
  desc_arr any_var[1];

  any_var[0].type.any = event_info;
  if (0 == (parm = checkErrorsAndCreateCallParameters(msd,op,invoke,0, obj_class, 
           obj_inst,event_time, 2,any_var, 0, 0, mi))) {
     return NOTOK;
   }
  if (missing_midP(event_type)) {
    return arg_fail(invoke, op, 0, "Event Type", mi);
  }
/*  All Events are send using context object and base session */
  parm[EVENT_RPL_OBJ].type.desc =  create_event_type_id_obj(event_type);
  parm[ATTRS_PAR].type.any = event_info;
  cmis_Event_Rep_argument = create_event_rep_arg_obj(parm);

  if (M_EVENT_REP == op) {
    private_context = create_agent_context(msd,MP_T_NON_CONFIRMED,TRUE);
  } else {
    private_context = create_agent_context(msd,MP_T_CONFIRMED,TRUE);
  }
  oldMask = sigblock(sigMask);

#if DEBUGGING
  printPrivate("### Event report context: ", private_context);
  printPrivate("### Event report session: ", xom_heads[0].session);
  printPublic("### Event report arg: ", cmis_Event_Rep_argument);
#endif

  status = mp_event_report_req(xom_heads[0].session,private_context,
             cmis_Event_Rep_argument, &result, &invoke_id);

  om_free(cmis_Event_Rep_argument);
  (void)om_delete(private_context);
  sigsetmask(oldMask);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_event_report_req error %d \n", parse_statusCode(status,mi));
    return NOTOK;
  }

  record_invoke_id(invoke_id,invoke);
  return OK;
}


int  M_EventRepRes (msd, invoke, obj_class, obj_inst, cur_time, event_reply,
				error, error_info, mi)
int  msd, invoke;
MID  obj_class;
MN   obj_inst;
char* cur_time;
CMISParam* event_reply;
CMISErrors error;
CMISErrorInfo* error_info;
MSAPIndication* mi;
{
  desc_arr *res;
  desc_arr any_var[1];
  MP_status               status;
  OM_descriptor           *cmis_event_resp_argument;
  OM_sint32            invoke_id;     

  any_var[0].type.attrs = event_reply;
  if (0 == (res =checkErrorsAndCreateCallParameters(msd, M_EVENT_REPC,invoke,0,
                  obj_class, obj_inst,cur_time,0,any_var,error,error_info, mi))) {
    return NOTOK;
  }

  res[EVENT_RPL_OBJ].type.desc = create_event_reply_obj(event_reply);
  cmis_event_resp_argument = create_event_resp_arg_obj(res);

  invoke_id = invoke;
  oldMask = sigblock(sigMask);
  status = mp_event_report_rsp(xom_heads[msd].session, MP_DEFAULT_CONTEXT,
                               cmis_event_resp_argument, invoke_id);
  sigsetmask(oldMask);

  om_free(cmis_event_resp_argument);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_event_report_rsp error %d \n",parse_statusCode(status,mi));
    return NOTOK;
  }

  return OK;
}




int  M_Get (msd, invoke, obj_class, obj_inst, Cscope, filter,
			access, sync, nattrs, attrs, mi)
int  msd, invoke;   /* NOTE  OSIMIS GIVES HERE ID <> CONFLICT */
MID  obj_class;
MN   obj_inst;
CMISScope* Cscope;
CMISFilter* filter;
External* access;
CMISSync sync;
int  nattrs;
MID  attrs;
MSAPIndication* mi;
{
  static desc_arr *parm;
  OM_descriptor *cmis_get_argument;
  MP_status               status;
  OM_private_object       result;
  OM_sint32            invoke_id;     
  desc_arr any_var[1];

  any_var[0].type.mattrs = attrs;
  if (0 == (parm = checkAndCreateCallParameters(msd,M_GET,invoke, obj_class, obj_inst,
       Cscope, filter,access, sync, nattrs, any_var,mi))) {
     return NOTOK;
   }

  cmis_get_argument = create_get_arg_obj(parm);
  oldMask = sigblock(sigMask);
  status = mp_get_req(xom_heads[msd].session, xom_heads[msd].context,
                      cmis_get_argument, &result, &invoke_id);
  sigsetmask(oldMask);

  om_free(cmis_get_argument);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_get_req error %d \n",parse_statusCode(status,mi));
    return NOTOK;
  }
  record_invoke_id(invoke_id,invoke);
  return OK;
}


int  M_GetRes (msd, invoke, linked, obj_class, obj_inst, cur_time,
			nattrs, attrs, error, error_info, mi)
int  msd, invoke, linked;
MID  obj_class;
MN   obj_inst;
char* cur_time;
int  nattrs;
CMISGetAttr* attrs;
CMISErrors error;
CMISErrorInfo* error_info;
MSAPIndication* mi;
{
    desc_arr                *res;
    desc_arr                any_var[1];
    MP_status               status;
    OM_private_object       result;
    OM_descriptor           *cmis_get_result;
    OM_sint32            invoke_id;     

  any_var[0].type.gattrs = attrs;
/* NOTE time causes failure in old xmp */
  if (0 == (res =checkErrorsAndCreateCallParameters(msd,M_GET,invoke,linked,
                  obj_class, obj_inst, cur_time,nattrs,any_var,error,error_info, mi))) {
    return NOTOK;
  }
  cmis_get_result = error ? res[0].type.desc:  create_get_resp_obj(res) ;
  invoke_id =  updateInvokeIdAndLinkedReply(&cmis_get_result,linked, invoke);
  oldMask = sigblock(sigMask);
  status = mp_get_rsp(xom_heads[msd].session, MP_DEFAULT_CONTEXT/* private_context*/,
                        cmis_get_result, invoke_id);
  sigsetmask(oldMask);

  om_free(cmis_get_result);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_get_res error %d \n",parse_statusCode(status,mi));
    return NOTOK;
  }
  return OK;
}

int  M_SetAux (msd, op, invoke, obj_class, obj_inst, scope, filter,
			access, sync, nattrs, attrs, mi)
int  msd, op, invoke;
MID  obj_class;
MN   obj_inst;
CMISScope* scope;
CMISFilter* filter;
External* access;
CMISSync sync;
int  nattrs;
CMISSetAttr* attrs;
MSAPIndication* mi;
{
  int i;
  MIDentifier class;
  MP_status               status;
  OM_private_object       result;
  OM_descriptor           *cmis_set_argument;
  OM_sint32            invoke_id;     
  OM_private_object       private_context;
  desc_arr *parm;
  desc_arr any_var[1];

  any_var[0].type.sattrs = attrs;
  if (0 == (parm = checkAndCreateCallParameters(msd,op,invoke, obj_class, obj_inst,
       scope, filter,access, sync, nattrs,any_var, mi))) {
     return NOTOK;
   }
  private_context = (M_SET == op)? xom_heads[msd].context1: 
                                   xom_heads[msd].context;
  cmis_set_argument = create_set_arg_obj(parm);

  oldMask = sigblock(sigMask);
  mi->mi_invoke=invoke;
  status = mp_set_req(xom_heads[msd].session, private_context, cmis_set_argument,
                      &result, &invoke_id);
  sigsetmask(oldMask);

  om_free(cmis_set_argument);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_set_req error %d \n",parse_statusCode(status,mi));
    return NOTOK;
  }
  record_invoke_id(invoke_id,invoke);
  return OK;
}



int  M_SetRes (msd, invoke, linked, obj_class, obj_inst, cur_time,
			nattrs, attrs, error, error_info, mi)
int  msd, invoke, linked;
MID  obj_class;
MN   obj_inst;
char* cur_time;
int  nattrs;
CMISSetAttr* attrs;
CMISErrors error;
CMISErrorInfo* error_info;
MSAPIndication* mi;
{
  int i;
  MP_status               status;
  OM_private_object       session, result, private_context;
  OM_descriptor *class_obj, *inst_obj, *cmis_set_result=0;
  OM_sint32            invoke_id;     
  desc_arr * res;
  desc_arr any_var[1];
 		

  any_var[0].type.sattrs = attrs;
  if (0 == (res =checkErrorsAndCreateCallParameters(msd,M_SETC,invoke,linked,
                  obj_class, obj_inst,cur_time,nattrs,any_var,error,error_info, mi))) {
    return NOTOK;
  }
  
  if (error)
    cmis_set_result = linked ? res[0].type.desc:res[0].type.desc ;
  else
  cmis_set_result = create_set_rsp_obj(res);
 
  invoke_id =  updateInvokeIdAndLinkedReply(&cmis_set_result,linked, invoke);
  oldMask = sigblock(sigMask);
  status = mp_set_rsp(xom_heads[msd].session, MP_DEFAULT_CONTEXT, cmis_set_result,
                        invoke_id);
  sigsetmask(oldMask);

  om_free(cmis_set_result);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_set_rsp error %d \n",parse_statusCode(status,mi));
    return NOTOK;
  }

  return OK;
}



int  M_ActionAux (msd, op, invoke, obj_class, obj_inst, scope, filter,
			access, sync, action_type, action_info, mi)
int  msd, op, invoke;
MID  obj_class;
MN   obj_inst;
CMISScope* scope;
CMISFilter* filter;
External* access;
CMISSync sync;
MID  action_type;
PE   action_info;
MSAPIndication* mi;
{
  static desc_arr *parm;
  OM_descriptor *cmis_action_argument;
  MP_status               status;
  OM_private_object       result, private_context;
  OM_sint32            invoke_id;     
  desc_arr any_var[2];

  any_var[0].type.mattrs = action_type;
  any_var[1].type.any = action_info;
  if (0 == (parm = checkAndCreateCallParameters(msd, op, invoke, obj_class, obj_inst,
       scope, filter,access, sync, 1,any_var, mi))) {
     return NOTOK;
   }
  private_context = (M_ACTION == op) ? xom_heads[msd].context1:
                                       xom_heads[msd].context;

  cmis_action_argument = create_action_arg_obj(parm);
  mi->mi_invoke=invoke;
  oldMask = sigblock(sigMask);
  status = mp_action_req(xom_heads[msd].session, private_context, 
                        cmis_action_argument, &result, &invoke_id);
  sigsetmask(oldMask);

  om_free(cmis_action_argument);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_action_req error %d \n",parse_statusCode(status,mi));
    return NOTOK;
  }
  record_invoke_id(invoke_id,invoke);
  return OK;
}


static OM_descriptor *create_action_error_info_obj(error)
int error;
{
OM_descriptor *desc, *desc2, *desc3;
static  const OM_descriptor       action_error_info[] = {
  OM_OID_DESC(OM_CLASS, MP_C_ACTION_ERROR_INFO),
{ MP_ERROR_STATUS, OM_S_ENUMERATION, {0, 0} },
 { MP_ERROR_INFO, OM_S_OBJECT, {0, 0} },  
  OM_NULL_DESCRIPTOR,
  };
static const OM_descriptor  error_info_obj[] = {
  OM_OID_DESC(OM_CLASS, MP_C_ERROR_INFO),
{ MP_ACTION_TYPE, OM_S_OBJECT, {0, 0} },
  OM_NULL_DESCRIPTOR,
  };
static const OM_descriptor action_type_id[] = {
  OM_OID_DESC(OM_CLASS, MP_C_ACTION_TYPE_ID),
{ MP_LOCAL_FORM, OM_S_INTEGER, {0, 0} }, 
  OM_NULL_DESCRIPTOR,
  };

  desc = (OM_descriptor *) om_malloc(sizeof(action_error_info));
  desc2 = (OM_descriptor *) om_malloc(sizeof(error_info_obj));
  desc3 = (OM_descriptor *) om_malloc(sizeof(action_type_id));
  memcpy(desc,action_error_info,4*DSCSIZE);
  memcpy(desc2, error_info_obj, 3*DSCSIZE);
  memcpy(desc3, action_type_id, 3*DSCSIZE);
  desc3[1].value.integer = 10;
  desc[1].value.enumeration = cmiserr2err(error);
  desc2[1].value.object.object = desc3;
  desc[2].value.object.object = desc2;
   
  return desc;
}

    


int  M_ActionRes (msd, invoke, linked, obj_class, obj_inst, cur_time,
				action_reply, error, error_info, mi)
int  msd, invoke, linked;
MID  obj_class;
MN   obj_inst;
char* cur_time;
CMISParam* action_reply;
CMISErrors error;
CMISErrorInfo* error_info;
MSAPIndication* mi;
{
  static OM_descriptor action_error[] = {
  OM_OID_DESC(OM_CLASS, MP_C_ACTION_ERROR),
  { MP_MANAGED_OBJECT_CLASS, OM_S_OBJECT, {0, 0} },
  { MP_MANAGED_OBJECT_INSTANCE, OM_S_OBJECT, {0, 0} },
  { MP_ACTION_ERROR_INFO,OM_S_OBJECT, {0, 0} },
  OM_NULL_DESCRIPTOR,
  };

  static desc_arr *res;
  desc_arr any_var[1];
  OM_descriptor *cmis_action_rsp;
  MP_status               status;
  OM_sint32            invoke_id;     

  
  any_var[0].type.attrs = action_reply;
  if (0 == (res =checkErrorsAndCreateCallParameters(msd,M_ACTIONC,invoke,linked,
                      obj_class, obj_inst,cur_time,0,any_var,error,error_info, mi))) {
    return NOTOK;
  }
  action_error[1].value.object.object = res[CLASS_OBJ].type.desc;
  action_error[2].value.object.object = res[INSTANCE_OBJ].type.desc;
  action_error[3].value.object.object = create_action_error_info_obj(error);
  
  if (action_reply) {
    if (null_midP(&action_reply->mp_id))
      return arg_fail(invoke, M_ACTIONC, 1, "Action Reply Id", mi);
      if (action_reply->mp_val == NULLPE)
        return arg_fail(invoke, M_ACTIONC, 1, "Action Reply Info", mi);
  }
  if (!error) { 
    res[ACTION_REPLY_OBJ].type.desc  = create_action_reply_obj(action_reply);
    cmis_action_rsp =  create_action_rsp_obj(res);
  } else {
    cmis_action_rsp = linked ?  action_error : res[0].type.desc;  
  }
  invoke_id =  updateInvokeIdAndLinkedReply(&cmis_action_rsp,linked, invoke);
  oldMask = sigblock(sigMask);
  status = mp_action_rsp(xom_heads[msd].session, MP_DEFAULT_CONTEXT, 
                         cmis_action_rsp,invoke_id);
  sigsetmask(oldMask);	

  om_free(cmis_action_rsp);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_action_rsp error %d \n",parse_statusCode(status,mi));
    return NOTOK;
  }
  return OK;
}




int  M_Create (msd, invoke, obj_class, obj_inst, instance_type, reference_inst,
			access, nattrs, attrs, mi)
int  msd, invoke;
MID  obj_class;
MN   obj_inst, reference_inst;
int  instance_type;
External* access;
int  nattrs;
CMISParam* attrs;
MSAPIndication* mi;
{
  OM_descriptor *class, *inst, *sinst, *rinst, *acc, *cmis_create_argument;   
  OM_private_object        result;
  MP_status               status;
  OM_sint32            invoke_id;     
  int i;

  if (missing_midP(obj_class))
    return arg_fail(invoke, M_CREATE, 0, "Object Class", mi);

  inst = sinst = rinst = NULL;
  if (obj_inst) {
    switch (instance_type) {
      case CA_OBJECT_INST: {
        inst =  create_instance_obj(obj_inst,msd);
        break;
      }
      case CA_SUPERIOR_INST: {
        sinst =  create_instance_obj(obj_inst,msd);
      break;
      }
   default:  return arg_fail(invoke, M_CREATE, 0, "Instance Type", mi);
    }
  }

  for (i = 0; i < nattrs; i++) {
    if (null_midP(&attrs[i].mp_id)) {
      return arg_fail(invoke, M_CREATE, 0, "Attribute Id", mi);
    }
    if (attrs[i].mp_val == NULLPE) {
      return arg_fail(invoke, M_CREATE, 0, "Attribute Value", mi);
    }
  }

  if (reference_inst) {
    rinst = create_instance_obj(reference_inst,msd);
  } else {
    rinst = NULL;
  }

  if (access) {
    fprintf(stderr,"access not yet supported\n");
  }
  acc = 0;
  class = create_class_obj(obj_class,msd);

  cmis_create_argument =  create_create_argument_obj(class,inst,sinst,acc,
                                                     rinst,attrs,nattrs);
  oldMask = sigblock(sigMask);
  status = mp_create_req(xom_heads[msd].session, xom_heads[msd].context, 
                         cmis_create_argument, &result, &invoke_id);
  sigsetmask(oldMask);	

  om_free(cmis_create_argument);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_create_req error %d \n",parse_statusCode(status,mi));
    return NOTOK;
  }

  record_invoke_id(invoke_id,invoke);
  return OK;
}


int  M_CreateRes (msd, invoke, obj_class, obj_inst, cur_time, nattrs, attrs,
				error, error_info, mi)
int  msd, invoke;
MID  obj_class;
MN   obj_inst;
char* cur_time;
int  nattrs;
CMISParam* attrs;
CMISErrors error;
CMISErrorInfo* error_info;
MSAPIndication* mi;
{
  OM_descriptor  *cmis_create_rsp;   
  MP_status               status;
  OM_sint32            invoke_id;     
  desc_arr any_var[1];
  desc_arr * res;

  any_var[0].type.attrs = attrs;
  if (0 == (res =checkErrorsAndCreateCallParameters(msd,M_CREATE,invoke,0,
                  obj_class, obj_inst,cur_time,nattrs,any_var,error,error_info, mi))) {
    return NOTOK;
  }
  cmis_create_rsp = error ? res[0].type.desc: create_create_rsp_obj(res) ;
  invoke_id = invoke;

  oldMask = sigblock(sigMask);
  status = mp_create_rsp(xom_heads[msd].session, MP_DEFAULT_CONTEXT, 
                         cmis_create_rsp,invoke_id);
  sigsetmask(oldMask);	

  om_free(cmis_create_rsp);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_create_rsp error %d \n", parse_statusCode(status,mi));
    return NOTOK;
  }
  record_invoke_id(invoke_id,invoke);
  return OK;
}



int  M_Delete (msd, invoke, obj_class, obj_inst, scope, filter,
			access, sync, mi)
int  msd, invoke;
MID  obj_class;
MN   obj_inst;
CMISScope* scope;
CMISFilter* filter;
External* access;
CMISSync sync;
MSAPIndication* mi;
{
    MP_status               status;
    OM_private_object       result;
    OM_descriptor           *cmis_delete_argument;
    OM_sint32            invoke_id;     
    desc_arr *parm;

  MIDentifier default_obj_class;
  if (obj_class == NULLMID) { /*use default = EFD*/
    printf("*** M_Delete class not specified, assuming eventForwardingDiscriminator\n");
    default_obj_class.mid_type = MID_GLOBAL;
    default_obj_class.mid_global = name2oid("eventForwardingDiscriminator");
    obj_class = &default_obj_class;
  }

  if (0 == (parm = checkAndCreateCallParameters(msd,M_DELETE,invoke, obj_class,
       obj_inst, scope, filter,access, sync, 0, 0, mi))) {
     return NOTOK;
   }

  cmis_delete_argument = create_delete_arg_obj(parm);

  oldMask = sigblock(sigMask);
  mi->mi_invoke=invoke;
  status = mp_delete_req(xom_heads[msd].session, xom_heads[msd].context, 
                  cmis_delete_argument, &result, &invoke_id);
  sigsetmask(oldMask);

  om_free(cmis_delete_argument);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_delete_req error %d \n", parse_statusCode(status,mi));
    return NOTOK;
  }
  record_invoke_id(invoke_id,invoke);
  return OK;
}
 


int  M_DeleteRes (msd, invoke, linked, obj_class, obj_inst, cur_time,
				error, error_info, mi)
int  msd, invoke, linked;
MID  obj_class;
MN   obj_inst;
char* cur_time;
CMISErrors error;
CMISErrorInfo* error_info;
MSAPIndication* mi;
{
  MP_status               status;
  OM_descriptor           *cmis_delete_result;
  OM_sint32            invoke_id;     
  desc_arr *res;
  desc_arr any_var[1];

  any_var[0].type.gattrs = 0;
  if (0 == (res =checkErrorsAndCreateCallParameters(msd,M_DELETE,invoke,linked,
                  obj_class, obj_inst,cur_time,0,any_var,error,error_info, mi))) {
    return NOTOK;
  }
  cmis_delete_result = error ? res[0].type.desc: create_delete_result_obj(res) ;
  invoke_id =  updateInvokeIdAndLinkedReply(&cmis_delete_result,linked, invoke);

  oldMask = sigblock(sigMask);
  status = mp_delete_rsp(xom_heads[msd].session, MP_DEFAULT_CONTEXT, 
                         cmis_delete_result, invoke_id);
  sigsetmask(oldMask);
  om_free(cmis_delete_result);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_delete_res error %d \n",parse_statusCode(status,mi));
    return NOTOK;
  }
  return OK;
}




int  M_CancelGet (msd, invoke, get_invoke, mi)
int  msd, invoke, get_invoke;
MSAPIndication* mi;
{
    MP_status               status;
    OM_private_object       result;
    OM_descriptor  *cmis_cancelGet_arg;
    OM_sint32            invoke_id;     

  cmis_cancelGet_arg = create_canGet_arg_obj(get_invoke);

  oldMask = sigblock(sigMask);
  status = mp_cancel_get_req(xom_heads[msd].session, xom_heads[msd].context, 
                            cmis_cancelGet_arg, &invoke_id);
  sigsetmask(oldMask);

  om_free(cmis_cancelGet_arg);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_cancel_get_req error %d \n",parse_statusCode(status,mi));
    return NOTOK;
  }
  record_invoke_id(invoke_id,invoke);
  return OK;
  }




int  M_CancelGetRes (msd, invoke, error, error_info, mi)
int  msd, invoke;
CMISErrors error;
CMISErrorInfo* error_info;
MSAPIndication* mi;
{
  MP_status               status;
  OM_descriptor            *cmis_cancel_get_result;
  OM_sint32            invoke_id;     
  desc_arr *res;
  desc_arr any_var[1];

  any_var[0].type.gattrs = 0;
  if (0 == (res =checkErrorsAndCreateCallParameters(msd,M_CANCEL_GET,invoke,0,
                  0, 0, 0,0,any_var,error,error_info, mi))) {
    return NOTOK;
  }
  cmis_cancel_get_result = error ?  res[0].type.desc: 0;
  invoke_id = invoke;
  oldMask = sigblock(sigMask);
  status = mp_cancel_get_rsp(xom_heads[msd].session, MP_DEFAULT_CONTEXT, 
                         cmis_cancel_get_result, invoke_id);
  sigsetmask(oldMask);
  om_free(cmis_cancel_get_result);
  if (status != MP_SUCCESS) {
    fprintf(stderr,"mp_cancel_get_rsp error %d \n",parse_statusCode(status,mi));
    return NOTOK;
  }
  return OK;
}


static int  M_Error (msd, op, invoke, error, error_info, mi)
int  msd, op, invoke;
CMISErrors error;
CMISErrorInfo* error_info;
MSAPIndication* mi;
{
  int result, reason = 0;
  if (!error_info && !(error == m_duplicateInvocation ||
		 error == m_unrecognisedOperation ||
		 error == m_mistypedArgument ||
		 error == m_resourceLimitation ||
		 error == m_accessDenied ||
		 error == m_mistypedOperation ||
		 error == m_operationCancelled ||
		 error == m_complexityLimitation ||
                 error == m_setListError ||
                 error == m_getListError ||
		 error == m_processingFailure)) {
    mi->mi_type = MI_PREJECT;
    mi->mi_preject.mpr_reason = MA_BADARGS;
    mi->mi_preject.mpr_id = invoke;
    (void) sprintf(mi->mi_preject.mpr_data,
       		"%s Result: no error info for error %s",
       		op2str(op), MErrString(error));
    (void) fprintf(stderr, "%s!\n", mi->mi_preject.mpr_data);
    return NOTOK;
  }

    switch (error) {
      case m_duplicateInvocation:{
	return OK;
      }
      case m_noSuchObjectClass: {
	if (null_midP(&error_info->ei_noSuchObjectClass))
          return arg_fail(invoke, op, 1, 
                           "Error (noSuchObjectClass) -  Object Class", mi);
	break;
      }
      case m_noSuchObjectInstance:
      case m_duplicateManagedObjectInstance:
      case m_noSuchReferenceObject:
      case m_invalidObjectInstance: {
        if (null_mnP(&error_info->ei_noSuchObjectInstance))
	  return arg_fail(invoke, op, 1, "Error - Object Instance", mi);
	break;
      }
      case m_accessDenied:
      case m_complexityLimitation:
      case m_invalidScope:
      case m_mistypedOperation:
      case m_noSuchInvokeId:
      case m_operationCancelled:
      case m_setListError:
      case m_getListError:
      case m_syncNotSupported: {
	break;
      }
     case m_invalidFilter: {
	if (error_info->ei_invalidFilter == NULLMFILTER)
	  return arg_fail(invoke, op, 1, 
                          "Error (invalidFilter) - CMIS Filter", mi);
	break;
      }
      case m_noSuchAttribute: {
	if (null_midP(&error_info->ei_noSuchAttribute))
	  return arg_fail(invoke, op, 1, "Error - AttributeId", mi);
	break;
      }
      case m_invalidAttributeValue: {
	if (null_midP(&error_info->ei_invalidAttributeValue.mp_id))
	  return arg_fail(invoke, op, 1, 
                          "Error (invalidAttributeValue) -  Attribute Id", mi);
	if (error_info->ei_invalidAttributeValue.mp_val == NULLPE)
	  return arg_fail(invoke, op, 1, 
                        "Error (invalidAttributeValue) - Attribute Value", mi);
	break;
      }
      case m_noSuchAction: {
	if (null_midP(&error_info->ei_noSuchAction.nsa_class))
	  return arg_fail(invoke, op, 1, 
                          "Error (noSuchAction) - Object Class", mi);
	if (null_midP(&error_info->ei_noSuchAction.nsa_type))
	  return arg_fail(invoke, op, 1, 
                         "Error (noSuchAction) - ActionTypeId", mi);
	break;
      }
      case m_processingFailure: {
     /* check in case no info has been supplied - error parameter optional */
	if (!error_info) {
	    break;
	}
	/* if info has been supplied check its completeness */
	if (null_midP(&error_info->ei_processingFailure.pf_class))
	  return arg_fail(invoke, op, 1, 
                           "Error (processingFailure) - Object Class", mi);
	if (null_midP(&error_info->ei_processingFailure.pf_error.mp_id))
	  return arg_fail(invoke, op, 1, 
                           "Error (processingFailure) - ErrorInfoId", mi);
	if (error_info->ei_processingFailure.pf_error.mp_val == NULLPE)
	  return arg_fail(invoke, op, 1, 
                           "Error (processingFailure) - ErrorInfo", mi);
	break;
      }
      case m_noSuchEventType: {
	if (null_midP(&error_info->ei_noSuchEventType.nsa_class))
	  return arg_fail(invoke, op, 1, 
                           "Error (noSuchEventType) - Object Class", mi);
	if (null_midP(&error_info->ei_noSuchAction.nsa_type))
	  return arg_fail(invoke, op, 1, 
                          "Error (noSuchEventType) - EventTypeId", mi);
	break;
      }
      case m_noSuchArgument: {
	if (null_midP(&error_info->ei_noSuchArgument.nsa_type))
	    return arg_fail(invoke, op, 1, 
                        "Error (noSuchArgument) - Action/Event TypeId", mi);
	break;
      }
      case m_invalidArgumentValue: {
	if (null_midP(&error_info->ei_invalidArgumentValue.mp_id))
	  return arg_fail(invoke, op, 1, 
               "Error (invalidArgumentValue) - Action/EventType Id", mi);
	break;
      }
      case m_missingAttributeValue: {
	if (error_info->ei_missingAttributeValue == NULL)
	    return arg_fail(invoke, op, 1, 
                   "Error (missingAttributeValue) - AttributeValue", mi);
	break;
      }
      case m_classInstanceConflict: {
	if (null_midP(&error_info->ei_classInstanceConflict.cic_class))
          return arg_fail(invoke, op, 1, 
                  "Error (classInstanceConflict) - Object Class", mi);
	if (null_mnP(&error_info->ei_classInstanceConflict.cic_inst))
	  return arg_fail(invoke, op, 1, 
                        "Error (classInstanceConflict) - Object Instance", mi);
        break;
      }


    default:
	return OK; /* This branch is taken care by caller */
    }
}
static  int  arg_fail_OK (invoke, op, res, arg, mi)
int  invoke, op, res;
char* arg;
MSAPIndication* mi;
{
  arg_fail (invoke, op, res, arg, mi);
  return 0;
}

static int  arg_fail (invoke, op, res, arg, mi)
int  invoke, op, res;
char* arg;
MSAPIndication* mi;
{
    mi->mi_type = MI_PREJECT;
    mi->mi_preject.mpr_reason = MA_BADARGS;
    mi->mi_preject.mpr_id = invoke;
    if (res) {
        (void) sprintf(mi->mi_preject.mpr_data,
		"%s Result: argument \"%s\" is mandatory", op2str(op), arg);
	(void) fprintf(stderr, "%s!\n", mi->mi_preject.mpr_data);
    }
    else {
        (void) sprintf(mi->mi_preject.mpr_data,
		"%s: argument \"%s\" is mandatory", op2str(op), arg);
	(void) fprintf(stderr, "%s!\n", mi->mi_preject.mpr_data);
    }
    return NOTOK;
}

static int  error_fail_OK (invoke, op, error, mi)
int  invoke, op;
CMISErrors error;
MSAPIndication* mi;
{
  error_fail (invoke, op, error, mi);
  return 0;
}

static int  error_fail (invoke, op, error, mi)
int  invoke, op;
CMISErrors error;
MSAPIndication* mi;
{
    mi->mi_type = MI_PREJECT;
    mi->mi_preject.mpr_reason = MA_BADARGS;
    mi->mi_preject.mpr_id = invoke;
    (void) sprintf(mi->mi_preject.mpr_data,
		"%s Result: invalid error %s", op2str(op), MErrString(error));
    (void) fprintf(stderr, "%s!\n", mi->mi_preject.mpr_data);
    return NOTOK;
}

static char*  op2str (op)
int op;
{
    static char buf[16];
    switch (op) {
    case M_EVENT_REP:
	(void) strcpy(buf, "M_EventRep");
	break;
    case M_EVENT_REPC:
	(void) strcpy(buf, "M_EventRepC");
	break;
    case M_LINKED_REPLY:
	(void) strcpy(buf, "M_LinkedReply");
	break;
    case M_GET:
	(void) strcpy(buf, "M_Get");
	break;
    case M_SET:
	(void) strcpy(buf, "M_Set");
	break;
    case M_SETC:
	(void) strcpy(buf, "M_SetC");
	break;
    case M_ACTION:
	(void) strcpy(buf, "M_Action");
	break;
    case M_ACTIONC:
	(void) strcpy(buf, "M_ActionC");
	break;
    case M_CREATE:
	(void) strcpy(buf, "M_Create");
	break;
    case M_DELETE:
	(void) strcpy(buf, "M_Delete");
	break;
    case M_CANCEL_GET:
	(void) strcpy(buf, "M_CancelGet");
	break;
    default:
	(void) fprintf(stderr, "op2str: unknown operation code %d\n", op);
	buf[0] = '\0';
	break;
    }
    return buf;
}
