#if !defined(_moperatio_)
#define _moperation_
/*
 * Copyright (c) 1994 Technical Researc Centre of Finland.
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $Id:  $
 *
 * By Matti Hallivuori, December 1994
 */

/* -------- parameters for request object creation --------------------- */
#define PARMSIZE 10
#define CLASS_OBJ 1         /* NOTE class name is position 0 */
#define INSTANCE_OBJ 2
#define ACCESS_OBJ 3
#define EVENT_RPL_OBJ 4     /* NOTE handled like response */
#define SCOPE_OBJ 4
#define FILTER_OBJ 5
#define SYNC_OBJ 6
#define NATTRS_OBJ 7
#define ACTION_INFO_OBJ 8  /* all request parameters */
/* ------- parameters for response object creation -------------------- */
#define RESSIZE 7
#define TIME_PAR   3
#define ACTION_REPLY_OBJ 4
#define NATTRS_PAR 5
#define ATTRS_PAR  6
#define OMDESC     1
#define INTVAL     2
#define STRVAL     3
#define GETVAL     4
#define SETVAL     5
#define ATRVAL     6
#define MIDVAL     7
typedef struct desc_arr {
   int               valtype;
   union {
     OM_descriptor * desc;
     int             intval;
     char *          str;
     CMISGetAttr*    gattrs;
     CMISSetAttr*    sattrs;
     CMISParam*      attrs;
     MID             mattrs;
     PE              any;
   }type;
 } desc_arr;
/* ------------- error code definitios -------------------------------- */
#define ACTION_RSP 0
#define CANGET_RSP 1
#define CREATE_RSP 2
#define DELETE_RSP 3
#define EVENT_RSP  4
#define GET_RSP    5
#define SET_RSP    6
#define noap       0   /* error not applicable   */
#define NOAP      noap
#define LGER       1   /* list error             */
#define LSER       2
#define PERR       3   /* processing failure     */
#define MERR       4   /* this for normal errors */
typedef struct {
  int  rsp[7];
} err_code;
const int opcode[] = {
EVENT_RSP,  /* M_EVENT_REP */
EVENT_RSP,  /* M_EVENT_REPC */
0,          /* M_LINKED_REPLY */
GET_RSP,    /* M_GET     */
SET_RSP,    /* M_SET      */
SET_RSP,    /* M_SETC     */
ACTION_RSP, /* M_ACTION   */
ACTION_RSP, /* M_ACTIONC  */
CREATE_RSP, /* M_CREATE   */
DELETE_RSP, /* M_DELETE   */
CANGET_RSP  /* M_CANCEL_GET */
};

const err_code error_classes[m_resourceLimitation+2] =
{
/* acc   can   crea  del   even  get   set  */
  {noap, noap, noap, noap, noap, noap, noap}, /* m_noError */
  {MERR, noap, MERR, MERR, MERR, MERR, MERR}, /* m_noSuchObjectClass */
  {MERR, noap, MERR, MERR, MERR, MERR, MERR}, /* m_noSuchObjectInstance */
  {MERR, noap, MERR, MERR, noap, MERR, MERR}, /* m_accessDenied */
  {MERR, noap, noap, MERR, noap, MERR, MERR}, /* m_syncNotSupported */
  {MERR, noap, noap, MERR, noap, MERR, MERR}, /* m_invalidFilter */
  {NOAP, noap, MERR, noap, noap, noap, noap}, /* m_noSuchAttribute */
  {NOAP, noap, MERR, noap, noap, noap, noap}, /* m_invalidAttributeValue */
  {NOAP, noap, noap, noap, noap, LGER, noap}, /* m_getListError */
  {NOAP, noap, noap, noap, noap, noap, LSER}, /* m_setListError */
  {MERR, noap, noap, noap, noap, noap, noap}, /* m_noSuchAction */
  {PERR, PERR, PERR, PERR, PERR, PERR, PERR}, /* m_processingFailure */
  {NOAP, noap, MERR, noap, noap, noap, noap}, /* m_duplicateManagedObjectInstance */
  {NOAP, noap, MERR, noap, noap, noap, noap}, /* m_noSuchReferenceObject */
  {NOAP, noap, noap, noap, MERR, noap, noap}, /* m_noSuchEventType */
  {MERR, noap, noap, noap, MERR, noap, noap}, /* m_noSuchArgument */
  {MERR, noap, noap, noap, MERR, noap, noap}, /* m_invalidArgumentValue */
  {MERR, noap, noap, MERR, noap, MERR, MERR}, /* m_invalidScope */
  {NOAP, noap, MERR, noap, noap, noap, noap}, /* m_invalidObjectInstance */
  {NOAP, noap, MERR, noap, noap, noap, noap}, /* m_missingAttributeValue */
  {NOAP, noap, MERR, MERR, noap, MERR, MERR}, /* m_classInstanceConflict */
  {MERR, noap, noap, MERR, noap, MERR, MERR}, /* m_complexityLimitation */
  {MERR, noap, noap, noap, noap, noap, noap}, /* m_mistypedOperation  */
  {MERR, MERR, noap, noap, noap, noap, noap}, /* m_noSuchInvokeId */
  {MERR, noap, noap, noap, noap, MERR, noap}, /* m_operationCancelled */
  {MERR, noap, noap, noap, noap, noap, noap}, /* m_invalidOperation */
  {MERR, noap, noap, noap, noap, noap, noap}, /*  m_invalidOperator */
  {MERR, MERR, MERR, MERR, MERR, MERR, MERR}, /* m_duplicateInvocation */
  {MERR, MERR, MERR, MERR, MERR, MERR, MERR}, /* m_unrecognisedOperation */
  {MERR, noap, MERR, MERR, MERR, MERR, MERR}, /* m_mistypedArgument */
  {MERR, MERR, MERR, MERR, MERR, MERR, MERR} /* m_resourceLimitation */
}
;


/* ---------- ansi c templates for function calls --------------------- */
typedef OM_descriptor * (*FNX) ();
static int  arg_fail_OK (int, int, int, char *, MSAPIndication *);
static int  error_fail_OK (int, int, CMISErrors, MSAPIndication *);
static int  mod_value(CMISModifyOp);
static int pe_row(int,int,char *, OM_descriptor *, OM_descriptor *);
static void internal_ber(OM_descriptor *,PE,int *);
static void assign_null_string(OM_descriptor *);
static void assign_typed_pe(OM_descriptor *,PE);
static OM_descriptor * build_ds_rdn_obj(RDN);
static OM_descriptor * build_ds_dn_obj(DN);
static OM_descriptor * build_instance_obj(DN,int);
static int cmiserr2err(int);
static  desc_arr * checkAndCreateCallParameters(int,int,int,MID,MN,
                       CMISScope *, CMISFilter *, External *, CMISSync,int,desc_arr *,
                       MSAPIndication *);
static  desc_arr * checkErrorsAndCreateCallParameters(int,int,int,int,MID,
                       MN,char*,int, desc_arr *,
                       CMISErrors, CMISErrorInfo *, MSAPIndication *);
static OM_descriptor * create_filter_item_obj(CMISFilterItem *);
static OM_descriptor * create_filter_obj(CMISFilter *);
static OM_descriptor * create_action_arg_obj(desc_arr *);
static OM_descriptor * create_action_error_info_obj(int /*,CMISErrorInfo * */);
static OM_descriptor * create_action_rsp_obj(desc_arr *);
static OM_descriptor * create_action_info_obj(MID, PE);
static OM_descriptor * create_action_reply_obj(CMISParam *);
static OM_descriptor * create_action_type_id_obj(MID);
static OM_private_object create_agent_context(int,int,int);
static OM_descriptor * create_and_fill_2obj_obj(const OM_descriptor *, OM_descriptor *,
                       OM_descriptor *);
static OM_descriptor * create_and_fill_any_obj(const OM_descriptor *, OM_descriptor *,
                       PE);
static OM_descriptor * create_and_fill_common_req_obj(const OM_descriptor *,
                       desc_arr *, int,int *);
static OM_descriptor * create_and_fill_common_req_obj2(const OM_descriptor *,
                       desc_arr *, FNX);
static OM_descriptor * create_and_fill_common_rsp_obj(const OM_descriptor *,
                       desc_arr *,FNX);
static OM_descriptor * create_attribute_id_error_obj(CMISGetAttr*);
static OM_descriptor * create_attribute_error_obj(CMISSetAttr *);
static OM_descriptor * create_attrID_list_obj(desc_arr *);
static OM_descriptor * create_attrID_obj(MID);
static OM_descriptor * create_attrID_obj2(desc_arr *,int);
static OM_descriptor * create_attr_obj(CMISParam  *);
static OM_descriptor * create_attr_obj2(desc_arr  *,int);
static OM_descriptor * create_ava_obj(char *, char *); /* attributes */
static OM_descriptor * create_avas_obj(OID,PE);
static OM_descriptor * create_base_managed_object_id(OM_descriptor *,
                         OM_descriptor *);
static OM_descriptor * create_cancel_get_result_obj(desc_arr *);
static OM_descriptor * create_class_obj(MID,int);
static OM_descriptor * create_no_such_action_obj(CMISNoSuchArgument *,int);
static OM_descriptor * create_no_such_action_id_obj(CMISNoSuchArgument*,int);
static OM_descriptor * create_no_such_argument(CMISNoSuchArgument *,int,int);
static OM_descriptor * create_no_such_event_id_obj(CMISNoSuchArgument *,int);
static OM_descriptor * create_no_such_event_type_obj(CMISNoSuchArgument *,int);
static OM_descriptor * create_event_reply_obj(CMISParam *);
static OM_descriptor * create_event_type_id_obj(MID);
static OM_descriptor * create_create_argument_obj(OM_descriptor *,
                        OM_descriptor *, OM_descriptor *, OM_descriptor *,
                        OM_descriptor *, CMISParam* ,int);
static OM_descriptor * create_canGet_arg_obj(int);
static OM_descriptor * create_create_object_instance_obj(OM_descriptor *,
                        OM_descriptor *);
static OM_descriptor * create_create_rsp_obj(desc_arr *);
static OM_descriptor * create_delete_arg_obj(desc_arr *);
static OM_descriptor * create_delete_result_obj(desc_arr *);
static OM_descriptor * create_ds_dn_obj(int,OM_object *);
static OM_descriptor * create_event_rep_arg_obj(desc_arr *);
static OM_descriptor * create_event_resp_arg_obj(desc_arr *);
static OM_descriptor * create_form2_obj(AEI,int);
static OM_descriptor * create_get_arg_obj(desc_arr *);
static OM_descriptor * create_getListError_obj(desc_arr *);
static OM_descriptor * create_get_resp_obj(desc_arr *);
static OM_descriptor * create_info_list_obj(desc_arr *,int);
static OM_descriptor * create_instance_obj(MN,int);
static OM_descriptor * create_linked_reply_obj(OM_descriptor *);
static OM_descriptor * create_limitation_obj(CMISComplexityLimitation *);
static OM_descriptor * create_missing_attribute_value_obj(MIDListVal  *);
static OM_descriptor * create_mod_oper_obj(CMISModifyOp);
static OM_descriptor * create_modification_obj(desc_arr *,int);
static OM_descriptor * create_processing_failure_obj(CMISProcessingFailure *,
                         int);
static OM_descriptor * create_ServiceError_obj(CMISErrorInfo*,int,int,int,
               OM_descriptor *, int);
static OM_descriptor * create_set_arg_obj(desc_arr *);
static OM_descriptor * create_set_info_status_obj(desc_arr *, int);
static OM_descriptor * create_set_rsp_obj(desc_arr *);
static OM_descriptor * create_setListError_obj(desc_arr *);
static OM_descriptor * create_specific_error_info_obj(CMISParam *);
static OM_descriptor * create_scope_obj(CMISScope*);
static OM_descriptor * create_specific_error_info_obj(CMISParam *);
static OM_descriptor * create_substring_obj(CMISFilterSubstrings *);
static OM_descriptor * create_substrings_obj(CMISFilterSubstrings *);
static OM_descriptor * create_sync_obj(CMISSync);
static OM_descriptor * refine_proc_err(CMISErrorInfo *, CMISErrors, int, int,
                         int,int);
static int updateInvokeIdAndLinkedReply(OM_descriptor **,int, int);
#endif






