#ifndef	lint
static char *rcsid = "$Header: xmsap.c,v 1.3 94/12/19 10:14:59 mha Exp $";
#endif


/* $Header: xmsap.c,v 1.3 94/12/19 10:14:59 mha Exp $ */

/*
 * Copyright (c) 1994 Technical Research Centre of Finland
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* xmsap.c - common routines for xmp version of libmsap.a */

/*
 * By Matti Hallivuori, December 1994
 */
#include <stdio.h>
#include <xmsap.h>

extern int IamAgent=0; /* manager = 0, Agent = 1 */
extern int IamSun=0;
OM_EXPORT (MP_C_DS_RDN)
int attrNumEntries;
xom_ev xom_event[NR_EVENTS];
extern xom_head  xom_heads[];
invoke_map invokeIds[MAXINVOKEMAP];

/* Life Time memory allocation routines for moperation.c Space is reseved
 * for internal usage for the duration of one M_Xxxx call. All space is 
 * freed ay the end of the operation. THESE ROUTINES MUST NOT BE USED 
 * ELSEWHERE.
 */
static char _lifeTime[_lifeSize];
static int  _lifeTimeUsed=0;
void *om_malloc(size)
{
  void *mem;
  int _size;
  _size = _lifeTimeUsed+size;
  if (_size >=_lifeSize-3) {
    fprintf(stderr,"om_malloc: no space left, asked %d, free %d\n",size,
            _lifeSize-   _lifeTimeUsed-3);
    return 0;
  }
  mem = (void *) &_lifeTime[_lifeTimeUsed];
  _lifeTimeUsed = (_size+3) & 0xffffffc;
  return mem;
}

int om_free(desc)
OM_descriptor *desc;
{
  _lifeTimeUsed = 0;

}


/* Routines for mapping actual host invoke ID's to Internal invoke ID's */
int record_invoke_id(c,o)
int c,o;
{
int n;
/*  n = (c % MAXINVOKEMAP);*/
  n = c <  MAXINVOKEMAP ? c :0;
  invokeIds[n].osimis = o;
  invokeIds[n].com = c;
}

int replay_invoke(c)
int c;
{
int n;
/*  n = (c % MAXINVOKEMAP);*/
  n = c <  MAXINVOKEMAP ? c :0;
  if (invokeIds[n].com == c) {
    return invokeIds[n].osimis;
  }
  fprintf(stderr,"Invoke id %d  found %d \n",c,invokeIds[n].com);
  return NOTOK;
}

/* Routines for mapping manager AEI to msd for sending reports from
 * agent to manager specified in efd.
 */


char * int2str(elem,str)
int elem;
char *str;
{
  int n;
  n = sprintf(str,"%d",elem);
  str = &str[n];
  return str;
}

/* Converts primitive OID (ber without header info) to string notation */
char * berOID2str(pe)
PE pe;
{
  unsigned char *ber;
  int len;
  static char tmp[100];
  char *str;
  int i=0,ch,elem;
  ber = (unsigned char *) pe->pe_un1.un_pe_prim;
  len = pe->pe_len;

  ch = (unsigned int) '0';
  tmp[i++] = (char) ((((unsigned int) ber[0]) / 40)+ch);
  tmp[i++] = '.';
  str = &tmp[i];
  elem = (((unsigned int) ber[0]) % 40);
  str = int2str(elem,str);
  str[0] = '.';
  str++;
  len--;
  while(len>0) {
    ber++;
    if ((elem = (unsigned int) ber[0]) >= 128) {
    /* the element is coded with several characters by using 7 bits per char */
     elem = 0; 
     while (*ber & 0x80) {
       elem = elem | ((unsigned int) (*ber++ & 0x7f));
       elem <<= 7;
        len--;
      }
      elem = elem | ((unsigned int) (*ber++ & 0x7f));
   }
   str = int2str(elem,str);
   str[0] = '.';
   str++;
   len--;
  }
  str[-1] =0;
  return tmp;
}

static _lastMsd=1;
static int titleInTable(title)
PE title;
{
  int msd=1;
  char *name;
  if ((!title)) {
    fprintf(stderr,"bad aei_title in msd-mapping call \n");
    return 0;
  }
  name = berOID2str(title);
  while (msd < _lastMsd) {
    if (xom_event[msd].name) {
      if (0 == strcmp(name,xom_event[msd].name)) {
        return msd;
      }
    }
    msd++;
  }
  return 0;
}

int aeTitle2Msd(title)
PE title;
{
  struct PSAPaddr  *pa;
  OM_descriptor *addr;  
  AEInfo aeis;
  AEI aei;
  int msd;
  if(msd = titleInTable(title)) {
    return msd + NR_HEADS;
  }
  pa = title2agentPa(title);
  if (NULLPA == pa) {
    fprintf(stderr,"Manager title not found\n");
    return NOTOK;
  }
  msd = _lastMsd++;
  if (0 == (addr = pa2xomAddress(pa,NULLAEI))) {
    return NOTOK;
  }
  xom_event[msd].name = berOID2str(title);
  pub2priv(0,addr,&xom_event[msd].paddr); 
  return msd+NR_HEADS;
}

OID app2oid(char * host, char * app)
{
  AEI aei;
  if ((!host) || (!app)) {
    fprintf(stderr,"app2oid needs two args - received %s %s\n",host,app);
    return (OID) 0;
  }
  aei = (AEI) str2aei_stub(host,app);
  if (!aei) {
    return (OID) 0;
  }
  return prim2oid(aei-> aei_ap_title);
}

OID currentAssoc2oid()
{
  return  paddr2title(xom_heads[0].p_select,xom_heads[0].n_addr,
                    xom_heads[0].ln);
}

/* Life Time memory allocation with multiple lifeTimeGroups. New group is
 * allocated with the setNewLifeTimeGroup(mi) procedure. The parameter must
 * be the same pointer that will be used in mi_free(mi) procedure to free
 * the LFG. Memory is allocated from the current group with mi_malloc call.
 * Any reserved group is freed with mi_free(mi). These routines are mainly 
 * designed to be used inside mindicate. Due to multiple LFG it is possible
 * to use them also from other routines. CARE MUST BE TAKEN TO FREE LFG
 * VERY SOON in order to not roun our of memory.
 */

static int _doInitialiselifeTimeMemory=1;
static char _lifeTime2[NROFLFRS*_lifeSize2];
const unsigned int _lf2first = (unsigned int) &_lifeTime2[0];
const unsigned int _lf2last = (unsigned int) &_lifeTime2[NROFLFRS*_lifeSize-1];
static int  _lifeTimeUsed2[NROFLFRS];
static MSAPIndication * _lifeTimEmi[NROFLFRS];
static int  _lifeTimeGRP=0;
static int  _lifeTimeBaseAddr=0;

int setNewLifeTimeGroup(mi)
MSAPIndication * mi;
{
  int i=0;
  if (_doInitialiselifeTimeMemory) {
    memset(_lifeTimeUsed2,0,sizeof(_lifeTimeUsed2));
    memset(_lifeTimEmi,0,sizeof(_lifeTimEmi));
    _doInitialiselifeTimeMemory= 0;
  }

  while (i<NROFLFRS) {
    _lifeTimeGRP = (_lifeTimeGRP + 1) < NROFLFRS ? _lifeTimeGRP +1 : 0;
    if (0 == _lifeTimeUsed2[_lifeTimeGRP]) {
      _lifeTimeBaseAddr = _lifeTimeGRP*_lifeSize2;
      _lifeTimEmi[_lifeTimeGRP] = mi;
      break;
    }
    i++;
  }
  if (NROFLFRS == i) {
    fprintf(stderr,"All lifeTimeGroups are already allocated\n");
  }
  return i;
}

void *mi_malloc(size)
{
  int used;
  void *mem;
  if (((used = _lifeTimeUsed2[_lifeTimeGRP])+size) >=_lifeSize2-3) {
    fprintf(stderr,"mi_malloc: no space left, asked %d, free %d\n",size,
           _lifeSize2-  used -3);
    return 0;
  }
  mem = (void *) &_lifeTime2[_lifeTimeBaseAddr+used];
  _lifeTimeUsed2[_lifeTimeGRP] =  (used +size +3) & 0xffffffc;;
  return mem;
}

void  mi_free (mi)
MSAPIndication * mi;
{
  int grp,i=0;
  if (!mi) {
    return;
  }
  grp = _lifeTimeGRP;
  while (i <NROFLFRS) {
    if (mi == _lifeTimEmi[grp]) {
      _lifeTimeUsed2[grp] = 0;
      _lifeTimEmi[grp] = 0;
      break;
    }
    i++;
/*    grp = (grp +1) % NROFLFRS;*/
    grp = (grp +1) < NROFLFRS ? grp+1 : 0;
  }
  if ((i >= NROFLFRS) && (mi->mi_type)) {
    fprintf(stderr,"mi_free used for non lifeTimeGroup memory freeing\n");

  }
}

/* These frees are mingled to code and must be hacked for LFT */
dn_comp_free (dn)
DN dn;
{
  unsigned int addr;
  addr = (unsigned int) dn->dn_rdn;
  if ((addr > _lf2last) || ((addr <_lf2first) && (addr))) {
    rdn_free (dn->dn_rdn);
   free ((char *) dn);
  }
}

dn_free (dn)
DN dn;
{
  register DN eptr;
  register DN next;
  for (eptr = dn; eptr != NULLDN; eptr=next) {
    next = eptr->dn_parent;
    dn_comp_free (eptr);
  }
}

void  mid_free (mid)
MID mid;
{
  unsigned int addr;
  if (!mid)
    return;
  addr = (unsigned int) mid -> mid_global;
  if (mid -> mid_type == MID_GLOBAL && mid -> mid_global) {
    if ((addr > _lf2last) || ((addr <_lf2first) && (addr))) {
      if (mid->mid_global) 
         oid_free(mid -> mid_global);
    }
    mid -> mid_global = NULLOID;
  }
}

#define free_string(str) \
   if (str->value.string.length > 0) {\
     free(str->value.string.elements);\
     str->value.string.length = 0; }\

/* NOTE Syntax values correspond directly to Universal Tag values */


int chartohex(char c)
{
  if (isdigit(c)) return (0xFF & (c-'0'));
  return (10+(0xFF & (toupper(c)-'A')));
}

char *alphahexatostr(char *src, int *len)
/*	char	*src;	alphanumeric string to be converted */
/*	int	*len;	returned length of result (+1 for null) */
{
  int	i= strlen(src);
  int	j= (i+1)/2; 
  char	*res= (char *) om_malloc(sizeof(char)*(j+1));
  char	*ptr= res;
  if (res==NULL) return(NULL);
  *len = j;
  while (i>0)
 	if (isxdigit(*src) && isxdigit(*(src+1))) {
 		*ptr++= (char) (chartohex(*src)<<4 | chartohex(*(src+1)));
 		i-= 2; src+= 2;
 	} else {
 		free(res); return(NULL);
 	}
 return(res);
}

extern int oid2syntax2(OIDentifier *oid)  /* index to attribute syntax */
{
  oid_table_attr * atr;
  atr = oid2attr(oid);
  if (atr) {
    return atr->oa_syntax;
  } else {
    return 0;
  }
}

int string_defined(str)
char *str;
{
  int i = ((str != 0) && (*str != 0)) ? 1 : 0;
  return i;
}

/* XMP related messages are always presented as XOM structures. The 
 * construction of such structures is in this implementation done by copying
 * selectively needed rows from the template array and by updating the
 * variable part. The templates are named in the same way as the respective
 * XOM objects (mostly shohrtened). The updated part may contain a direct 
 * value (integer, enumeration
 * boolean, OID string) or pointer to further object or string. 
 * The strings are (in this implementation) in most cases presened as 
 * OM_S_ENCODED strings. This means, that the stings are presented in BER
 * encoded form. In this way it is possible to handle very strighforward
 * the anyType by calling assign_ber() provedure which transforms PE to
 * OM_S_ENCODED string.
 */

OM_descriptor *  create_ds_rdn_obj2(cnt,avas,mem)
int cnt;
OM_object *avas;
int mem;
{
int i;
OM_descriptor *desc;
static const OM_descriptor    ds_rdn[] = {
   OM_OID_DESC(OM_CLASS, MP_C_DS_RDN),
 { MP_AVAS, OM_S_OBJECT, {0, 0} },  /* MP_C_AVA */
   OM_NULL_DESCRIPTOR,
  };

   desc = mem ?(OM_descriptor *) malloc((cnt+2)*DSCSIZE):
               (OM_descriptor *) om_malloc((cnt+2)*DSCSIZE);
   memcpy(desc,ds_rdn,DSCSIZE);
   for (i=1;i<=cnt;i++) {
     desc[i] = ds_rdn[1];  /* copy AVA atributes */
     desc[i].value.object.object = avas[i-1];
   }
   desc[cnt+1] = ds_rdn[2];  /* null descriptor */
   return desc;    
}

/* This routine is outside of the life time memory management - memory must be released
 * explicitly.
 */

OM_descriptor *  create_ds_rdn_obj(cnt,avas)
int cnt;
OM_object *avas;
{
  return  create_ds_rdn_obj2(cnt,avas,1);
}

int pub2priv(msd,pub,priv)
int msd;
OM_descriptor *pub;
OM_private_object *priv;
{
OM_workspace            workspace;
OM_object_identifier class;
OM_object source;
OM_private_object       res;
OM_return_code          ret;
OM_value_position       cnt;
OM_object        pubobj;
  class = pub[0].value.string;
  source = &pub[0];
  workspace = xom_heads[msd].workspace;  
  ret = om_create (class,OM_FALSE,workspace, &res);
  if (ret) 
    goto fail;
  ret = om_put (res,OM_INSERT_AT_BEGINNING,pub,NULL,0,0);
  if (ret)
    goto fail;
  ret = om_get (res,OM_NO_EXCLUSIONS,NULL,OM_FALSE,OM_ALL_VALUES,
                    OM_ALL_VALUES,&pubobj,&cnt);
  if (ret)
    goto fail;
  pub = &pubobj[0];
  *priv = res;
  return OK;

 fail:
  fprintf(stderr,"Conversion to private object failed err %d \n",ret);
  return NOTOK;
}









