/*
 * Copyright (c) 1988 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* extern.c - creates and fills an External (i.e. type_UNIV_EXTERNAL)
 *	       structure
 */

/* By George Pavlou, April 1990 */


#include <stdio.h>
#include "msap.h"


/* LINTLIBRARY */

External* external_build (type, context, context_id, pe, octet_aligned)
int type;
char* context;
int context_id;
PE pe;
struct qbuf* octet_aligned;
{
    External * external;

    if ((external = (External *) calloc(1, sizeof(External))) == NULL ||
		(external -> encoding = (struct choice_UNIV_0 *)
			calloc(1, sizeof(struct choice_UNIV_0))) == NULL)
	return NULLEXTERN;

    if (context)
	external -> direct__reference = oid_cpy(str2oid(context));
    else
    if (context_id)
	external -> indirect__reference = context_id;

    switch (external -> encoding -> offset = type) {
    case EXTERN_ASN1_TYPE:
	if ((external -> encoding -> un.single__ASN1__type = pe) == NULLPE) {
	    (void) fprintf(stderr, "msap: external_build: missing pe \
parameter for type EXTERN_ASN1_TYPE!\n");
	    return NULLEXTERN;
	}
	break;

    case EXTERN_OCTET_ALIGNED:
	if ((external -> encoding -> un.octet__aligned = octet_aligned)
			== (struct qbuf *) NULL) {
	    (void) fprintf(stderr, "msap: external_build: missing \
octet_aligned parameter for type EXTERN_OCTET_ALIGNED!\n");
	    return NULLEXTERN;
	}
	break;

    case EXTERN_ARBITRARY:
	if ((external -> encoding -> un.arbitrary = pe) == NULLPE) {
	    (void) fprintf(stderr, "msap: external_build: missing pe \
parameter for type EXTERN_ARBITRARY!\n");
	    return NULLEXTERN;
	}
	break;

    default:
	(void) fprintf(stderr, "msap: external_build: invalid type %d!\n",type);
	return NULLEXTERN;
    }

    external -> data__value__descriptor = NULL;
    return external;
}
