
IMIBTOOL(N)		USER COMMANDS			IMIBTOOL(N)


NAME
     imibtool - convert Internet SNMPv1 MIB description into an OSI
     GDMO MIB description


SYNOPSIS
     imibtool
        -Y1 MibName1 .. MibNameN \
        [-Y2 ASN.1ModuleName] \
        MibIncludeFilename > filename.gdmo


DESCRIPTION
     The input "MibIncludeFilename" is an include file of MIBs and SMIs to
     be parsed by imibtool.  Here is an example from "mibs/mibii" include
     file:

         -- file: MIBII - MIB II (with SNMP generic traps)
         -- include base mibs
         #include "rfc1155.smi"    -- SMI items
         #include "rfc1212.smi"    -- OBJECT-TYPE macro
         #include "rfc1215.smi"    -- TRAP-TYPE macro
         #include "rfc1213.mib"    -- MIB-II
         #include "rfc1215.trp"    -- SNMP generic traps
         #include "rfc1354.mib"    -- IP Forwarding Table MIB

      The -Y1 options are used to specify which SNMPv1 MIBs in the
      above include file should be converted to GDMO.  For example,
      imibtool "-Y1 RFC1213-MIB" would only convert that one MIB description
      to GDMO in the output file and no others, likewise
      "-Y1 RFC1213-MIB RFC1354-MIB" would convert those 2 SNMPv1 MIB
      descriptions into GDMO in the output file.  Note that the include
      file specifies all the SNMPv1 MIB things for a complete MIB, but
      you may only want to convert some not all of the sub-MIBs.

      imibtool may also generate some ASN.1 definitions, as explained
      in the IIMC documents.  The ASN.1 module name to be used (inside
      the produced ASN.1 file) is set by the -Y2 option.     

      By default, imibtool writes the converted GDMO onto standard output.
      It also produces a seperate file called "gdmo-asn1.tmp" where the
      associated ASN.1 files are written.  

      The IIMC documents also define certain keywords generated into
      GDMO descriptions, that describe e.g. how attributes/MOs can
      be created or deleted.  It is not possible to automatically generate
      the correct CREATE/DELETE syntaxes into GDMO (like CREATE WITH-AUTOMATIC
      -INSTANCE-NAMING).  A person who understands the original SNMP mib
      can do this by appropriate post-processing of produced GDMO MIB
      description, e.g. using sed or awk scripts:
	 imibtool -Y1 MIB1 -Y2 MYASN incfile | sed -e MIB1.sed > MIB1.gdmo
      You can understand this better by looking at the "vtt.xxxx.sed" scripts
      in the "mibs" subdirectory, and by reading the IIMC documents.


OPTIONS
     -Y1 Mibname1 ... MibName 2
	which mib descriptions in the include file should be converted to
	GDMO, note that each Mibname is not a filename, but the MIB name
        used in the SNMPv1 MIB description

     [-Y2 ASN1ModuleName]
	what is the name of the ASN.1 module to be used in the produced
	"gdmo-asn1.tmp" file in case any ASN.1 definitions are also
	generated.  If you dont set this, a stupid default ASN.1 module name
        will be used instead.


OTHER NOTES
    You can give other SMIC command line options as well on the command
    line, this isnt recommended unless you know what you are doing

    My work on SMIC stopped because I hoped to get a version of smic 
    that would also handle SNMPv2, although a binary release of "smicng"
    (SMIC Next Generation) has been released that handles SNMPv2, no
    source code for this has been released from Bay Networks (was Synoptics).

    The "mibs/vtt.gdmo.sh" is a shell script for converting all the
    included Internet RFC MIB descriptions.  It could be looked at for
    examples, also the associated "mibs/vtt.xxxx.sed" scripts will help
    you understand how to generate appropriate CREATE/DELETE statements
    into the final GDMO.

EXAMPLE
    See mibs/vtt.gdmo.sh for some examples of how to convert the
    standard Internet RFC MIBs into GDMO.

    Here's how to e.g. convert MIBII (RFC 1213 and 1354):
       imibtool -Y1 "RFC1213-MIB RFC1354-MIB" \
                 -Y2 "IIMCRFC12131354ASN1" mibii \
                 | sed -f vtt.mibii.sed > vtt.mibii.gdmo
       mv gdmo-asn1.tmp vtt.mibii.asn1

    mibs/vtt.mibii.sed contains the sed script for making correct CREATE/DELETE
    statements into the final GDMO for MIBII, not that the script is
    completely dependent on how MIBII actually works.

    The ASN1 module name "IIMCRFC12131354ASN1" set by -Y2 is used inside the 
    gdmo-asn1.tmp temporary file.  This corresponds to the name for this
    ASN.1 module as defined in the IIMC MIB specs.

    The -Y1 options said which MIB descriptions in "mibii" include file
    should be converted to GDMO.


ERRORS
    The produced ASN.1 and GDMO filenames should probably be set by
    command line options, but most of these were already used up by
    the original smic.  Maybe they should be based on the names used
    in Y1 option.


SEE ALSO
    Original SMIC User's guide (readme.txt smicug.txt)


AUTHOR
    Dave Perkins of Synoptics (now Bay Networks) was the original
    author of SMIC.  

    James Reilly modified it to be IMIBTOOL when he worked at VTT.
    Now he works at Nokia (James.Reilly@research.nokia.com)


