#ifdef  __GNUG__
#include <std.h>
typedef	char * malloc_t ;
#elif   __cplusplus
#include <stdlib.h>
#endif

#if !defined(OK) || !defined(NOTOK)
#define OK      0
#define NOTOK   -1
#endif

#include <ctype.h>
#include "msap.h"
#include "Error.h"
#include "CmisAgent.h"
#include "Create.h"
#include "SnmpImageMOClassInfo.h"
#include "SnmpImageMO.h"

extern	char* etcdir ;

extern "C" {
	short str2syntax( char * ) ;
#if	!defined(SOLARIS) && !defined(__linux__) && !defined(__HPUX__)
	int   strncasecmp( char*, char*, int ) ;
#endif
}

void	advise() ;


//
// Buffer next line of file and remove leading whitespace characters.
// Discard any comment lines.
//
int	
SnmpImageMOClassInfo::bufferNextLine( char* linecp, int maxBufferLen, FILE* fp )
{
int	status = OK ;
char *	lcp ;
Bool	lineIsAComment = False ;

	*linecp = '\0' ;

	do {
	
	    if( (status = (fgets( linecp, maxBufferLen, fp ) == NULL ) ? NOTOK : OK) == OK &&
		(lineIsAComment = ( linecp[0] == '#' ) ? True : False ) == False ) {
		
	    	lcp = linecp + strlen( linecp ) - 1 ;

	    	// remove trailing whitespaces..
	    	while( lcp >= linecp && isspace( *lcp ) )
		    --lcp ;

	    	*(++lcp) = '\0' ;
	    }

	} while( status == OK && lineIsAComment == True ) ;

	return( status ) ;
}

//
// Remove spaces and return a pointer to the first
// non-whitespace character..
//
char * 	
SnmpImageMOClassInfo::removeAllSpaces( char * fromcp )
{
char *	tocp = fromcp, * firstNonWspcecp = NULLCP ;

	while( *fromcp )
	{
	    if( !isspace( *fromcp ) ) {
		if( firstNonWspcecp == NULLCP )
		    firstNonWspcecp =  tocp ;
				
		*tocp++ = *fromcp ;
	    }
			
	    fromcp++ ;
	}

	// Null terminate..
	*tocp = '\0' ;

	return( firstNonWspcecp ) ;
}

//
// Create the class information objects for a single MIB
//

int	
SnmpImageMOClassInfo::parseSingleMIBClassInfo( FILE * MIBfp, MIBInfo * newMibInfo )
{
const	int	MaxBufferLen = 512 ;
char	line[ MaxBufferLen ] ;
char *	cp, * cp1, *cp2, * classNamecp = NULLCP ;
char ** attrNameList    = (char **)NULL,
     ** nameBindingList = (char **)NULL, ** superiorClassList = (char **)NULL,
     ** namingAttributeList = (char **)NULL, * deleteAttrValuecp = NULLCP ;
short * attrSyntaxList = (short *)0, * attrIndexSyntaxList = (short *)0,
	SnmpGenericRDNsntx = -1, GraphicStringSntx = -1, fixedLenOctStrSntx = -1 ;
int  *	attrMatchesForList = (int *)NULL, * attrGetReplaceList = (int *)NULL,
     *  attrFixedOctStrLenList = (int *)NULL, * attrIndexFixedOctStrLenList = (int *)NULL,
     *	createList = (int *)NULL, * deleteList = (int *)NULL ;
AttrNotifType * attrNotifList = (AttrNotifType*)NULL ;
int	nbindings, nattrs, ngroups, nevents, nactions, npackages, nindices, 
	deleteAttrId ;
enum	{ ClassNameBlock, AttributeBlock, NameBindingsBlock,
		IndexOrBlankBlock, DeleteOrBlankBlock, BlankBlock } reqLexBlock = ClassNameBlock ;
int	status = OK, classStatus = OK, i, j, isBlkLine ;
Bool	eof = False, firstPostEofLoop = True ;
SnmpImageMOClassInfo * info = NULLIMAGEINFO, * firstImageInfo = NULLIMAGEINFO ;
Attr *  deleteAttr = NULL ;

CreateType createMask = CreateWithAutoInstanceNaming ;

	nbindings = nattrs = ngroups = nevents = nactions = npackages = nindices = 0 ;
	deleteAttrId = -1 ;

	GraphicStringSntx  = str2syntax( "GraphicString" ) ;
	SnmpGenericRDNsntx = str2syntax( "SnmpGenericRDN" ) ;
	fixedLenOctStrSntx = str2syntax( "SnmpFixedLenOctetString" ) ;

	firstImageInfo = info = new SnmpImageMOClassInfo( True, newMibInfo ) ;

	while( bufferNextLine( line, MaxBufferLen, MIBfp ) == OK ||
			((eof = (feof(MIBfp) != 0)) == True && (firstPostEofLoop == True) ) )
	{
	    // .. even at the eof one further iteration is needed to save buffered data
	    
	    isBlkLine = (*line == '\0') ;
	    
	    if( reqLexBlock == ClassNameBlock && !isBlkLine) {
#ifdef DEBUG
fprintf( stderr, "Buffering class name [%s]\n", line ) ;
#endif
		classNamecp = strdup( line ) ;
		reqLexBlock = AttributeBlock ;

	    } else if( reqLexBlock == AttributeBlock && strncmp( line, "ATTRS=", strlen( "ATTRS=" ) ) == 0 ) {

		if( (cp = strchr( line, '=' )) == NULL ) {
		    advise( NULLCP, "ClassInfoParse.cc: Missing equals seperator in %s", line ) ;
		    classStatus = NOTOK ;
		} else {
		
		    cp++ ; nattrs = atoi( cp ) ;

		    attrMatchesForList  = new int[nattrs] ;
		    attrGetReplaceList  = new int[nattrs] ;
		    attrFixedOctStrLenList = (int *)NULL ;
		    attrNameList	= new char*[nattrs] ;
		    attrSyntaxList	= new short[nattrs] ;
		    attrNotifList	= (AttrNotifType*)NULL ;

		    for( i=0 ; i < nattrs ; i++ ) {

		    	attrNameList[ i ] = NULLCP ;

			if( bufferNextLine( line, MaxBufferLen, MIBfp ) == OK ) {

			    cp1 = line ;
				
			    if( (cp2=strchr( line, '\t' )) == NULL ) {
			    	advise( NULLCP, "ClassInfoParse.cc: Missing tab delimiter in %s", line ) ;
			    	classStatus = NOTOK ;
			    } else {

				*cp2 = '\0' ; cp2++ ; attrNameList[ i ] = strdup( cp1 ) ;
				
				if( i==0 ) {
				    // Check that we have a naming attribute - 
				    // name must end in "Id"...
				    int strln = strlen( attrNameList[ i ] ) ;

				    if( strln < 3 || attrNameList[ i ][ strln-2 ] != 'I' || 
				    		     attrNameList[ i ][ strln-1 ] != 'd' ) {
					advise( NULLCP, "ClassInfoParse.cc: Invalid naming attribute name %s", attrNameList[ i ] ) ;
					classStatus = NOTOK ;
				    }
			   	}

			    	if( (cp1=strchr( cp2, '\t' )) == NULL ) {
			    	    advise( NULLCP, "ClassInfoParse.cc: Missing tab delimiter in %s", line ) ;
			    	    classStatus = NOTOK ;				
				} else {
				    *cp1 = '\0' ; cp1++ ; 
				    
				    if( (attrSyntaxList[ i ] = str2syntax( cp2 )) == 0 ) {
					advise( NULLCP, "ClassInfoParse.cc: Unknown syntax %s for attribute %s", cp2, attrNameList[ i ] ) ;
					classStatus = NOTOK ;
				    } else {
					if( i==0 ) { // The naming attribute..

					    // check the MIB input file syntax..
					    if( MIBInfo::getUseGenericRDNs() == FALSE &&
					    	    attrSyntaxList[ i ] != GraphicStringSntx ||
						MIBInfo::getUseGenericRDNs() == TRUE && 
						    attrSyntaxList[ i ] != SnmpGenericRDNsntx ) {

					    	advise( NULLCP, "ClassInfoParse.cc: %s has incorrect RDN syntax %s", attrNameList[i], cp2 ) ;
						advise( NULLCP, "You may need to toggle the \"UseGenericRDNs\" MIB config switch." ) ;

						classStatus = NOTOK ;
					    }
					}

					// Check the oidtable.at syntax matches the MIB input file syntax..
					AttributeType at = str2AttrT( attrNameList[i] ) ;

					if( at == NULLAttrT || at->oa_syntax <= 0 ) {
					    advise( NULLCP, "ClassInfoParse.cc: %s has an unknown syntax - check oidtable.at", attrNameList[i] ) ;
					    classStatus = NOTOK ;
					} else if( at->oa_syntax != attrSyntaxList[ i ] ) {
					    advise( NULLCP, "ClassInfoParse.cc: %s has different syntax in the MIB input file to that in oidtable.at", attrNameList[i] ) ;
					    classStatus = NOTOK ;
					}
				    }

				    if( (cp2=strchr( cp1, '\t' )) == NULL ) {
					advise( NULLCP, "ClassInfoParse.cc: Missing tab delimiter in %s", line ) ;
					classStatus = NOTOK ;				    
				    } else {
					*cp2 = '\0' ; cp2++ ; 
					
					attrMatchesForList[ i ] = atoi( cp1 ) ;

					if( (cp1=strchr( cp2, '\t' )) == NULL ) {

					    attrGetReplaceList[ i ] = atoi( cp2 ) ;

					    /* Note: No attribute notification nor octet string fixed 
				               length specification - should there have been ?...    */
					    if( attrSyntaxList[ i ] == fixedLenOctStrSntx ) {
						advise( NULLCP, "ClassInfoParse.cc: Missing fixed length octet string specificiation %s", line ) ;
					    	classStatus = NOTOK ;
					    }

					} else {
					
					    *cp1 = '\0' ; cp1++ ;

					    attrGetReplaceList[ i ] = atoi( cp2 ) ;

		    			    if( attrNotifList == (AttrNotifType*)NULL ) {
						attrNotifList = new AttrNotifType[nattrs] ;
						for( j=0; j<nattrs ; j++ )
						    attrNotifList[j] = NoAttrNotif ;
					    }

					    if( attrSyntaxList[ i ] == fixedLenOctStrSntx ) {

						if( attrFixedOctStrLenList == (int*)NULL ) {
						    attrFixedOctStrLenList = new int[nattrs] ;
						    for( j=0; j<nattrs; j++ )
							attrFixedOctStrLenList[j] = -1 ;
						}
						
						// May also be an attr notif specification in addition
						// to the required octet string length !

						if( (cp2=strchr( cp1, '\t' )) != NULL ) {
						    *cp2 = '\0' ; cp2++ ;

						    attrFixedOctStrLenList[ i ] = (int)atoi( cp1 ) ;

						    // Notif specification is ALSO present...
						    attrNotifList[ i ] = (AttrNotifType)atoi( cp2 ) ;
						    
						} else {

						    attrFixedOctStrLenList[ i ] = (int)atoi( cp1 ) ;
						}

					    } else {

						attrNotifList[ i ] = (AttrNotifType)atoi( cp1 ) ;
					    }
					}
			    	    }
				}
			    }
			}
		    }
		}

		reqLexBlock = NameBindingsBlock ;

	    } else if( reqLexBlock == NameBindingsBlock && strncmp( line, "NB=", strlen( "NB=" ) ) == 0 ) {

		if( (cp = strchr( line, '=' )) == NULL ) {
		    advise( NULLCP, "ClassInfoParse.cc: Missing equals seperator in %s", line ) ;
		    classStatus = NOTOK ;
		} else {

		    cp++ ; nbindings = atoi( cp ) ;

		    nameBindingList     = new char*[nbindings] ;
		    superiorClassList   = new char*[nbindings] ;
		    namingAttributeList = new char*[nbindings] ;
			
		    createList = new int[nbindings] ;
		    deleteList = new int[nbindings] ;

		    for( i=0 ; i < nbindings ; i++ ) {

			if( bufferNextLine( line, MaxBufferLen, MIBfp ) == OK ) {

			    cp1 = line ;

			    if( (cp2=strchr( cp1, '\t' )) == NULL ) {
			    	advise( NULLCP, "ClassInfoParse.cc: Missing tab delimiter in %s", line ) ;
			    	classStatus = NOTOK ;
			    } else {
			    
				*cp2 = '\0' ; cp2++ ; nameBindingList[ i ] = strdup( cp1 ) ;

			    	if( (cp1=strchr( cp2, '\t' )) == NULL ) {
			    	    advise( NULLCP, "ClassInfoParse.cc: Missing tab delimiter in %s", line ) ;
			    	    classStatus = NOTOK ;
				} else {

				    *cp1 = '\0' ; cp1++ ; superiorClassList[ i ] = strdup( cp2 ) ;

				    if( (cp2=strchr( cp1, '\t' )) == NULL ) {
				    	advise( NULLCP, "ClassInfoParse.cc: Missing tab delimiter in %s", line ) ;
				    	classStatus = NOTOK ;
				    } else {

					*cp2 = '\0' ; cp2++ ; namingAttributeList[ i ] = strdup( cp1 ) ;
			    		
					if( (cp1=strchr( cp2, '\t' )) == NULL ) {
					    advise( NULLCP, "ClassInfoParse.cc: Missing tab delimiter in %s", line ) ;
					    classStatus = NOTOK ;
					} else {

					    *cp1 = '\0' ; cp1++ ; createList[ i ] = atoi( cp2 ) ;
					    deleteList[ i ] = atoi( cp1 ) ;
					}
				    }
				}
			    }
			}
		    }
		}

		reqLexBlock = IndexOrBlankBlock ;

	    } else if( reqLexBlock == IndexOrBlankBlock && strncmp( line, "INDEX=", strlen( "INDEX=" ) ) == 0 ) {

		if( (cp = strchr( line, '=' )) == NULL ) {
		    advise( NULLCP, "ClassInfoParse.cc: Missing equals seperator in %s", line ) ;
		    classStatus = NOTOK ;
		} else {
		    cp++ ; nindices = atoi( cp ) ;

		    attrIndexSyntaxList = new short[nindices] ;

		    for( i=0 ; i < nindices ; i++ ) {

			if( bufferNextLine( line, MaxBufferLen, MIBfp ) == OK ) {

			    if( *line == '\0' ) {
				advise( NULLCP, "ERROR ClassInfoParse.cc: For class %s INDEX statement contains a blank line", 
									classNamecp, line ) ;
			    	classStatus = NOTOK ;
			    } else {

				int	attrIndexId = 0 ;

			    	// Find the INDEX attribute id from the attribute list
			    	for( attrIndexId=0 ; attrIndexId<nattrs && attrNameList[ attrIndexId ] != NULL && 
					strcasecmp( line, attrNameList[ attrIndexId ]) ; attrIndexId++ )
				    ; // No loop body required

			    	AttributeType at = str2AttrT( line ) ;

			    	if( attrIndexId == nattrs ) {

				    // ...the index attribute was not contained in the list of entry attributes

				    if( at != NULLAttrT ) {
				    	advise( NULLCP, "WARNING ClassInfoParse.cc: For class %s INDEX attribute %s not in ATTRS clause", 
									classNamecp, line ) ;
				    } else {
				
				    	advise( NULLCP, "ERROR ClassInfoParse.cc: For class %s INDEX attribute %s unknown OID", 
									classNamecp, line ) ;
			    	    	classStatus = NOTOK ;
				    }
			    	}

			    	if( classStatus == OK ) {

				    attrIndexSyntaxList[ i ] = at->oa_syntax ;

				    if( attrFixedOctStrLenList != (int *)NULL &&
						at->oa_syntax == fixedLenOctStrSntx ) {
				    
				    	if( attrIndexFixedOctStrLenList == (int *)NULL ) {
				    	    attrIndexFixedOctStrLenList = new int[nindices] ;
					    for( j=0; j<nindices ; j++ )
					    	attrIndexFixedOctStrLenList[j] = -1 ;
					}
					
					attrIndexFixedOctStrLenList[ i ] = attrFixedOctStrLenList[ attrIndexId ] ;
				    }
				}
			    }			    
			}
		    }
		}

		reqLexBlock = DeleteOrBlankBlock ;

	    } else if( reqLexBlock == DeleteOrBlankBlock && !isBlkLine ) {

		// Find the DELETEATT attribute id from the attribute list
		for( j=0 ; j<nattrs && attrNameList[ j ] != NULL && strcasecmp( line, attrNameList[ j ]) ; j++ )
		    ; // No loop body required

		if( j == nattrs ) {

		    advise( NULLCP, "ClassInfoParse.cc: For class %s Delete Attribute %s not in ATTRS clause", 
										classNamecp, line ) ;
		    classStatus = NOTOK ;

		} else deleteAttrId = j ;

		if( bufferNextLine( line, MaxBufferLen, MIBfp ) == OK ) {

		    // rempove leading spaces (GDMO compiler work around)..		 
		    char * cp = line ;
		    while( *cp && isspace( *cp ) )
		    	cp++ ;

		    if( (deleteAttrValuecp = strdup( cp )) == NULLCP ) {
			advise( NULLCP, "ClassInfoParse.cc: strdup failure for the line %s", line ) ;
		      	classStatus = NOTOK ;
			
		    } else if( (deleteAttr = new AnyType( attrSyntaxList[deleteAttrId], NULLVD )) == NULL ) {
			advise( NULLCP, "ClassInfoParse.cc: failure to instantiate a delete attribute for %s", line ) ;
			classStatus = NOTOK ;
			
		    } else if( (deleteAttr->setstr( deleteAttrValuecp )) != OK ) { // attempt to set up the "_val"
			advise( NULLCP, "ClassInfoParse.cc: parsing of delete value failed for %s", line ) ;
			classStatus = NOTOK ;
			
		    } else if( deleteAttr->encode() == NULLPE ) { // attempt to set up the "_pe"
		    	advise( NULLCP, "ClassInfoParse.cc: encoding for delete value failed for %s", line ) ;
		    	classStatus = NOTOK ;
		    }
		}

		reqLexBlock = BlankBlock ;

	    } else if( eof == True ||
	    	(reqLexBlock == IndexOrBlankBlock || reqLexBlock == DeleteOrBlankBlock || 
						reqLexBlock == BlankBlock ) && isBlkLine ) {

		// Buffer the received information..

		if( nattrs > 0 && classStatus == OK ) {

		    if( info == NULLIMAGEINFO )
			info =  new SnmpImageMOClassInfo( False, newMibInfo ) ;

		    info->setMCreate( SnmpImageMO::cmisCreate );

		    if( attrNotifList != (AttrNotifType*)NULL )
		    	++nevents ;

		    if( info->setClass( classNamecp, nbindings, nattrs, ngroups,
						nevents, nactions, npackages ) == OK &&
			info->setAttrImage( nattrs, attrSyntaxList,
				attrMatchesForList, attrGetReplaceList, attrFixedOctStrLenList, 
				nindices, attrIndexSyntaxList, attrIndexFixedOctStrLenList, 
				deleteAttrId, deleteAttrValuecp,
 				deleteAttr, attrNameList, attrNotifList ) == OK )
		    {
		    	if( attrNotifList != (AttrNotifType*)NULL &&
			    info->setEvent( "attributeValueChange", 0 ) == NOTOK ) {
				classStatus = NOTOK ;
			} else {

			    GetReplaceType ReplaceMask = Replace ;
		    
			    for( i=0 ; i<nattrs ; i++ ) {
			    	if( (classStatus = info->setAttr( attrNameList[ i ], i, 
			    			((attrGetReplaceList[i] & ReplaceMask) != 0) ? sm_set : sm_getOnly, 
										NULLATTR ) ) == NOTOK )
				    break ;
			    }
			}
		    }
		    else classStatus = NOTOK ;

		    if( classStatus == OK )
			for( i=0 ; i < nbindings ; i++ )
			    if( (classStatus = info->setNameBinding( nameBindingList[ i ],
				superiorClassList[ i ], namingAttributeList[ i ] )) == NOTOK )
				 break ;

		    if( classStatus == OK ) {

		    	info->setParent( Top::getClassInfo() ) ;

			classStatus = info->setNameBindingImage( createList, deleteList ) ;
		    }
		}

		if( classStatus == NOTOK )
		    status = NOTOK ;

		if( nameBindingList && superiorClassList && namingAttributeList ) {

		    for( i=0 ; i<nbindings ; i++ ) {
			(void)free( (char*)nameBindingList[i] );     nameBindingList[i]     = NULLCP ;
			(void)free( (char*)superiorClassList[i] );   superiorClassList[i]   = NULLCP ;
			(void)free( (char*)namingAttributeList[i] ); namingAttributeList[i] = NULLCP ;
		    }

		    (void)free((char*) nameBindingList ) ;     nameBindingList     = (char **)NULL ;
		    (void)free((char*) superiorClassList ) ;   superiorClassList   = (char **)NULL ;
		    (void)free((char*) namingAttributeList ) ; namingAttributeList = (char **)NULL ;
		}

		if( attrNameList ) {
		    (void)free((char*)attrNameList ) ;
		    attrNameList = (char**)NULL ;
		}

		// Prepare for the next iteration..
	    	info = NULLIMAGEINFO ; classStatus = OK ;
		nbindings = nattrs = ngroups = nevents = nactions = npackages = nindices = 0 ;
		deleteAttrId = -1, deleteAttrValuecp = NULLCP, deleteAttr = NULL ;

		reqLexBlock = ClassNameBlock ;

		if( eof == True )
		    firstPostEofLoop = False ; // ensure loop exit on the next iteration

	    } else if( !isBlkLine ) {

		advise( NULLCP, "ClassInfoParse.cc: MIB parser rejected the line..\n%s\n", line ) ;
		status = NOTOK ;
	    }
	}


	// Set up the containment pointers for this MIB..
	if( status == OK )
	    status =  newMibInfo -> constructContainment( firstImageInfo ) ;
	
	return( status ) ;
}



//
// Create the class information objects for all required MIBs reading etcdir/<file>
//
int	
SnmpImageMOClassInfo::initialiseSnmpClassInfo( char* filecp )
{
const	int	MaxBufferLen = 512 ;
char	filename[ MaxBufferLen ], fileNameLine[ MaxBufferLen ], * mibNamecp = NULLCP, 
	*coloncp, *leftTokencp = NULLCP, *rightTokencp = NULLCP ;
FILE *	fileListfp, * MIBfp  ; 
MIBInfo * mibInfo = NULLMIBINFO ;
OID	mibOID = NULLOID ;
int	status = OK ;

	// Open the file that contains the list of MIB descriptions..
	if( etcdir == NULLCP ) {

	    advise(NULLCP, "ClassInfoParse.cc: Internal etcdir variable has not been defined" ) ;
            status = NOTOK ;
	
	} else if ((fileListfp = fopen(strcat(strcpy(filename, etcdir), filecp), "r")) == (FILE *)NULL) {

	    advise(NULLCP, "ClassInfoParse.cc: cannot open CLASS INFO file list initialisation file:\n%s !", filename);
            status = NOTOK ;

	} else {

	    fileNameLine[ 0 ] = '\0' ;

	    // Run through each MIB specification file..
	    Bool	useGenericRDNsSpecifiedAlready = False ;
	    Bool	internetSystemClassSpecifiedAlready = False ;

	    MIBInfo::setInternetSystemClassName( "internetSystem" ) ; /* Default */
	    
	    while( (status == OK) &&
	    	   bufferNextLine( fileNameLine, MaxBufferLen, fileListfp ) == OK )
	    {
		if( fileNameLine[ 0 ] != '\0' && fileNameLine[ 0 ] != '#' && !isspace( fileNameLine[ 0 ] )) {
		
		    // Extract the left token and right tokens..

		    if( (coloncp = strchr( fileNameLine, ':' )) == NULLCP ) {

			advise( NULLCP, "ClassInfoParse.cc: Missing ':' seperator in CLASS INFO file list initialisation file\n%s\nLine %s\n", filename, fileNameLine ) ;

			status = NOTOK ;
			break ;
		    }

		    *coloncp = '\0' ; // extract off the left component
		    
		    if( (leftTokencp  = removeAllSpaces( fileNameLine )) == NULLCP ||
		    	(rightTokencp = removeAllSpaces( coloncp + 1  )) == NULLCP   ) {
			advise( NULLCP, "ClassInfoParse.cc: failure when removing white space from the right token\n when\
processing file list initialisation file\n%s\nLine %s\n", filename, fileNameLine ) ;

			status = NOTOK ;
		    }
		    
		    if( status == OK )
		    {
			// Check whether we are handling an "internetSystemClass" specification,
			// a "UseGenericRDNs switch
			// or MIB file specification..

			if( !strncasecmp( leftTokencp, "internetSystemClass", strlen("internetSystemClass") ) ) {

			    if( internetSystemClassSpecifiedAlready == True ) {
				advise(NULLCP, "ClassInfoParse.cc: Multiple \"internetSystemClass\" specifications in intialisation file %s", filename ) ;

			    } else {

				internetSystemClassSpecifiedAlready = True ;

			    	MIBInfo::setInternetSystemClassName( rightTokencp ) ;
			    }
			
			} else if( !strncasecmp( leftTokencp, "UseGenericRDNs", strlen("UseGenericRDNs") ) ) {

			    if( useGenericRDNsSpecifiedAlready == True ) {
				advise(NULLCP, "ClassInfoParse.cc: Multiple \"UseGenericRDNs\" specifications in intialisation file %s", filename ) ;

			    } else {

				useGenericRDNsSpecifiedAlready = True ;

				AttributeType rdnat ;
				rdnat = str2AttrT( MIBInfo::getInternetSystemIdName() ) ;

				if( rdnat == NULLAttrT ) {
				    advise( NULLCP, "ClassInfoParse.cc: %s not in oidtable.at", 
				    		MIBInfo::getInternetSystemIdName() ) ;
				    status = NOTOK ;
				    
				}else if( !strcasecmp( rightTokencp, "TRUE" ) ) {

				    short sntx = str2syntax( "SnmpGenericRDN" ) ;

				    if( sntx != rdnat->oa_syntax ) {

				    	advise( NULLCP, "ClassInfoParse.cc: %s does not have syntax SnmpGenericRDN",
						MIBInfo::getInternetSystemIdName()) ;
					advise( NULLCP, "You may need to toggle the \"UseGenericRDNs\" MIB config switch." ) ;
					status = NOTOK ;
				    
				    } else MIBInfo::setUseGenericRDNs( True );
			    
			       	} else if( !strcasecmp( rightTokencp, "FALSE" ) ) {

				    short sntx = str2syntax( "GraphicString" ) ;

				    if( sntx != rdnat->oa_syntax ) {

				    	advise( NULLCP, "ClassInfoParse.cc: %s does not have syntax GraphicString",
						MIBInfo::getInternetSystemIdName() ) ;
					advise( NULLCP, "You may need to toggle the \"UseGenericRDNs\" MIB config switch." ) ;
					status = NOTOK ;
				    
				    } else MIBInfo::setUseGenericRDNs( False );
			    
			   	} else {
			    
				    advise(NULLCP, "ClassInfoParse.cc: Invalid \"UseGenericRDNs\" flag %s in intialisation file %s", rightTokencp, filename ) ;
		    	    	    status = NOTOK ;
				}
			    }
			    			
			} else {

		            if( (mibOID = name2oid( rightTokencp )) == NULLOID ) {
			    
				advise( NULLCP, "ClassInfoParse.cc: MIB name not in \"oidtable.gen\" for file list initialisation\
file\n%s\nLine %s\t:\t%s\n", filename, leftTokencp, rightTokencp ) ;
				status = NOTOK ;
				
			    } else {

				mibInfo =  new MIBInfo( mibOID ) ;
 
		    	    	if ((MIBfp = fopen( strcat(strcat(strcpy(filename, etcdir), "iqadir/" ), leftTokencp ), "r")) == (FILE *)NULL) {

		    	    	    advise(NULLCP, "ClassInfoParse.cc: cannot open MIB intialisation file : %s", filename ) ;
		    	    	    status = NOTOK ;
		    	    	}
	    	    	    	else {

		    	    	    status = parseSingleMIBClassInfo( MIBfp, mibInfo ) ;

		    	    	    fclose( MIBfp ) ;
				}
			    }
			}
		    }
		}

	    	fileNameLine[ 0 ] = '\0' ;
	    }

	    fclose( fileListfp ) ;
	}

	return( status ) ;
}

