#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>

#include "msap.h"
#include "SmiSntx.h"
#include "PrxACCSntx-types.h"
#include "PrxIIMCSntx-syntax.h"
#include "PrxIIMCSntx-utils.h"
#include "PrxSV1Sntx-types.h"
#include "PrxAlarmSntx-types.h"
#include "IQASntx.h"

extern  int  empty_asn1_type;    /* from the msap library (attrv.c) */		
extern  char * prtparse () ;
extern  char * hexprint () ;

int	syntaxesBeingUsedByProxy = FALSE ;

/*
 * Support routines..
 */

/*
defined in SmiSntx.c...

char*  hexprint (char* str, int len)
{
    char *cp = (char*) malloc(3*len + 1), *tp = cp;
    if (!cp)
	return NULLCP;

    while (len--) {
	sprintf(tp, "\\%02x", *str);
	tp += 3; str++;
    }
    return cp;
}*/

char*
AttrT2str( at )
AttributeType	at ;
{
    PS 	  ps ;
    char *buf;

    if(((ps = ps_alloc (str_open)) == NULLPS)
		    || str_setup (ps, NULLCP, BUFSIZ, 0) == NOTOK)
	return NULLCP ;

    AttrT_print ( ps, at, EDBOUT );
    *ps->ps_ptr = NULL ;

    if ((buf = strdup(ps->ps_base)) == NULLCP) {
        ps_free(ps);
	return NULLCP;
    }
    ps_free(ps);
    return buf;
}

char *
removeLeadingSpaces( str )
char * 	str ;
{
	if( str != NULLCP ) {

	    while( *str && isspace( *str ) )
	    	++str ;
	}

	return str ;
}

/*
 * Contributed by NYSERNet Inc.  This work was partially supported by the
 * U.S. Defense Advanced Research Projects Agency and the Rome Air Development
 * Center of the U.S. Air Force Systems Command under contract number
 * F30602-88-C-0016.
 *
 * Some SNMP syntaxes partially based on those of Dr Rose.
 */
 
/* UNSIGNED LONGs */

static u_long	prim2ulong (pe)		/* also used in SNMP-capable gawk... */
register PE	pe;
{
    register u_long   i;
    register PElementData dp,
			  ep;

    if (pe -> pe_form != PE_FORM_PRIM || (dp = pe -> pe_prim) == NULLPED)
	return pe_seterr (pe, PE_ERR_PRIM, 0);
    if (pe -> pe_len > sizeof (i) + 1)
	return pe_seterr (pe, PE_ERR_OVER, 0);
    if (pe -> pe_len == sizeof (i) + 1 && (*dp & 0x7f))
	return pe_seterr (pe, PE_ERR_OVER, 0);
    if (*dp & 0x80)
	return pe_seterr (pe, PE_ERR_SIGNED, 0);

    pe -> pe_errno = PE_ERR_NONE;	/* in case result is ZERO-valued */
    i = 0L;
    for (ep = dp + pe -> pe_len; dp < ep;)
	i = (i << 8) | (*dp++ & 0xff);

    return i;
}


static PE  ulong2prim (i, class, id)	/* also used in SNMP-capable gawk... */
register u_long i;
PElementClass	class;
PElementID	id;
{
    int	    extend;
    register int    n;
    register u_long mask;
    register PElementData dp;
    register PE	    pe;

    if ((pe = pe_alloc (class, PE_FORM_PRIM, id)) == NULLPE)
	return NULLPE;

    mask = 0xff << (((n = sizeof i) - 1) * 8);
    while (n > 1 && (i & mask) == 0)
	mask >>= 8, n--;
    extend = (i & (0x80 << ((n - 1) * 8))) ? 1 : 0;

    if ((pe -> pe_prim = PEDalloc (n + extend)) == NULLPED) {
	pe_free (pe);
	return NULLPE;
    }

    for (dp = pe -> pe_prim + (pe -> pe_len = n + extend); n-- > 0; i >>= 8)
	*--dp = i & 0xff;
    if (extend)
	*--dp = 0x00;

    return pe;
}


PE	counter_enc( lp )
u_long	*lp ;
{
PE	pe ;

	pe = ulong2prim( *lp, PE_CLASS_APPL, 1) ;

	return pe ;
}

u_long *counter_dec( pe )
PE	pe ;
{
u_long  *lp, l = prim2ulong( pe ) ;

	if( l == 0 && pe -> pe_errno != PE_ERR_NONE)
	    return NULL ;

	if( (lp= (u_long*)malloc(sizeof( u_long ))) == NULL)
 	    return NULL ;
	 
	*lp = l ;

	return lp ;
}

void
counter_free( lp )
u_long  *lp;
{
    	free((char *) lp);
    	return ;
}

u_long * counter_cpy( lp )
u_long * lp ;
{
u_long * newlp ;

	if((newlp = (u_long*)malloc( sizeof(u_long))) == NULL )
	    return NULL ;

	*newlp = *lp ;

	return newlp ;
}

int	counter_cmp( l1p, l2p )
u_long	*l1p, *l2p ;
{
	return( *l1p == *l2p ? 0 : (*l1p > *l2p ? 1 : -1) ) ;
}

counter_print(ps, lp, format)
PS ps;
u_long *lp ;
int	format ;
{
    	ps_printf(ps, "%U", *lp);

    	return ;
}


u_long *
SnmpULong_cpy( lp )
u_long * lp ;
{
u_long *newlp = (u_long*)NULL ;

	if( lp != (u_long*)NULL &&
	    (newlp = (u_long*)malloc( sizeof( u_long ) ) ) != (u_long*)NULL )
	    *newlp = *lp ;

	return newlp ;
}

u_long  *SnmpULong_parse (str)
char *str;
{
u_long 	*lp, l = (u_long)0 ;

	if( str == NULL )
	    return NULL ;

    	if( strcasecmp( str, GENERICIQADEFAULTATTRVALUE ) != 0 )
    	    if( sscanf(str, "%U", &l) != 1 )
	    	return NULL ;

    	if( (lp = (u_long *)malloc(sizeof(u_long))) == NULL)
            return(NULL);

	*lp = l ;

    	return lp ;
}

PE	gauge_enc( lp )
u_long	*lp ;
{
PE	pe ;

	pe = ulong2prim( *lp, PE_CLASS_APPL, 2) ;

	return pe ;
}

PE	timeTicks_enc( lp )
u_long *lp ;
{
PE	pe ;

	pe = ulong2prim( *lp, PE_CLASS_APPL, 3) ;

	return pe ;
}



/* These are from string.c in dsap/common */

PE 	oid2pe() ;
int 	r_octprint();
struct 	qbuf * r_octparse();
PE 	r_octenc();
struct 	qbuf *r_octsdec();
struct 	qbuf *qb_cpy();
int 	qb_cmp();


/*
 * Hex format "0xAB:CD:DE:FA"
 */
static struct qbuf *
string_parse( s )
char * s ;
{
    struct qbuf * qb ;

    if (strncasecmp (s, "0x", 2) == 0) {

	int	len;
	char   *p;

	s += 2;
	if ((len = strlen (s)) % 3 != 2)
	    return NULL ;
	len /= 3, len++ ;
	if ((qb = str2qb (NULLCP, len, 1)) == NULL)
	    return NULL ;
	p = qb -> qb_forw -> qb_data;
	while (*s) {

	    int	    i;

	    if (sscanf (s, "%x", &i) != 1) {
oops: ;
		qb_free (qb);
		return NULL;
	    }
	    *p++ = i & 0xff;

	    s += 2;
	    if (*s && *s++ != ':')
		goto oops;
	}
    }
    else
	if ((qb = str2qb (s, strlen (s), 1)) == NULL)
	    return NULL ;

    return qb;    
}

int
static string_print(ps, v, format)
PS ps;
struct qbuf *v;
int format;
{
register char *cp, *ep;
char   *p;
register struct qbuf *qb;

	if( syntaxesBeingUsedByProxy == True ) {
	    p = "" ;
    	    for (qb =v -> qb_forw; qb != v; qb = qb -> qb_forw)
	        for (ep = (cp = qb -> qb_data) + qb -> qb_len; cp < ep; cp++) {
	    	    ps_printf( ps, "%s%d", p, *cp & 0xff);
	    	    p = ".";
	        }

	} else {
    	    p = "0x";
    	    for (qb =v -> qb_forw; qb != v; qb = qb -> qb_forw)
	        for (ep = (cp = qb -> qb_data) + qb -> qb_len; cp < ep; cp++) {
	    	    ps_printf( ps, "%s%02x", p, *cp & 0xff);
	    	    p = ":";
	        }
	}

	return OK ;
}


/* To return string lengths when NULLs may be present.. */
unsigned 
qbcharlen( q )
struct qbuf * q ;
{
register unsigned len ;
register char  *b, *d ;
register struct qbuf   *p;

    	p = q -> qb_forw, len = 0;

    	do {

	    len += p -> qb_len;

	    p = p -> qb_forw;

    	} while (p != q);

	return len ;
}


int
static string_display(ps, v, format)
PS ps;
struct qbuf *v;
int format;
{
    register struct qbuf *qb;

    ps_printf( ps, "\"");
    for (qb = v -> qb_forw; qb != v; qb = qb -> qb_forw)
	ps_printf( ps, "%*.*s", qb -> qb_len, qb -> qb_len, qb -> qb_data);

    ps_printf( ps, "\"");

    return OK ;
}

/*
 * Note: variable length strings..
 */
int
static SnmpRDNDisplayString_print(ps, v, format)
PS ps;
struct qbuf *v;
int format;
{
register struct qbuf *qb;
int i ;

    ps_printf( ps, "%d", qbcharlen( v ) ) ;
   
    for (qb = v -> qb_forw; qb != v; qb = qb -> qb_forw) {
    	for( i=0 ; i<qb -> qb_len ; i++ )
	    ps_printf( ps, ".%d", qb -> qb_data[i] );
    }    

    return OK ;
}


char *
dotRdnToHexStrFormat( dotrdncp, numSubIds )
char * 	dotrdncp ;
int	numSubIds ;
{
static	char hexrdnbuff[1024] ;
char*	retcp = hexrdnbuff, *cp1, *cp2 ;
int	hexrdnindex ;

	
	strcpy( hexrdnbuff, "0x" ), hexrdnindex = 2 ;
	cp1 = dotrdncp ;

	while( --numSubIds > 0 && (cp2 = strchr( cp1, '.')) != NULLCP ) {

	    *cp2 = '\0' ; /* NULL terminate */
	    sprintf( &hexrdnbuff[ hexrdnindex ], "%02x:", atoi( cp1 ) ) ;
	    hexrdnindex += 3 ;
 	    *cp2 = '.', cp1 = ++cp2 ; /* Skip last '.' */	    
	}

	sprintf( &hexrdnbuff[ hexrdnindex ], "%02x", atoi( cp1 ) ) ;
	
	return retcp ;
	
}

struct type_PrxSV1Sntx_SnmpOctetString *
SnmpOctetString_parse( str )
char *	str ;
{
struct type_PrxSV1Sntx_SnmpOctetString * osp = NULL ;
char *	lcp, *rcp ;
char	buffer[1024], *buffcp = buffer, bufferedchar ;
int	len ;

	if( str == NULLCP ) {
	    advise( NULLCP, "IQASntx.c: Invalid string in SnmpOctetString_parse() [%s]", str ) ;
		
	} else if( (len = strlen( str )) > 650 ) {
	    advise( NULLCP, "IQASntx.c: Insufficient buffer size in SnmpOctetString_parse() [%d]", len ) ;

	} else {

	    if( strcasecmp( str, GENERICIQADEFAULTATTRVALUE ) == 0 )
	    	osp = string_parse( "" ) ;

	    else if( *str == '\'' && 
	    	     (rcp = strrchr( str, '\'' )) != NULLCP &&
		     ((lcp = str) < rcp ) &&
		     (*(rcp+1) == 'h') ) {

		/* parse the hex representation.. */

		bufferedchar = *rcp ;

		*rcp = '\0' ; lcp++ ;

		len = strlen( lcp ) ;

		if( len % 2 != 0 ) {
		    advise( NULLCP, "IQASntx.c: Invalid hex string '%s'h in SnmpOctetString_parse()", lcp ) ;

		} else {

		    if( lcp == rcp ) { 
		    	/* ''h */
			strcpy( buffer, "" ) ; /* Empty string */

		    } else {

			/* Format the hex data for parsing by string_parse()... */
			
			strcpy( buffer, "0x" ) , buffcp += 2 ;
		    	
		    	while( lcp < rcp ) {
			
			    *buffcp++ = *lcp++ ;
			    *buffcp++ = *lcp++ ;

			    if( lcp < rcp )
			    	*buffcp++ = ':' ;
			}

			*buffcp = '\0' ; /* null terminate */
		    }

	    	    osp = string_parse( buffer ) ;
		}

		*rcp = bufferedchar ; /* replace this character */
		
	    } else osp = string_parse( str ) ;
	}
	
	return osp ;
}


struct type_PrxIIMCSntx_AccessControlEnforcement*
AccessControlEnf_parse( str )
char * str ;
{
	struct type_PrxIIMCSntx_AccessControlEnforcement* acep ;
	int	ace_parm = 0 ; 

	if( strcasecmp( str, "agent" ) == 0 )
	    ace_parm = int_PrxIIMCSntx_AccessControlEnforcement_agent ;

	else if( strcasecmp( str, "proxy" ) == 0 )
	    ace_parm = int_PrxIIMCSntx_AccessControlEnforcement_proxy ;

	else if( strcasecmp( str, "both" ) == 0 )
	    ace_parm = int_PrxIIMCSntx_AccessControlEnforcement_both ;

	else return NULL ;

	if( (acep = (struct type_PrxIIMCSntx_AccessControlEnforcement*)malloc(
			sizeof( struct type_PrxIIMCSntx_AccessControlEnforcement ))) != NULL ) {

	    acep->parm = ace_parm ;
	}
	
	return  acep ; /* May be NULL */    
}

struct  type_PrxIIMCSntx_TransportAddresses *
TransportAddresses_parse( str )
char * str ;
{
    /* {SnmpV1:0x80:10:08:0b:00:a1 SnmpV1:0x80:33:19:0b:00:a1} */

    struct  type_PrxIIMCSntx_TransportAddresses * val = NULL, **next = &val;
    type_PrxIIMCSntx_TransportDomain * transDomainOid ;
    int  len;
    char buf[128], *delimcp, *transAddcp, *tcp ;

    empty_asn1_type = 0;
    if ( (tcp = str = tidyString(str, 1)) == NULLCP )
        return NULL;
	
    if (strlen(str) == 0) {
	empty_asn1_type = 1;
	(void)free((char*)tcp) ;
	return NULL;
    }

    while (str != '\0') {

	if (sscanf(str, "%s", buf) <= 0) {
	    (void)free((char*)tcp) ;
	    return val;
	}
	
	len = strlen(buf);
	str = strstr(str, buf);		/* to skip preceding blanks */
	str += len;

	/* Extract off the domain component.. */
	if( (delimcp = strchr( buf, ':' )) == NULLCP ) {
	    if (val)
		(void) TransportAddresses_free(val);
	    (void)free((char*)tcp) ;
	    return NULL ;
	}

	*delimcp = '\0' ; 
	if ((transDomainOid = name2oid(buf)) == NULLOID) {

	    if (val)
		(void) TransportAddresses_free(val);
	    (void)free((char*)tcp) ;
	    return NULL;
	}
	
	transAddcp = ++delimcp ; /* Move to the transportAddress component */

	if( (*next = (struct  type_PrxIIMCSntx_TransportAddresses *) malloc(
				sizeof(struct type_PrxIIMCSntx_TransportAddresses))) == NULL) {
	    if (val)
		(void) TransportAddresses_free(val);
	    (void)free((char*)tcp) ;
	    return NULL;
	}

	if( ((*next)->member_PrxIIMCSntx_1 = (struct element_PrxIIMCSntx_2*)malloc(
				sizeof( struct element_PrxIIMCSntx_2 ))) == NULL ) {
	    if (val)
		(void) TransportAddresses_free(val);
	    (void)free((char*)tcp) ;
	    return NULL ;
	}

	(*next) -> member_PrxIIMCSntx_1->domain  = transDomainOid ;
	(*next) -> member_PrxIIMCSntx_1->address = SnmpOctetString_parse( transAddcp ) ;
	(*next) -> next = NULL;

	if( qb_pullup( (*next) -> member_PrxIIMCSntx_1->address ) == NOTOK ) {

	    if (val)
		(void) TransportAddresses_free(val);
	    (void)free((char*)tcp) ;
	    return NULL ;
	}

	next = &(*next)->next;
    }
    
    (void)free((char*)tcp) ;
    
    return val;
}

/* SnmpSecurityParameter.. */
void *
createCommunityStringSecurityParameter( communityString )
char * 	communityString ;
{
PE	snmpBitOperationPE ;

	struct type_PrxIIMCSntx_SnmpSecurity * sp ;

	sp = (struct type_PrxIIMCSntx_SnmpSecurity*)malloc( sizeof( struct type_PrxIIMCSntx_SnmpSecurity ) ) ;
	sp -> next = NULL ;
	sp -> member_PrxIIMCSntx_0 = (struct element_PrxIIMCSntx_1 *)malloc(
	 						sizeof( struct element_PrxIIMCSntx_1 )) ;
						
	sp -> member_PrxIIMCSntx_0 -> snmpOperation    = pe_alloc( PE_CLASS_UNIV, PE_FORM_PRIM, PE_PRIM_BITS ) ;
	snmpBitOperationPE = prim2bit( sp -> member_PrxIIMCSntx_0 -> snmpOperation ) ;
	(void)bit_on(  snmpBitOperationPE, bit_PrxIIMCSntx_SnmpOpType_get ) ;
	(void)bit_on(  snmpBitOperationPE, bit_PrxIIMCSntx_SnmpOpType_getNext ) ;
	(void)bit_on(  snmpBitOperationPE, bit_PrxIIMCSntx_SnmpOpType_response ) ;
	(void)bit_on(  snmpBitOperationPE, bit_PrxIIMCSntx_SnmpOpType_set ) ;
	(void)bit_off( snmpBitOperationPE, bit_PrxIIMCSntx_SnmpOpType_getBulk ) ;
	(void)bit_off( snmpBitOperationPE, bit_PrxIIMCSntx_SnmpOpType_inform ) ;
	(void)bit_off( snmpBitOperationPE, bit_PrxIIMCSntx_SnmpOpType_trap ) ;
	sp -> member_PrxIIMCSntx_0 -> snmpOperation = bit2prim( snmpBitOperationPE ) ;
	
	sp -> member_PrxIIMCSntx_0 -> snmpSecurityInfo = 
				(struct type_PrxIIMCSntx_AccessControlInfo *)malloc(
					sizeof( struct type_PrxIIMCSntx_AccessControlInfo )) ;
	sp -> member_PrxIIMCSntx_0 -> snmpSecurityInfo -> offset = type_PrxIIMCSntx_AccessControlInfo_communityString ;

	sp -> member_PrxIIMCSntx_0 -> snmpSecurityInfo -> un.communityString = str2qb( communityString, strlen( communityString ), 1 ) ;

	return (void*)sp ;
}

/* retrieve the community string.. */
struct 	qbuf *
retrieveCommunityStringSecurityParameter( sp )
struct type_PrxIIMCSntx_SnmpSecurity * sp ;
{
struct 	qbuf * communityString = NULL ;

	if( sp != NULL &&
	    sp -> member_PrxIIMCSntx_0 != NULL &&
	    sp -> member_PrxIIMCSntx_0 -> snmpSecurityInfo -> offset == type_PrxIIMCSntx_AccessControlInfo_communityString &&
	    sp -> member_PrxIIMCSntx_0 -> snmpSecurityInfo -> un.communityString != NULL ) {

	    communityString = qb_cpy( sp -> member_PrxIIMCSntx_0 -> snmpSecurityInfo -> un.communityString ) ;
	    
	}

	return communityString ;
}

/* IpAddress */

PE build_SnmpIpAddress( report )
struct type_PrxSV1Sntx_SnmpIpAddress *report;
{
	PE pe;

	if (build_PrxSV1Sntx_SnmpIpAddress(&pe, 1, 0, NULL, report) == NOTOK)
	   return(NULL);
	else
	   return(pe);
}

struct type_PrxSV1Sntx_SnmpIpAddress* parse_SnmpIpAddress(pe)
PE pe;
{
	struct type_PrxSV1Sntx_SnmpIpAddress *report;

	if (parse_PrxSV1Sntx_SnmpIpAddress(pe, 1, 0, NULL, &report) == NOTOK)
	   return(NULL);
	else
	   return(report);
}

int
IpAddress_equal( ip1qb, ip2qb )
struct	qbuf *ip1qb, *ip2qb ;
{
int	equal = 0 ;
char 	ipAddress1Buffer[BUFSIZ], ipAddress2Buffer[BUFSIZ], *cp ;

	if( ip1qb != NULL && (cp = qb2IpAddress(ip1qb)) != NULLCP ) {

	    strcpy( ipAddress1Buffer, cp ) ;

	    if( ip2qb != NULL && (cp = qb2IpAddress(ip2qb)) != NULLCP ) {

		strcpy( ipAddress2Buffer, cp ) ;

		if( strcmp( ipAddress1Buffer, ipAddress2Buffer ) == 0 )
		    equal = 1 ;
	    }
	}

	return equal ;
}
					  
/* Curtesy of Saleem Bhatti... */

#define DIGIT(d) (u_int) ((u_char) (d))

char *
qb2IpAddress( ipqb )
struct qbuf *ipqb ;
{
static char ipAddressBuffer[BUFSIZ] ;
    
    /* Assume that address is in 1 qbuf */
    register
    struct qbuf * qb ;
    struct in_addr addr;
    register
    u_long s;

    if ((ipqb == NULL) || ((qb = ipqb->qb_forw) == NULL) || 
    			(qb->qb_len != 4 && qb->qb_len != 6)) {
					    /* In case a trailing port number
					       is included */
	return NULLCP ;
    }

    addr.s_addr = 0;
    addr.s_addr = (DIGIT(qb->qb_data[0]) << 24) |
	          (DIGIT(qb->qb_data[1]) << 16) |
	          (DIGIT(qb->qb_data[2]) << 8) |
		  (DIGIT(qb->qb_data[3]));

    s = ntohl(addr.s_addr);

    sprintf( ipAddressBuffer, "%d.%d.%d.%d", (s >> 24) & 0xff,
                                 	     (s >> 16) & 0xff,
                                 	     (s >>  8) & 0xff,
                                  	      s        & 0xff);
	      
    return ipAddressBuffer ; /* static buffer */
}

int
SnmpProxyIpAddress_print(ps, v, format)
PS ps;
struct qbuf *v;
int format;
{
    /* Assume that address is in 1 qbuf */
    register
    struct qbuf *qb;
    struct in_addr addr;
    register
    u_long s;

    if ((v == NULL) || ((qb = v->qb_forw) == NULL) || (qb->qb_len != 4)) {
	ps_printf(ps, "<bad value>");
	return(NOTOK);
    }

    addr.s_addr = 0;
    addr.s_addr = (DIGIT(qb->qb_data[0]) << 24) |
	          (DIGIT(qb->qb_data[1]) << 16) |
	          (DIGIT(qb->qb_data[2]) << 8) |
		  (DIGIT(qb->qb_data[3]));

    s = ntohl(addr.s_addr);

    ps_printf(ps, "%d.%d.%d.%d", (s >> 24) & 0xff,
                                 (s >> 16) & 0xff,
                                 (s >>  8) & 0xff,
                                  s        & 0xff);
	      
    return(OK);
}


/* Curtesy of Saleem Bhatti... */

struct qbuf *
SnmpProxyIpAddress_parse(str)
char *str;
{
    register
    struct qbuf *v, *head;
    struct in_addr addr;

    register
    u_long s = 0;
    register
    int i;

    u_char value[4];
    u_int n0 = 0, n1 = 0, n2 = 0, n3 = 0;

    if (str == NULL)
	return(NULL);

    if( strcasecmp( str, GENERICIQADEFAULTATTRVALUE ) != 0 ) {
    
	i = sscanf(str, "%u.%u.%u.%u", &n0, &n1, &n2, &n3);
    	if ((n0 > 255) || (n1 > 255) || (n2 > 255) || (n3 > 255)) return(NULL);

    	switch (i) {

    	  case 4 :
      	  	s = (n0 << 24) | (n1 << 16) | (n2 << 8) | n3;
      	  break;

      	  case 3 :
        	s = (n0 << 24) | (n1 << 16) | n2;
          break;

          case 2 :
        	s = (n0 << 24) | n1;
          break;
    	}

    } /* else s = 0 */

    addr.s_addr = htonl(s);

    value[0] = (addr.s_addr & 0xff000000) >> 24;
    value[1] = (addr.s_addr & 0x00ff0000) >> 16;
    value[2] = (addr.s_addr & 0x0000ff00) >> 8;
    value[3] = (addr.s_addr & 0x000000ff);

    return(str2qb(value, 4, 1));
}

/*
 * NetworkAddress = IpAddress with the extra tag sub-identifier.
 */

PE build_SnmpNetworkAddress( report )
struct type_PrxSV1Sntx_SnmpNetworkAddress *report;
{
	PE pe;

	if (build_PrxSV1Sntx_SnmpNetworkAddress(&pe, 1, 0, NULL, report) == NOTOK)
	   return(NULL);
	else
	   return(pe);
}

struct type_PrxSV1Sntx_SnmpNetworkAddress* parse_SnmpNetworkAddress(pe)
PE pe;
{
	struct type_PrxSV1Sntx_SnmpNetworkAddress *report;

	if (parse_PrxSV1Sntx_SnmpNetworkAddress(pe, 1, 0, NULL, &report) == NOTOK)
	   return(NULL);
	else
	   return(report);
}

int
SnmpProxyNetworkAddress_print(ps, v, format)
PS ps;
struct qbuf *v;
int format;
{
    /* Assume that address is in 1 qbuf */
    register
    struct qbuf *qb;
    struct in_addr addr;
    register
    u_long s;

    if ((v == NULL) || ((qb = v->qb_forw) == NULL) || (qb->qb_len != 4)) {
	ps_printf(ps, "<bad value>");
	return(NOTOK);
    }

    addr.s_addr = 0;
    addr.s_addr = (DIGIT(qb->qb_data[0]) << 24) |
	          (DIGIT(qb->qb_data[1]) << 16) |
	          (DIGIT(qb->qb_data[2]) << 8) |
		  (DIGIT(qb->qb_data[3]));

    s = ntohl(addr.s_addr);

    /* Includes the prepended IpAddress tag */
    ps_printf(ps, "1.%d.%d.%d.%d", (s >> 24) & 0xff,
                                   (s >> 16) & 0xff,
                                   (s >>  8) & 0xff,
                                    s        & 0xff);
	      
    return(OK);
}

struct qbuf *
SnmpProxyNetworkAddress_parse(str)
char *str;
{
    register
    struct qbuf *v, *head;
    struct in_addr addr;

    register
    u_long s = 0;
    register
    int i;

    u_char value[4];
    u_int tag = 0, n0 = 0, n1 = 0, n2 = 0, n3 = 0;

    if (str == NULL)
	return(NULL);

    if( strcasecmp( str, GENERICIQADEFAULTATTRVALUE ) != 0 ) {
    
	i = sscanf(str, "%u.%u.%u.%u.%u", &tag, &n0, &n1, &n2, &n3);

	if ( tag != 1 ) return(NULL); /* Non IpAddress tag */

	--i ; /* Ignore the tag sub-identifier */
	
    	if ((n0 > 255) || (n1 > 255) || (n2 > 255) || (n3 > 255)) return(NULL);

    	switch (i) {

    	  case 4 :
      	  	s = (n0 << 24) | (n1 << 16) | (n2 << 8) | n3;
      	  break;

      	  case 3 :
        	s = (n0 << 24) | (n1 << 16) | n2;
          break;

          case 2 :
        	s = (n0 << 24) | n1;
          break;
    	}

    } /* else s = 0 */

    addr.s_addr = htonl(s);

    value[0] = (addr.s_addr & 0xff000000) >> 24;
    value[1] = (addr.s_addr & 0x00ff0000) >> 16;
    value[2] = (addr.s_addr & 0x0000ff00) >> 8;
    value[3] = (addr.s_addr & 0x000000ff);

    return(str2qb(value, 4, 1));
}

int *
SnmpInteger_parse( str )
char *	str ;
{
int	* ip = NULL ;

	if( str != NULLCP ) {

	    if( (ip = (int*)malloc( sizeof( int ))) != NULL ) {

		if( strcasecmp( str, GENERICIQADEFAULTATTRVALUE ) != 0 )
		    *ip = atoi( str ) ;
		else
		    *ip = -1 ;
	    }
	}

	return ip ;
}

struct type_PrxSV1Sntx_SnmpOID *
SnmpOID_parse( str )
char *	str ;
{
type_PrxSV1Sntx_SnmpOID	* oidp = NULLOID ;

	if( str != NULLCP ) {

	    if( strcasecmp( str, GENERICIQADEFAULTATTRVALUE ) != 0 )
		oidp = name2oid( str ) ;
	    else
	    	oidp = oid_cpy( str2oid( "0.0" ) ) ;
	}
	
	return oidp ;
}


PE build_SnmpNULL(report)
struct type_PrxSV1Sntx_SnmpNULL *report;
{
	PE pe;

	if (build_PrxSV1Sntx_SnmpNULL(&pe, 1, 0, NULL, report) == NOTOK)
	   return(NULL);
	else
	   return(pe);
}

struct type_PrxSV1Sntx_SnmpNULL* 
parse_SnmpNULL(pe)
PE pe;
{
	struct type_PrxSV1Sntx_SnmpNULL *report;

	if (parse_PrxSV1Sntx_SnmpNULL(pe, 1, 0, NULL, &report) == NOTOK)
	   return(NULL);
	else
	   return(report);
}


struct type_PrxSV1Sntx_SnmpNULL *
NULL_parse( str )
char *	str ;
{
struct type_PrxSV1Sntx_SnmpNULL * np = NULL ;

	np = (struct type_PrxSV1Sntx_SnmpNULL *)calloc(1,sizeof( struct type_PrxSV1Sntx_SnmpNULL )) ;

	return np ;
}

int
NULL_print( ps, lp, format )
PS 	ps;
u_long *lp ;
int	format ;
{
	ps_printf(ps, "NULL" ) ;

	return ;
}

int
NULL_compare( n1p, n2p )
struct type_PrxSV1Sntx_SnmpNULL *n1p, *n2p ;
{
	return 0 ;
}

void
SnmpNULL_free( nullp )
struct type_PrxSV1Sntx_SnmpNULL *nullp ;
{
	if( nullp == NULL )
	    return ;
	else
	    free_PrxSV1Sntx_SnmpNULL( nullp ) ;
}


/*
 * SnmpGenericRDN
 */ 

/*
 * Note: the elements of snmpV1rdnSyntaxNumbers[] and the #defines that
 *       follow must correspond to the SnmpRDNcomponent syntax within
 *	 PrxSV1Sntx.py.
 */
static char* snmpV1rdnSyntaxNames[] = { "SnmpInteger",
					"SnmpOctetString",
					"SnmpFixedLenOctetString",
					"SnmpOID",
					"SnmpIpAddress",
					"SnmpNetworkAddress",
					NULLCP
				      } ;

static int snmpV1RDNcomponentTypes[] = { type_PrxSV1Sntx_SnmpRDNcomponent_snmpInteger,
					 type_PrxSV1Sntx_SnmpRDNcomponent_snmpOctetString,
					 type_PrxSV1Sntx_SnmpRDNcomponent_snmpOctetString,
					 type_PrxSV1Sntx_SnmpRDNcomponent_snmpOID,
					 type_PrxSV1Sntx_SnmpRDNcomponent_snmpIpAddress,
					 type_PrxSV1Sntx_SnmpRDNcomponent_snmpNetworkAddress,
					 -1
				       } ;

static void* (*snmpV1rdnSyntaxParsers[])() = {
		       			(void*)SnmpInteger_parse,
					(void*)SnmpOctetString_parse,
					(void*)SnmpOctetString_parse,
					(void*)SnmpOID_parse,			
					(void*)SnmpProxyIpAddress_parse,
					(void*)SnmpProxyNetworkAddress_parse,
					(void*)NULLIFP
					} ;
				      
#define SNMPINTEGERSYNTAX	0
#define SNMPOCTETSTRING		1
#define SNMPFIXEDLENOCTETSTRING 2
#define SNMPOIDSYNTAX 		3
#define SNMPIPADDRESS		4
#define SNMPNWKADDRESS		5
 

PE build_SnmpGenericRDN(report)
struct type_PrxSV1Sntx_SnmpGenericRDN *report;
{
	PE pe;

	if (build_PrxSV1Sntx_SnmpGenericRDN(&pe, 1, 0, NULL, report) == NOTOK)
	   return(NULL);
	else
	   return(pe);
}

struct type_PrxSV1Sntx_SnmpGenericRDN* 
parse_SnmpGenericRDN(pe)
PE pe;
{
	struct type_PrxSV1Sntx_SnmpGenericRDN *report;

	if (parse_PrxSV1Sntx_SnmpGenericRDN(pe, 1, 0, NULL, &report) == NOTOK)
	   return(NULL);
	else
	   return(report);
}

void
SnmpGenericRDN_free(theElem)
struct type_PrxSV1Sntx_SnmpGenericRDN* theElem;
{
   if(theElem == NULL)
     return; /* Nothing to free */
   else
     (void)free_PrxSV1Sntx_SnmpGenericRDN(theElem);
}


int
SnmpRDNcomponent_compare( SGRDNcomponent1p, SGRDNcomponent2p )
struct 	type_PrxSV1Sntx_SnmpRDNcomponent *SGRDNcomponent1p, *SGRDNcomponent2p ;
{
int	match = 0 ;

	if( SGRDNcomponent1p == NULL ) {
 	    if( SGRDNcomponent2p == NULL )
	    	match = 0 ;
	    else
	    	match = -1 ;
		
	} else if( SGRDNcomponent2p == NULL )
	    match = 1 ;

	else if( SGRDNcomponent1p->offset != SGRDNcomponent2p->offset )
	    match = -1 ;

	else switch( SGRDNcomponent1p->offset ) {
	    case type_PrxSV1Sntx_SnmpRDNcomponent_snmpInteger   :
		match = int_cmp( SGRDNcomponent1p->un.snmpInteger,
				 SGRDNcomponent2p->un.snmpInteger ) ;
	    	break ;
	    case type_PrxSV1Sntx_SnmpRDNcomponent_snmpOctetString :
	    	match = qb_cmp(  SGRDNcomponent1p->un.snmpOctetString,
				 SGRDNcomponent2p->un.snmpOctetString ) ;
		break ;
	    case type_PrxSV1Sntx_SnmpRDNcomponent_snmpOID       :
		match = oid_cmp( SGRDNcomponent1p->un.snmpOID,
				 SGRDNcomponent2p->un.snmpOID ) ;
	    	break ;
	    case type_PrxSV1Sntx_SnmpRDNcomponent_snmpIpAddress :
		match = qb_cmp( SGRDNcomponent1p->un.snmpIpAddress,
				SGRDNcomponent2p->un.snmpIpAddress ) ;
	    	break ;
	    case type_PrxSV1Sntx_SnmpRDNcomponent_snmpNetworkAddress :
		match = qb_cmp( SGRDNcomponent1p->un.snmpNetworkAddress,
				SGRDNcomponent2p->un.snmpNetworkAddress ) ;
	    	break ;
	}

	return match ;
}


int
SnmpGenericRDN_element_PrxSV1Sntx_0_compare( SGRDNchoice1p, SGRDNchoice2p )
struct element_PrxSV1Sntx_0 *SGRDNchoice1p, *SGRDNchoice2p ;
{
int	match = 0 ;

	while( SGRDNchoice1p != NULL && SGRDNchoice2p != NULL && match == 0 ) {

	    match = SnmpRDNcomponent_compare( SGRDNchoice1p->SnmpRDNcomponent,
		    			      SGRDNchoice2p->SnmpRDNcomponent ) ;
	
	    SGRDNchoice1p = SGRDNchoice1p->next ;
	    SGRDNchoice2p = SGRDNchoice2p->next ;
	}

	if( match == 0 ) {
		
	    if( SGRDNchoice1p == NULL ) {
	    	if( SGRDNchoice2p == NULL )
		    match = 0 ;
	    	else
		    match = -1 ;
	    } else {
	    	if( SGRDNchoice2p == NULL )
		    match = 1 ;
	    }
	}

	return match ;
}

int 
SnmpGenericRDN_compare( SGRDN1p, SGRDN2p )
struct type_PrxSV1Sntx_SnmpGenericRDN *SGRDN1p, *SGRDN2p ;
{
int	match = -1 ;

	if( SGRDN1p == NULL ) {
 	    if( SGRDN2p == NULL )
	    	match = 0 ;
	    else
	    	match = -1 ;
	} else if( SGRDN2p == NULL ) {
	    match = 1 ;
	
	} else if( SGRDN1p->offset != SGRDN2p->offset )
	    match = -1 ;

	else switch( SGRDN1p->offset ) {

	    case type_PrxSV1Sntx_SnmpGenericRDN_snmpNULL :
		match = 0 ; /* To Nulls ! */
	    	break ;
		
	    case type_PrxSV1Sntx_SnmpGenericRDN_2 :
	    	match = SnmpGenericRDN_element_PrxSV1Sntx_0_compare(
					SGRDN1p->un.choice_PrxSV1Sntx_0,
					SGRDN2p->un.choice_PrxSV1Sntx_0 );
	        break ;
	}

	return match ;
}

int
SnmpRDNcomponent_print( ps, SGRDNcomponentp, quoted )
PS	ps ;
struct 	type_PrxSV1Sntx_SnmpRDNcomponent *SGRDNcomponentp ;
int	quoted ;
{
int	status = OK, dotFormatRequired = syntaxesBeingUsedByProxy ;

	if( SGRDNcomponentp != NULL ) {

	    switch( SGRDNcomponentp->offset ) {

	    case type_PrxSV1Sntx_SnmpRDNcomponent_snmpInteger   :
		if( dotFormatRequired == FALSE )
		    ps_printf( ps, "SnmpInteger=" ) ;
		int_print( ps, SGRDNcomponentp->un.snmpInteger, quoted ) ;
	    	break ;

	    case type_PrxSV1Sntx_SnmpRDNcomponent_snmpOctetString   :
		if( dotFormatRequired == FALSE )
		    ps_printf( ps, "SnmpOctetString=" ) ;
		string_print( ps, SGRDNcomponentp->un.snmpOctetString, quoted ) ;
	    	break ;

	    case type_PrxSV1Sntx_SnmpRDNcomponent_snmpOID       :
		if( dotFormatRequired == FALSE )
	    	    ps_printf( ps, "SnmpOID=" ) ;
		oidprint( ps, SGRDNcomponentp->un.snmpOID, quoted ) ;
	    	break ;

	    case type_PrxSV1Sntx_SnmpRDNcomponent_snmpIpAddress :
		if( dotFormatRequired == FALSE )
	    	    ps_printf( ps, "SnmpIpAddress=" ) ;
		SnmpProxyIpAddress_print( ps, SGRDNcomponentp->un.snmpIpAddress, quoted ) ;
	    	break ;

	    case type_PrxSV1Sntx_SnmpRDNcomponent_snmpNetworkAddress :
		if( dotFormatRequired == FALSE )
	    	    ps_printf( ps, "SnmpNetworkAddress=" ) ;
		SnmpProxyNetworkAddress_print( ps, SGRDNcomponentp->un.snmpNetworkAddress, quoted ) ;
	    	break ;	    
	    }
	}

	return status ;
}

int
SnmpGenericRDN_element_PrxSV1Sntx_0_print( ps, SGRDNchoicep, quoted )
PS 	ps ;
struct 	element_PrxSV1Sntx_0 *SGRDNchoicep ;
int	quoted ;
{
int	status = OK, dotFormatRequired = syntaxesBeingUsedByProxy ;

	while( SGRDNchoicep != NULL && status == OK ) {

	    status = SnmpRDNcomponent_print( ps, SGRDNchoicep->SnmpRDNcomponent, quoted ) ;

	    SGRDNchoicep = SGRDNchoicep->next ;

	    if( dotFormatRequired == FALSE )
		ps_printf( ps, "\t" ) ;

	    else if( SGRDNchoicep != NULL )
	    	ps_printf( ps, "." ) ; /* Another component to follow so a dot delimiter is required */
	}

	return status ;
}

int
SnmpGenericRDN_print( ps, SGRDNp, quoted )
PS	ps;
struct 	type_PrxSV1Sntx_SnmpGenericRDN *SGRDNp ;
int 	quoted;
{
int	status = OK ;

	if( SGRDNp == NULL ) {
	    ps_printf( ps, "NULL" ) ;

	} else switch( SGRDNp->offset ) {

	    case type_PrxSV1Sntx_SnmpGenericRDN_snmpNULL :
		status = NULL_print( ps, SGRDNp->un.snmpNULL, quoted ) ;
	    	break ;

	    case type_PrxSV1Sntx_SnmpGenericRDN_2 :
		status = SnmpGenericRDN_element_PrxSV1Sntx_0_print( ps, SGRDNp->un.choice_PrxSV1Sntx_0, quoted ) ;
	    	break ;
	}
	
	return status ;
}


struct 	type_PrxSV1Sntx_SnmpRDNcomponent *
SnmpRDNcomponent_parse( strp )
char **	strp ;
{
struct 	type_PrxSV1Sntx_SnmpRDNcomponent *SGRDNcomponentp = NULL ;
int 	i, typeFound = FALSE ;
char 	bufferedchar, *buffercharcp, *str ;

	str = *strp ;

	if( str != NULL && 
	    (SGRDNcomponentp = (struct type_PrxSV1Sntx_SnmpRDNcomponent*)malloc(
		    		sizeof( struct type_PrxSV1Sntx_SnmpRDNcomponent ))) != NULL ) {

	    str = removeLeadingSpaces( str ) ;

	    for( i=0 ; snmpV1rdnSyntaxNames[i] != NULLCP ; i++ ) {

		if( strncasecmp( str, snmpV1rdnSyntaxNames[i], strlen( snmpV1rdnSyntaxNames[i] )) == 0 ) {

		    typeFound = TRUE ;

		    str += ( strlen( snmpV1rdnSyntaxNames[i] ) + 1 ) ; /* +1 for the equals */

		    str = removeLeadingSpaces( str ) ;

		    /* Find the terminating whitespace */
		    buffercharcp = str ;
		    while( *buffercharcp && !isspace( *buffercharcp ) )
		    	++buffercharcp ;

		    bufferedchar  = *buffercharcp ;
		    *buffercharcp = '\0' ; /* Temporarily extract off the base syntax string */

		    SGRDNcomponentp->offset = snmpV1RDNcomponentTypes[i] ;
 		    if( ((void*)SGRDNcomponentp->un.snmpInteger = (void*)snmpV1rdnSyntaxParsers[i]( str )) == NULL )
	    		advise( NULLCP, "IQASntx.c: could not encode value %s for SnmpGenericRDN syntax name %s", str, snmpV1rdnSyntaxNames[i] ) ;
			
		    *buffercharcp = bufferedchar ;

		    str = buffercharcp ;

		    break ;
		}
	    }

	    if( typeFound == FALSE )
	    	advise( NULLCP, "IQASntx.c: could not match SnmpGenericRDN component syntax name %s", str ) ;

	    if( typeFound == FALSE || SGRDNcomponentp->un.snmpInteger == NULL ) {
	    	(void)free((char*)SGRDNcomponentp );
		SGRDNcomponentp = NULL ;
	    }
	}

	*strp = str ;

	return SGRDNcomponentp ;
}


struct 	element_PrxSV1Sntx_0 *
SnmpGenericRDN_element_PrxSV1Sntx_0_parse( str )
char *	str ;
{
struct 	element_PrxSV1Sntx_0 *headSGRDNchoicep = NULL, **SGRDNchoicepp = &headSGRDNchoicep,
			     *currSGRDNchoicep, *nextSGRDNchoicep ;

	str = removeLeadingSpaces( str ) ;

	while( str && *str ) {

	    if((*SGRDNchoicepp = (struct element_PrxSV1Sntx_0*)malloc(
	    				sizeof( struct element_PrxSV1Sntx_0 ))) == NULL )
		break ;

	    (*SGRDNchoicepp)->next = NULL ;

	    if( ((*SGRDNchoicepp)->SnmpRDNcomponent = SnmpRDNcomponent_parse( &str )) == NULL ) {

		/* Partially unwind the storage - should really also remove Intergets/qbufs... */
	    	for( currSGRDNchoicep =  headSGRDNchoicep ;
		     currSGRDNchoicep != NULL ;
		     currSGRDNchoicep =  nextSGRDNchoicep ) {

		    nextSGRDNchoicep = currSGRDNchoicep->next ;
		    (void)free((char*)currSGRDNchoicep ) ;
		}
		
	    	headSGRDNchoicep = NULL ;
	    	break ;
	    }

	    str = removeLeadingSpaces( str ) ;

	    SGRDNchoicepp = &((*SGRDNchoicepp)->next) ;
	}

	return headSGRDNchoicep ;
}


struct  type_PrxSV1Sntx_SnmpGenericRDN *
SnmpGenericRDN_parse( str )
char *	str ;
{
struct  type_PrxSV1Sntx_SnmpGenericRDN * SGRDNp = NULL ;

	if( str != NULLCP ) {

	    if( (SGRDNp = (struct type_PrxSV1Sntx_SnmpGenericRDN *)malloc(sizeof( struct type_PrxSV1Sntx_SnmpGenericRDN ))) != NULL ) {

		str = removeLeadingSpaces( str ) ;
	
	    	if( strncasecmp( str, "NULL", 4 ) == 0 ) {
		    SGRDNp->offset = type_PrxSV1Sntx_SnmpGenericRDN_snmpNULL ;
		    SGRDNp->un.snmpNULL = NULL_parse( str ) ;

	    	} else {
		    SGRDNp->offset = type_PrxSV1Sntx_SnmpGenericRDN_2 ;

		    if( (SGRDNp->un.choice_PrxSV1Sntx_0 = SnmpGenericRDN_element_PrxSV1Sntx_0_parse( str )) == NULL ) {
		    	(void)free((char*)SGRDNp ) ;
			SGRDNp = NULL ;
		    }
		}
	    }
	}

	return SGRDNp ;
}


RDN
makeNullGenericRDN( type )
char* 	type ;
{
RDN	nullRDNp = NULLRDN ;
AttributeType	nullRDNatp ;
attrVal	nullRDNav ;
struct 	type_PrxSV1Sntx_SnmpGenericRDN * nullSGRDNp ;

	nullRDNatp = AttrT_new( type ) ;

	if( nullRDNatp != NULLAttrT ) {

	    nullRDNav.av_syntax = nullRDNatp->oa_syntax ;

	    nullSGRDNp = (struct type_PrxSV1Sntx_SnmpGenericRDN *)malloc(sizeof( struct type_PrxSV1Sntx_SnmpGenericRDN )) ;

	    if( nullSGRDNp != NULL ) {

	    	nullRDNav.av_struct = (caddr_t)nullSGRDNp ;

		nullSGRDNp->offset = type_PrxSV1Sntx_SnmpGenericRDN_snmpNULL ;

		nullSGRDNp->un.snmpNULL = NULL_parse("") ;

		if( nullSGRDNp->un.snmpNULL != NULL ) {

		    /* Note: we do not utilise rdn_comp_new since this creates
		             a copy of nullRDNavp... */
			     
		    nullRDNp =  rdn_comp_alloc();
		    nullRDNp -> rdn_at   = nullRDNatp ;
		    nullRDNp -> rdn_av   = nullRDNav  ; /* struct copy */
		    nullRDNp -> rdn_next = NULLRDN ;
 		    
		} else {
		    (void)free((char*)nullSGRDNp ) ;
		}
	    }
	}
	
	return nullRDNp ;
}

RDN 
makeGenericRDN( type, SGRDNp )
char *	type ;
struct  type_PrxSV1Sntx_SnmpGenericRDN * SGRDNp ;
{
RDN	genericRDNp = NULLRDN ;
AttributeType	genericRDNatp ;
attrVal genericRDNav ;
struct 	type_PrxSV1Sntx_SnmpGenericRDN * genericSGRDNp ;

	genericRDNatp = AttrT_new( type ) ;

	if( genericRDNatp != NULLAttrT && SGRDNp != NULL && (genericRDNp = rdn_comp_alloc()) != NULLRDN ) {

	    genericRDNav.av_syntax = genericRDNatp -> oa_syntax ;
	    genericRDNav.av_struct = (caddr_t)SGRDNp ;

	    genericRDNp -> rdn_at   = genericRDNatp ;
	    genericRDNp -> rdn_av   = genericRDNav  ; /* struct copy */
	    genericRDNp -> rdn_next = NULLRDN ;	
	}

	return genericRDNp ;
}

struct  type_PrxSV1Sntx_SnmpGenericRDN *
SnmpGenericRDN_cpy( SGRDNp )
struct  type_PrxSV1Sntx_SnmpGenericRDN * SGRDNp ;
{
struct	type_PrxSV1Sntx_SnmpGenericRDN   * newSGRDNp = NULL ;
struct	type_PrxSV1Sntx_SnmpRDNcomponent * newSGRDNcomponentp = NULL ;
			    

	if( SGRDNp != NULL &&
	    (newSGRDNp = (struct type_PrxSV1Sntx_SnmpGenericRDN*)malloc(
				sizeof( struct type_PrxSV1Sntx_SnmpGenericRDN ) )) != NULL ) {

	    newSGRDNp->offset = SGRDNp->offset ;

	    if( SGRDNp->offset == type_PrxSV1Sntx_SnmpGenericRDN_snmpNULL ) {

		if( (newSGRDNp->un.snmpNULL = NULL_parse( "" )) == NULL ) {
		    (void)free((char*)newSGRDNp ) ; newSGRDNp = NULL ;
		}
		    
	    } else {

		struct  element_PrxSV1Sntx_0 *  SGRDNelement_PrxSV1Sntx_0p = NULL,
					     ** currNewSGRDNelement_PrxSV1Sntx_0pp = NULL ;

		for( SGRDNelement_PrxSV1Sntx_0p = SGRDNp->un.choice_PrxSV1Sntx_0,
		   	currNewSGRDNelement_PrxSV1Sntx_0pp = &(newSGRDNp->un.choice_PrxSV1Sntx_0) ;
		     
		     SGRDNelement_PrxSV1Sntx_0p != NULL ;
		     
		     SGRDNelement_PrxSV1Sntx_0p = SGRDNelement_PrxSV1Sntx_0p->next,
 			currNewSGRDNelement_PrxSV1Sntx_0pp = &((*currNewSGRDNelement_PrxSV1Sntx_0pp)->next) ) {

		    if( ((*currNewSGRDNelement_PrxSV1Sntx_0pp) = (struct element_PrxSV1Sntx_0*)malloc(
			    		sizeof( struct element_PrxSV1Sntx_0 ) )) == NULL ) {
		    	(void)free((char*)newSGRDNp ) ; newSGRDNp = NULL ;
			break ;

		    } else {

			(*currNewSGRDNelement_PrxSV1Sntx_0pp)->next = NULL ;

			if( (newSGRDNcomponentp = (*currNewSGRDNelement_PrxSV1Sntx_0pp)->SnmpRDNcomponent =
			    	(struct type_PrxSV1Sntx_SnmpRDNcomponent*)malloc(
				sizeof( struct type_PrxSV1Sntx_SnmpRDNcomponent ))) == NULL ) {
			
			    (void)free((char*)newSGRDNp ) ; newSGRDNp = NULL ;
			    break ;

			} else  {

			    newSGRDNcomponentp->offset = SGRDNelement_PrxSV1Sntx_0p->SnmpRDNcomponent->offset ;
			
			    switch( SGRDNelement_PrxSV1Sntx_0p->SnmpRDNcomponent->offset ) {

				case type_PrxSV1Sntx_SnmpRDNcomponent_snmpInteger :
				    newSGRDNcomponentp->un.snmpInteger =
			 		(struct type_PrxSV1Sntx_SnmpInteger*)int_cpy( 
					    SGRDNelement_PrxSV1Sntx_0p->SnmpRDNcomponent->un.snmpInteger ) ;
				    break ;

				case type_PrxSV1Sntx_SnmpRDNcomponent_snmpOctetString :
				    newSGRDNcomponentp->un.snmpOctetString =
			 		(struct type_PrxSV1Sntx_SnmpOctetString*)qb_cpy( 
					    SGRDNelement_PrxSV1Sntx_0p->SnmpRDNcomponent->un.snmpOctetString ) ;
				    break ;
				    
				case type_PrxSV1Sntx_SnmpRDNcomponent_snmpOID :
				    newSGRDNcomponentp->un.snmpOID = 
 					(struct type_PrxSV1Sntx_SnmpOID*)oid_cpy( 
					    SGRDNelement_PrxSV1Sntx_0p->SnmpRDNcomponent->un.snmpOID ) ;
				    break ;

				case type_PrxSV1Sntx_SnmpRDNcomponent_snmpIpAddress :
				    newSGRDNcomponentp->un.snmpIpAddress =
				    	(struct type_PrxSV1Sntx_SnmpIpAddress*)qb_cpy(
					    SGRDNelement_PrxSV1Sntx_0p->SnmpRDNcomponent->un.snmpIpAddress ) ;
				    break ;

				case type_PrxSV1Sntx_SnmpRDNcomponent_snmpNetworkAddress :
				    newSGRDNcomponentp->un.snmpNetworkAddress =
				    	(struct type_PrxSV1Sntx_SnmpIpAddress*)qb_cpy(
					    SGRDNelement_PrxSV1Sntx_0p->SnmpRDNcomponent->un.snmpNetworkAddress ) ;
				    break ;

				default : advise( NULLCP, "Error: IQASntx.c unknown syntax offset when copying SnmpGenericRDN" ) ;
				    	  (void)free((char*)newSGRDNp ) ; newSGRDNp = NULL ;
				    break ;
			    }
			}
		    }
		}
	    }
	}

	return newSGRDNp ;
}


int
appendGenericRDNcomponent( SGRDNpp, syntax, rdnCompValuep )
struct  type_PrxSV1Sntx_SnmpGenericRDN ** SGRDNpp ;
short	syntax ;
void *	rdnCompValuep ; /* The structure that represents the corresponding simple syntax e.g. a qbuf */
{
static  short * snmpV1rdnSyntaxNumbers = NULL ;
static  int numSnmpV1rdnSyntaxes = 0 ;
int 	status = OK, i ;
struct 	type_PrxSV1Sntx_SnmpGenericRDN * SGRDNp = NULL ;
struct  element_PrxSV1Sntx_0 * SGRDNelement_PrxSV1Sntx_0p = NULL ;
struct  type_PrxSV1Sntx_SnmpRDNcomponent ** SGRDNCOMPpp = NULL ;
struct	qbuf * qbp ;
OID	oidp ;

	/* Check if data initialisation has still to be performed.. */
	if( snmpV1rdnSyntaxNumbers == NULL ) {

	    for( i=0 ; snmpV1rdnSyntaxNames[i] != NULLCP ; i++ )
		; /* EMPTY LOOP */
		
	    numSnmpV1rdnSyntaxes = i ;

	    if( (snmpV1rdnSyntaxNumbers = (short*)malloc( sizeof(short)*numSnmpV1rdnSyntaxes )) == NULL )
 	    	return NOTOK ;

	    for( i=0 ; i<numSnmpV1rdnSyntaxes ; i++ )
	    	snmpV1rdnSyntaxNumbers[i] = str2syntax( snmpV1rdnSyntaxNames[i] ) ;
	}

	if( *SGRDNpp == NULL ) {

	    if( (*SGRDNpp = SGRDNp = (struct type_PrxSV1Sntx_SnmpGenericRDN*)malloc(
				sizeof( struct type_PrxSV1Sntx_SnmpGenericRDN ) )) == NULL ) {
	    	status = NOTOK ;

	    } else {

		SGRDNp->offset = type_PrxSV1Sntx_SnmpGenericRDN_2 ;

		if( (SGRDNp->un.choice_PrxSV1Sntx_0 = (struct element_PrxSV1Sntx_0*)malloc( 
			sizeof( struct element_PrxSV1Sntx_0 ) ) ) == NULL ) {
		    status = NOTOK ;
		} else {
		    SGRDNCOMPpp = &(SGRDNp->un.choice_PrxSV1Sntx_0->SnmpRDNcomponent) ;
		    SGRDNp->un.choice_PrxSV1Sntx_0->next = NULL ;
		}
	    }
	    
	} else {

	    SGRDNp = *SGRDNpp ;

	    for( SGRDNelement_PrxSV1Sntx_0p = SGRDNp->un.choice_PrxSV1Sntx_0 ;
	         SGRDNelement_PrxSV1Sntx_0p->next != NULL ;
		 SGRDNelement_PrxSV1Sntx_0p = SGRDNelement_PrxSV1Sntx_0p->next )
	    	 ; /* EMPTY LOOP */

	    if( (SGRDNelement_PrxSV1Sntx_0p->next = (struct element_PrxSV1Sntx_0*)malloc( 
						sizeof( struct element_PrxSV1Sntx_0 ) ) ) == NULL ) {
		status = NOTOK ;
	    } else {
	    	SGRDNCOMPpp = &(SGRDNelement_PrxSV1Sntx_0p->next->SnmpRDNcomponent) ;
		SGRDNelement_PrxSV1Sntx_0p->next->next = NULL ;
	    }
	}

	if( status == OK ) {

	    /* Now insert a new "struct type_PrxSV1Sntx_SnmpRDNcomponent" node.. */

	    for( i=0 ; i<numSnmpV1rdnSyntaxes && snmpV1rdnSyntaxNumbers[i] != syntax  ; i++ )
	    	; /* EMPTY LOOP */

	    if( i == numSnmpV1rdnSyntaxes ) {
	    	advise( NULLCP, "Error: IQASntx.c unknown SNMPv1 syntax number %d received %s", syntax, syntax2str(syntax) ) ;
	    	status = NOTOK ;

	    } else {

		if( (*SGRDNCOMPpp = (struct type_PrxSV1Sntx_SnmpRDNcomponent*)malloc(
				sizeof( struct type_PrxSV1Sntx_SnmpRDNcomponent ) )) == NULL ) {

		    status = NOTOK ;

		} else {

	    	    switch( i ) {
		    
		    case SNMPINTEGERSYNTAX :
		    		(*SGRDNCOMPpp)->offset = type_PrxSV1Sntx_SnmpRDNcomponent_snmpInteger ;
 				(*SGRDNCOMPpp)->un.snmpInteger = (struct type_PrxSV1Sntx_SnmpInteger*)int_cpy( rdnCompValuep ) ;
		    		break ;

		    case SNMPOCTETSTRING :
		    		(*SGRDNCOMPpp)->offset = type_PrxSV1Sntx_SnmpRDNcomponent_snmpOctetString ;
				(*SGRDNCOMPpp)->un.snmpOctetString = qb_cpy( rdnCompValuep ) ;

				/* Now indicate the number of VARIABLE LENGTH characters as the 
				   first element of the Octet string (rfc1212)... */
				   
				if( (*SGRDNCOMPpp)->un.snmpOctetString == NULL ||
				    qb_pullup( (*SGRDNCOMPpp)->un.snmpOctetString ) == NOTOK ) {
				    status = NOTOK ;
				    
				} else {
				   
				    qbp = (*SGRDNCOMPpp)->un.snmpOctetString->qb_forw ;
				
				    qbp->qb_data = (char*)realloc( qbp->qb_data, qbp->qb_len + 2 ) ;

				    if( qbp->qb_data == NULLCP )
				    	status = NOTOK ;
				    else {
				    	/* Shift the current characters one place...*/
				    	bcopy( qbp->qb_data,
				    	       &(qbp->qb_data[1]),
					       qbp->qb_len ) ;

				    	qbp->qb_data[1] = (qbp->qb_len)++ ;
				    }
				}
				
				break ;
				
		    case SNMPFIXEDLENOCTETSTRING :
		    		(*SGRDNCOMPpp)->offset = type_PrxSV1Sntx_SnmpRDNcomponent_snmpOctetString ;
				(*SGRDNCOMPpp)->un.snmpOctetString = qb_cpy( rdnCompValuep ) ;
				
				if( (*SGRDNCOMPpp)->un.snmpOctetString == NULL )
				    status = NOTOK ;

				break ;
				
		    case SNMPOIDSYNTAX :
		    		(*SGRDNCOMPpp)->offset = type_PrxSV1Sntx_SnmpRDNcomponent_snmpOID ;
				(*SGRDNCOMPpp)->un.snmpOID = oid_cpy( rdnCompValuep ) ;

				/* Now indicate the number of sub-identifiers as the first
				   element of the OID (rfc1212)... */

				oidp = (*SGRDNCOMPpp)->un.snmpOID ;
				
				oidp->oid_elements = (unsigned int*)
					realloc( oidp->oid_elements,
					   sizeof(unsigned int) * (oidp->oid_nelem + 1) ) ;

				if( oidp->oid_elements == NULL )
				    status = NOTOK ;
				else {
				    /* Shift the current sub-identifiers one place...*/
				    bcopy( (char*)oidp->oid_elements,
				    	   (char*)&(oidp->oid_elements[1]),
					   sizeof(unsigned int) * oidp->oid_nelem ) ;

				    oidp->oid_elements[0] = (oidp->oid_nelem)++ ;
				}
		    		break ;

		    case SNMPIPADDRESS :
		    		(*SGRDNCOMPpp)->offset = type_PrxSV1Sntx_SnmpRDNcomponent_snmpIpAddress ;
				if( ((*SGRDNCOMPpp)->un.snmpIpAddress = qb_cpy( rdnCompValuep )) == NULL )
 				    status = NOTOK ;
		    		break ;

		    case SNMPNWKADDRESS :
		    		(*SGRDNCOMPpp)->offset = type_PrxSV1Sntx_SnmpRDNcomponent_snmpNetworkAddress ;
				if( ((*SGRDNCOMPpp)->un.snmpNetworkAddress = qb_cpy( rdnCompValuep )) == NULL )
 				    status = NOTOK ;
		    		break ;

	    	    default : advise( NULLCP, "Error: IQASntx.c invalid syntax number %d received", syntax ) ;
			      status = NOTOK ;
			      break ;
		    }
	    	}
	    }
	}

	return status ;
}


/*
 * Form an RDN component from the next instance sub-identifiers in the
 * "dot" format sub-identifier buffer that is pointed to by rdncp...
 */
int
formSnmpV1RDNcomponent( rdncp, nextrdncpp, SGRDNpp, syntax, octStrFixedLen  )
char *	rdncp ;
char**	nextrdncpp ;
struct  type_PrxSV1Sntx_SnmpGenericRDN ** SGRDNpp ;
int	syntax ;
int	octStrFixedLen ; /* -1 if not applicable */
{
int	status = OK ;
static  short * snmpV1rdnSyntaxNumbers = NULL ;
static  int numSnmpV1rdnSyntaxes = 0 ;
int	i, ipdotcnt, oiddotcnt, oidmaxcnt, octdotcnt, octmaxcnt ;
char *	cp = NULLCP, buffc ;
char 	rdnbuffer[2048], *hexrdncp ;
integer	* intp ;
struct	qbuf * qbp ;
OID	oid ;

	/* Check if data initialisation has still to be performed.. */
	if( snmpV1rdnSyntaxNumbers == NULL ) {

	    for( i=0 ; snmpV1rdnSyntaxNames[i] != NULLCP ; i++ )
		; /* EMPTY LOOP */
		
	    numSnmpV1rdnSyntaxes = i ;

	    if( (snmpV1rdnSyntaxNumbers = (short*)malloc( sizeof(short)*numSnmpV1rdnSyntaxes )) == NULL )
 	    	return NOTOK ;

	    for( i=0 ; i<numSnmpV1rdnSyntaxes ; i++ )
	    	snmpV1rdnSyntaxNumbers[i] = str2syntax( snmpV1rdnSyntaxNames[i] ) ;
	}


	if( rdncp != NULLCP && nextrdncpp != NULL && strlen( rdncp ) > 0 ) {

	    for( i=0 ; i<numSnmpV1rdnSyntaxes && snmpV1rdnSyntaxNumbers[i] != syntax  ; i++ )
	    	; /* EMPTY LOOP */

	    if( i == numSnmpV1rdnSyntaxes ) {
	    	advise( NULLCP, "Error: IQASntx.c unknown SNMPv1 syntax number %d received %s", syntax, syntax2str(syntax) ) ;
	    	status = NOTOK ;

	    } else {
	    
		switch( i ) {
		    case SNMPINTEGERSYNTAX :
		    	if( (cp = strchr( rdncp, '.' )) != NULLCP ) {
			    buffc = *cp, *cp = '\0' ;
			    *cp = '\0' ; /* Only the first sub-identifier is required */
			}

			if( (intp = (integer*)SnmpInteger_parse( rdncp )) == NULL) {
			    status = NOTOK ;
			} else {
			    status = appendGenericRDNcomponent( SGRDNpp, syntax, intp ) ;
			    free_PrxSV1Sntx_SnmpInteger( intp ) ;
			}
			
			if( cp != NULLCP )
			    *cp = buffc ;

			*nextrdncpp = ( cp == NULLCP ) ? NULLCP : cp+1 ; /* Skip '.' if necessary */
			
		    	break ;

		    case SNMPOCTETSTRING :
			/*
			 * Variable length string 
			 */
			 
			cp = rdncp ;

			if( (cp = strchr( cp, '.' )) != NULLCP ) {
			    buffc = *cp, *cp = '\0' ;
			    *cp = '\0' ;
			}

			octmaxcnt = atoi( rdncp ) ;

			if( cp != NULLCP )
			    *cp = buffc ;

			for( octdotcnt=0 ; octdotcnt<octStrFixedLen ; ++octdotcnt ) {
			    if( (cp = strchr( cp+1, '.' )) == NULLCP )
			    	break ;
			}

			if( octStrFixedLen > 0 &&
			    (octdotcnt == octStrFixedLen ||    /* more sub-ids afterwards    */
			     octdotcnt == (octStrFixedLen - 1))/* no more sub-ids afterwards */) {
			    
			    if( cp != NULLCP ) {
				buffc = *cp, *cp = '\0' ;
				*cp = '\0' ;
			    }

			    hexrdncp = dotRdnToHexStrFormat( rdncp, octmaxcnt ) ;

			    if( hexrdncp == NULLCP ||
			        (qbp = string_parse( hexrdncp )) == NULL )
			    	status = NOTOK ;
			    else {
				status = appendGenericRDNcomponent( SGRDNpp, syntax, qbp ) ;
				qb_free( qbp ) ;
			    }
			    
			    if( cp != NULLCP )
				*cp = buffc ;
			
			    *nextrdncpp = ( cp == NULLCP ) ? NULLCP : cp+1 ; /* Skip '.' if necessary */

		    	} else status = NOTOK ;

		    	break ;

		    case SNMPFIXEDLENOCTETSTRING :
			/*
 			 * Fixed length string 
			 */
			
			cp = rdncp, octmaxcnt = octStrFixedLen ;

			for( octdotcnt=0 ; octdotcnt<octmaxcnt ; ++octdotcnt ) {
			    if( (cp = strchr( cp+1, '.' )) == NULLCP )
			    	break ;
			}

			if( octmaxcnt > 0 &&
			    (octdotcnt == octmaxcnt ||    /* more sub-ids afterwards    */
			     octdotcnt == (octmaxcnt - 1))/* no more sub-ids afterwards */) {
			    
			    if( cp != NULLCP ) {
				buffc = *cp, *cp = '\0' ;
				*cp = '\0' ;
			    }

			    hexrdncp = dotRdnToHexStrFormat( rdncp, octmaxcnt ) ;

			    if( hexrdncp == NULLCP ||
			        (qbp = string_parse( hexrdncp )) == NULL )
			    	status = NOTOK ;
			    else {
				status = appendGenericRDNcomponent( SGRDNpp, syntax, qbp ) ;
				qb_free( qbp ) ;
			    }
			    
			    if( cp != NULLCP )
				*cp = buffc ;
			
			    *nextrdncpp = ( cp == NULLCP ) ? NULLCP : cp+1 ; /* Skip '.' if necessary */

		    	} else status = NOTOK ;

		    	break ;

		    case SNMPOIDSYNTAX :
			cp = rdncp ;

			if( (cp = strchr( cp, '.' )) == NULLCP ) {
			    buffc = *cp, *cp = '\0' ;
			    *cp = '\0' ;
			}

			oidmaxcnt = atoi( rdncp ) ;

			if( cp != NULLCP )
			    *cp = buffc ;

			for( oiddotcnt=0 ; oiddotcnt<oidmaxcnt ; ++oiddotcnt ) {
			    if( (cp = strchr( cp+1, '.' )) == NULLCP )
			    	break ;
			}

			if( oidmaxcnt > 0 &&
			    (oiddotcnt == oidmaxcnt ||    /* more sub-ids afterwards    */
			     oiddotcnt == (oidmaxcnt - 1))/* no more sub-ids afterwards */) {

			    if( cp != NULLCP ) {
				buffc = *cp, *cp = '\0' ;
				*cp = '\0' ;
			    }

			    if( (oid = SnmpOID_parse( rdncp )) == NULLOID )
			    	status = NOTOK ;
			    else {
				status = appendGenericRDNcomponent( SGRDNpp, syntax, oid ) ;
				oid_free( oid ) ;
			    }
			    
			    if( cp != NULLCP )
				*cp = buffc ;
			
			    *nextrdncpp = ( cp == NULLCP ) ? NULLCP : cp+1 ; /* Skip '.' if necessary */

		    	} else status = NOTOK ;
			
		    	break ;
		    case SNMPIPADDRESS :

			cp = rdncp ;

		    	for( ipdotcnt = 0 ; ipdotcnt < 4 ; ++ipdotcnt ) {
			    if( (cp = strchr( cp+1, '.' )) == NULLCP )
			    	break ;
			}

			if( ipdotcnt == 4 || /* more sub-ids afterwards    */
			    ipdotcnt == 3    /* no more sub-ids afterwards */ ) {
			    
			    if( cp != NULLCP ) {
				buffc = *cp, *cp = '\0' ;
				*cp = '\0' ; /* Four sub-identifiers are required */
			    }

			    if((qbp = SnmpProxyIpAddress_parse( rdncp )) == NULL) {
			    	status = NOTOK ;
			    } else {
				status = appendGenericRDNcomponent( SGRDNpp, syntax, qbp ) ;
				qb_free( qbp ) ;
			    }

			    if( cp != NULLCP )
				*cp = buffc ;
			
			    *nextrdncpp = ( cp == NULLCP ) ? NULLCP : cp+1 ; /* Skip '.' if necessary */

			} else status = NOTOK ;
		    	
			break ;

		    case SNMPNWKADDRESS : /* IpAddress with a leading "1." */

			cp = rdncp ;

		    	for( ipdotcnt = 0 ; ipdotcnt < 5 ; ++ipdotcnt ) {
			    if( (cp = strchr( cp+1, '.' )) == NULLCP )
			    	break ;
			}

			if( ipdotcnt == 5 || /* more sub-ids afterwards    */
			    ipdotcnt == 4    /* no more sub-ids afterwards */ ) {
			    
			    if( cp != NULLCP ) {
				buffc = *cp, *cp = '\0' ;
				*cp = '\0' ; /* Five sub-identifiers are required */
			    }

			    if((qbp = SnmpProxyNetworkAddress_parse( rdncp )) == NULL) {
			    	status = NOTOK ;
			    } else {
				status = appendGenericRDNcomponent( SGRDNpp, syntax, qbp ) ;
				qb_free( qbp ) ;
			    }

			    if( cp != NULLCP )
				*cp = buffc ;
			
			    *nextrdncpp = ( cp == NULLCP ) ? NULLCP : cp+1 ; /* Skip '.' if necessary */

			} else status = NOTOK ;
		    	
			break ;
	    	    default : advise( NULLCP, "Error: IQASntx.c invalid syntax number %d received", syntax ) ;
			      status = NOTOK ;
			      break ;
		}
	    }
	}

	return status ;
}


/*
struct  type_PrxSV1Sntx_SnmpGenericRDN *
SnmpGenericRDN_GraphicString_parse( str )
char *	str ;
{
struct  type_PrxSV1Sntx_SnmpGenericRDN * SGRDNp = NULL ;
char *	parsedStrcp ;

	if( str != NULLCP ) {

	    if( (SGRDNp = (struct type_PrxSV1Sntx_SnmpGenericRDN*)malloc(
					sizeof( struct type_PrxSV1Sntx_SnmpGenericRDN ) )) != NULL ) {

		SGRDNp->offset = type_PrxSV1Sntx_SnmpGenericRDN_snmpNonGeneric ;

		if( (parsedStrcp = prtparse( str ) ) == NULL ||
		    (SGRDNp->un.snmpNonGeneric = str2qb( parsedStrcp, strlen(parsedStrcp), 1 )) == NULL ) {

		    (void)free((char*)SGRDNp ) ;
		    SGRDNp = NULL ;
		}
	    }
	}

	return SGRDNp ;
}*/

/*
 * Check is we are to print the GraphicString choice...
 */
/*SnmpGenericRDN_GraphicString_print( ps, SGRDNp, format )
PS	ps ;
struct  type_PrxSV1Sntx_SnmpGenericRDN * SGRDNp ;
int	format ;
{
	if( SGRDNp != NULL && SGRDNp->offset == type_PrxSV1Sntx_SnmpGenericRDN_snmpNonGeneric )
	    string_display( ps, SGRDNp->un.snmpNonGeneric, format ) ;
	else
	    SnmpGenericRDN_print( ps, SGRDNp, format ) ;

	return ;	
}*/



PE build_IpNetToMediaEntryIdValue(report)
struct type_PrxSV1Sntx_IpNetToMediaEntryIdValue *report;
{
	PE pe;

	if (build_PrxSV1Sntx_IpNetToMediaEntryIdValue(&pe, 1, 0, NULL, report) == NOTOK)
	   return(NULL);
	else
	   return(pe);
}

struct type_PrxSV1Sntx_IpNetToMediaEntryIdValue* 
parse_IpNetToMediaEntryIdValue( pe )
PE pe;
{
	struct type_PrxSV1Sntx_IpNetToMediaEntryIdValue *report;

	if (parse_PrxSV1Sntx_IpNetToMediaEntryIdValue(pe, 1, 0, NULL, &report) == NOTOK)
	   return(NULL);
	else
	   return(report);
}

void
IpNetToMediaEntryIdValue_free(theElem)
struct type_PrxSV1Sntx_IpNetToMediaEntryIdValue* theElem;
{
   if(theElem == NULL)
     return; /* Nothing to free */
   else
     (void)free_PrxSV1Sntx_IpNetToMediaEntryIdValue(theElem);
}

int
IpNetToMediaEntryIdValue_print( ps, IpIdp, quoted )
PS	ps ;
struct	type_PrxSV1Sntx_IpNetToMediaEntryIdValue * IpIdp ;
int	quoted ;
{
int	status = OK ;

	if( IpIdp == NULL ) {
	    ps_printf( ps, "NULL" ) ;

	} else {
	    ps_print( ps, "ipNetToMediaIfIndex=" ) ;
	    int_print( ps, IpIdp->ipNetToMediaIfIndex, quoted ) ;

	    ps_printf( ps, "\t" ) ;

	    ps_print( ps, "ipNetToMediaNetAddress=" ) ;
	    SnmpProxyIpAddress_print( ps, IpIdp->ipNetToMediaNetAddress, quoted ) ; 
	}

	return status ;
}


struct	type_PrxSV1Sntx_IpNetToMediaEntryIdValue *
IpNetToMediaEntryIdValue_parse( str )
char *	str ;
{
struct	type_PrxSV1Sntx_IpNetToMediaEntryIdValue * IpIdp = NULL ;
char *	termcp ;

	if( str != NULLCP && strncasecmp( str, "NULL", 4 ) != 0 ) {

	    if(( IpIdp = (struct type_PrxSV1Sntx_IpNetToMediaEntryIdValue*)calloc(1,
	    		sizeof( struct type_PrxSV1Sntx_IpNetToMediaEntryIdValue ) )) != NULL ) {

		str = removeLeadingSpaces( str ) ;

		if( strncasecmp( str, "ipNetToMediaIfIndex=", strlen( "ipNetToMediaIfIndex=" )) == 0 ) {

		    str += strlen( "ipNetToMediaIfIndex=" ) ;
		
		    termcp = str = removeLeadingSpaces( str ) ;

		    while( *termcp && !isspace( *termcp ) )
		    	++termcp ;

		    if( *termcp ) {

		    	*termcp = '\0' ;
		    	IpIdp->ipNetToMediaIfIndex = (struct type_PrxSV1Sntx_SnmpInteger*)SnmpInteger_parse( str ) ;
		    	*termcp = '\t' ;

		    	str = termcp + 1 ;

			if( strncasecmp( str, "ipNetToMediaNetAddress=", strlen( "ipNetToMediaNetAddress=" )) == 0 ) {

			    str += strlen( "ipNetToMediaNetAddress=" ) ;
			    
		    	    termcp = str = removeLeadingSpaces( str ) ;

		    	    while( *termcp && !isspace( *termcp ) )
		    		++termcp ;

		    	    *termcp = '\0' ;
		    	    IpIdp -> ipNetToMediaNetAddress = SnmpProxyIpAddress_parse( str ) ;
			}
		    }
	    	}
	    }
	}

	return IpIdp ;
}

int
IpNetToMediaEntryIdValue_compare( IpId1p, IpId2p )
struct type_PrxSV1Sntx_IpNetToMediaEntryIdValue * IpId1p, * IpId2p ;
{
int	match = 0 ;

	if( IpId1p == NULL ) {
 	    if( IpId2p == NULL )
	    	match = 0 ;
	    else
	    	match = -1 ;

	} else if( IpId2p == NULL ) {
	    match = 1 ;

	} else {

	    match = int_cmp( IpId1p->ipNetToMediaIfIndex, IpId2p->ipNetToMediaIfIndex ) ;

	    if( match == 0 )
		match = qb_cmp( IpId1p->ipNetToMediaNetAddress, IpId2p->ipNetToMediaNetAddress ) ;
	}

	return match ;
}

/* 
 * ACC syntaxes..
 */ 

PE
build_CapabilityType1( report )
struct type_PrxACCSntx_CapabilityType1* report ;
{
PE	pe;

	if (build_PrxACCSntx_CapabilityType1(&pe, 1, 0, NULL, report) == NOTOK)
	   return(NULL);
	else
	   return(pe);
}

struct	type_PrxACCSntx_CapabilityType1*
parse_CapabilityType1( pe )
PE	pe ;
{
struct type_PrxACCSntx_CapabilityType1 *report;

	if (parse_PrxACCSntx_CapabilityType1(pe, 1, 0, NULL, &report) == NOTOK)
	   return( NULL );
	else
	   return( report );
}

int
CapabilityType1_free(theElem)
struct type_PrxACCSntx_CapabilityType1 *theElem ;
{
	if(theElem == NULL)
   	    return; /* Nothing to free */
   	else
     	    (void)free_PrxACCSntx_CapabilityType1(theElem);

	return ;
}


PE 
build_AccessControlCertficate( report )
struct type_PrxACCSntx_Certificate *report;
{
PE pe;
	if (build_PrxACCSntx_AccessControlCertficate(&pe, 1, 0, NULL, report) == NOTOK)
	   return(NULL);
	else
	   return(pe);
}


struct type_PrxACCSntx_AccessControlCertficate* 
parse_AccessControlCertficate(pe)
PE pe;
{
struct type_PrxACCSntx_AccessControlCertficate *report;

	if (parse_PrxACCSntx_AccessControlCertficate(pe, 1, 0, NULL, &report) == NOTOK)
	   return(NULL);
	else
	   return(report);
}


int 
AccessControlCertficate_free(theElem)
struct type_PrxACCSntx_AccessControlCertficate* theElem;
{
	if(theElem == NULL)
   	    return; /* Nothing to free */
   	else
     	    (void)free_PrxACCSntx_AccessControlCertficate(theElem);

	return ;
}


External*
buildAccessControl( communityString )
char*	communityString ;
{
External* builtExternp = NULLEXTERN ;
struct	type_PrxACCSntx_AccessControlCertficate* PACp ;
struct	element_PrxACCSntx_1* PACelemp ;
static	OID desdAttCapOid = NULLOID ;

	if( desdAttCapOid == NULLOID &&
	    (desdAttCapOid = name2oid( "desd-att-capability-type-1" )) == NULLOID ) {

	    advise( NULLCP, "IQASntx.c: oidtable.gen needs to define \"desd-att-capability-type-1\"" ) ;
	    return builtExternp ;
	}

	if( (PACp = (struct type_PrxACCSntx_AccessControlCertficate*)calloc( 1,
			sizeof( struct type_PrxACCSntx_AccessControlCertficate) )) != NULL &&
	    ((PACelemp = PACp->element_PrxACCSntx_0 = (struct element_PrxACCSntx_1*)calloc(1,
	    		sizeof( struct element_PrxACCSntx_1 )))) != NULL ) {

	    struct 	element_PrxACCSntx_3* PACprivp ;
	    PACelemp->optionals = 0 ;

	    if( (PACprivp = PACelemp->privilegeAttributes = (struct element_PrxACCSntx_3*)calloc(1,
	    		sizeof( struct element_PrxACCSntx_3 ))) != NULL &&	    
	        (PACprivp->SecurityAttribute = (struct type_PrxACCSntx_SecurityAttribute*)calloc( 1,
		    	sizeof( struct type_PrxACCSntx_SecurityAttribute ))) != NULL ) {

		struct 	element_PrxACCSntx_8* PACattrValp ;
		
		if( (PACprivp->SecurityAttribute->attributeType = oid_cpy( desdAttCapOid )) != NULLOID &&
		    (PACattrValp = PACprivp->SecurityAttribute->attributeValue = (struct element_PrxACCSntx_8*)calloc(1,
		    	sizeof( struct element_PrxACCSntx_8 ))) != NULL ) {

		    PACattrValp->authority = NULL ;

		    if( (PACattrValp->element_PrxACCSntx_9 = (struct element_PrxACCSntx_10*)calloc(1,
						    	sizeof( struct element_PrxACCSntx_10 ))) != NULL ) {

			struct	type_PrxACCSntx_CapabilityType1* capeType1p ;

			if((capeType1p = (struct type_PrxACCSntx_CapabilityType1*)calloc(1,
					sizeof( struct type_PrxACCSntx_CapabilityType1 ))) != NULL &&
			   (capeType1p->objectDefiner = (struct type_PrxACCSntx_ObjectDefiner*)calloc(1,
  				sizeof( struct type_PrxACCSntx_ObjectDefiner ))) != NULL &&
			   (capeType1p->accessType = (struct type_PrxACCSntx_AccessDefiner*)calloc(1,
		    		sizeof( struct type_PrxACCSntx_AccessDefiner ))) != NULL   ) {

			    PE	builtCapeType1PE = NULLPE ;
				
			    capeType1p->objectDefiner->offset = type_PrxACCSntx_IntegerOrString_stringPart ;
		    	    capeType1p->accessType->offset    = type_PrxACCSntx_IntegerOrString_stringPart ;

		    	    if( (capeType1p->objectDefiner->un.stringPart = str2qb( "", 0, 1 )) != NULL &&
		                (capeType1p->accessType->un.stringPart = str2qb( communityString, strlen( communityString ), 1 )) != NULL &&
				(builtCapeType1PE = build_CapabilityType1( capeType1p )) != NULLPE ) {

				PE builtPE = NULLPE ;

				PACattrValp->element_PrxACCSntx_9->element_PrxACCSntx_11 = builtCapeType1PE ;

				if( (builtPE = build_AccessControlCertficate( PACp )) != NULLPE )
				    builtExternp = external_build(EXTERN_ASN1_TYPE, NULL, NULL, builtPE, NULL) ;

				(void)AccessControlCertficate_free(PACp) ;

			    } else {
			    	(void)free((char*)capeType1p->objectDefiner ) ;
			    	(void)free((char*)capeType1p->accessType ) ;
			    	(void)free((char*)capeType1p ) ;
			 	(void)free((char*)PACattrValp->element_PrxACCSntx_9 ) ;   		
			    	(void)free((char*)PACattrValp ) ;
			    	(void)oid_free( PACprivp->SecurityAttribute->attributeType ) ;
			    	(void)free((char*)PACprivp->SecurityAttribute ) ;
		    		(void)free((char*)PACprivp ) ;
		    	    	(void)free((char*)PACelemp ) ;
			    	(void)free((char*)PACp ) ;			
			    }
			} else {
			    (void)free((char*)PACattrValp ) ;
		    	    (void)oid_free( PACprivp->SecurityAttribute->attributeType ) ;
			    (void)free((char*)PACprivp->SecurityAttribute ) ;
		    	    (void)free((char*)PACprivp ) ;
		    	    (void)free((char*)PACelemp ) ;
			    (void)free((char*)PACp ) ;			
			}
			
		    } else {
		    	(void)free((char*)PACattrValp ) ;
		    	(void)oid_free( PACprivp->SecurityAttribute->attributeType ) ;
		    	(void)free((char*)PACprivp->SecurityAttribute ) ;
		    	(void)free((char*)PACprivp ) ;
	    	    	(void)free((char*)PACelemp ) ;
		    	(void)free((char*)PACp ) ;			
		    }
		       
		} else {
		    (void)free((char*)PACprivp->SecurityAttribute ) ;
		    (void)free((char*)PACprivp ) ;
	    	    (void)free((char*)PACelemp ) ;
		    (void)free((char*)PACp ) ;
		}

	    } else {
	    	(void)free((char*)PACelemp ) ;
	    	(void)free((char*)PACp ) ;
	    }

	} else if( PACp != NULL ) (void)free( (char*)PACp ) ;

	return builtExternp ;
}


struct qbuf *
retrieveCommunityFromPAC( PACexternp )
External*	PACexternp ;
{	    
struct 	qbuf * communityString = NULL ;
static	OID desdAttCapOid = NULLOID ;

	if( desdAttCapOid == NULLOID &&
	    (desdAttCapOid = name2oid( "desd-att-capability-type-1" )) == NULLOID ) {

	    advise( NULLCP, "IQASntx.c: oidtable.gen needs to define \"desd-att-capability-type-1\"" ) ;
	    return communityString ;
	}

	if( PACexternp != NULLEXTERN &&
	    PACexternp->encoding != NULL &&
	    PACexternp->encoding->un.single__ASN1__type != NULLPE ) {

 	    struct type_PrxACCSntx_AccessControlCertficate* PACp ;

	    PACp = parse_AccessControlCertficate( PACexternp->encoding->un.single__ASN1__type ) ;

	    if( PACp != (struct type_PrxACCSntx_AccessControlCertficate*)NULL ) {

		struct type_PrxACCSntx_SecurityAttribute * secAttrp ;

		if( PACp->element_PrxACCSntx_0 != NULL &&
		    PACp->element_PrxACCSntx_0->privilegeAttributes != NULL &&
		    (secAttrp = PACp->element_PrxACCSntx_0->privilegeAttributes->SecurityAttribute) != NULL ) {

		    struct element_PrxACCSntx_10 * secAttrValSEQp ;
		    PE		secAttrValPE ;
		    struct	type_PrxACCSntx_CapabilityType1* capeType1p ;
		    
		    if( oid_equal( secAttrp->attributeType, desdAttCapOid ) &&
		    	secAttrp->attributeValue != NULL &&
			(secAttrValSEQp = secAttrp->attributeValue->element_PrxACCSntx_9) != NULL &&
			(secAttrValPE = secAttrValSEQp->element_PrxACCSntx_11) != NULLPE &&
			(capeType1p = parse_CapabilityType1( secAttrValPE )) != NULL ) {

			/* Check that we have an IIMC SnmpV1 community string... */
		    	if( capeType1p->objectDefiner != NULL &&
		            capeType1p->objectDefiner->offset == type_PrxACCSntx_IntegerOrString_stringPart &&
			    capeType1p->objectDefiner->un.stringPart != NULL ) {

			    char * objDefcp = qb2str( capeType1p->objectDefiner->un.stringPart ) ;

			    if( objDefcp != NULLCP ) {

 			    	if( strlen( objDefcp ) == 0 ) {
			    	    /* ...the objectDefiner is undefined and represented as an empty string */

				    /* Now (finally) we can retrieve the community string.. */
				    if( capeType1p->accessType != NULL &&
				    	capeType1p->accessType->offset == type_PrxACCSntx_IntegerOrString_stringPart &&
				    	capeType1p->accessType->un.stringPart != NULL ) {

				    	communityString = qb_cpy( capeType1p->accessType->un.stringPart ) ;
				    }
				}
			    }

			    (void)free( objDefcp ) ;
			}

			(void)CapabilityType1_free( capeType1p ) ;
		    }     
		}

		(void)AccessControlCertficate_free(PACp) ;
	    }
	}

	return communityString ;
}

int InternetAlarmInfo_print();

PE 
build_InternetAlarmInfo( report )
struct type_PrxAlarmSntx_InternetAlarmInfo *report;
{
PE 	pe;
#ifdef DEBUG
PS 	ps;
	ps = ps_alloc( str_open ) ;
	if( str_setup(ps, NULLCP, 20000, 0) == OK &&
		InternetAlarmInfo_print( ps, report, 1 ) == OK && ps->ps_base ) {

	    *ps->ps_ptr = NULL ; /* NULL terminate the buffer */
	    advise( NULLCP, "AlarmInfo: %s", ps->ps_base ) ;
	}
	ps_free(ps) ;
#endif
	if (build_PrxAlarmSntx_InternetAlarmInfo(&pe, 1, 0, NULL, report) == NOTOK)
	   return(NULL);
	else
	   return(pe);
}


struct type_PrxAlarmSntx_InternetAlarmInfo* 
parse_InternetAlarmInfo(pe)
PE pe;
{
struct type_PrxAlarmSntx_InternetAlarmInfo *report;

	if (parse_PrxAlarmSntx_InternetAlarmInfo(pe, 1, 0, NULL, &report) == NOTOK)
	   return(NULL);
	else
	   return(report);
}


int 
InternetAlarmInfo_free(theElem)
struct type_PrxAlarmSntx_InternetAlarmInfo * theElem;
{
	if(theElem == NULL)
   	    return; /* Nothing to free */
   	else {

	    /* Pepsy generated free will not handle DNs and RDNs... */

	    struct type_PrxAlarmSntx_ObjectInstanceList * objInstListp ;
	    struct type_PrxAlarmSntx_InternetTrapInfo   * intTrapListp ;

	    for( objInstListp =  theElem->objectInstanceList ;
	    	 objInstListp != NULL ;
		 objInstListp =  objInstListp -> next ) {

		struct type_PrxAlarmSntx_ObjectInstance * objInstp ;

		if( (objInstp = objInstListp->ObjectInstance) != NULL ) {

		    if( objInstp->offset = type_PrxAlarmSntx_ObjectInstance_distinguishedName ) {

		     	if( objInstp->un.distinguishedName != NULL ) {
			    dn_free( objInstp->un.distinguishedName ) ;
			    objInstp->un.distinguishedName = NULL ;
			}
			
		    } else if( objInstp->offset = type_PrxAlarmSntx_ObjectInstance_localDistinguishedName ) {

		     	if( objInstp->un.localDistinguishedName != NULL ){
			    rdn_free( objInstp->un.localDistinguishedName ) ;
			    objInstp->un.localDistinguishedName = NULL ;
			}
		    }
		}
	    }

	    for( intTrapListp = theElem->internetTrapInfo ;
	    	 intTrapListp != NULL ;
		 intTrapListp = intTrapListp->next ) {

		struct element_PrxAlarmSntx_0 * elemp ;
		struct type_PrxAlarmSntx_ObjectInstance * objInstp ;

		if( (elemp = intTrapListp->member_PrxAlarmSntx_0) != NULL &&
		    (objInstp = elemp->objectInstance) != NULL ) {

		    if( objInstp->offset == type_PrxAlarmSntx_ObjectInstance_distinguishedName ) {

		    	if( objInstp->un.distinguishedName != NULL ) {
			    dn_free( objInstp->un.distinguishedName ) ;
			    objInstp->un.distinguishedName = NULL ;
			}

		    } else if( objInstp->offset == type_PrxAlarmSntx_ObjectInstance_localDistinguishedName ) {

		     	if( objInstp->un.localDistinguishedName != NULL ){
			    rdn_free( objInstp->un.localDistinguishedName ) ;
			    objInstp->un.localDistinguishedName = NULL ;
			}
		    }
		}
	    }

	    /* Free whatever is left... */
     	    (void)free_PrxAlarmSntx_InternetAlarmInfo(theElem);
	}

	return ;
}


struct type_PrxAlarmSntx_AttributeIdentifierList **
appendAttributeIdListAttrId( currAttrIdListpp, iimcVarBindNameOID )
struct 	type_PrxAlarmSntx_AttributeIdentifierList ** currAttrIdListpp ;
OID 	iimcVarBindNameOID ;
{
struct type_PrxAlarmSntx_AttributeId * attrIdp ;

	if( ((*currAttrIdListpp) = (struct type_PrxAlarmSntx_AttributeIdentifierList*)malloc(
		sizeof( struct type_PrxAlarmSntx_AttributeIdentifierList ))) == NULL ) {

	    /* no action required */

	} else if( (attrIdp = (*currAttrIdListpp) -> AttributeId = (struct type_PrxAlarmSntx_AttributeId*)malloc(
		sizeof( struct type_PrxAlarmSntx_AttributeId ))) == NULL ) {

	    	free_PrxAlarmSntx_AttributeIdentifierList( *currAttrIdListpp ) ;
		(*currAttrIdListpp) = NULL ;
	    
	} else {

	    attrIdp->offset = type_PrxAlarmSntx_AttributeId_globalForm ;

	    if( (attrIdp -> un.globalForm = oid_cpy( iimcVarBindNameOID )) == NULLOID ) {

	    	free_PrxAlarmSntx_AttributeIdentifierList( *currAttrIdListpp ) ;
		(*currAttrIdListpp) = NULL ;

	    } else {

		(*currAttrIdListpp) ->next = NULL ;
		currAttrIdListpp = &((*currAttrIdListpp)->next) ;
	    }
	}

	return currAttrIdListpp ;
}

struct type_PrxAlarmSntx_UnknownVarBindList **
appendUnknownVarBindListVarBind( currUnknownVBListpp, iimcVarBindNameOID, varBindValuePE )
struct 	type_PrxAlarmSntx_UnknownVarBindList ** currUnknownVBListpp ;
OID 	iimcVarBindNameOID ;
PE	varBindValuePE ;
{
struct type_PrxAlarmSntx_RFC1157__SNMPVarBind * unkVBLvarBindp ;

	if( ((*currUnknownVBListpp) = (struct type_PrxAlarmSntx_UnknownVarBindList*)malloc(
			sizeof(struct type_PrxAlarmSntx_UnknownVarBindList))) == NULL ) {

	    /* no action required */
	    
	} else if( (unkVBLvarBindp = (*currUnknownVBListpp)->RFC1157__SNMPVarBind = 
		(struct type_PrxAlarmSntx_RFC1157__SNMPVarBind*)calloc( 1, 
			sizeof( struct type_PrxAlarmSntx_RFC1157__SNMPVarBind))) == NULL ||
		(unkVBLvarBindp->name  = oid_cpy( iimcVarBindNameOID ))          == NULLOID ||
		(unkVBLvarBindp->value = pe_cpy( varBindValuePE ))		 == NULLPE    ) {

	    free_PrxAlarmSntx_RFC1157__SNMPVarBind( *currUnknownVBListpp ) ;
	    *currUnknownVBListpp = NULL ;

	} else {

	    (*currUnknownVBListpp)-> next = NULL ;
	    currUnknownVBListpp = &((*currUnknownVBListpp)->next) ;
	}

	return currUnknownVBListpp ;
}


struct type_PrxAlarmSntx_ObjectInstanceList **
appendObjectInstList( currObjInstListpp, objectInstanceDN )
struct	type_PrxAlarmSntx_ObjectInstanceList ** currObjInstListpp ;
DN	objectInstanceDN ;
{
struct type_PrxAlarmSntx_ObjectInstance * objInstp ;

	if( ((*currObjInstListpp) = (struct type_PrxAlarmSntx_ObjectInstanceList*)malloc(
			sizeof(struct type_PrxAlarmSntx_ObjectInstanceList))) == NULL ) {

	    /* no action required */

	} else if( (objInstp = ((*currObjInstListpp)->ObjectInstance) = 
		   	(struct type_PrxAlarmSntx_ObjectInstance*)calloc(1, 
 				sizeof(struct type_PrxAlarmSntx_ObjectInstance))) == NULL) {

	    free_PrxAlarmSntx_ObjectInstanceList( *currObjInstListpp ) ;
	    (*currObjInstListpp) = NULL ;

	} else {

	    objInstp->offset = type_PrxAlarmSntx_ObjectInstance_distinguishedName ;

	    if( (objInstp->un.distinguishedName =
	    		(struct type_IF_DistinguishedName *)dn_cpy( objectInstanceDN )) == NULL ) {

		free_PrxAlarmSntx_ObjectInstanceList( *currObjInstListpp ) ;
		(*currObjInstListpp) = NULL ;
	    } else {
	
		(*currObjInstListpp)->next = NULL ;
		currObjInstListpp = &((*currObjInstListpp)->next) ;
	    }
	}

	return currObjInstListpp ;
}


struct type_PrxAlarmSntx_InternetTrapInfo **
appendIntTrapInfo( currIntTrapInfopp, iimcVarBindNameOID, varBindValuePE, objectInstanceDN )
struct	type_PrxAlarmSntx_InternetTrapInfo ** currIntTrapInfopp ;
OID	iimcVarBindNameOID ;
PE	varBindValuePE ;
DN	objectInstanceDN ;
{
struct element_PrxAlarmSntx_0 		* intTrapElemp ;
struct type_PrxAlarmSntx_AttributeId 	* attrIdp ;
struct type_PrxAlarmSntx_ObjectInstance * objInstp ;

	if( ((*currIntTrapInfopp) = (struct type_PrxAlarmSntx_InternetTrapInfo*)malloc(
		sizeof(struct type_PrxAlarmSntx_InternetTrapInfo))) == NULL ) {

	    /* no action required */

	} else if( (intTrapElemp = ((*currIntTrapInfopp)->member_PrxAlarmSntx_0) =
		(struct element_PrxAlarmSntx_0*)calloc( 1, sizeof(struct element_PrxAlarmSntx_0))) == NULL ||
		(intTrapElemp->attributeValue = pe_cpy( varBindValuePE )) == NULLPE ||
		(attrIdp = intTrapElemp->attributeId = (struct type_PrxAlarmSntx_AttributeId*)malloc(
			sizeof( struct type_PrxAlarmSntx_AttributeId ))) == NULL ) {

	    free_PrxAlarmSntx_InternetTrapInfo( *currIntTrapInfopp ) ;
	    (*currIntTrapInfopp) = NULL ;

	} else {
	
	    attrIdp -> offset = type_PrxAlarmSntx_AttributeId_globalForm ;

	    if( (attrIdp->un.globalForm = oid_cpy( iimcVarBindNameOID )) == NULLOID ||
	    	(objectInstanceDN != NULLDN &&
			(objInstp = intTrapElemp->objectInstance = (struct type_PrxAlarmSntx_ObjectInstance*)calloc(1,
				sizeof( struct type_PrxAlarmSntx_ObjectInstance ))) == NULL) ) {

		free_PrxAlarmSntx_InternetTrapInfo( *currIntTrapInfopp ) ;
		(*currIntTrapInfopp) = NULL ;

	    } else if( objectInstanceDN != NULLDN ) {

	    	objInstp -> offset = type_PrxAlarmSntx_ObjectInstance_distinguishedName ;

		if( (objInstp->un.distinguishedName = 
			(struct type_IF_RDNSequence*)dn_cpy( objectInstanceDN )) == NULL ) {
		    free_PrxAlarmSntx_InternetTrapInfo( *currIntTrapInfopp ) ;
		    (*currIntTrapInfopp) = NULL ;
		} else {
		    (*currIntTrapInfopp)->next = NULL ;
		    currIntTrapInfopp = &((*currIntTrapInfopp)->next) ;
		}
	    } else {
		(*currIntTrapInfopp)->next = NULL ;
		currIntTrapInfopp = &((*currIntTrapInfopp)->next) ;
	    }
	}

	return currIntTrapInfopp ;
}


int
InternetAlarmInfo_compare( ial1p, ial2p )
struct type_PrxAlarmSntx_InternetAlarmInfo *ial1p , *ial2p ;
{
int	match = 0 ;

	if( ial1p == NULL ) {
 	    if( ial2p == NULL )
	    	match = 0 ;
	    else
	    	match = -1 ;

	} else if( ial2p == NULL ) {
	    match = 1 ;

	} else {
	    if( ial1p->notificationId && ial2p->notificationId )
		match = int_cmp( ial1p->notificationId, ial2p->notificationId ) ;
	}

	return match ;
}


static int
pe_printf( ps, pe, quoted )
PS	ps ;
PE	pe ;
int	quoted ;
{
int 	status = OK ;
int 	pepscnt = 0 ;
char * 	cp1 = NULLCP, *cp2 = NULLCP ;

	if( pe2mem( pe, &cp1, &pepscnt ) == OK &&
	    (cp1 != NULLCP) && (cp2 = hexprint( cp1, pepscnt )) != NULLCP ) {
	
	    ps_printf( ps, "%s", cp2 ) ;

	    (void)free( cp2 ) ;

	} else {
	    ps_printf( ps, "INVALID PE" ) ;
	}

        if( cp1 ) (void)free( cp1 ) ;

	return status ;
}
	
static int
AttributeId_print( ps, alpId, quoted )
PS 	ps ;
struct	type_PrxAlarmSntx_AttributeId * alpId ;
int	quoted ;
{
int 	status = OK ;

	ps_printf( ps, "{" ) ;

	if( alpId == NULL ) {
	    ps_printf( ps, "NULL" ) ;
	} else {
	    if( alpId->offset == type_PrxAlarmSntx_AttributeId_globalForm &&
	    		alpId->un.globalForm != NULLOID )
		ps_printf( ps, "%s", sprintoid( alpId->un.globalForm )) ;

	    else if( alpId->offset == type_PrxAlarmSntx_AttributeId_localForm )
		ps_printf( ps, "%d", alpId->un.localForm ) ;
	}

	ps_printf( ps, "}" ) ;

	return status ;
}

		    
static int
IQAObjectInstance_print( ps, objInstp, quoted )
PS	ps ;
struct	type_PrxAlarmSntx_ObjectInstance * objInstp ;
int 	quoted ;
{
int	status = OK ;
char *	cp ;

	ps_printf( ps, "{" ) ;

	if( objInstp == NULL) {
	    ps_printf( ps, "NULL" ) ;
	} else {
	    if( objInstp->offset == type_PrxAlarmSntx_ObjectInstance_distinguishedName &&
			    		objInstp->un.distinguishedName != NULL ) {
		if( (cp = dn2str( (DN)objInstp->un.distinguishedName)) != NULLCP ) {			 
		    ps_printf( ps, "%s", cp ) ; (void)free( cp ) ;
		}

	    } else if( objInstp->offset == type_PrxAlarmSntx_ObjectInstance_nonSpecificForm &&
	    				objInstp->un.nonSpecificForm != NULL ) {
		if( (cp = qb2str( objInstp->un.nonSpecificForm)) != NULLCP ) {
		    ps_printf( ps, "%s", cp ) ; (void)free( cp ) ;
		}
		
	    } else if( objInstp->offset == type_PrxAlarmSntx_ObjectInstance_localDistinguishedName &&
	    				objInstp->un.localDistinguishedName != NULL ) {
		if( (cp = rdn2str( (RDN)objInstp->un.localDistinguishedName)) != NULLCP ) {			 
		    ps_printf( ps, "%s", cp ) ; (void)free( cp ) ;
		}
	    }
	}

	ps_printf( ps, "}" ) ;

	return status ;
}

static int
VarBind_print( ps, varBindp, quoted )
PS	ps ;
struct	type_PrxAlarmSntx_RFC1157__SNMPVarBind * varBindp ;
int	quoted ;
{
int	status = OK ;

	ps_printf( ps, "{" ) ;

	if( varBindp == NULL) {
	    ps_printf( ps, "NULL" ) ;
	} else {

	    if( varBindp->name != NULLOID )
	    	ps_printf( ps, "%s=", sprintoid( varBindp->name )) ;

	    if( varBindp->value != NULL )
	    	status = pe_printf( ps, varBindp->value, quoted ) ;
	}

	ps_printf( ps, "}" ) ;

	return status ;
}

static int
IQATransportAddress_print( ps, transportAddress, quoted )
PS	ps ;
struct	type_PrxIIMCSntx_TransportAddress * transportAddress ;
int	quoted ;
{
int	status = OK ;
char   *cp, *cp1 ;
 		
	if( transportAddress == NULL ||
	    (cp = cp1 = qb2str(transportAddress)) == NULLCP ) {

	    ps_printf( ps, "NULL" ) ;

	} else {
	    while( *cp1 )
		ps_printf( ps, "%02x", (unsigned char)(*(cp1++)) ) ;
		        
	    (void)free(cp) ;
	}
	return status ;
}

static int
ManagementExtension_print( ps, mgmtp, quoted )
PS	ps ;
struct	type_PrxAlarmSntx_ManagementExtension * mgmtp ;
int	quoted ;
{
int	status = OK ;

	ps_printf( ps, "{" ) ;

	if( mgmtp == NULL ) {
	    ps_printf( ps, "NULL" ) ;
	} else {
	    if( mgmtp->identifier != NULL )
	    	ps_printf( ps, "id=%s ", sprintoid(  mgmtp->identifier )) ;

	    ps_printf( ps, "sig:%c ", mgmtp->significance ) ;

	    if( mgmtp->information != NULL ) {
		int pepscnt = 0 ;
		char * cp   = NULLCP ;
			    
		ps_printf( ps, "info:" ) ;

		if( pe2mem( mgmtp->information, &cp, &pepscnt ) == OK && cp == NULLCP ) {
		    ps_printf( ps, "%s", cp ) ;
 		    (void)free(cp) ;
		}
	    }
	}
	ps_printf( ps, "}" ) ;

	return status ;
}

int
InternetAlarmInfo_print( ps, ialp, quoted )
PS	ps ;
struct type_PrxAlarmSntx_InternetAlarmInfo * ialp ;
int	quoted ;
{
int	status = OK ;

	if( ialp == NULL ) {
	    ps_printf( ps, "NULL" ) ;
	    
	} else {

	    ps_printf( ps, "{probableCause: " ) ;
	    if( ialp->probableCause == NULL )
	    	ps_printf( ps, "NULL" ) ;
	    else {
	    	if( ialp->probableCause->offset == type_PrxAlarmSntx_ProbableCause_globalValue &&
							ialp->probableCause->un.globalValue != NULLOID )
		    ps_printf( ps, "%s", sprintoid( ialp->probableCause->un.globalValue )) ;
		else if( ialp->probableCause->offset == type_PrxAlarmSntx_ProbableCause_localValue )
		    ps_printf( ps, "%d", ialp->probableCause->un.localValue ) ;
	    }
	    ps_printf( ps, "}" ) ;


	    ps_printf( ps, "{attributeIdList: " ) ;
	    if( ialp->attributeIdList == NULL )
	    	ps_printf( ps, "NULL" ) ;
	    else {
	    	struct type_PrxAlarmSntx_AttributeIdentifierList* alp ;
	    	for( alp=ialp->attributeIdList ; alp != NULL ; alp=alp->next ) {
		    status = AttributeId_print( ps, alp->AttributeId, quoted ) ;		    
		}
	    }
	    ps_printf( ps, "}" ) ;


	    ps_printf( ps, "{objectInstanceList: " ) ;
	    if( ialp->objectInstanceList == NULL )
	    	ps_printf( ps, "NULL" ) ;
	    else {
	        struct type_PrxAlarmSntx_ObjectInstanceList * objInstLp ;
		for( objInstLp=ialp->objectInstanceList ; objInstLp != NULL ; objInstLp=objInstLp->next ) {
		    status = IQAObjectInstance_print( ps, objInstLp->ObjectInstance, quoted ) ;		
		}

	    }
	    ps_printf( ps, "}" ) ;


	    ps_printf( ps, "{UnknownVarBindList: " ) ;
	    if( ialp->unknownVarBindList == NULL )
	    	ps_printf( ps, "NULL" ) ;
	    else {
	    	struct type_PrxAlarmSntx_UnknownVarBindList * varBindListp ;
		for( varBindListp=ialp->unknownVarBindList ; varBindListp != NULL ; varBindListp=varBindListp->next ) {
		    status = VarBind_print( ps, varBindListp->RFC1157__SNMPVarBind, quoted ) ;
		}
	    }
	    ps_printf( ps, "}" ) ;


	    ps_printf( ps, "{internetTrapInfo: " ) ;
	    if( ialp -> internetTrapInfo == NULL )
	    	ps_printf( ps, "NULL" ) ;
	    else {
	        struct type_PrxAlarmSntx_InternetTrapInfo * intTrpInfop ;
		struct element_PrxAlarmSntx_0 * elemp ;
		for( intTrpInfop=ialp->internetTrapInfo ; intTrpInfop != NULL ; intTrpInfop=intTrpInfop->next ) {
		    if( (elemp = intTrpInfop->member_PrxAlarmSntx_0) != NULL ) {

		    	status = IQAObjectInstance_print( ps, elemp->objectInstance, quoted ) ;
			status = AttributeId_print( ps, elemp->attributeId, quoted ) ;

			if( elemp->attributeValue ) {

			    ps_printf( ps, "{av:" ) ;

			    pe_printf( ps, elemp->attributeValue, quoted ) ;

			    ps_printf( ps, "}" ) ;
			}
		    }
		}
	    }
	    ps_printf( ps, "}" ) ;


	    ps_printf( ps, "{perceivedSeverity: " ) ;
	    if( ialp->perceivedSeverity == NULL )
	    	ps_printf( ps, "NULL" ) ;
	    else {
	    	switch( ialp->perceivedSeverity->parm ) {
		    case int_PrxAlarmSntx_PerceivedSeverity_indeterminate :
				    	ps_printf( ps,"indeterminate" ) ;
					break ;
		    case int_PrxAlarmSntx_PerceivedSeverity_critical :
				    	ps_printf( ps,"critical" ) ;
					break ;
		    case int_PrxAlarmSntx_PerceivedSeverity_major :
				    	ps_printf( ps,"major" ) ;
					break ;
		    case int_PrxAlarmSntx_PerceivedSeverity_minor :
				    	ps_printf( ps,"minor" ) ;
					break ;
		    case int_PrxAlarmSntx_PerceivedSeverity_warning :
				    	ps_printf( ps,"warning" ) ;
					break ;
		    case int_PrxAlarmSntx_PerceivedSeverity_cleared :
				    	ps_printf( ps,"cleared" ) ;
					break ;
		    default:
				    	ps_printf( ps,"INVALID" ) ;
					break ;		    
		}
	    }
	    ps_printf( ps, "}" ) ;



	    ps_printf( ps, "{notificationId: " ) ;
	    if( ialp->notificationId == NULL )
	    	ps_printf( ps, "NULL" ) ;
	    else {
	    	ps_printf( ps, "%d", ialp->notificationId->parm ) ;
	    }
	    ps_printf( ps, "}" ) ;


	    ps_printf( ps, "{CorrelatedNotifications: " ) ;
	    ps_printf( ps, "NO PRINT" ) ;
	    ps_printf( ps, "}" ) ;

	    ps_printf( ps, "{transportDomain: " ) ;
	    if( ialp->transportDomain == NULL ) 
	    	ps_printf( ps, "NULL" ) ;
	    else
 		ps_printf( ps, "%s", sprintoid( ialp->transportDomain )) ;
	    ps_printf( ps, "}" ) ;


	    ps_printf( ps, "{transportAddress: " ) ;
	    status = IQATransportAddress_print( ps, ialp->transportAddress, quoted ) ;
	    ps_printf( ps, "}" ) ;


	    ps_printf( ps, "{accessControlInfo: " ) ;
	    if( ialp->accessControlInfo == NULL )
	    	ps_printf( ps, "NULL" ) ;
	    else {
	    	if( ialp->accessControlInfo->offset == type_PrxIIMCSntx_AccessControlInfo_communityString ) {

		    char *cp ;
		    if( ialp->accessControlInfo->un.communityString == NULL )
		    	ps_printf( ps, "NULL" ) ;

		    else if( (cp = qb2str( ialp->accessControlInfo->un.communityString )) != NULLCP ) {
			ps_printf( ps, "commStr:%s", cp ) ; (void)free(cp) ;
		    }

		} else ps_printf( ps, "NO AccessControlInfo PRINT" ) ;
	    }
	    ps_printf( ps, "}" ) ;


	    ps_printf( ps, "{additionalInformation: " ) ;
	    if( ialp->additionalInformation == NULL )
	    	ps_printf( ps, "NULL" ) ;
	    else {
	    	struct type_PrxAlarmSntx_AdditionalInformation * addInfp ;
		for( addInfp=ialp->additionalInformation ; addInfp!=NULL ; addInfp=addInfp->next ) {
		    status = ManagementExtension_print( ps, addInfp->ManagementExtension, quoted ) ;
		}
	    }
	    ps_printf( ps, "}" ) ;
	    
	    ps_printf( ps, "}" ) ;
	}

	return status ;
}


void
iqa_all_syntaxes()
{
	iqa_evrep_syntaxes();

	return ;
}

void
iqa_evrep_syntaxes() 
{
	iqa_attr_syntaxes() ;

	(void)add_attribute_syntax( "InternetAlarmInfo",
		(IFP) build_InternetAlarmInfo,
		(IFP) parse_InternetAlarmInfo,
		(IFP) NULLIFP,
		(IFP) InternetAlarmInfo_print,
		NULLIFP,
		(IFP) InternetAlarmInfo_compare,
		(IFP) InternetAlarmInfo_free,
		NULLCP,
		NULLIFP, 0 );

	return ;
}

void
iqa_attr_syntaxes()
{
	PrxIIMCSntx_syntax_table() ;

	(void)set_attribute_syntax( str2syntax( "AccessControlEnforcement" ),
		(IFP) int_enc,		(IFP) int_dec,
		(IFP) int_parse,	int_print,
		(IFP) int_cpy,		int_cmp,
		int_free,		NULLCP,
		NULLIFP,		FALSE);

	(void)set_attribute_syntax( str2syntax( "PollPeriod" ),
		(IFP) int_enc,		(IFP) int_dec,
		(IFP) int_parse,	int_print,
		(IFP) int_cpy,		int_cmp,
		int_free,		NULLCP,
		NULLIFP,		FALSE);

	(void)set_attribute_syntax( str2syntax( "RetryLimit" ),
		(IFP) int_enc,		(IFP) int_dec,
		(IFP) int_parse,	int_print,
		(IFP) int_cpy,		int_cmp,
		int_free,		NULLCP,
		NULLIFP,		FALSE);

	(void)set_attribute_syntax( str2syntax( "SupportedMIBs" ),
		(IFP) build_SupportedMIBs,
		(IFP) parse_SupportedMIBs,
		(IFP) OIDList_parse, /* parse function */
		(IFP) OIDList_print,
		NULLIFP,
		(IFP) OIDListVal_cmp,
		(IFP) SupportedMIBs_free,
		NULLCP,
		NULLIFP, 0);

	(void)set_attribute_syntax( str2syntax( "TimeoutInterval" ),
		(IFP) int_enc,		(IFP) int_dec,
		(IFP) int_parse,	int_print,
		(IFP) int_cpy,		int_cmp,
		int_free,		NULLCP,
		NULLIFP,		FALSE);

	(void)set_attribute_syntax( str2syntax( "TransportAddress" ),
		(IFP) r_octenc, 	(IFP) r_octsdec,
                (IFP) r_octparse, 	r_octprint,
		(IFP) qb_cpy,   	qb_cmp,
		qb_free,        	NULLCP,
		NULLIFP,        	TRUE);
	
	(void)set_attribute_syntax( str2syntax( "TransportDomain" ), 
		(IFP) oid2pe,   (IFP) dup_prim2oid,
                (IFP) name2oid, oidprint,
		(IFP) oid_cpy,  oid_cmp,
		oid_free,       NULLCP,
		NULLIFP,        FALSE );

	(void)set_attribute_syntax( str2syntax( "TransportAddresses" ),
		(IFP) build_TransportAddresses,
		(IFP) parse_TransportAddresses,
		TransportAddresses_parse, /* parse function */
		(IFP) TransportAddresses_print,
		NULLIFP,
		(IFP) TransportAddresses_compare,
		(IFP) TransportAddresses_free,
		NULLCP,
		NULLIFP, 0);

	(void)set_attribute_syntax( str2syntax( "NullRDN" ),
		(IFP) build_NullRDN,
		(IFP) parse_NullRDN,
		NULL_parse, /* parse function */
		(IFP) NULL_print,
		NULLIFP,
		(IFP) NULL_compare,
		(IFP) NullRDN_free,
		NULLCP,
		NULLIFP, 0);	

	(void)add_attribute_syntax( "SnmpIpAddress",
		(IFP) build_SnmpIpAddress,
 		(IFP) parse_SnmpIpAddress,
                (IFP) SnmpProxyIpAddress_parse,
		(IFP) SnmpProxyIpAddress_print,
		(IFP) qb_cpy,   	
		(IFP) qb_cmp, /* WARNING may cause problems */
		(IFP) qb_free,
		NULLCP,
		NULLIFP, TRUE);

	(void)add_attribute_syntax( "SnmpNetworkAddress",
		(IFP) build_SnmpNetworkAddress,
 		(IFP) parse_SnmpNetworkAddress,
                (IFP) SnmpProxyNetworkAddress_parse,
		(IFP) SnmpProxyNetworkAddress_print,
		(IFP) qb_cpy,   	
		(IFP) qb_cmp, /* WARNING may cause problems */
		(IFP) qb_free,
		NULLCP,
		NULLIFP, TRUE);
		
	(void)add_attribute_syntax( "SnmpInteger",
		(IFP) int_enc,		(IFP) int_dec,
		(IFP) SnmpInteger_parse,int_print,
		(IFP) int_cpy,		int_cmp,
		int_free,		NULLCP,
		NULLIFP,		FALSE);

	(void)add_attribute_syntax( "SnmpCounter",
		(IFP) counter_enc,	(IFP) counter_dec,
		(IFP) SnmpULong_parse,	counter_print,
		(IFP) SnmpULong_cpy,	counter_cmp,
		counter_free,		NULLCP,
		NULLIFP,		FALSE);

	(void)add_attribute_syntax( "SnmpGauge",
		(IFP) gauge_enc,	(IFP) counter_dec,
		(IFP) SnmpULong_parse,	counter_print,
		(IFP) SnmpULong_cpy,	counter_cmp,
		counter_free,		NULLCP,
		NULLIFP,		FALSE);

	(void)add_attribute_syntax( "SnmpTimeTicks",
		(IFP) timeTicks_enc,	(IFP) counter_dec,
		(IFP) SnmpULong_parse,	counter_print,
		(IFP) SnmpULong_cpy,	counter_cmp,
		counter_free,		NULLCP,
		NULLIFP,		FALSE);

	(void)add_attribute_syntax( "SnmpOID",
		(IFP) oid2pe,	(IFP) dup_prim2oid,
		(IFP) SnmpOID_parse,	oidprint,
		(IFP) oid_cpy,	oid_cmp,
		oid_free,	NULLCP,
		NULLIFP,	FALSE );
 		
	(void)add_attribute_syntax( "SnmpOctetString",
		(IFP) r_octenc, 	(IFP) r_octsdec,
                SnmpOctetString_parse,	string_print,
		(IFP) qb_cpy,   	qb_cmp,
		qb_free,        	NULLCP,
		NULLIFP,        	TRUE);

	(void)add_attribute_syntax( "SnmpFixedLenOctetString",
		(IFP) r_octenc, 	(IFP) r_octsdec,
                SnmpOctetString_parse,	string_print,
		(IFP) qb_cpy,   	qb_cmp,
		qb_free,        	NULLCP,
		NULLIFP,        	TRUE);

	(void)add_attribute_syntax( "SnmpDisplayString",
		(IFP) r_octenc, 	(IFP) r_octsdec,
                SnmpOctetString_parse,	string_display,
		(IFP) qb_cpy,   	qb_cmp,
		qb_free,        	NULLCP,
		NULLIFP,        	TRUE);

	(void)add_attribute_syntax( "SnmpPhysAddress",
		(IFP) r_octenc, 	(IFP) r_octsdec,
                SnmpOctetString_parse,	string_print,
		(IFP) qb_cpy,   	qb_cmp,
		qb_free,        	NULLCP,
		NULLIFP,        	TRUE);

	(void)add_attribute_syntax( "SnmpNULL",
		(IFP) build_SnmpNULL,
		(IFP) parse_SnmpNULL,
		NULL_parse, /* parse function */
		(IFP) NULL_print,
		NULLIFP,
		(IFP) NULL_compare,
		(IFP) SnmpNULL_free,
		NULLCP,
		NULLIFP, 0);		

	(void)add_attribute_syntax( "SnmpGenericRDN",
		(IFP) build_SnmpGenericRDN,
		(IFP) parse_SnmpGenericRDN,
		(IFP) SnmpGenericRDN_parse, /* parse function */
		(IFP) SnmpGenericRDN_print,
		(IFP) SnmpGenericRDN_cpy,
		(IFP) SnmpGenericRDN_compare,
		(IFP) SnmpGenericRDN_free,
		NULLCP,
		NULLIFP, 0);

	/* Test syntax.. */
	(void)add_attribute_syntax( "IpNetToMediaEntryIdValue",
		(IFP) build_IpNetToMediaEntryIdValue,
		(IFP) parse_IpNetToMediaEntryIdValue,
		(IFP) IpNetToMediaEntryIdValue_parse, /* parse function */
		(IFP) IpNetToMediaEntryIdValue_print,
		NULLIFP,
		(IFP) IpNetToMediaEntryIdValue_compare,
		(IFP) IpNetToMediaEntryIdValue_free,
		NULLCP,
		NULLIFP, 0);

	return ;
}
