-- Access Control specific syntaxes
-- K.M.T.McCarthy
-- 10-Mar-94
PrxACCSntx { ccitt(0) data(9) pss(2342) ucl(19200300) iimc(114) iimcSyntaxes(1) 3 }

DEFINITIONS ::=

PREFIXES build parse print

BEGIN

SECTIONS build parse none

	-- NMF 016 K.2

	AccessControlCertficate ::=  
	    SEQUENCE {
		SEQUENCE {		    
		    -- for a compound ACC:
		    containedACCs	[0]	SEQUENCE OF AccessControlCertficate OPTIONAL,

		    -- the actual privilege attributes:
		    privilegeAttributes	[1]	SEQUENCE OF SecurityAttribute,

		    -- fields used to support ACC protection schemes:
		    initiatorQualifierAttributes [2] SEQUENCE OF SecurityAttribute OPTIONAL,
		    targetQualifierAttributes 	 [3] SEQUENCE OF SecurityAttribute OPTIONAL,
		    validationKeyIdentifier	 [4] BIT STRING OPTIONAL,

		    -- fields for additional protection in use:
		    creationTime	[5]	GeneralizedTime OPTIONAL,
		    validityTime	[6]	TimePeriod OPTIONAL,
		    accIdentifier	[7]	INTEGER OPTIONAL,
		    recoveryIdentifier	[8]	INTEGER OPTIONAL,

		    -- fields used for certification:
		    accAuthority	[9]	Authority OPTIONAL 
	        },

		-- seal at the end to assist in length calculation:
		accSeal			Seal	OPTIONAL
	    }

	Authority ::=
	    SEQUENCE {
	    	authorityType		OBJECT IDENTIFIER,
		authorityValue		ANY DEFINED BY authorityType
	    }

	Seal ::=
	    SEQUENCE {
	    	algorithmIdentifier	OBJECT IDENTIFIER,
		keyIdentifier		OCTET STRING,
		seal			OCTET STRING
	    }

	TimePeriod ::=
	    SEQUENCE OF SEQUENCE {
		validFrom	[0]	GeneralizedTime OPTIONAL,
		validUntil	[1]	GeneralizedTime OPTIONAL
	    }

	
	-- ECMA 138


	SecurityAttribute ::= SEQUENCE {
        			attributeType   OBJECT IDENTIFIER,

			        attributeValue  SEQUENCE {
                               			    authority [0] PolicyAuthority OPTIONAL,
 			                            SEQUENCE OF ANY DEFINED BY attributeType
                                 		}
                              }

	PolicyAuthority ::= OBJECT IDENTIFIER


	-- NMF 027 section 3.1.2


--	Security-capability-type-1 ::= ATTRIBUTE
--		WITH ATTRIBUTE-SYNTAX CapabilityType1
--		SINGLE VALUE

	CapabilityType1 ::= 
	    SEQUENCE {
	    	objectDefiner	ObjectDefiner,
		accessType	AccessDefiner
	    }

	ObjectDefiner ::= IntegerOrString
	AccessDefiner ::= IntegerOrString

	IntegerOrString ::=
	    CHOICE {
	    	integerPart	INTEGER,
		stringPart	IA5String
	    }
END
