#ifndef _IQASupportedMIBs_h_
#define _IQASupportedMIBs_h_

#ifdef __GNU__
#include <std.h>
#else ifdef __cplusplus
#include <stdlib.h>
#endif

#include "msap.h"
#include "GenericAttr.h"
#include "PrxIIMCSntx-syntax.h"
#include "PrxIIMCSntx-utils.h"

 extern "C" {
	int SupportedMIBs_print(PS, struct type_PrxIIMCSntx_SupportedMIBs*, int);
	int SupportedMIBs_compare(void*, void*); };

class SupportedMIBs : public Attr {

protected:
   Bool CmpEquality, CmpOrdering;
   PE     _encode();
   void*  _decode(PE);
   char*  _print();
   void   _free();
   int    _compare(void*, void*);

public:
   SupportedMIBs(struct type_PrxIIMCSntx_SupportedMIBs* = NULL);
   ~SupportedMIBs();
   int  add(void*);
   int  remove(void*);
   Bool filter(int, void*);
};


inline PE SupportedMIBs::_encode()
{
   return(build_SupportedMIBs((struct type_PrxIIMCSntx_SupportedMIBs*)getval()));
};

inline void* SupportedMIBs::_decode(PE pe)
{
   return((void*)parse_SupportedMIBs(pe));
};

inline char* SupportedMIBs::_print()
{
   return(attrv2str(getval(), (PRINT_FNX)SupportedMIBs_print));
};

inline void SupportedMIBs::_free()
{
   (void)SupportedMIBs_free((struct type_PrxIIMCSntx_SupportedMIBs*)getval());
}

inline int SupportedMIBs::_compare(void* theElem, void* theCmpElem)
{
   return(SupportedMIBs_compare(theElem, theCmpElem));
};

inline int SupportedMIBs::add(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

inline int SupportedMIBs::remove(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

#endif
