#ifndef _IQATransportAddresses_h_
#define _IQATransportAddresses_h_

#ifdef __GNU__
#include <std.h>
#else ifdef __cplusplus
#include <stdlib.h>
#endif

#include "msap.h"
#include "GenericAttr.h"
#include "PrxIIMCSntx-syntax.h"
#include "PrxIIMCSntx-utils.h"

 extern "C" {
	int TransportAddresses_print(PS, struct type_PrxIIMCSntx_TransportAddresses*, int);
	int TransportAddresses_compare(void*, void*); };

class TransportAddresses : public Attr {

protected:
   Bool CmpEquality, CmpOrdering;
   PE     _encode();
   void*  _decode(PE);
   char*  _print();
   void   _free();
   int    _compare(void*, void*);

public:
   TransportAddresses(struct type_PrxIIMCSntx_TransportAddresses* = NULL);
   ~TransportAddresses();
   int  add(void*);
   int  remove(void*);
   Bool filter(int, void*);
};


inline PE TransportAddresses::_encode()
{
   return(build_TransportAddresses((struct type_PrxIIMCSntx_TransportAddresses*)getval()));
};

inline void* TransportAddresses::_decode(PE pe)
{
   return((void*)parse_TransportAddresses(pe));
};

inline char* TransportAddresses::_print()
{
   return(attrv2str(getval(), (PRINT_FNX)TransportAddresses_print));
};

inline void TransportAddresses::_free()
{
   (void)TransportAddresses_free((struct type_PrxIIMCSntx_TransportAddresses*)getval());
}

inline int TransportAddresses::_compare(void* theElem, void* theCmpElem)
{
   return(TransportAddresses_compare(theElem, theCmpElem));
};

inline int TransportAddresses::add(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

inline int TransportAddresses::remove(void*)
{
   return(NOTOK); /* It is not a SEQUENCE OF/SET OF */
};

#endif
