/* compiled */

#include <stdio.h>
#include "objects.h"

static unsigned int _elems[] = {
      0, 0, /* ccitt */ 
      1, 0, /* iso */ 
      1, 3, 6, 1, 0, /* internet */ 
      1, 3, 6, 1, 1, 0, /* directory */ 
      1, 3, 6, 1, 2, 0, /* mgmt */ 
      1, 3, 6, 1, 3, 0, /* experimental */ 
      1, 3, 6, 1, 4, 0, /* private */ 
      1, 3, 6, 1, 4, 1, 0, /* enterprises */ 
      1, 3, 6, 1, 5, 0, /* security */ 
      1, 3, 6, 1, 6, 0, /* snmpV2 */ 
      1, 3, 6, 1, 6, 1, 0, /* snmpDomains */ 
      1, 3, 6, 1, 6, 1, 1, 0, /* snmpUDPDomain */ 
      1, 3, 6, 1, 6, 1, 2, 0, /* snmpCLNSDomain */ 
      1, 3, 6, 1, 6, 1, 3, 0, /* snmpCONSDomain */ 
      1, 3, 6, 1, 6, 1, 4, 0, /* snmpDDPDomain */ 
      1, 3, 6, 1, 6, 1, 5, 0, /* snmpIPXDomain */ 
      1, 3, 6, 1, 6, 2, 0, /* snmpProxys */ 
      1, 3, 6, 1, 6, 2, 1, 0, /* rfc1157Proxy */ 
      1, 3, 6, 1, 6, 2, 1, 1, 0, /* rfc1157Domain */ 
      1, 3, 6, 1, 6, 2, 1, 2, 0, /* rfc1157noAuth */ 
      1, 3, 6, 1, 6, 3, 0, /* snmpModules */ 
      1, 3, 6, 1, 6, 3, 2, 0, /* snmpM2M */ 
      1, 3, 6, 1, 6, 3, 2, 1, 0, /* snmpM2MObjects */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 0, /* snmpAlarm */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 1, 0, /* snmpAlarmNextIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 0, /* snmpAlarmTable */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 0, /* snmpAlarmEntry */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 1, 0, /* snmpAlarmIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 2, 0, /* snmpAlarmVariable */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 3, 0, /* snmpAlarmInterval */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 4, 0, /* snmpAlarmSampleType */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 5, 0, /* snmpAlarmValue */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 6, 0, /* snmpAlarmStartupAlarm */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 7, 0, /* snmpAlarmRisingThreshold */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 8, 0, /* snmpAlarmFallingThreshold */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 9, 0, /* snmpAlarmRisingEventIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 10, 0, /* snmpAlarmFallingEventIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 11, 0, /* snmpAlarmUnavailableEventIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 2, 1, 12, 0, /* snmpAlarmStatus */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 3, 0, /* snmpAlarmNotifications */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 3, 1, 0, /* snmpRisingAlarm */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 3, 2, 0, /* snmpFallingAlarm */ 
      1, 3, 6, 1, 6, 3, 2, 1, 1, 3, 3, 0, /* snmpObjectUnavailableAlarm */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 0, /* snmpEvent */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 1, 0, /* snmpEventNextIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 0, /* snmpEventTable */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 0, /* snmpEventEntry */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 1, 0, /* snmpEventIndex */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 2, 0, /* snmpEventID */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 3, 0, /* snmpEventDescription */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 4, 0, /* snmpEventEvents */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 5, 0, /* snmpEventLastTimeSent */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 2, 1, 6, 0, /* snmpEventStatus */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 3, 0, /* snmpEventNotifyMinInterval */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 4, 0, /* snmpEventNotifyMaxRetransmissions */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 5, 0, /* snmpEventNotifyTable */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 5, 1, 0, /* snmpEventNotifyEntry */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 5, 1, 1, 0, /* snmpEventNotifyIntervalRequested */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 5, 1, 2, 0, /* snmpEventNotifyRetransmissionsRequested */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 5, 1, 3, 0, /* snmpEventNotifyLifetime */ 
      1, 3, 6, 1, 6, 3, 2, 1, 2, 5, 1, 4, 0, /* snmpEventNotifyStatus */ 
      1, 3, 6, 1, 6, 3, 2, 2, 0, /* snmpM2MConformance */ 
      1, 3, 6, 1, 6, 3, 2, 2, 1, 0, /* snmpM2MCompliances */ 
      1, 3, 6, 1, 6, 3, 2, 2, 1, 1, 0, /* snmpM2MCompliance */ 
      1, 3, 6, 1, 6, 3, 2, 2, 2, 0, /* snmpM2MGroups */ 
      1, 3, 6, 1, 6, 3, 2, 2, 2, 1, 0, /* snmpAlarmGroup */ 
      1, 3, 6, 1, 6, 3, 2, 2, 2, 2, 0, /* snmpEventGroup */ 
      1, 3, 6, 1, 6, 3, 3, 0, /* partyMIB */ 
      1, 3, 6, 1, 6, 3, 3, 1, 0, /* partyAdmin */ 
      1, 3, 6, 1, 6, 3, 3, 1, 1, 0, /* partyProtocols */ 
      1, 3, 6, 1, 6, 3, 3, 1, 1, 1, 0, /* noAuth */ 
      1, 3, 6, 1, 6, 3, 3, 1, 1, 2, 0, /* noPriv */ 
      1, 3, 6, 1, 6, 3, 3, 1, 1, 3, 0, /* desPrivProtocol */ 
      1, 3, 6, 1, 6, 3, 3, 1, 1, 4, 0, /* v2md5AuthProtocol */ 
      1, 3, 6, 1, 6, 3, 3, 1, 2, 0, /* temporalDomains */ 
      1, 3, 6, 1, 6, 3, 3, 1, 2, 1, 0, /* currentTime */ 
      1, 3, 6, 1, 6, 3, 3, 1, 2, 2, 0, /* restartTime */ 
      1, 3, 6, 1, 6, 3, 3, 1, 2, 3, 0, /* cacheTime */ 
      1, 3, 6, 1, 6, 3, 3, 1, 3, 0, /* initialPartyId */ 
      1, 3, 6, 1, 6, 3, 3, 1, 4, 0, /* initialContextId */ 
      1, 3, 6, 1, 6, 3, 3, 2, 0, /* partyMIBObjects */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 0, /* snmpParties */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 0, /* partyTable */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 0, /* partyEntry */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 1, 0, /* partyIdentity */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 2, 0, /* partyIndex */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 3, 0, /* partyTDomain */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 4, 0, /* partyTAddress */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 5, 0, /* partyMaxMessageSize */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 6, 0, /* partyLocal */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 7, 0, /* partyAuthProtocol */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 8, 0, /* partyAuthClock */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 9, 0, /* partyAuthPrivate */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 10, 0, /* partyAuthPublic */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 11, 0, /* partyAuthLifetime */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 12, 0, /* partyPrivProtocol */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 13, 0, /* partyPrivPrivate */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 14, 0, /* partyPrivPublic */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 15, 0, /* partyCloneFrom */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 16, 0, /* partyStorageType */ 
      1, 3, 6, 1, 6, 3, 3, 2, 1, 1, 1, 17, 0, /* partyStatus */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 0, /* snmpContexts */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 0, /* contextTable */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 0, /* contextEntry */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 1, 0, /* contextIdentity */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 2, 0, /* contextIndex */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 3, 0, /* contextLocal */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 4, 0, /* contextViewIndex */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 5, 0, /* contextLocalEntity */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 6, 0, /* contextLocalTime */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 7, 0, /* contextProxyDstParty */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 8, 0, /* contextProxySrcParty */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 9, 0, /* contextProxyContext */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 10, 0, /* contextStorageType */ 
      1, 3, 6, 1, 6, 3, 3, 2, 2, 1, 1, 11, 0, /* contextStatus */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 0, /* snmpAccess */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 0, /* aclTable */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 0, /* aclEntry */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 1, 0, /* aclTarget */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 2, 0, /* aclSubject */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 3, 0, /* aclResources */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 4, 0, /* aclPrivileges */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 5, 0, /* aclStorageType */ 
      1, 3, 6, 1, 6, 3, 3, 2, 3, 1, 1, 6, 0, /* aclStatus */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 0, /* snmpViews */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 0, /* viewTable */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 0, /* viewEntry */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 1, 0, /* viewIndex */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 2, 0, /* viewSubtree */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 3, 0, /* viewMask */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 4, 0, /* viewType */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 5, 0, /* viewStorageType */ 
      1, 3, 6, 1, 6, 3, 3, 2, 4, 1, 1, 6, 0, /* viewStatus */ 
      1, 3, 6, 1, 6, 3, 3, 3, 0, /* partyMIBConformance */ 
      1, 3, 6, 1, 6, 3, 3, 3, 1, 0, /* partyMIBCompliances */ 
      1, 3, 6, 1, 6, 3, 3, 3, 1, 1, 0, /* unSecurableCompliance */ 
      1, 3, 6, 1, 6, 3, 3, 3, 1, 2, 0, /* partyNoPrivacyCompliance */ 
      1, 3, 6, 1, 6, 3, 3, 3, 1, 3, 0, /* partyPrivacyCompliance */ 
      1, 3, 6, 1, 6, 3, 3, 3, 1, 4, 0, /* fullPrivacyCompliance */ 
      1, 3, 6, 1, 6, 3, 3, 3, 2, 0, /* partyMIBGroups */ 
      1, 3, 6, 1, 6, 3, 3, 3, 2, 1, 0, /* partyMIBGroup */ 
      2, 0, /* joint-iso-ccitt */ 
};

static OIDentifier _names[] = {
    { 1, &_elems[0] }, 
    { 1, &_elems[2] }, 
    { 4, &_elems[4] }, 
    { 5, &_elems[9] }, 
    { 5, &_elems[15] }, 
    { 5, &_elems[21] }, 
    { 5, &_elems[27] }, 
    { 6, &_elems[33] }, 
    { 5, &_elems[40] }, 
    { 5, &_elems[46] }, 
    { 6, &_elems[52] }, 
    { 7, &_elems[59] }, 
    { 7, &_elems[67] }, 
    { 7, &_elems[75] }, 
    { 7, &_elems[83] }, 
    { 7, &_elems[91] }, 
    { 6, &_elems[99] }, 
    { 7, &_elems[106] }, 
    { 8, &_elems[114] }, 
    { 8, &_elems[123] }, 
    { 6, &_elems[132] }, 
    { 7, &_elems[139] }, 
    { 8, &_elems[147] }, 
    { 9, &_elems[156] }, 
    { 10, &_elems[166] }, 
    { 10, &_elems[177] }, 
    { 11, &_elems[188] }, 
    { 12, &_elems[200] }, 
    { 12, &_elems[213] }, 
    { 12, &_elems[226] }, 
    { 12, &_elems[239] }, 
    { 12, &_elems[252] }, 
    { 12, &_elems[265] }, 
    { 12, &_elems[278] }, 
    { 12, &_elems[291] }, 
    { 12, &_elems[304] }, 
    { 12, &_elems[317] }, 
    { 12, &_elems[330] }, 
    { 12, &_elems[343] }, 
    { 10, &_elems[356] }, 
    { 11, &_elems[367] }, 
    { 11, &_elems[379] }, 
    { 11, &_elems[391] }, 
    { 9, &_elems[403] }, 
    { 10, &_elems[413] }, 
    { 10, &_elems[424] }, 
    { 11, &_elems[435] }, 
    { 12, &_elems[447] }, 
    { 12, &_elems[460] }, 
    { 12, &_elems[473] }, 
    { 12, &_elems[486] }, 
    { 12, &_elems[499] }, 
    { 12, &_elems[512] }, 
    { 10, &_elems[525] }, 
    { 10, &_elems[536] }, 
    { 10, &_elems[547] }, 
    { 11, &_elems[558] }, 
    { 12, &_elems[570] }, 
    { 12, &_elems[583] }, 
    { 12, &_elems[596] }, 
    { 12, &_elems[609] }, 
    { 8, &_elems[622] }, 
    { 9, &_elems[631] }, 
    { 10, &_elems[641] }, 
    { 9, &_elems[652] }, 
    { 10, &_elems[662] }, 
    { 10, &_elems[673] }, 
    { 7, &_elems[684] }, 
    { 8, &_elems[692] }, 
    { 9, &_elems[701] }, 
    { 10, &_elems[711] }, 
    { 10, &_elems[722] }, 
    { 10, &_elems[733] }, 
    { 10, &_elems[744] }, 
    { 9, &_elems[755] }, 
    { 10, &_elems[765] }, 
    { 10, &_elems[776] }, 
    { 10, &_elems[787] }, 
    { 9, &_elems[798] }, 
    { 9, &_elems[808] }, 
    { 8, &_elems[818] }, 
    { 9, &_elems[827] }, 
    { 10, &_elems[837] }, 
    { 11, &_elems[848] }, 
    { 12, &_elems[860] }, 
    { 12, &_elems[873] }, 
    { 12, &_elems[886] }, 
    { 12, &_elems[899] }, 
    { 12, &_elems[912] }, 
    { 12, &_elems[925] }, 
    { 12, &_elems[938] }, 
    { 12, &_elems[951] }, 
    { 12, &_elems[964] }, 
    { 12, &_elems[977] }, 
    { 12, &_elems[990] }, 
    { 12, &_elems[1003] }, 
    { 12, &_elems[1016] }, 
    { 12, &_elems[1029] }, 
    { 12, &_elems[1042] }, 
    { 12, &_elems[1055] }, 
    { 12, &_elems[1068] }, 
    { 9, &_elems[1081] }, 
    { 10, &_elems[1091] }, 
    { 11, &_elems[1102] }, 
    { 12, &_elems[1114] }, 
    { 12, &_elems[1127] }, 
    { 12, &_elems[1140] }, 
    { 12, &_elems[1153] }, 
    { 12, &_elems[1166] }, 
    { 12, &_elems[1179] }, 
    { 12, &_elems[1192] }, 
    { 12, &_elems[1205] }, 
    { 12, &_elems[1218] }, 
    { 12, &_elems[1231] }, 
    { 12, &_elems[1244] }, 
    { 9, &_elems[1257] }, 
    { 10, &_elems[1267] }, 
    { 11, &_elems[1278] }, 
    { 12, &_elems[1290] }, 
    { 12, &_elems[1303] }, 
    { 12, &_elems[1316] }, 
    { 12, &_elems[1329] }, 
    { 12, &_elems[1342] }, 
    { 12, &_elems[1355] }, 
    { 9, &_elems[1368] }, 
    { 10, &_elems[1378] }, 
    { 11, &_elems[1389] }, 
    { 12, &_elems[1401] }, 
    { 12, &_elems[1414] }, 
    { 12, &_elems[1427] }, 
    { 12, &_elems[1440] }, 
    { 12, &_elems[1453] }, 
    { 12, &_elems[1466] }, 
    { 8, &_elems[1479] }, 
    { 9, &_elems[1488] }, 
    { 10, &_elems[1498] }, 
    { 10, &_elems[1509] }, 
    { 10, &_elems[1520] }, 
    { 10, &_elems[1531] }, 
    { 9, &_elems[1542] }, 
    { 10, &_elems[1552] }, 
    { 1, &_elems[1563] }, 
};

static struct _syntax {
    char   *name;
    OS      value;
    char   *textual;
    char   *display;
}	_syntaxes[] = {
    { "INTEGER", NULLOS, NULL, NULL }, 
    { "Integer32", NULLOS, NULL, NULL }, 
    { "Services", NULLOS, NULL, NULL }, 
    { "Privileges", NULLOS, NULL, NULL }, 
    { "OctetString", NULLOS, NULL, NULL }, 
    { "DisplayString", NULLOS, NULL, NULL }, 
    { "PhysAddress", NULLOS, NULL, NULL }, 
    { "ObjectID", NULLOS, NULL, NULL }, 
    { "BitString", NULLOS, NULL, NULL }, 
    { "IpAddress", NULLOS, NULL, NULL }, 
    { "NetworkAddress", NULLOS, NULL, NULL }, 
    { "Counter", NULLOS, NULL, NULL }, 
    { "Counter32", NULLOS, NULL, NULL }, 
    { "Counter64", NULLOS, NULL, NULL }, 
    { "Gauge", NULLOS, NULL, NULL }, 
    { "Gauge32", NULLOS, NULL, NULL }, 
    { "UInteger32", NULLOS, NULL, NULL }, 
    { "TimeTicks", NULLOS, NULL, NULL }, 
    { "NsapAddress", NULLOS, NULL, NULL }, 
    { "ClnpAddress", NULLOS, NULL, NULL }, 
    { "Party", NULLOS, "ObjectID", NULL }, 
    { "TAddress", NULLOS, "OctetString", NULL }, 
    { "Clock", NULLOS, "UInteger32", NULL }, 
    { "Context", NULLOS, "ObjectID", NULL }, 
    { "StorageType", NULLOS, "INTEGER", NULL }, 
    { "MacAddress", NULLOS, "OctetString", "1x:" }, 
    { "TruthValue", NULLOS, "INTEGER", NULL }, 
    { "TestAndIncr", NULLOS, "INTEGER", NULL }, 
    { "AutonomousType", NULLOS, "ObjectID", NULL }, 
    { "InstancePointer", NULLOS, "ObjectID", NULL }, 
    { "RowStatus", NULLOS, "INTEGER", NULL }, 
    { "TimeStamp", NULLOS, "TimeTicks", NULL }, 
    { "TimeInterval", NULLOS, "INTEGER", NULL }, 
    { "DateAndTime", NULLOS, "OctetString", "2d-1d-1d,1d:1d:1d.1d,1a1d:1d" }, 
    { "SnmpUDPAddress", NULLOS, "OctetString", "1d.1d.1d.1d/2d" }, 
    { "SnmpOSIAddress", NULLOS, "OctetString", "*1x:/1x:" }, 
    { "SnmpNBPAddress", NULLOS, "OctetString", NULL }, 
    { "SnmpIPXAddress", NULLOS, "OctetString", "4x.1x:1x:1x:1x:1x:1x.2d" }, 
    NULL
};

static object_type _types[] = {
    { "ccitt", "0", &_names[0],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, NULLOT, NULLOT, &_types[1] },
    { "iso", "1", &_names[1],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, NULLOT, &_types[2], &_types[2] },
    { "internet", "1.3.6.1", &_names[2],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[53], NULLOT, &_types[3], &_types[3] },
    { "directory", "1.3.6.1.1", &_names[3],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[95], &_types[6], NULLOT, &_types[4] },
    { "mgmt", "1.3.6.1.2", &_names[4],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[8], NULLOT, &_types[5] },
    { "experimental", "1.3.6.1.3", &_names[5],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[97], &_types[4], NULLOT, &_types[6] },
    { "private", "1.3.6.1.4", &_names[6],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[121], &_types[5], &_types[7], &_types[7] },
    { "enterprises", "1.3.6.1.4.1", &_names[7],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[131], NULLOT, NULLOT, &_types[8] },
    { "security", "1.3.6.1.5", &_names[8],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[9], NULLOT, &_types[9] },
    { "snmpV2", "1.3.6.1.6", &_names[9],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, NULLOT, &_types[16], &_types[10] },
    { "snmpDomains", "1.3.6.1.6.1", &_names[10],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[112], &_types[20], &_types[11], &_types[11] },
    { "snmpUDPDomain", "1.3.6.1.6.1.1", &_names[11],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[20], &_types[12], NULLOT, &_types[12] },
    { "snmpCLNSDomain", "1.3.6.1.6.1.2", &_names[12],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[11], &_types[13], NULLOT, &_types[13] },
    { "snmpCONSDomain", "1.3.6.1.6.1.3", &_names[13],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[12], &_types[14], NULLOT, &_types[14] },
    { "snmpDDPDomain", "1.3.6.1.6.1.4", &_names[14],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[13], &_types[15], NULLOT, &_types[15] },
    { "snmpIPXDomain", "1.3.6.1.6.1.5", &_names[15],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[14], NULLOT, NULLOT, &_types[16] },
    { "snmpProxys", "1.3.6.1.6.2", &_names[16],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[3], &_types[10], &_types[17], &_types[17] },
    { "rfc1157Proxy", "1.3.6.1.6.2.1", &_names[17],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[16], NULLOT, &_types[18], &_types[18] },
    { "rfc1157Domain", "1.3.6.1.6.2.1.1", &_names[18],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[15], &_types[19], NULLOT, &_types[19] },
    { "rfc1157noAuth", "1.3.6.1.6.2.1.2", &_names[19],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[132], NULLOT, NULLOT, &_types[20] },
    { "snmpModules", "1.3.6.1.6.3", &_names[20],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[10], NULLOT, &_types[21], &_types[21] },
    { "snmpM2M", "1.3.6.1.6.3.2", &_names[21],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[67], &_types[61], &_types[22] },
    { "snmpM2MObjects", "1.3.6.1.6.3.2.1", &_names[22],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, NULLOT, &_types[23], &_types[23] },
    { "snmpAlarm", "1.3.6.1.6.3.2.1.1", &_names[23],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[43], &_types[25], &_types[24] },
    { "snmpAlarmNextIndex", "1.3.6.1.6.3.2.1.1.1", &_names[24],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, NULLOT, NULLOT, &_types[25] },
    { "snmpAlarmTable", "1.3.6.1.6.3.2.1.1.2", &_names[25],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[39], &_types[26], &_types[26] },
    { "snmpAlarmEntry", "1.3.6.1.6.3.2.1.1.2.1", &_names[26],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, NULLOT, &_types[30], &_types[27] },
    { "snmpAlarmIndex", "1.3.6.1.6.3.2.1.1.2.1.1", &_names[27],
      (OS) 0, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[24], &_types[35], NULLOT, &_types[28] },
    { "snmpAlarmVariable", "1.3.6.1.6.3.2.1.1.2.1.2", &_names[28],
      (OS) -1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[31], NULLOT, &_types[29] },
    { "snmpAlarmInterval", "1.3.6.1.6.3.2.1.1.2.1.3", &_names[29],
      (OS) 1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, NULLOT, NULLOT, &_types[30] },
    { "snmpAlarmSampleType", "1.3.6.1.6.3.2.1.1.2.1.4", &_names[30],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[26], &_types[28], NULLOT, &_types[31] },
    { "snmpAlarmValue", "1.3.6.1.6.3.2.1.1.2.1.5", &_names[31],
      (OS) 1, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[62], &_types[38], NULLOT, &_types[32] },
    { "snmpAlarmStartupAlarm", "1.3.6.1.6.3.2.1.1.2.1.6", &_names[32],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[23], &_types[29], NULLOT, &_types[33] },
    { "snmpAlarmRisingThreshold", "1.3.6.1.6.3.2.1.1.2.1.7", &_names[33],
      (OS) 1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[34], NULLOT, &_types[34] },
    { "snmpAlarmFallingThreshold", "1.3.6.1.6.3.2.1.1.2.1.8", &_names[34],
      (OS) 1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[33], &_types[32], NULLOT, &_types[35] },
    { "snmpAlarmRisingEventIndex", "1.3.6.1.6.3.2.1.1.2.1.9", &_names[35],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[27], &_types[36], NULLOT, &_types[36] },
    { "snmpAlarmFallingEventIndex", "1.3.6.1.6.3.2.1.1.2.1.10", &_names[36],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[35], &_types[37], NULLOT, &_types[37] },
    { "snmpAlarmUnavailableEventIndex", "1.3.6.1.6.3.2.1.1.2.1.11", &_names[37],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[36], &_types[33], NULLOT, &_types[38] },
    { "snmpAlarmStatus", "1.3.6.1.6.3.2.1.1.2.1.12", &_names[38],
      (OS) -1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[27], NULLOT, &_types[39] },
    { "snmpAlarmNotifications", "1.3.6.1.6.3.2.1.1.3", &_names[39],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[24], &_types[40], &_types[40] },
    { "snmpRisingAlarm", "1.3.6.1.6.3.2.1.1.3.1", &_names[40],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[32], &_types[41], NULLOT, &_types[41] },
    { "snmpFallingAlarm", "1.3.6.1.6.3.2.1.1.3.2", &_names[41],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[40], &_types[42], NULLOT, &_types[42] },
    { "snmpObjectUnavailableAlarm", "1.3.6.1.6.3.2.1.1.3.3", &_names[42],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[41], NULLOT, NULLOT, &_types[43] },
    { "snmpEvent", "1.3.6.1.6.3.2.1.2", &_names[43],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, NULLOT, &_types[53], &_types[44] },
    { "snmpEventNextIndex", "1.3.6.1.6.3.2.1.2.1", &_names[44],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[37], &_types[45], NULLOT, &_types[45] },
    { "snmpEventTable", "1.3.6.1.6.3.2.1.2.2", &_names[45],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[25], &_types[55], &_types[46], &_types[46] },
    { "snmpEventEntry", "1.3.6.1.6.3.2.1.2.2.1", &_names[46],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[30], NULLOT, &_types[48], &_types[47] },
    { "snmpEventIndex", "1.3.6.1.6.3.2.1.2.2.1.1", &_names[47],
      (OS) 0, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[44], &_types[51], NULLOT, &_types[48] },
    { "snmpEventID", "1.3.6.1.6.3.2.1.2.2.1.2", &_names[48],
      (OS) 7, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[64], &_types[52], NULLOT, &_types[49] },
    { "snmpEventDescription", "1.3.6.1.6.3.2.1.2.2.1.3", &_names[49],
      (OS) 5, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, NULLOT, NULLOT, &_types[50] },
    { "snmpEventEvents", "1.3.6.1.6.3.2.1.2.2.1.4", &_names[50],
      (OS) 12, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[43], &_types[49], NULLOT, &_types[51] },
    { "snmpEventLastTimeSent", "1.3.6.1.6.3.2.1.2.2.1.5", &_names[51],
      (OS) -1, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[50], NULLOT, &_types[52] },
    { "snmpEventStatus", "1.3.6.1.6.3.2.1.2.2.1.6", &_names[52],
      (OS) -1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[38], &_types[47], NULLOT, &_types[53] },
    { "snmpEventNotifyMinInterval", "1.3.6.1.6.3.2.1.2.3", &_names[53],
      (OS) 1, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[29], &_types[54], NULLOT, &_types[54] },
    { "snmpEventNotifyMaxRetransmissions", "1.3.6.1.6.3.2.1.2.4", &_names[54],
      (OS) 1, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[31], &_types[44], NULLOT, &_types[55] },
    { "snmpEventNotifyTable", "1.3.6.1.6.3.2.1.2.5", &_names[55],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[45], NULLOT, &_types[56], &_types[56] },
    { "snmpEventNotifyEntry", "1.3.6.1.6.3.2.1.2.5.1", &_names[56],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[46], NULLOT, &_types[60], &_types[57] },
    { "snmpEventNotifyIntervalRequested", "1.3.6.1.6.3.2.1.2.5.1.1", &_names[57],
      (OS) 1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[34], &_types[58], NULLOT, &_types[58] },
    { "snmpEventNotifyRetransmissionsRequested", "1.3.6.1.6.3.2.1.2.5.1.2", &_names[58],
      (OS) 1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[57], &_types[59], NULLOT, &_types[59] },
    { "snmpEventNotifyLifetime", "1.3.6.1.6.3.2.1.2.5.1.3", &_names[59],
      (OS) 1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[0], NULLOT, NULLOT, &_types[60] },
    { "snmpEventNotifyStatus", "1.3.6.1.6.3.2.1.2.5.1.4", &_names[60],
      (OS) -1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[52], &_types[57], NULLOT, &_types[61] },
    { "snmpM2MConformance", "1.3.6.1.6.3.2.2", &_names[61],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[22], &_types[62], &_types[62] },
    { "snmpM2MCompliances", "1.3.6.1.6.3.2.2.1", &_names[62],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[64], &_types[63], &_types[63] },
    { "snmpM2MCompliance", "1.3.6.1.6.3.2.2.1.1", &_names[63],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[54], NULLOT, NULLOT, &_types[64] },
    { "snmpM2MGroups", "1.3.6.1.6.3.2.2.2", &_names[64],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[141], NULLOT, &_types[65], &_types[65] },
    { "snmpAlarmGroup", "1.3.6.1.6.3.2.2.2.1", &_names[65],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[48], &_types[66], NULLOT, &_types[66] },
    { "snmpEventGroup", "1.3.6.1.6.3.2.2.2.2", &_names[66],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[65], NULLOT, NULLOT, &_types[67] },
    { "partyMIB", "1.3.6.1.6.3.3", &_names[67],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[61], NULLOT, &_types[133], &_types[68] },
    { "partyAdmin", "1.3.6.1.6.3.3.1", &_names[68],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, NULLOT, &_types[74], &_types[69] },
    { "partyProtocols", "1.3.6.1.6.3.3.1.1", &_names[69],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[21], NULLOT, &_types[72], &_types[70] },
    { "noAuth", "1.3.6.1.6.3.3.1.1.1", &_names[70],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[60], NULLOT, NULLOT, &_types[71] },
    { "noPriv", "1.3.6.1.6.3.3.1.1.2", &_names[71],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[28], &_types[70], NULLOT, &_types[72] },
    { "desPrivProtocol", "1.3.6.1.6.3.3.1.1.3", &_names[72],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[69], &_types[73], NULLOT, &_types[73] },
    { "v2md5AuthProtocol", "1.3.6.1.6.3.3.1.1.4", &_names[73],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[72], &_types[71], NULLOT, &_types[74] },
    { "temporalDomains", "1.3.6.1.6.3.3.1.2", &_names[74],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[67], &_types[78], &_types[75], &_types[75] },
    { "currentTime", "1.3.6.1.6.3.3.1.2.1", &_names[75],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[76], NULLOT, &_types[76] },
    { "restartTime", "1.3.6.1.6.3.3.1.2.2", &_names[76],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[75], &_types[77], NULLOT, &_types[77] },
    { "cacheTime", "1.3.6.1.6.3.3.1.2.3", &_names[77],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[76], NULLOT, NULLOT, &_types[78] },
    { "initialPartyId", "1.3.6.1.6.3.3.1.3", &_names[78],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[79], NULLOT, &_types[79] },
    { "initialContextId", "1.3.6.1.6.3.3.1.4", &_names[79],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[78], &_types[69], NULLOT, &_types[80] },
    { "partyMIBObjects", "1.3.6.1.6.3.3.2", &_names[80],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[22], &_types[68], &_types[124], &_types[81] },
    { "snmpParties", "1.3.6.1.6.3.3.2.1", &_names[81],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[63], &_types[115], &_types[82], &_types[82] },
    { "partyTable", "1.3.6.1.6.3.3.2.1.1", &_names[82],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[55], NULLOT, &_types[83], &_types[83] },
    { "partyEntry", "1.3.6.1.6.3.3.2.1.1.1", &_names[83],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[56], NULLOT, &_types[99], &_types[84] },
    { "partyIdentity", "1.3.6.1.6.3.3.2.1.1.1.1", &_names[84],
      (OS) 20, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[94], NULLOT, &_types[85] },
    { "partyIndex", "1.3.6.1.6.3.3.2.1.1.1.2", &_names[85],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[47], &_types[93], NULLOT, &_types[86] },
    { "partyTDomain", "1.3.6.1.6.3.3.2.1.1.1.3", &_names[86],
      (OS) 7, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[133], &_types[87], NULLOT, &_types[87] },
    { "partyTAddress", "1.3.6.1.6.3.3.2.1.1.1.4", &_names[87],
      (OS) 21, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[134], &_types[89], NULLOT, &_types[88] },
    { "partyMaxMessageSize", "1.3.6.1.6.3.3.2.1.1.1.5", &_names[88],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[139], &_types[98], NULLOT, &_types[89] },
    { "partyLocal", "1.3.6.1.6.3.3.2.1.1.1.6", &_names[89],
      (OS) -1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[70], &_types[100], NULLOT, &_types[90] },
    { "partyAuthProtocol", "1.3.6.1.6.3.3.2.1.1.1.7", &_names[90],
      (OS) 7, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[73], &_types[95], NULLOT, &_types[91] },
    { "partyAuthClock", "1.3.6.1.6.3.3.2.1.1.1.8", &_names[91],
      (OS) 22, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[88], NULLOT, &_types[92] },
    { "partyAuthPrivate", "1.3.6.1.6.3.3.2.1.1.1.9", &_names[92],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[71], &_types[96], NULLOT, &_types[93] },
    { "partyAuthPublic", "1.3.6.1.6.3.3.2.1.1.1.10", &_names[93],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[97], NULLOT, &_types[94] },
    { "partyAuthLifetime", "1.3.6.1.6.3.3.2.1.1.1.11", &_names[94],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[59], &_types[90], NULLOT, &_types[95] },
    { "partyPrivProtocol", "1.3.6.1.6.3.3.2.1.1.1.12", &_names[95],
      (OS) 7, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[90], NULLOT, NULLOT, &_types[96] },
    { "partyPrivPrivate", "1.3.6.1.6.3.3.2.1.1.1.13", &_names[96],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[92], &_types[91], NULLOT, &_types[97] },
    { "partyPrivPublic", "1.3.6.1.6.3.3.2.1.1.1.14", &_names[97],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[93], &_types[84], NULLOT, &_types[98] },
    { "partyCloneFrom", "1.3.6.1.6.3.3.2.1.1.1.15", &_names[98],
      (OS) 20, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[86], NULLOT, &_types[99] },
    { "partyStorageType", "1.3.6.1.6.3.3.2.1.1.1.16", &_names[99],
      (OS) 24, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[83], &_types[92], NULLOT, &_types[100] },
    { "partyStatus", "1.3.6.1.6.3.3.2.1.1.1.17", &_names[100],
      (OS) -1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[89], &_types[85], NULLOT, &_types[101] },
    { "snmpContexts", "1.3.6.1.6.3.3.2.2", &_names[101],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[74], &_types[81], &_types[102], &_types[102] },
    { "contextTable", "1.3.6.1.6.3.3.2.2.1", &_names[102],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[82], NULLOT, &_types[103], &_types[103] },
    { "contextEntry", "1.3.6.1.6.3.3.2.2.1.1", &_names[103],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[99], NULLOT, &_types[108], &_types[104] },
    { "contextIdentity", "1.3.6.1.6.3.3.2.2.1.1.1", &_names[104],
      (OS) 23, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[84], NULLOT, NULLOT, &_types[105] },
    { "contextIndex", "1.3.6.1.6.3.3.2.2.1.1.2", &_names[105],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[85], &_types[107], NULLOT, &_types[106] },
    { "contextLocal", "1.3.6.1.6.3.3.2.2.1.1.3", &_names[106],
      (OS) -1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[100], &_types[114], NULLOT, &_types[107] },
    { "contextViewIndex", "1.3.6.1.6.3.3.2.2.1.1.4", &_names[107],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[105], &_types[109], NULLOT, &_types[108] },
    { "contextLocalEntity", "1.3.6.1.6.3.3.2.2.1.1.5", &_names[108],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[103], &_types[113], NULLOT, &_types[109] },
    { "contextLocalTime", "1.3.6.1.6.3.3.2.2.1.1.6", &_names[109],
      (OS) 7, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[77], &_types[104], NULLOT, &_types[110] },
    { "contextProxyDstParty", "1.3.6.1.6.3.3.2.2.1.1.7", &_names[110],
      (OS) 20, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[87], &_types[111], NULLOT, &_types[111] },
    { "contextProxySrcParty", "1.3.6.1.6.3.3.2.2.1.1.8", &_names[111],
      (OS) 20, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[110], &_types[106], NULLOT, &_types[112] },
    { "contextProxyContext", "1.3.6.1.6.3.3.2.2.1.1.9", &_names[112],
      (OS) 7, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[86], &_types[110], NULLOT, &_types[113] },
    { "contextStorageType", "1.3.6.1.6.3.3.2.2.1.1.10", &_names[113],
      (OS) 24, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[108], &_types[112], NULLOT, &_types[114] },
    { "contextStatus", "1.3.6.1.6.3.3.2.2.1.1.11", &_names[114],
      (OS) -1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[106], &_types[105], NULLOT, &_types[115] },
    { "snmpAccess", "1.3.6.1.6.3.3.2.3", &_names[115],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[81], NULLOT, &_types[116], &_types[116] },
    { "aclTable", "1.3.6.1.6.3.3.2.3.1", &_names[116],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[102], NULLOT, &_types[117], &_types[117] },
    { "aclEntry", "1.3.6.1.6.3.3.2.3.1.1", &_names[117],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[113], NULLOT, &_types[122], &_types[118] },
    { "aclTarget", "1.3.6.1.6.3.3.2.3.1.1.1", &_names[118],
      (OS) 0, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[1], &_types[119], NULLOT, &_types[119] },
    { "aclSubject", "1.3.6.1.6.3.3.2.3.1.1.2", &_names[119],
      (OS) 0, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[114], &_types[120], NULLOT, &_types[120] },
    { "aclResources", "1.3.6.1.6.3.3.2.3.1.1.3", &_names[120],
      (OS) 0, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[119], &_types[123], NULLOT, &_types[121] },
    { "aclPrivileges", "1.3.6.1.6.3.3.2.3.1.1.4", &_names[121],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[96], &_types[118], NULLOT, &_types[122] },
    { "aclStorageType", "1.3.6.1.6.3.3.2.3.1.1.5", &_names[122],
      (OS) 24, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[117], &_types[121], NULLOT, &_types[123] },
    { "aclStatus", "1.3.6.1.6.3.3.2.3.1.1.6", &_names[123],
      (OS) -1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[120], NULLOT, NULLOT, &_types[124] },
    { "snmpViews", "1.3.6.1.6.3.3.2.4", &_names[124],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, &_types[101], &_types[125], &_types[125] },
    { "viewTable", "1.3.6.1.6.3.3.2.4.1", &_names[125],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[116], NULLOT, &_types[126], &_types[126] },
    { "viewEntry", "1.3.6.1.6.3.3.2.4.1.1", &_names[126],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[122], NULLOT, &_types[130], &_types[127] },
    { "viewIndex", "1.3.6.1.6.3.3.2.4.1.1.1", &_names[127],
      (OS) 0, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[107], &_types[129], NULLOT, &_types[128] },
    { "viewSubtree", "1.3.6.1.6.3.3.2.4.1.1.2", &_names[128],
      (OS) 7, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[123], &_types[132], NULLOT, &_types[129] },
    { "viewMask", "1.3.6.1.6.3.3.2.4.1.1.3", &_names[129],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[127], NULLOT, NULLOT, &_types[130] },
    { "viewType", "1.3.6.1.6.3.3.2.4.1.1.4", &_names[130],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[126], &_types[131], NULLOT, &_types[131] },
    { "viewStorageType", "1.3.6.1.6.3.3.2.4.1.1.5", &_names[131],
      (OS) 24, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[130], &_types[128], NULLOT, &_types[132] },
    { "viewStatus", "1.3.6.1.6.3.3.2.4.1.1.6", &_names[132],
      (OS) -1, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[128], &_types[127], NULLOT, &_types[133] },
    { "partyMIBConformance", "1.3.6.1.6.3.3.3", &_names[133],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[101], &_types[80], &_types[134], &_types[134] },
    { "partyMIBCompliances", "1.3.6.1.6.3.3.3.1", &_names[134],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[115], &_types[139], &_types[135], &_types[135] },
    { "unSecurableCompliance", "1.3.6.1.6.3.3.3.1.1", &_names[135],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[111], &_types[136], NULLOT, &_types[136] },
    { "partyNoPrivacyCompliance", "1.3.6.1.6.3.3.3.1.2", &_names[136],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[135], &_types[137], NULLOT, &_types[137] },
    { "partyPrivacyCompliance", "1.3.6.1.6.3.3.3.1.3", &_names[137],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[136], &_types[138], NULLOT, &_types[138] },
    { "fullPrivacyCompliance", "1.3.6.1.6.3.3.3.1.4", &_names[138],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[137], NULLOT, NULLOT, &_types[139] },
    { "partyMIBGroups", "1.3.6.1.6.3.3.3.2", &_names[139],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[66], NULLOT, &_types[140], &_types[140] },
    { "partyMIBGroup", "1.3.6.1.6.3.3.3.2.1", &_names[140],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      &_types[88], NULLOT, NULLOT, &_types[141] },
    { "joint-iso-ccitt", "2", &_names[141],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0,
      NULLOT, NULLOT, NULLOT, NULLOT },
    NULL
};

OT	anchor = _types;
OT	chain = &_types[141];

static OT _Tbuckets[128] = {
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[9],
    &_types[79],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[94],
    &_types[104],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[8],
    &_types[124],
    &_types[4],
    &_types[50],
    &_types[125],
    &_types[42],
    &_types[80],
    &_types[109],
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[51],
    &_types[5],
    &_types[58],
    &_types[129],
    &_types[19],
    &_types[138],
    &_types[18],
    &_types[98],
    &_types[140],
    &_types[118],
    &_types[91],
    &_types[6],
    NULLOT,
    NULLOT,
    &_types[68],
    &_types[7],
    NULLOT,
    &_types[17],
    NULLOT,
    &_types[2],
    NULLOT,
    NULLOT,
    &_types[49],
    &_types[39],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
};

extern	int	once_only_Tbuckets;
extern	OT	Tbuckets[];

loadobjects (file)
char   *file;
{
    int	    i;
    register struct _syntax *sy;
    register OT	    ot;
    static int once_only = 0;

    if (file && !once_only)
	return readobjects (file);

    if (once_only) {
	(void) sprintf (PY_pepy, "loadobjects called more than once!");
	return NOTOK;
    }
    once_only = 1;

    bcopy ((char *) _Tbuckets, (char *) Tbuckets, sizeof _Tbuckets);
    once_only_Tbuckets = 1;

    readsyntax ();
    for (sy = _syntaxes; sy -> name; sy++) {
	if (sy -> textual
	        && add_textual (sy -> name, sy -> textual,
				sy -> display ? sy -> display : "") == NOTOK) {
	    (void) sprintf (PY_pepy, "lost \"%s\" textual convention",
			    sy -> name);
	    return NOTOK;
	}

	if ((sy -> value = text2syn (sy -> name)) == NULLOS) {
	    (void) sprintf (PY_pepy, "lost \"%s\" syntax", sy -> name);
	    return NOTOK;
	}
    }

    for (ot = _types; ot -> ot_text; ot++)
	ot -> ot_syntax = (i = (int) ot -> ot_syntax) < 0
	    			? NULLOS : _syntaxes[i].value;

    return OK;
}
