/* snmp-g.c - SNMP group */

#ifndef	lint
static char *rcsid = "$Header$";
#endif

/* 
 * $Header$
 *
 *
 * $Log$
 */

/*
 *			  ISODE 8.0 NOTICE
 *
 *   Acquisition, use, and distribution of this module and related
 *   materials are subject to the restrictions of a license agreement.
 *   Consult the Preface in the User's Manual for the full terms of
 *   this agreement.
 *
 *
 *			4BSD/ISODE SNMPv2 NOTICE
 *
 *    Acquisition, use, and distribution of this module and related
 *    materials are subject to the restrictions given in the file
 *    SNMPv2-READ-ME.
 *
 */


#include <stdio.h>
#include "mib.h"
#include "snmp-g.h"

/*    SNMP GROUP */

struct snmpstat snmpstat;

caddr_t	*agentAction;

static int  new_snmp (char*, caddr_t**, int, int);


/*  */

static	integer	snmpORLastChange = 0L;


/* ARGSUSED */

static int  o_snmp_or (oi, v, offset)
OI	oi;
register struct type_SNMP_VarBind *v;
int	offset;
{
    switch (offset) {
	case type_SNMP_PDUs_get__request:
	    return int_SNMP_error__status_noSuchName;

	case type_SNMP_PDUs_get__next__request:
	    return NOTOK;
		
	default:
	    return int_SNMP_error__status_genErr;
    }
}

/*  */

static struct objreg snmp_objects[] = {
    "snmpInPkts",		(caddr_t) &snmpstat.s_packets,
    "snmpOutPkts",		(caddr_t) &snmpstat.s_outpkts,
    "snmpInBadVersions",	(caddr_t) &snmpstat.s_badversions,
    "snmpInBadCommunityNames",	(caddr_t) &snmpstat.s_badcommunitynames,
    "snmpInBadCommunityUses",	(caddr_t) &snmpstat.s_badcommunityuses,
    "snmpInASNParseErrs",	(caddr_t) &snmpstat.s_encodingerrs,
    "snmpInTooBigs",		(caddr_t) &snmpstat.s_intoobigs,
    "snmpInNoSuchNames",	(caddr_t) &snmpstat.s_innosuchnames,
    "snmpInBadValues",		(caddr_t) &snmpstat.s_inbadvalues,
    "snmpInReadOnlys",		(caddr_t) &snmpstat.s_inreadonlys,
    "snmpInGenErrs",		(caddr_t) &snmpstat.s_ingenerrs,
    "snmpInTotalReqVars",	(caddr_t) &snmpstat.s_totalreqvars,
    "snmpInTotalSetVars",	(caddr_t) &snmpstat.s_totalsetvars,
    "snmpInGetRequests",	(caddr_t) &snmpstat.s_ingetrequests,
    "snmpInGetNexts",		(caddr_t) &snmpstat.s_ingetnexts,
    "snmpInSetRequests",	(caddr_t) &snmpstat.s_insetrequests,
    "snmpInGetResponses",	(caddr_t) &snmpstat.s_ingetresponses,
    "snmpInTraps",		(caddr_t) &snmpstat.s_intraps,
    "snmpOutTooBigs",		(caddr_t) &snmpstat.s_outtoobigs,
    "snmpOutNoSuchNames",	(caddr_t) &snmpstat.s_outnosuchnames,
    "snmpOutBadValues",		(caddr_t) &snmpstat.s_outbadvalues,
    "snmpOutGenErrs",		(caddr_t) &snmpstat.s_outgenerrs,
    "snmpOutGetRequests",	(caddr_t) &snmpstat.s_outgetrequests,
    "snmpOutGetNexts",		(caddr_t) &snmpstat.s_outgetnexts,
    "snmpOutSetRequests",	(caddr_t) &snmpstat.s_outsetrequests,
    "snmpOutGetResponses",	(caddr_t) &snmpstat.s_outgetresponses,
    "snmpOutTraps",		(caddr_t) &snmpstat.s_outtraps,

    NULL
};


static struct objreg snmpV2_objects[] = {
    "snmpStatsPackets",		(caddr_t) &snmpstat.s_packets,
    "snmpStats30Something",	(caddr_t) &snmpstat.s_30something,
    "snmpStatsEncodingErrors",	(caddr_t) &snmpstat.s_encodingerrs,
    "snmpStatsUnknownDstParties",(caddr_t) &snmpstat.s_unknownsrcparties,
    "snmpStatsDstPartyMismatches",(caddr_t) &snmpstat.s_dstpartymismatches,
    "snmpStatsUnknownSrcParties",(caddr_t) &snmpstat.s_unknowndstparties,
    "snmpStatsBadAuths",	(caddr_t) &snmpstat.s_badauths,
    "snmpStatsNotInLifetimes",	(caddr_t) &snmpstat.s_notinlifetimes,
    "snmpStatsWrongDigestValues",(caddr_t) &snmpstat.s_wrongdigestvalues,
    "snmpStatsUnknownContexts",	(caddr_t) &snmpstat.s_unknowncontexts,
    "snmpStatsBadOperations",	(caddr_t) &snmpstat.s_badoperations,
    "snmpStatsSilentDrops",	(caddr_t) &snmpstat.s_silentdrops,

    "snmpV1BadCommunityNames",  (caddr_t) &snmpstat.s_badcommunitynames,
    "snmpV1BadCommunityUses",	(caddr_t) &snmpstat.s_badcommunityuses,

    "snmpORLastChange",		(caddr_t) &snmpORLastChange,

    NULL
};


static struct objreg snmp_or_objects[] = {
    "snmpORID",			NULL,
    "snmpORDescr",		NULL,

    NULL
};


init_snmp (isnmpV2, isaction)
int	isnmpV2,
	isaction;
{
    bzero ((char *) &snmpstat, sizeof snmpstat);

    if (isnmpV2) {
	OT	ot;

	if (ot = text2obj ("snmpInBadCommunityNames"))
	    ot -> ot_getfnx = NULLIFP;

	register_objects (snmpV2_objects, o_generic, NULLIFP);
	register_objects (snmp_or_objects, o_snmp_or, NULLIFP);
	if (new_snmp ("snmpV2EnableAuthenTraps", &snmpstat.s_enableauthentraps,
		      TRAPS_ENABLED, TRAPS_MAXVALUE) == NOTOK)
	    return NOTOK;

	if (new_snmp ("snmpSetSerialNo", (caddr_t **) 0, 0, 0) == NOTOK)
	    return NOTOK;
    }
    else {
	register_objects (snmp_objects, o_generic, NULLIFP);
	if (new_snmp ("snmpEnableAuthenTraps", &snmpstat.s_enableauthentraps,
		      TRAPS_ENABLED, TRAPS_MAXVALUE) == NOTOK)
	    return NOTOK;
    }

    if (isaction
	    && new_snmp ("agentAction", &agentAction, AGENT_OTHER,
			 AGENT_MAXVALUE) == NOTOK)
	return NOTOK;

    return OK;
}

/*  */

static int  new_snmp (text, theval, defval, maxval)
char   *text;
caddr_t **theval;
int	defval,
	maxval;
{
    register OT	    ot;
    
    if ((ot = text2obj (text)) == NULL) {
	(void) sprintf (PY_pepy, "unable to resolve %s", text);
	return NOTOK;
    }

    ot -> ot_getfnx = o_generic;
    ot -> ot_setfnx = s_generic;
    if ((ot -> ot_info = calloc (1, sizeof (integer))) == NULL) {
        (void) strcpy (PY_pepy, "out of memory");
        return NOTOK;
    }
    if (theval)
	*theval = &ot -> ot_info;
    *((integer *) ot -> ot_info) = defval;

    if (maxval) {
	char   *name;
	register OS    os;

	if ((os = ot -> ot_syntax) == NULL)
	    adios (NULLCP, "no syntax defined for object \"%s\"",
		   ot -> ot_text);
	name = os -> os_name;

	(void) add_syntax (ot -> ot_text, os -> os_encode, os -> os_decode,
			   os -> os_free, os -> os_parse, os -> os_print);
	if ((os = text2syn (ot -> ot_text)) == NULL)
	    adios (NULLCP, "lost syntax for object \"%s\"", ot -> ot_text);
	ot -> ot_syntax = os;
	os -> os_name = name;
	os -> os_data2 = maxval;
    }

    return OK;
}
