//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// AlarmManager.cc - alarm manager realisation

// By George Pavlou, March 1994


#include <stdlib.h>
#include <unistd.h>
#include "msap.h"
#include "AlarmManager.h"


AlarmManager::AlarmManager ()
{
    _time  = 0;
    _intvl = DEFAULT_INTERVAL;
    scheduleWakeUps(DEFAULT_INTERVAL, NULLCP);
}


AlarmManager::AlarmManager (long intvl)
{
    _time  = 0;
    _intvl = intvl;
    scheduleWakeUps(intvl, NULLCP);
}


AlarmManager::~AlarmManager ()
{
    cancelWakeUps(NULLCP);
}


int  AlarmManager::wakeUp (char* token)
{
    _time += _intvl;
    printf("time now is %d\n", _time);
    return OK;
}

