//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// SimMgr.cc

// By George Pavlou, February 1994


#include <stdlib.h>
#ifdef __GNUG__
#include <std.h>
#endif
#include "msap.h"
#include "Error.h"
#include "Coordinator.h"
#include "TimeManager.h"
#include "AlarmManager.h"
#include "RMIBAgent.h"
#include "SmiSntx.h"


VoidFunc  syntaxes[] = {	// ASN.1 syntaxes
		    smi_syntaxes,
		    NULL
		};


main (int argc, char** argv)
{
    if (argc < 2)
	error(NULLCP, "usage: simmgr <host>");

    // load syntaxes

    initialiseSyntaxes(NULLCP, syntaxes);


    // instantiate the coordinator and time manager (coordinator FIRST)

    Coordinator coordinator;
    TimeManager timeManager;


    // instantiate the RMIB agent and try to connect to the agent
    // that can tell if the time is real or simulated -
    // then initialise the time manager who will find this out

    RMIBAgent rmibAgent;
    if (rmibAgent.connect("SMA", argv[1]) == NOTOK)
	error(NULLCP, "unable to establish association to simsma at %s",
			argv[1]);

    if (timeManager.initialise(&rmibAgent) == NOTOK)
	error(NULLCP, "cannot initialise time manager!");


    // instantiate the alarm manager knowledge source

    AlarmManager alarmManager;


    // start listening...

    printf("listening...\n");
    coordinator.listen();
}
