#include "TimeManager.h"

int systemSim::createRR (AVA*& err, void*, int)
{
    // call the parent class createRR method -
    // in this case it will do nothing but for correct OO style...

    if (System::createRR(err) == NOTOK)
	return NOTOK;


    // initialise instance variables

    reportingInterval() -> set(DEFAULT_INTVL);


    // tell Top we are allomorphic to system

    addAllomorphicClass(name2oid("system"));

    return OK;
}


int systemSim::setSimulatedTime (double newTime)
{
    // check first that the time is greater than the previous one

    if (newTime <= *(double*) simulatedTime() -> get()) {
	advise(NULLCP, "systemSim: new time less or equal to previous one! - \
%.2f <= %.2f\n",
			newTime, *(double*) simulatedTime() -> get());
	return NOTOK;
    }

    // set it and trigger the attributeValueChange event

    simulatedTime() -> set(newTime);
    triggerAttributeValueChange(I_simulatedTime, _level);

    // check if there is a local TimeManager and update its time

    TimeManager* timeMgr = TimeManager::getInstance();
    if (timeMgr)
	timeMgr -> updateTime(newTime);

    return OK;
}

