/*
 * Copyright (c) 1988 University College London
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Department of Computer Science, University College London.
 * The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/* oid3.c - fast OID comparison method */

/*
 * By George Pavlou, June 1991
 */

#include <stdio.h>
#include "isode/psap.h"


/* LINTLIBRARY */


/* oid_equal: compares two OIDs for equality only (more efficient than oid_cmp)
 *            returns 1 (TRUE) if equal, 0 (FALSE) otherwise
 */

static int oid_elem_cmp ();

int  oid_equal (p, q)
register OID  p, q;
{
    if (p == NULLOID || q == NULLOID) {
	if (p == NULLOID && q == NULLOID)
	    return 1;
	return 0;
    }

    if (p->oid_nelem != q->oid_nelem)
	return 0;

    return oid_elem_cmp (p->oid_elements, q->oid_elements, p->oid_nelem);
}


static int  oid_elem_cmp (p, q, nelem)
register unsigned int *p, *q;
register int nelem;
{
    while (--nelem > -1)
	if (p[nelem] != q[nelem])
	    return 0;
    return 1;
}
