/******************************************************************/
/*
	DebugMem.h

	Memory debugging header	file

To use this code, define DEBUG_MEMORY as below and code
all your new in	your application as (NEW ....).	At the end of
your program, a	list of	all unallocated	objects	will be	printed.

The memory debugging works by using the	CURLINE	and CURFILE macros
automatically set up by	a C++ compiler.	The NEW	macro passes
the values of these macros to the overloaded new operator.

The delete opeator can be coded	as DELETE ., but there is no need to
do this	as the delete operator can use just the	memory address to find
out which trace	entry is being deleted;	ie there is no need to
use the	CURFILE, CURLINE macros.

*/
/******************************************************************/

#include <stdio.h>
#include <stdlib.h>
/*
#define	DEBUG_MEMORY
*/
#ifndef	_DEBUG_MEMORY_INC
#define	_DEBUG_MEMORY_INC

#ifndef	DEBUG_MEMORY

#define	NEW	new
#define	DELETE	delete

#else

/******************************************************************/

#define	NEW curFile=__FILE__,curLine=__LINE__,new
/*
#define	DELETE curFile=__FILE__,curLine=__LINE__,delete
*/
#define	DELETE delete

/******************************************************************/

extern	char	*curFile;
extern	int	curLine;

/******************************************************************/

void	init_mem_trace();
void	print_mem_trace();

/******************************************************************/

#endif
#endif

/******************************************************************/
/* End of file */
/******************************************************************/


