//
// Copyright (c) 1990 University College London
// All rights reserved.
//
// Redistribution and use in source and binary forms are permitted
// provided that the above copyright notice and this paragraph are
// duplicated in all such forms and that any documentation,
// advertising materials, and other materials related to such
// distribution and use acknowledge that the software was developed
// by the Department of Computer Science, University College London.
// The name of the University may not be used to
// endorse or promote products derived from this software without
// specific prior written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
// WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

// MInit.cc - initialise a management association

// By George Pavlou, February 1991


#ifdef  __GNUG__
#include <std.h>
#elif   __cplusplus
#include <stdlib.h>
#ifdef AIXV3
#include <stdio.h>
#endif
#endif
#include <strings.h>
#ifndef	ICR1
#include <isode/manifest.h>
#else
#include <isode/compat/manifest.h>
#endif


int  parseAvaArg (int argc, char** argv,
			char** strType, char** strValue, int* advance)
{
    char buf[256], *cp = buf;
    *cp = '\0';

    for (register int i = 0; i < argc; i++) {
	if (*argv[i] == '-' && strlen(argv[i]) == 2)
	    break;
	sprintf(cp, "%s ", argv[i]);
	cp += strlen(argv[i]) + 1;
    }
    *(cp-1) = '\0';
    *advance = i == argc-1 ? i : i-1;

    if ((cp = strchr(buf, '=')) == NULLCP) {
	if (i == 0)
	    return NOTOK;
	*strType = strdup(buf);
	*strValue = NULLCP;
	return OK;
    }

    // remove trailing spaces from type
    for (register char* s = cp-1; *s == ' '; s--);
    *(s+1) = '\0';
    *strType = strdup(buf);

    // remove preceding spaces from value
    for (s = cp+1; *s == ' '; s++);
    *strValue = strdup(s);

    return OK;
}


int  parseFilterArg (int argc, char** argv, char** strFilter, int* advance)
{
    char buf[256], *cp = buf;
    *cp = '\0';

    for (register int i = 0; i < argc; i++) {
	if (*argv[i] == '-' && strlen(argv[i]) == 2)
	    break;
	sprintf(cp, "%s ", argv[i]);
	cp += strlen(argv[i]) + 1;
    }
    *(cp-1) = '\0';
    if (advance)
	*advance = i;

    *strFilter = strdup(buf);
    return OK;
}
